// /**
//  * Created by xieli on 2017/2/26.
//  */
//
// module cc {
//     export class Color {
//         /**
//          @param r red component of the color, default value is 0.
//          @param g green component of the color, defualt value is 0.
//          @param b blue component of the color, default value is 0.
//          @param a alpha component of the color, default value is 255.
//          */
//         constructor(r?: number, g?: number, b?: number, a?: number) {
//             this.r = r;
//             this.g = g;
//             this.b = b;
//             this.a = a;
//         }
//
//         r: number;
//         g: number;
//         b: number;
//         a: number;
//
//
//         /**
//          * White color (255, 255, 255, 255)
//          * @returns {Color}
//          * @private
//          */
//         static _getWhite = function () {
//             return cc.color(255, 255, 255, 255);
//         };
//
//         /**
//          *  Yellow color (255, 255, 0, 255)
//          * @returns {Color}
//          * @private
//          */
//         static _getYellow = function () {
//             return cc.color(255, 255, 0, 255);
//         };
//
//         /**
//          *  Blue color (0, 0, 255, 255)
//          * @type {Color}
//          * @private
//          */
//         static _getBlue = function () {
//             return cc.color(0, 0, 255, 255);
//         };
//
//         /**
//          *  Green Color (0, 255, 0, 255)
//          * @type {Color}
//          * @private
//          */
//         static _getGreen = function () {
//             return cc.color(0, 255, 0, 255);
//         };
//
//         /**
//          *  Red Color (255, 0, 0, 255)
//          * @type {Color}
//          * @private
//          */
//         static _getRed = function () {
//             return cc.color(255, 0, 0, 255);
//         };
//
//         /**
//          *  Magenta Color (255, 0, 255, 255)
//          * @type {Color}
//          * @private
//          */
//         static _getMagenta = function () {
//             return cc.color(255, 0, 255, 255);
//         };
//
//         /**
//          *  Black Color (0, 0, 0, 255)
//          * @type {Color}
//          * @private
//          */
//         static _getBlack = function () {
//             return cc.color(0, 0, 0, 255);
//         };
//
//         /**
//          *  Orange Color (255, 127, 0, 255)
//          * @type {Color}
//          * @private
//          */
//         static _getOrange = function () {
//             return cc.color(255, 127, 0, 255);
//         };
//
//         /**
//          *  Gray Color (166, 166, 166, 255)
//          * @type {Color}
//          * @private
//          */
//         static _getGray = function () {
//             return cc.color(166, 166, 166, 255);
//         };
//
//         //  Color(r?: number, g?: number, b?: number, a?: number): Color;
//
//         /** !#en Solid white, RGBA is [255, 255, 255, 255].
//          !#zh 纯白色，RGBA 是 [255, 255, 255, 255]。 */
//         static WHITE: Color = Color._getWhite();
//         /** !#en Solid black, RGBA is [0, 0, 0, 255].
//          !#zh 纯黑色，RGBA 是 [0, 0, 0, 255]。 */
//         static BLACK: Color = Color._getBlack();
//         /** !#en Transparent, RGBA is [0, 0, 0, 0].
//          !#zh 透明，RGBA 是 [0, 0, 0, 0]。 */
//         static TRANSPARENT: Color
//         /** !#en Grey, RGBA is [127.5, 127.5, 127.5].
//          !#zh 灰色，RGBA 是 [127.5, 127.5, 127.5]。 */
//         static GRAY: Color = Color._getGray();
//         /** !#en Solid red, RGBA is [255, 0, 0].
//          !#zh 纯红色，RGBA 是 [255, 0, 0]。 */
//         static RED: Color = Color._getRed();
//         /** !#en Solid green, RGBA is [0, 255, 0].
//          !#zh 纯绿色，RGBA 是 [0, 255, 0]。 */
//         static GREEN: Color = Color._getGreen();
//         /** !#en Solid blue, RGBA is [0, 0, 255].
//          !#zh 纯蓝色，RGBA 是 [0, 0, 255]。 */
//         static BLUE: Color = Color._getBlue();
//         /** !#en Yellow, RGBA is [255, 235, 4].
//          !#zh 黄色，RGBA 是 [255, 235, 4]。 */
//         static YELLOW: Color = Color._getYellow();
//         /** !#en Orange, RGBA is [255, 127, 0].
//          !#zh 橙色，RGBA 是 [255, 127, 0]。 */
//         static ORANGE: Color = Color._getOrange();
//         /** !#en Cyan, RGBA is [0, 255, 255].
//          !#zh 青色，RGBA 是 [0, 255, 255]。 */
//         static CYAN: Color
//         /** !#en Magenta, RGBA is [255, 0, 255].
//          !#zh 洋红色（品红色），RGBA 是 [255, 0, 255]。 */
//         static MAGENTA: Color = Color._getMagenta();
//
//         /** !#en Clone a new color from the current color.
//          !#zh 克隆当前颜色。
//
//          @example
//          ```js
//          var color = new Color();
//          var newColor = color.clone();// Color {r: 0, g: 0, b: 0, a: 255}
//          ```
//          */
//         // clone(): Color;
//
//         /** !#en TODO
//          !#zh 判断两个颜色是否相等。
//
//          @example
//          ```js
//          var color1 = Color.WHITE;
//          var color2 = new Color(255, 255, 255);
//          cc.log(color1.equals(color2)); // true;
//          color2 = Color.RED;
//          cc.log(color2.equals(color1)); // false;
//          ```
//          */
//         // equals(other: (r: number, g: number, b: number, a: number) => void): boolean;
//         //
//         // /** !#en TODO
//         //  !#zh 线性插值
//         //  @param ratio the interpolation coefficient.
//         //  @param out optional, the receiving vector.
//         //
//         //  @example
//         //  ```js
//         //  // Converts a white color to a black one trough time.
//         //  update: function (dt) {
//         //     var color = this.node.color;
//         //     if (color.equals(Color.BLACK)) {
//         //         return;
//         //     }
//         //     this.ratio += dt * 0.1;
//         //     this.node.color = Color.WHITE.lerp(Color.BLACK, ratio);
//         // }
//         //
//         //  ```
//         //  */
//         // lerp(to: (r: number, g: number, b: number, a: number) => void, ratio: number, out: (r: number, g: number, b: number, a: number) => void): Color;
//         //
//         // /** !#en TODO
//         //  !#zh 转换为方便阅读的字符串。
//         //
//         //  @example
//         //  ```js
//         //  var color = Color.WHITE;
//         //  color.toString(); // "rgba(255, 255, 255, 255)"
//         //  ```
//         //  */
//         // toString(): string;
//         //
//         // /** !#en TODO
//         //  !#zh 设置当前的红色值，并返回当前对象。
//         //  @param red the new Red component.
//         //
//         //  @example
//         //  ```js
//         //  var color = new Color();
//         //  color.setR(255); // Color {r: 255, g: 0, b: 0, a: 255}
//         //  ```
//         //  */
//         // setR(red: number): Color;
//         //
//         // /** !#en TODO
//         //  !#zh 设置当前的绿色值，并返回当前对象。
//         //  @param green the new Green component.
//         //
//         //  @example
//         //  ```js
//         //  var color = new Color();
//         //  color.setG(255); // Color {r: 0, g: 255, b: 0, a: 255}
//         //  ```
//         //  */
//         // setG(green: number): Color;
//         //
//         // /** !#en TODO
//         //  !#zh 设置当前的蓝色值，并返回当前对象。
//         //  @param blue the new Blue component.
//         //
//         //  @example
//         //  ```js
//         //  var color = new Color();
//         //  color.setB(255); // Color {r: 0, g: 0, b: 255, a: 255}
//         //  ```
//         //  */
//         // setB(blue: number): Color;
//         //
//         // /** !#en TODO
//         //  !#zh 设置当前的透明度，并返回当前对象。
//         //  @param alpha the new Alpha component.
//         //
//         //  @example
//         //  ```js
//         //  var color = new Color();
//         //  color.setA(0); // Color {r: 0, g: 0, b: 0, a: 0}
//         //  ```
//         //  */
//         // setA(alpha: number): Color;
//         //
//         // /** !#en TODO
//         //  !#zh 转换为 CSS 格式。
//         //  @param opt "rgba", "rgb", "#rgb" or "#rrggbb".
//         //
//         //  @example
//         //  ```js
//         //  var color = Color.BLACK;
//         //  color.toCSS();          // "#000";
//         //  color.toCSS("rgba");    // "rgba(0,0,0,1.00)";
//         //  color.toCSS("rgb");     // "rgba(0,0,0)";
//         //  color.toCSS("#rgb");    // "#000";
//         //  color.toCSS("#rrggbb"); // "#000000";
//         //  ```
//         //  */
//         // toCSS(opt: string): string;
//         //
//         // /** !#en Clamp this color to make all components between 0 to 255。
//         //  !#zh 限制颜色数值，在 0 到 255 之间。
//         //
//         //  @example
//         //  ```js
//         //  var color = new Color(1000, 0, 0, 255);
//         //  color.clamp();
//         //  cc.log(color); // (255, 0, 0, 255)
//         //  ```
//         //  */
//         // clamp(): void;
//         //
//         // /** !#en TODO
//         //  !#zh 读取 16 进制。
//         //
//         //  @example
//         //  ```js
//         //  var color = Color.BLACK;
//         //  color.fromHEX("#FFFF33"); // Color {r: 255, g: 255, b: 51, a: 255};
//         //  ```
//         //  */
//         // fromHEX(hexString: string): Color;
//         //
//         // /** !#en TODO
//         //  !#zh 转换为 16 进制。
//         //  @param fmt "#rgb" or "#rrggbb".
//         //
//         //  @example
//         //  ```js
//         //  var color = Color.BLACK;
//         //  color.toHEX("#rgb");     // "000";
//         //  color.toHEX("#rrggbb");  // "000000";
//         //  ```
//         //  */
//         // toHEX(fmt: string): string;
//         //
//         // /** !#en Convert to 24bit rgb value.
//         //  !#zh 转换为 24bit 的 RGB 值。
//         //
//         //  @example
//         //  ```js
//         //  var color = Color.YELLOW;
//         //  color.toRGBValue(); // 16771844;
//         //  ```
//         //  */
//         // toRGBValue(): number;
//         //
//         // /** !#en TODO
//         //  !#zh 读取 HSV（色彩模型）格式。
//         //
//         //  @example
//         //  ```js
//         //  var color = Color.YELLOW;
//         //  color.fromHSV(0, 0, 1); // Color {r: 255, g: 255, b: 255, a: 255};
//         //  ```
//         //  */
//         // fromHSV(h: number, s: number, v: number): Color;
//         //
//         // /** !#en TODO
//         //  !#zh 转换为 HSV（色彩模型）格式。
//         //
//         //  @example
//         //  ```js
//         //  var color = Color.YELLOW;
//         //  color.toHSV(); // Object {h: 0.1533864541832669, s: 0.9843137254901961, v: 1};
//         //  ```
//         //  */
//         // toHSV(): any;
//         //
//         // /** !#en TODO
//         //  !#zh RGB 转换为 HSV。
//         //  @param r red, must be [0, 255].
//         //  @param g red, must be [0, 255].
//         //  @param b red, must be [0, 255].
//         //
//         //  @example
//         //  ```js
//         //  Color.rgb2hsv(255, 255, 255); // Object {h: 0, s: 0, v: 1};
//         //  ```
//         //  */
//         // rgb2hsv(r: number, g: number, b: number): any;
//         //
//         // /** !#en TODO
//         //  !#zh HSV 转换为 RGB。
//         //
//         //  @example
//         //  ```js
//         //  Color.hsv2rgb(0, 0, 1); // Object {r: 255, g: 255, b: 255};
//         //  ```
//         //  */
//         // hsv2rgb(h: number, s: number, v: number): any;
//     }
//
// }