/**
 * Created by xieli on 2017/2/23.
 */


module cc {
    export class Size {

        width: number;
        height: number;

        /**
         */
        constructor(width: number, height: number) {
            this.width = width;
            this.height = height;

        }


        /** !#en return a Size object with width = 0 and height = 0.
         !#zh 返回一个宽度为 0 和高度为 0 的 Size 对象。 */
        ZERO: Size;

        /** !#en TODO
         !#zh 克隆 size 对象。

         @example
         ```js
         var a = new cc.size(10, 10);
         a.clone();// return Size {width: 0, height: 0};
         ```
         */
       // clone(): Size;

        /** !#en TODO
         !#zh 当前 Size 对象是否等于指定 Size 对象。

         @example
         ```js
         var a = new cc.size(10, 10);
         a.equals(new cc.size(10, 10));// return true;
         ```
         */
        // equals(other: (width: number, height: number) => void): boolean;

        /** !#en TODO
         !#zh 线性插值。
         @param to !#en
         Constructor of cc.Rect class.
         see {{#crossLink "cc/rect:method"}} cc.rect {{/crossLink}} for convenience method.
         !#zh
         cc.Rect类的构造函数。可以通过 {{#crossLink "cc/rect:method"}} cc.rect {{/crossLink}} 简便方法进行创建。
         @param ratio the interpolation coefficient.
         @param out optional, the receiving vector.

         @example
         ```js
         var a = new cc.size(10, 10);
         var b = new cc.rect(50, 50, 100, 100);
         update (dt) {
		   // method 1;
		   var c = a.lerp(b, dt * 0.1);
		   // method 2;
		   a.lerp(b, dt * 0.1, c);
		}
         ```
         */
        // lerp(to: (x: number, y: number, w: number, h: number) => void, ratio: number, out: (width: number, height: number) => void): Size;

        /** !#en TODO
         !#zh 转换为方便阅读的字符串。

         @example
         ```js
         var a = new cc.size(10, 10);
         a.toString();// return "(10.00, 10.00)";
         ```
         */
        //toString(): string;

        /** !#en
         Helper function that creates a cc.Size.<br/>
         Please use cc.p or cc.v2 instead, it will soon replace cc.Size.
         !#zh
         创建一个 cc.Size 对象的帮助函数。<br/>
         注意：可以使用 cc.p 或者是 cc.v2 代替，它们将很快取代 cc.Size。
         @param w width or a size object
         @param h height

         @example
         ```js
         var size1 = cc.size();
         var size2 = cc.size(100,100);
         var size3 = cc.size(size2);
         var size4 = cc.size({width: 100, height: 100});

         ```
         */
        // size(w: number|Size, h: number): Size;

        /** !#en Check whether a point's value equals to another.
         !#zh 检查 Size 对象是否等于另一个。

         @example
         ```js
         var a = new cc.size(10, 10);
         var b = new cc.size(10, 10);
         cc.sizeEqualToSize(a, b);// return true;
         var b = new cc.size(5, 10);
         cc.sizeEqualToSize(a, b);// return false;
         ```
         */
        //sizeEqualToSize(size1: (width: number, height: number) => void, size2: (width: number, height: number) => void): boolean;
    }
}