//主要用于玩家存档
module game {
    export class dataMgr {

        static g_ing: any = null;

        static getMe(): dataMgr {
            if (game.dataMgr.g_ing == null) {
                dataMgr.g_ing = new dataMgr();
                return dataMgr.g_ing;
            }
            else {
                return dataMgr.g_ing;
            }
        };


        constructor() {
        }

        init() {
        }

        getPlayDoc(): play_doc_s {
            return fileMgr.getMe().m_play_doc;
        }


        getPlayPintuDoc() {
            return fileMgr.getMe().m_play_doc.pintu;
        }

        getPlayYindaoByType(name){
            let data = fileMgr.getMe().m_play_doc.yindao[name];
            return data;
        }

        setPlayYindao(name,flag){
            let data = fileMgr.getMe().m_play_doc.yindao[name];
            fileMgr.getMe().m_play_doc.yindao[name] = flag;
        }

        setItems(items) {
            fileMgr.getMe().m_play_doc["items"] = items;
        }

        //获取当前日期
        getTodayDate() {
            return dataMgr.getMe().getPlayDoc().coreData.curdate;
        }

        addGold(num) {
            if (this.addItemByType("gold", num) == false) {
                console.error("addGold");
                return false;
            }
            uiMgr.getMe().updateGoldandDiamonds();
            return true;
        }

        getGold() {
            return fileMgr.getMe().m_play_doc["items"]["gold"]["num"];
        }

        removeGold(num) {
            if (this.removeItemByType("gold", num) == false) {
                console.error("removeGold");
                return false;
            }
            uiMgr.getMe().updateGoldandDiamonds();
            return true;
        }


        removeDiamond(num) {
            if (this.removeItemByType("zuanshi", num) == false) {
                console.error("removeDiamond");
                return false;
            }
            uiMgr.getMe().updateGoldandDiamonds();
            return true;
        }

        getDiamond() {
            return fileMgr.getMe().m_play_doc["items"]["zuanshi"]["num"];
        }

        addDiamond(num) {
            if (this.addItemByType("zuanshi", num) == false) {
                console.error("addDiamond");
                return false;
            }
            uiMgr.getMe().updateGoldandDiamonds();
            return true;
        }

        addItemByType(type, num) {
            if (type == null || type == "") {
                console.error("addItemByType");
                return false;
            }
            if (num == null) {
                console.error("addItemByType");
                return false;
            }
            if (num < 0) {
                console.error("addItemByType");
                return false;
            }
            //
            if (!isNaN(num)) {
                num = parseInt(num);
            }
            let buffnum = fileMgr.getMe().m_play_doc["items"][type]["num"] + num;
            if (buffnum > Number.MAX_VALUE) {
                console.error("addItemByType");
                return false;
            }
            fileMgr.getMe().m_play_doc["items"][type]["num"] += num;
        }


        setItemByType(type, num) {
            if (type == null || type == "") {
                console.error("setItemByType");
                return false;
            }
            if (num == null) {
                console.error("setItemByType");
                return false;
            }
            if (num < 0) {
                console.error("setItemByType");
                return false;
            }
            //
            if (!isNaN(num)) {
                num = parseInt(num);
            }
            if (num > Number.MAX_VALUE) {
                console.error("setItemByType");
                return false;
            }
            fileMgr.getMe().m_play_doc["items"][type]["num"] = num;
        }

        getItemByType(type) {
            return parseInt(game.fileMgr.getMe().m_play_doc["items"][type]["num"]);
        }

        removeItemByType(type, num) {
            if (type == null || type == "") {
                console.error("removeItemByType");
                return false;
            }
            if (num == null) {
                console.error("removeItemByType");
                return false;
            }
            if (num < 0) {
                console.error("removeItemByType");
                return false;
            }
            //
            if (!isNaN(num)) {
                num = parseInt(num);
            }
            let buffnum = fileMgr.getMe().m_play_doc["items"][type]["num"] - num;
            if (buffnum > Number.MAX_VALUE) {
                console.error("addItemByType");
                return false;
            }
            fileMgr.getMe().m_play_doc["items"][type]["num"] -= num;
        }



        addPintuByName(name, num) {
            if (name == null || name == "") {
                console.error("addPintuByName");
                return false;
            }
            if (num == null) {
                console.error("addPintuByName");
                return false;
            }
            if (num < 0) {
                console.error("addPintuByName");
                return false;
            }
            //
            if (!isNaN(num)) {
                num = parseInt(num);
            }
            let buffnum = fileMgr.getMe().m_play_doc["pintu"][name]["num"] + num;
            if (buffnum > Number.MAX_VALUE) {
                console.error("addItemByType");
                return false;
            }
            fileMgr.getMe().m_play_doc["pintu"][name]["num"] += num;
        }

        getPintuByName(name) {
            return parseInt(game.fileMgr.getMe().m_play_doc["pintu"][name]["num"]);
        }

        removePintuByName(name, num) {
            if (name == null || name == "") {
                console.error("removePintuByName");
                return false;
            }
            if (num == null) {
                console.error("removePintuByName");
                return false;
            }
            if (num < 0) {
                console.error("removePintuByName");
                return false;
            }
            //
            if (!isNaN(num)) {
                num = parseInt(num);
            }
            let buffnum = fileMgr.getMe().m_play_doc["pintu"][name]["num"] - num;
            if (buffnum > Number.MAX_VALUE) {
                console.error("addItemByType");
                return false;
            }
            fileMgr.getMe().m_play_doc["pintu"][name]["num"] -= num;
        }

        //获得英雄存档信息 - 随从
        getHeroPlaydocInfo(heroname: string): hero_save_data_s {
            let ret: hero_save_data_s = fileMgr.getMe().m_hero_save_data_Map.get(heroname);

            if (ret == null) {
                console.log("error getHeroPlaydocInfo 没有这个角色 " + heroname);
            }
            return ret;
        }

        //获得英雄的等级
        getHeroLevel(heroname:string ):number {
            if(heroname.indexOf("bobifenshen") > -1){
                heroname = "bobi";
            }
            let playinfo = this.getHeroPlaydocInfo(heroname);
            if(playinfo.islocked == null){
                return 1;
            }
            if(playinfo.islocked == 1){
                return 1;
            }
            let level = playinfo.level;
            if (level == null) {
                console.error("getHeroLevel:" + heroname);
            }
            return level;
        }

        getHeroNameByName(heroname:string ):string {
            let level = this.getHeroLevel(heroname);
            return heroname + level;
            // return this.getHeroConfig(heroname).spine_res;
        }

        //英雄升级函数
        addHeroLevel(heroname: string): boolean {
            if (this.isHeroMaxLevel(heroname)) {
                //console.error("addHeroLevel: > g_PlayerMaxLevel" + heroname);
                return false;
            }
            let playinfo = this.getHeroPlaydocInfo(heroname);
            playinfo.level++;

            uiMgr.getMe().show_ui_playOnce("jinhuachenggong.json", "play");

            return true;
        }

        //获取解锁花费
        getUnlockCost(heroname){

            if(!g_differentPrices[g_version]){
                console.error("error getUnlockCost 版本不对" + g_version);
            }
            // if (fileMgr.getMe().m_playHero_data_Map.has(heroname) == false) {
            //     console.error("error getUnlockCost 没有这个角色" + heroname);
            // }
            return g_differentPrices[g_version].unlock[heroname];
            // let ret = fileMgr.getMe().m_playHero_data_Map.get(heroname).unLockDiamond;
            // if (ret == null) {
            //     console.error("getUnlockCost:" + heroname);
            // }
            // return ret;
        }

        getLevelUpCost(heroname){
            if(!g_differentPrices[g_version]){
                console.error("error getUnlockCost 版本不对" + g_version);
            }
            return g_differentPrices[g_version].heros[heroname];
        }

        //获得英雄是否解锁
        getHeroIsLocked(heroname) {
            let playinfo = this.getHeroPlaydocInfo(heroname);
            let ret = playinfo.islocked;
            if (ret == null) {
                console.error("getHeroIsLocked:" + heroname);
            }
            if (ret == 0) {
                return false;
            }
            return true;
        }



        //判断英雄是否满级
        isHeroMaxLevel(heroname) {
            let level = this.getHeroLevel(heroname);
            if ((level == null)) {
                console.error("isHeroMaxLevel: isHeroMaxLevel error" + heroname);
            }
            if (level >= g_PlayerMaxLevel) {
                return true;
            }
            return false;
        }

        heroLevelUP(heroname){
            let playinfo = this.getHeroPlaydocInfo(heroname);
            if(playinfo.level < 3){
                ++playinfo.level
                return true
            }else{
                console.log("等级已到最高级")
            }
            return false
        }

        getHeroHeadIcon(heroname) {
            let ret = this.getHeroConfig(heroname).small_head_icon;
            if (ret == null) {
                console.error("getHeroHeadIcon:" + heroname);
            }
            return ret;
        }

        getHeroHeadBigIcon(heroname) {
            let ret = this.getHeroConfig(heroname).big_head_icon;
            if (ret == null) {
                console.error("getHeroHeadBigIcon:" + heroname);
            }
            return ret;
        }

        //获得英雄的名字 中文
        getHeroName_ZH(heroname) {

            if (fileMgr.getMe().m_playHero_data_Map.has(heroname) == false) {
                console.error("error getHeroName_ZH 没有这个角色" + heroname);
            }
            let ret = fileMgr.getMe().m_playHero_data_Map.get(heroname).desName;
            if (ret == null) {
                console.error("getHeroName_ZH:" + heroname);
            }
            return ret;
        }

        //获得怪物的名字 中文
        getMonsterName_ZH(name) {
            if (g_monster_config[name] == null) {
                console.log("error g_monster_config 没有这个角色" + name);
                console.error("error g_monster_config 没有这个角色" + name);
            }
            let ret = g_monster_config[name]["desName"];
            if (ret == null) {
                console.error("getMonsterName_ZH:" + name);
            }
            return ret;
        }

        //获得英雄名字的图片
        getHeroNameImage(heroname) {
            if (fileMgr.getMe().m_playHero_data_Map.has(heroname) == false) {
                console.error("error getHeroNameImage 没有这个角色" + heroname);
            }
            let ret = fileMgr.getMe().m_playHero_data_Map.get(heroname).hero_name_image;
            if (ret == null) {
                console.error("getHeroNameImage:" + heroname);
            }
            return ret;
        }


        //解锁英雄
        unLockHero(heroname) {
            let playinfo = this.getHeroPlaydocInfo(heroname);
            let ret = playinfo.islocked;
            if (ret == null) {
                console.error("unLockHero:" + heroname);
                return false;
            }
            playinfo.islocked = 0;

            uiMgr.getMe().show_ui_playOnce("jiesuochenggong.json", "play");

            return true;
        }


        getMonsterBaseInfo(name) {
            let ret = g_monster_config[name];
            if (ret == null) {
                console.error("error g_monster_config 没有这个角色" + name);
            }
            return ret;
        }

        //获得英雄或随从的配置信息，图片地址等
        getHeroConfig(heroname: string): HeroConfig_s {
            let ret = fileMgr.getMe().m_playHero_data_Map.get(heroname);
            if (ret == null) {
                console.error("error getHeroConfig 没有这个角色" + heroname);
            }
            return ret;
        }

        //获得角色 介绍
        getHeroshuoming(heroname: string):string {
            let info = this.getHeroConfig(heroname);
            if ((info == null)) {
                console.error("getjieshao:" + heroname);
            }
            let ret = info["shuoming"];
            if (ret == null) {
                console.error("getshuoming:" + heroname);
            }
            return ret;
        }


        //获得基础攻击
        getBaseAtt(heroname) {
            let info = this.getHeroConfig(heroname);
            if ((info == null)) {
                console.error("getBaseSpeed:" + heroname);
            }
            let ret = info["attackPoint"];
            if (ret == null) {
                console.error("getBaseAtt:" + heroname);
            }
            return ret;
        }

        //获得基础暴击
        getBaseCrit(heroname) {
            let info = this.getHeroConfig(heroname);
            if ((info == null)) {
                console.error("getBaseSpeed:" + heroname);
            }
            let ret = info["criticalRate"];
            if (ret == null) {
                console.error("criticalRate:" + heroname);
            }
            return ret;
        }

        //获得基础血量
        getBasehp(heroname) {
            let info = this.getHeroConfig(heroname);
            if ((info == null)) {
                console.error("getBasehp:" + heroname);
            }
            let ret = info["hp"];
            if (ret == null) {
                console.error("getBasehp:" + heroname);
            }
            return ret;
        }
        //获得绝招
        getBaseJuezhao(heroname){
            let info = this.getHeroConfig(heroname);
            if ((info == null)) {
                console.error("getBaseSpeed:" + heroname);
            }
            let ret = info.juezhao;
            if (ret == null) {
                console.error("getBaseSpeed:" + heroname);
            }
            return ret;
        }
        //获得基础移速
        getBaseSpeed(heroname) {
            let info = this.getHeroConfig(heroname);
            if ((info == null)) {
                console.error("getBaseSpeed:" + heroname);
            }
            let ret = info.runSpeed;
            if (ret == null) {
                console.error("getBaseSpeed:" + heroname);
            }
            return ret;
        }

        getBasemiss(heroname) {
            let info = this.getHeroConfig(heroname);
            if ((info == null)) {
                console.error("getBasemiss:" + heroname);
            }
            let ret = info["dodgeRate"];
            if (ret == null) {
                console.error("getBasemiss:" + heroname);
            }
            return ret;
        }

        //天赋基础cd 不升级  玩家和 怪物公用
        getBasecd(heroname) {
            return 0;
        }

        //基础防御力
        getBasesdefense(heroname) {
            let info = this.getHeroConfig(heroname);
            if ((info == null)) {
                console.error("getBasesdefense:" + heroname);
            }
            let ret = info["defencePoint"];
            if (ret == null) {
                console.error("getBasemiss:" + heroname);
            }
            return ret;
        }


        //获得解锁的英雄
        getUnLockedHero(): Array<string> {
            let datalist = new Array();
            fileMgr.getMe().m_hero_save_data_Map.forEach(function (data: hero_save_data_s, key: string) {
                if (data.islocked == 0) {
                    datalist.push(key);
                }
            }, this);


            return datalist;
        }

        //获得英雄解锁数量
        getHeroUnLockNum():number {
            let unLockNum = 0;
            fileMgr.getMe().m_hero_save_data_Map.forEach(function (data: hero_save_data_s, key: string) {
                if (data.islocked == 0) {
                    unLockNum++;
                }
            }, this);
            return unLockNum;
        }

        isBoss(name) {
            if (game.g_monster_config[name] == null) {
                console.log("error   g_monster_config 没有这个随从" + name);
                console.error("error isBoss 没有这个角色" + name);
            }
            if(g_monster_config[name]["type"] == "boss"){
                return true;
            }
            return false;
        }


        //获取技能信息
        getSkillInfo(heroname, skillname):skill_struct {
            if (game.g_player_skill[heroname] == null) {
                console.error("error getSkillInfo 没有这个角色 " + heroname);
            }
            let ret:skill_struct = g_player_skill[heroname][skillname];
            if (ret == null) {
                console.error("getSkillInfo:" + heroname);
            }
            return ret;
        }


        // 向导是否完成
        isFinishxiangdao(id) {
            let ret = fileMgr.getMe().m_play_doc["yindaos"][id]["lock"];
            if (ret == null) {
                console.error("isFinishxiangdao:" + id);
                return false;
            }
            if (!ret) {
                return false;
            }
            return true;
        }

        // 完成向导id
        finishxiangdao(id) {
            let ret = fileMgr.getMe().m_play_doc["yindaos"][id]["lock"];
            if (ret == null) {
                console.error("isFinishxiangdao:" + id);
                return false;
            }
            fileMgr.getMe().m_play_doc["yindaos"][id]["lock"] = 1;
            return true;
        }

        getChengjiuInfoById(id) {
            let ret = fileMgr.getMe().m_play_doc["chengjius"][id];
            if (ret == null) {
                console.error("getChengjiuInfoById:" + id);
            }
            return ret;
        }

        finishChengjiu(id) {
            let ret = fileMgr.getMe().m_play_doc["chengjius"][id];
            if (ret == null) {
                console.error("finishChengjiu:" + id);
            }
            fileMgr.getMe().m_play_doc["chengjius"][id]["over"] = 2;
        }


        getSceneDocById(id: number): play_doc_scene {
            for (var i = 0; i < fileMgr.getMe().m_scenesMsg_Map.size; ++i) {
                var data = fileMgr.getMe().m_scenesMsg_Map.getByIndex(i);
                if (data.id == id) {
                    return data;
                }
            }
            return null;
        }

        //获得场景存档信息
        getSceneDocInfo(scenename: string): play_doc_scene {
            let ret = fileMgr.getMe().m_scenesMsg_Map.get(scenename);// ["scenes"][scenename];
            if (ret == null) {
                console.error("getSceneDocInfo:");
            }
            return ret;
        }
        //
        // //获得场景存档信息
        // getSceneDocInfo(scenename) {
        //     let ret = fileMgr.getMe().m_play_doc["scenes"][scenename];
        //     if (ret == null) {
        //         console.error("getSceneDocInfo:");
        //     }
        //     return ret;
        // }

        setWinBySceneName(name,flag){
            let ret = fileMgr.getMe().m_scenesMsg_Map.get(name);
            if (ret == null) {
                console.error("getSceneDocInfo:");
            }
            ret.isWined = flag;
        }

        isWinBySceneName(name){
            let ret = fileMgr.getMe().m_scenesMsg_Map.get(name);
            if (ret == null) {
                console.error("getSceneDocInfo:");
            }
            return ret.isWined;
        }

        getCurFollow(): Array<string> {
            return this.getPlayDoc().coreData.curFollower;
        }

        setCurFollow(name:Array<string>) {
            this.getPlayDoc().coreData.curFollower = name;
        }

        getCurHero(): string {
            return this.getPlayDoc().coreData.curHero;
        }

        setCurHero(name: string) {
            return this.getPlayDoc().coreData.curHero = name;
        }

        getOneRandBoss() {
            var arr = new Array();
            for (let p in g_monster_config) {
                if (g_monster_config[p]["type"] == "boss") {
                    if(p.indexOf("wulingwang") == -1)
                    arr.push(p);
                }
            }
            var ret = public_rand_array(arr, 1);
            return ret[0];
        }
    }

}
//# sourceMappingURL=dataMgr.js.map