/**
 * Created by cy1234 on 2016/7/30.
 */
//
// 状态机控制管理
//

module game {
    export class baseStateControl {
        m_cur_RoleAiState: baseState = null;
        m_Ai_map_1: Map<e_AiType,baseState> = null;
        m_roleObj: baseRole = null;

        constructor(playObj: baseRole) {
            this.m_roleObj = playObj;
            this.m_Ai_map_1 = new Map<e_AiType,baseState>();
        }

        init() {
        }

        getRoleObj(): baseRole {
            return this.m_roleObj;
        }

        getCurStateInfo(): baseState {
            return this.m_cur_RoleAiState;
        }

        initState() {
        }

        addState(data: baseState, type: e_AiType = null) {

            if (data == null) {
                return;
            }

            if (type == null) {
                if (this.m_Ai_map_1 == null) {
                    this.m_Ai_map_1.set(data.m_stateType, data);
                }
                if (data.m_stateType) {
                    this.m_Ai_map_1.set(data.m_stateType, data);
                }
                else {
                    this.m_Ai_map_1.set(data.m_stateType, data);
                }

            }
            else {
                this.m_Ai_map_1.set(type, data);
            }
        }

        getState(type:e_AiType):baseState {
            return this.m_Ai_map_1.get(type);
        }

        //强制切换状态
        changeState_Ex(key: e_AiType, data: any = null) {
            this.m_cur_RoleAiState.ExternalEvent(key, data);
            var buffai = this.m_Ai_map_1.get(key);
            if (buffai == null) {
                return true;
            }
            if (buffai.InternalEvent(key, data)) {
                this.m_cur_RoleAiState = buffai;
                return true;
            }
        }

        changeState(key: e_AiType, in_data: any = null) {
            // if(this.m_roleObj instanceof monster){
            // //
            //     console.log(  this.m_roleObj.getName() +"的状态是:"+  g_AiType.getAiTypeStr( key ) );
            //     if (this.m_roleObj.m_monsterAiControl.getAttackTarget())
            //         console.log( this.m_roleObj.getName() +"的目标是:"+ this.m_roleObj.m_monsterAiControl.getAttackTarget().getName() );
            // }

            var buffAi = this.m_Ai_map_1.get(key);
            if (buffAi == null) {
                console.log("  changeState!  没有這个状态:" + g_AiType.getAiTypeStr(key));
                return false;
            }
            if(this.getCurStateType() == e_AiType.g_AiType_yun && this.m_roleObj.m_buffControl.isFaint()){
                return false;
            }
            if (!this.m_cur_RoleAiState.ExternalEvent(key, in_data)) {
                //console.log("  changeState!  当前状态不退出:" + this.getCurStateType() );
                return false;
            }
            if (buffAi.InternalEvent == null) {
                console.log("changeState!");
                return false;
            }
            if (buffAi.InternalEvent(key, in_data)) {
                this.m_cur_RoleAiState = buffAi;
            }
            else {
                this.m_cur_RoleAiState.InternalEvent(key, in_data);
            }
            return true;

        }

        loop(dt) {
            if (this.getRoleObj().isdead()) {
                return;
            }
            this.m_cur_RoleAiState.update(dt);
        }

        shutdown() {
        }

        getCurStateType(): e_AiType {
            if (this.m_cur_RoleAiState == null) {
                return null;
            }
            return this.m_cur_RoleAiState.m_stateType;
        }

        onFrameEvent(type, event) {
            this.m_cur_RoleAiState.onFrameEvent(type, event);
        }
    }
}
