"use strict";
// 事件类
var game;
(function (game) {
    var EventEmitter = (function () {
        function EventEmitter() {
            this.m_eventFunc = null;
            this.m_eventFunc = new game.MapGame();
        }
        EventEmitter.prototype.reset = function () {
            this.m_eventFunc = new game.MapGame();
        };
        EventEmitter.prototype.on = function (name, func) {
            this.reg(name, func);
        };
        EventEmitter.prototype.reg = function (name, func) {
            var ret = this.m_eventFunc.getDataByKey(name);
            if (ret == null) {
                ret = new game.MapGame();
                this.m_eventFunc.put(name, ret);
            }
            func._eventFuncId = game.guid();
            ret.put(func._eventFuncId, func);
        };
        EventEmitter.prototype.unReg = function (name, func) {
            var ret = this.m_eventFunc.getDataByKey(name);
            if (ret) {
                ret.remove(func._eventFuncId);
            }
        };
        EventEmitter.prototype.emit = function (name, data) {
            if (data === void 0) { data = null; }
            if (this.m_eventFunc == null) {
                return;
            }
            var ret = this.m_eventFunc.getDataByKey(name);
            if (ret == null) {
                return;
            }
            for (var i = 0; i < ret.getSize(); ++i) {
                var data_func = ret.getData(i);
                data_func(data);
            }
        };
        return EventEmitter;
    }());
    game.EventEmitter = EventEmitter;
})(game || (game = {}));
//# sourceMappingURL=EventEmitter.js.map 
//# sourceMappingURL=EventEmitter.js.map