"use strict";
// 事件类
module game {
    export class EventEmitter {
        m_eventFunc: any = null;

        constructor() {
            this.m_eventFunc = new game.MapGame();
        }

        reset() {
            this.m_eventFunc = new game.MapGame();
        }

        on(name, func) {
            this.reg(name, func);
        }

        reg(name, func) {
            var ret:MapGame = this.m_eventFunc.getDataByKey(name);
            if (ret == null) {
                ret = new game.MapGame();
                this.m_eventFunc.put(name, ret);
            }
            func._eventFuncId = guid();
            ret.put(func._eventFuncId, func);
        }

        unReg( name ,func) {
            var ret = this.m_eventFunc.getDataByKey(name);
            if (ret) {
                ret.remove(func._eventFuncId);
            }
        }

        emit(name, data:any = null) {
            if (this.m_eventFunc == null) {
                return;
            }
            var ret = this.m_eventFunc.getDataByKey(name);
            if (ret == null) {
                return;
            }
            for (var i = 0; i < ret.getSize(); ++i) {
                var data_func = ret.getData(i);
                data_func(data);
            }
        }
    }

}

//# sourceMappingURL=EventEmitter.js.map