var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var game;
(function (game) {
    var spineObj = (function (_super) {
        __extends(spineObj, _super);
        function spineObj() {
            _super.apply(this, arguments);
            this.m_res = "";
            this.m_SpineNode = null;
            this.m_roledir = -1;
        }
        spineObj.prototype.setTimeScale = function (per) {
            if (this.m_SpineNode) {
                this.m_SpineNode.setTimeScale(per);
            }
        };
        spineObj.prototype.shutdown = function () {
            // spineMgr.getMe().deleteBuffSpine(this.m_SpineNode);
            console.log("卸载资源" + this.m_res);
        };
        //重置
        spineObj.prototype.reset = function () {
            if (this.m_SpineNode) {
                this.removeChild(this.m_SpineNode.getNode());
            }
            this.m_res = ""; //spine 资源名
            this.m_SpineNode = null;
            this.m_roledir = -1; // -1 :左边 1: 右边  // 朝向
        };
        spineObj.prototype.loadres = function (res, animationName) {
            this.m_res = res;
            this.m_SpineNode = game.spineMgr.getMe().loadSpine(res, this.getNode(), 4);
            //this.addChild(this.m_SpineNode.getNode(), 4);
            this.setRoleDir(this.m_roledir);
            this.playAnimation(animationName);
            this.m_SpineNode.setStartListener(function (trackIndex) {
                this.onFrameEvent("Start");
            }.bind(this));
            this.m_SpineNode.setEndListener(function (traceIndex) {
                this.onFrameEvent("End");
            }.bind(this));
            this.m_SpineNode.setCompleteListener(function (traceIndex, loopCount) {
                this.onFrameEvent("Complete");
            }.bind(this));
            this.m_SpineNode.setEventListener(function (traceIndex, event) {
                this.onFrameEvent("event", event);
            }.bind(this));
            this.setRootState(1);
            return true;
        };
        spineObj.prototype.isPlay = function () {
            return this.m_SpineNode.isPlay();
        };
        spineObj.prototype.zanting = function (falg) {
            if (falg)
                this.m_SpineNode.pause();
            else {
                this.m_SpineNode.resume();
            }
        };
        spineObj.prototype.onFrameEvent = function (type, event) {
            //if (type == "event") {
            //    if (event.data.name.indexOf(".mp3") >= 0) {
            //        musicMgr.getMe().playeffect(event.data.name);
            //    }
            //}
            if ("Complete" == type) {
                this.onComplete();
            }
        };
        spineObj.prototype.onComplete = function (traceIndex, loopCount) {
            if (traceIndex === void 0) { traceIndex = null; }
            if (loopCount === void 0) { loopCount = null; }
        };
        //朝向
        spineObj.prototype.setRoleDir = function (dir) {
            this.m_roledir = dir;
            var nowScale = this.m_SpineNode.getScale();
            if (nowScale < 0) {
                nowScale = -nowScale;
            }
            this.m_SpineNode.setScaleX(nowScale * dir);
        };
        //控制角色方向
        spineObj.prototype.setDir = function (dir) {
            if (dir > 0) {
                this.setRoleDir(1);
            }
            else {
                this.setRoleDir(-1);
            }
        };
        spineObj.prototype.setRolePosition = function (x, y) {
            this.m_SpineNode.setPosition(cc.p(x, y));
        };
        spineObj.prototype.update = function (dt) {
        };
        spineObj.prototype.playAnimation = function (name, loop, mix, mintime, b_setToSetupPose) {
            if (loop === void 0) { loop = null; }
            if (mix === void 0) { mix = null; }
            if (mintime === void 0) { mintime = null; }
            if (b_setToSetupPose === void 0) { b_setToSetupPose = null; }
            var ret = this.m_SpineNode.setAnimation(0, name, loop);
            if (ret == null) {
                game.uiMgr.getMe().show_ui_MessageBox(true, "没有动画" + name + "怪物" + this.m_res);
            }
        };
        spineObj.prototype.setRootState = function (flag) {
            if (cc.sys.isNative) {
                if (!this.m_SpineNode) {
                    return;
                }
                this.m_SpineNode.SetBoneData("root", flag);
            }
            else {
                if (!this.m_SpineNode) {
                    return;
                }
                var pspBone = this.m_SpineNode.findBone("root");
                if (!pspBone) {
                    return;
                }
                pspBone.isMoveX = flag;
                pspBone.isMoveY = flag;
            }
        };
        spineObj.prototype.getRootPosition = function () {
            return this.m_SpineNode.getBoneWorldPos("bone");
        };
        spineObj.prototype.getBone_RelativePos = function () {
            return this.m_SpineNode.getBone_RelativePos("bone");
        };
        spineObj.prototype.setPositionEx = function (position) {
            this.setPosition(position);
            return true;
        };
        return spineObj;
    }(game.xjNode));
    game.spineObj = spineObj;
})(game || (game = {}));
//# sourceMappingURL=spinebaseObj.js.map 
//# sourceMappingURL=spinebaseObj.js.map