module game {
   export class spineObj extends xjNode{
        m_res:any =  "";
        m_SpineNode: SkeletonAnimation_Ex = null;
        m_roledir: any = -1;


        setTimeScale (per) {
            if (this.m_SpineNode) {
                this.m_SpineNode.setTimeScale(per);
            }
        }
        shutdown ()
        {
            // spineMgr.getMe().deleteBuffSpine(this.m_SpineNode);
            console.log("卸载资源" + this.m_res);
        }
        //重置
        reset () {
            if (this.m_SpineNode) {
                this.removeChild(this.m_SpineNode.getNode());
            }
            this.m_res = ""; //spine 资源名
            this.m_SpineNode = null;
            this.m_roledir = -1; // -1 :左边 1: 右边  // 朝向
        }
        loadres (res, animationName):any {
            this.m_res = res;
            this.m_SpineNode = game.spineMgr.getMe().loadSpine( res ,this.getNode(), 4);
            //this.addChild(this.m_SpineNode.getNode(), 4);
            this.setRoleDir(this.m_roledir);
            this.playAnimation(animationName);
            this.m_SpineNode.setStartListener(function (trackIndex) {
                this.onFrameEvent("Start");
            }.bind(this));
            this.m_SpineNode.setEndListener(function (traceIndex) {
                this.onFrameEvent("End");
            }.bind(this));
            this.m_SpineNode.setCompleteListener(function (traceIndex, loopCount) {
                this.onFrameEvent("Complete");
            }.bind(this));
            this.m_SpineNode.setEventListener(function (traceIndex, event) {
                this.onFrameEvent("event", event);
            }.bind(this));
            this.setRootState(1);
            return true;
        }
        isPlay () {
            return this.m_SpineNode.isPlay();
        }
        zanting (falg) {
            if (falg)
                this.m_SpineNode.pause();
            else {
                this.m_SpineNode.resume();
            }
        }
        onFrameEvent (type, event) {
            //if (type == "event") {
            //    if (event.data.name.indexOf(".mp3") >= 0) {
            //        musicMgr.getMe().playeffect(event.data.name);
            //    }
            //}
            if ("Complete" == type) {
                this.onComplete();
            }
        }
        onComplete (traceIndex:any = null, loopCount:any = null ) {
        }
        //朝向
        setRoleDir (dir) {
            this.m_roledir = dir;
            var nowScale = this.m_SpineNode.getScale();
            if (nowScale < 0) {
                nowScale = -nowScale;
            }
            this.m_SpineNode.setScaleX(nowScale * dir);
        }
        //控制角色方向
        setDir (dir) {
            if (dir > 0) {
                this.setRoleDir(1);
            }
            else {
                this.setRoleDir(-1);
            }
        }
        setRolePosition (x, y) {
            this.m_SpineNode.setPosition(cc.p(x, y));
        }
        update (dt) {
        }
        playAnimation (name, loop:any = null, mix:any = null, mintime:any = null, b_setToSetupPose:any = null) {
            var ret = this.m_SpineNode.setAnimation(0, name, loop);
            if (ret == null) {
                game.uiMgr.getMe().show_ui_MessageBox(true, "没有动画" + name + "怪物" + this.m_res);
            }
        }
        setRootState (flag) {
            if (cc.sys.isNative) {
                if (!this.m_SpineNode) {
                    return;
                }
                this.m_SpineNode.SetBoneData("root", flag);
            }
            else {
                if (!this.m_SpineNode) {
                    return;
                }
                var pspBone = this.m_SpineNode.findBone("root");
                if (!pspBone) {
                    return;
                }
                pspBone.isMoveX = flag;
                pspBone.isMoveY = flag;
            }
        }
        getRootPosition () {
            return this.m_SpineNode.getBoneWorldPos("bone");
        }
        getBone_RelativePos () {
            return this.m_SpineNode.getBone_RelativePos("bone");
        }
        setPositionEx (position) {
            this.setPosition(position);
            return true;
        }
    }
}
//# sourceMappingURL=spinebaseObj.js.map