var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
// 定时器
// 不能用于一次性定时器 退出必须调用shutdown
var game;
(function (game) {
    var baseTime = (function (_super) {
        __extends(baseTime, _super);
        function baseTime() {
            _super.call(this);
            this.m_events = null;
            this.m_loopTime = 1000 * 0.016666;
            this.m_cur_time = null;
            this.m_Interval_id = -1;
        }
        baseTime.prototype.onLoop = function (func) {
            this.reg('loop', func);
        };
        baseTime.prototype.outLoop = function (func) {
            this.unReg('loop', func);
        };
        baseTime.prototype.init = function (_loop, IntervalTime) {
            if (this.m_Interval_id != -1) {
                return;
            }
            this.m_loopTime = IntervalTime * 1000;
            this.m_cur_time = Date.now();
            this.m_Interval_id = setInterval(this.loop.bind(this), this.m_loopTime);
            if (_loop) {
                this.on('loop', _loop);
            }
            this.loop.bind(this);
        };
        baseTime.prototype.shutdown = function () {
            clearInterval(this.m_Interval_id);
            this.m_Interval_id = -1;
        };
        baseTime.prototype.loop = function () {
            var nowtime = Date.now();
            var t = nowtime - this.m_cur_time;
            this.m_cur_time = nowtime;
            var elapsed = t / 1000;
            this.emit("loop", elapsed);
        };
        return baseTime;
    }(game.EventEmitter));
    game.baseTime = baseTime;
    var timingControl = (function (_super) {
        __extends(timingControl, _super);
        function timingControl() {
            _super.apply(this, arguments);
        }
        return timingControl;
    }(game.baseTime));
    game.timingControl = timingControl;
    var timingOnce = (function (_super) {
        __extends(timingOnce, _super);
        function timingOnce() {
            _super.apply(this, arguments);
        }
        timingOnce.prototype.loop = function () {
            _super.prototype.loop.call(this);
            this.shutdown();
        };
        return timingOnce;
    }(game.baseTime));
    game.timingOnce = timingOnce;
})(game || (game = {}));
//# sourceMappingURL=timersMgr.js.map 
//# sourceMappingURL=timersMgr.js.map