// 定时器
// 不能用于一次性定时器 退出必须调用shutdown
module game {
    export class baseTime extends EventEmitter {
        m_events: any = null;
        m_loopTime: any = 1000 * 0.016666;
        m_cur_time: any = null;
        m_Interval_id: any = -1;

        constructor() {
            super();
        }

        onLoop(func) {
            this.reg('loop', func);
        }

        outLoop(func) {
            this.unReg('loop', func);
        }

        init(_loop, IntervalTime) {
            if (this.m_Interval_id != -1) {
                return;
            }
            this.m_loopTime = IntervalTime * 1000;
            this.m_cur_time = Date.now();
            this.m_Interval_id = setInterval(this.loop.bind(this), this.m_loopTime);
           if(_loop)
           {
               this.on('loop', _loop);
           }


            this.loop.bind(this);
        }

        shutdown() {
            clearInterval(this.m_Interval_id);
            this.m_Interval_id = -1;
        }

        loop() {
            var nowtime = Date.now();
            var t = nowtime - this.m_cur_time;
            this.m_cur_time = nowtime;
            var elapsed = t / 1000;
            this.emit("loop", elapsed);
        }
    }
    export class timingControl extends game.baseTime {

    }


    export class timingOnce extends game.baseTime {
        loop() {
            super.loop();
            this.shutdown();
        }
    }
}
//# sourceMappingURL=timersMgr.js.map