var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
/**
 *  子弹基础类
 */
var game;
(function (game) {
    var baseBullet = (function (_super) {
        __extends(baseBullet, _super);
        function baseBullet() {
            _super.call(this);
            this.m_RoleType = game.g_bulletRoleType.bulletType_play;
            this.m_BulletNode = null;
            this.m_dir = cc.p(1, 0);
            this.m_rotation = null;
            this.m_speed = null;
            this.range_dis = 0;
            this.m_info = null;
            this.m_des = null;
            this.m_isAlive = true;
            this.m_bulletType = game.g_bulletType.normal;
            this.m_owner = null;
            this.m_des = "baseBullet";
            this.m_Type = game.g_ObjType.bullet;
            this.getNode().setName("baseBullet类");
        }
        baseBullet.prototype.zanting = function (flag) {
            if (flag) {
                this.m_BulletNode.pause();
            }
            else {
                this.m_BulletNode.resume();
            }
        };
        baseBullet.prototype.initEx = function (info) {
            this.m_info = info;
            this.m_speed = this.m_info.speed;
            this.m_dir = this.m_info.dir;
            this.m_rotation = this.m_info.rotation;
            this.range_dis = this.m_info.range_dis;
            this.m_RoleType = this.m_info.roleType;
            this.m_owner = this.m_info.affector;
            //加载资源
            this.loadres();
            this.setPosition(this.m_info.pos);
            //m_dir
            if (this.m_rotation) {
                this.setRotation(this.m_rotation); //
            }
        };
        baseBullet.prototype.shutdown = function () {
            this.m_isAlive = false;
            // spineMgr.getMe().deleteBuffSpine( this.m_BulletNode  );
        };
        baseBullet.prototype.loadres = function () {
            this.m_BulletNode = game.spineMgr.getMe().loadSpine(this.m_info["res"], this.getNode(), 4);
            if (this.m_info["resAnimation"]) {
                this.m_BulletNode.setAnimation(0, this.m_info["resAnimation"], true);
            }
            else {
                this.m_BulletNode.setAnimation(0, "play", true);
            }
            //this.addChild(this.m_BulletNode.getNode(), 4);
            this.m_BulletNode.setScale(this.m_info.scale);
            if (this.m_dir.x < 0) {
                this.m_BulletNode.setScaleX(-1 * this.m_info.scale);
            }
            return true;
        };
        baseBullet.prototype.update = function (dt) {
            return this.loopMove(dt);
        };
        // 移动
        baseBullet.prototype.loopMove = function (dt) {
            if (this.m_isAlive == false) {
                return false;
            }
            //
            var pos = this.getPosition();
            var newpos = cc.pAdd(pos, cc.pMult(this.m_dir, this.m_speed * dt));
            //处理射程
            var dis = cc.pDistance(this.m_info.pos, newpos);
            if (dis > this.range_dis) {
                this.m_isAlive = false;
                return true;
            }
            //处理碰撞
            var ret = false;
            if (this.m_RoleType == game.g_bulletRoleType.bulletType_monster) {
                ret = this.loopphy_monster(pos, newpos);
            }
            else {
                ret = this.loopphy(pos, newpos);
            }
            //
            this.setPosition(newpos);
            return ret;
        };
        // 子弹阻挡名 是 gongjizudang 通用特效阻挡名 gongjizudang1
        baseBullet.prototype.getPhyRect = function () {
            var rectme_qugan = this.m_BulletNode.getBoundingBoxBySlotName("gongjizudang");
            return rectme_qugan;
        };
        // 碰撞 玩家子弹碰撞
        baseBullet.prototype.loopphy = function (pos, newpos) {
            if (this.m_owner == null)
                return;
            var monsterMap = this.m_owner.getenemy();
            // let dis = cc.pDistance(pos, newpos);
            //let damageInfo = this.m_info["hit"]["shanghai1"];
            //let minY = damageInfo.subY;
            //let maxY = damageInfo.addY;
            var rect_bullet = this.getPhyRect();
            var m_pos_bullet = this.getPosition();
            for (var monsterCount = 0; monsterCount < monsterMap.size; ++monsterCount) {
                var monsterObj = monsterMap.getByIndex(monsterCount);
                if (monsterObj.getCurStateType() == game.e_AiType.g_AiType_dead_zhuolu) {
                    continue;
                }
                if (monsterObj.getCurStateType() == game.e_AiType.g_AiType_Dead) {
                    continue;
                }
                var monsterpos = monsterObj.getPosition();
                var dis = cc.pDistance(m_pos_bullet, monsterpos);
                if (dis > rect_bullet.width + 120) {
                    return;
                }
                var _rectIntersectsRect = cc.rectIntersectsRect(monsterObj.getshoujizudang(), rect_bullet);
                if (_rectIntersectsRect) {
                    //let y = monsterObj.getPositionY() - this.m_owner.getPositionY();
                    //if (y > -minY && y < maxY) {
                    this.phyParse(monsterObj);
                }
            }
            return true;
        };
        baseBullet.prototype.loopphy_monster = function (pos, newpos) {
            if (this.m_owner != null) {
                var enemylist = this.m_owner.getenemy();
                // let damageInfo = this.m_info["hit"]["shanghai1"];
                // let minY = damageInfo.subY;
                // let maxY = damageInfo.addY;
                var rect_bullet = this.getPhyRect();
                var m_pos_bullet = this.getPosition();
                for (var enemyCount = 0; enemyCount < enemylist.size; ++enemyCount) {
                    var playerObj = enemylist.getByIndex(enemyCount);
                    if (playerObj.getCurStateType() == game.e_AiType.g_AiType_dead_zhuolu) {
                        continue;
                    }
                    if (playerObj.getCurStateType() == game.e_AiType.g_AiType_Dead) {
                        continue;
                    }
                    var monsterpos = playerObj.getPosition();
                    var dis = cc.pDistance(m_pos_bullet, monsterpos);
                    if (dis > rect_bullet.width + 120) {
                        return;
                    }
                    var _rectIntersectsRect = cc.rectIntersectsRect(playerObj.getshoujizudang(), rect_bullet);
                    if (_rectIntersectsRect) {
                        var y = playerObj.getPositionY() - this.m_owner.getPositionY();
                        // if (y > -minY && y < maxY)
                        {
                            this.phyParse(playerObj);
                        }
                    }
                }
            }
            return true;
        };
        //碰撞到了后的处理  (撞到玩家身体)
        baseBullet.prototype.phyParse = function (obj) {
            if (this.m_isAlive == false)
                return;
            this.m_isAlive = false;
            var damageInfo = this.m_info["hit"]["shanghai1"];
            // spineMgr.getMe().createSpineOncePlay( damageInfo.spineName , damageInfo.animationName , roleMgr.getMe(), this.getPosition(), this.getLocalZOrder() );
            //与 受到伤害的特效处理 重复
            //dealDamageEffect (plistEffect, effectSpineName, effectAnimationName) {
            obj.dealDamageEffect(damageInfo.spineName, damageInfo.animationName);
        };
        baseBullet.prototype.playAnimation = function (name, loop) {
            this.m_BulletNode.setAnimation(0, name, loop);
        };
        //被打中  (撞到玩家武器)
        baseBullet.prototype.onHit = function () {
            //子弹能被打爆
            if (this.m_info["hitType"] == null) {
                return;
            }
            if (this.m_info["hitType"] == "bomb") {
                this.m_isAlive = false;
                var damageInfo = this.m_info["hit"]["shanghai1"];
                game.spineMgr.getMe().createSpineOncePlay(damageInfo.spineName, damageInfo.animationName, game.roleMgr.getMe().getNode(), this.getPosition(), this.getLocalZOrder());
            }
        };
        return baseBullet;
    }(game.baseObj));
    game.baseBullet = baseBullet;
})(game || (game = {}));
//# sourceMappingURL=baseBullet.js.map 
//# sourceMappingURL=baseBullet.js.map