/**
 *  子弹基础类
 */
module game {

    export class baseBullet extends baseObj {
        m_RoleType: any = g_bulletRoleType.bulletType_play;
        m_BulletNode: SkeletonAnimation_Ex = null;
        m_dir: any = cc.p(1, 0);
        m_rotation: any = null;
        m_speed: any = null;
        range_dis: any = 0;
        m_info: any = null;
        m_des: any = null;
        m_isAlive: any = true;
        m_bulletType: any = g_bulletType.normal;
        m_owner: baseRole = null;


        constructor() {
            super();
            this.m_des = "baseBullet";
            this.m_Type = g_ObjType.bullet;
            this.getNode().setName("baseBullet类");
        }


        zanting(flag) {
            if (flag) {
                this.m_BulletNode.pause();
            }
            else {
                this.m_BulletNode.resume();
            }
        }

        initEx(info) {

            this.m_info = info;
            this.m_speed = this.m_info.speed;
            this.m_dir = this.m_info.dir;
            this.m_rotation = this.m_info.rotation;
            this.range_dis = this.m_info.range_dis;
            this.m_RoleType = this.m_info.roleType;
            this.m_owner = this.m_info.affector;

            //加载资源
            this.loadres();
            this.setPosition(this.m_info.pos);
            //m_dir
            if (this.m_rotation) {
                this.setRotation(this.m_rotation); //
            }
        }

        shutdown() {
            this.m_isAlive = false;
            // spineMgr.getMe().deleteBuffSpine( this.m_BulletNode  );
        }

        loadres() {
            this.m_BulletNode = spineMgr.getMe().loadSpine(this.m_info["res"], this.getNode(), 4);
            if (this.m_info["resAnimation"]) {
                this.m_BulletNode.setAnimation(0, this.m_info["resAnimation"], true);
            }
            else {
                this.m_BulletNode.setAnimation(0, "play", true);
            }
            //this.addChild(this.m_BulletNode.getNode(), 4);
            this.m_BulletNode.setScale(this.m_info.scale);
            if (this.m_dir.x < 0) {
                this.m_BulletNode.setScaleX(-1 * this.m_info.scale);
            }
            return true;
        }

        update(dt: number) {
            return this.loopMove(dt);
        }

        // 移动
        loopMove(dt: number) {
            if (this.m_isAlive == false) {
                return false;
            }
            //
            let pos = this.getPosition();
            let newpos = cc.pAdd(pos, cc.pMult(this.m_dir, this.m_speed * dt));
            //处理射程
            let dis = cc.pDistance(this.m_info.pos, newpos);
            if (dis > this.range_dis) {
                this.m_isAlive = false;
                return true;
            }
            //处理碰撞
            let ret = false;
            if (this.m_RoleType == g_bulletRoleType.bulletType_monster) {
                ret = this.loopphy_monster(pos, newpos);
            }
            else {
                ret = this.loopphy(pos, newpos);
            }
            //
            this.setPosition(newpos);
            return ret;
        }









        // 子弹阻挡名 是 gongjizudang 通用特效阻挡名 gongjizudang1
        getPhyRect():cc.Rect
        {

            let rectme_qugan = this.m_BulletNode.getBoundingBoxBySlotName("gongjizudang");
            return rectme_qugan;
        }

        // 碰撞 玩家子弹碰撞
        loopphy(pos, newpos) {
            if (this.m_owner == null)
                return;

            let monsterMap: Map< number,baseRole > = this.m_owner.getenemy();
            // let dis = cc.pDistance(pos, newpos);

            //let damageInfo = this.m_info["hit"]["shanghai1"];
            //let minY = damageInfo.subY;
            //let maxY = damageInfo.addY;

            let rect_bullet: cc.Rect = this.getPhyRect();
            let m_pos_bullet: cc.Vec2 = this.getPosition();

            for (let monsterCount = 0; monsterCount < monsterMap.size; ++monsterCount) {
                let monsterObj = monsterMap.getByIndex(monsterCount);
                if (monsterObj.getCurStateType() == e_AiType.g_AiType_dead_zhuolu) {
                    continue;
                }
                if (monsterObj.getCurStateType() == e_AiType.g_AiType_Dead) {
                    continue;
                }

                let monsterpos = monsterObj.getPosition();
                let dis = cc.pDistance(m_pos_bullet, monsterpos);
                if (dis > rect_bullet.width + 120) {
                    return;
                }

                let _rectIntersectsRect = cc.rectIntersectsRect(monsterObj.getshoujizudang(), rect_bullet);
                if (_rectIntersectsRect) {
                    //let y = monsterObj.getPositionY() - this.m_owner.getPositionY();
                    //if (y > -minY && y < maxY) {
                        this.phyParse(monsterObj);
                    //}
                }
            }


            return true;
        }

        loopphy_monster(pos, newpos) {
            if (this.m_owner != null) {
                let enemylist: Map< number,baseRole > = this.m_owner.getenemy();

                // let damageInfo = this.m_info["hit"]["shanghai1"];
                // let minY = damageInfo.subY;
                // let maxY = damageInfo.addY;


                let rect_bullet: cc.Rect = this.getPhyRect();
                let m_pos_bullet: cc.Vec2 = this.getPosition();

                for (let enemyCount = 0; enemyCount < enemylist.size; ++enemyCount) {
                    let playerObj = enemylist.getByIndex(enemyCount);
                    if (playerObj.getCurStateType() == e_AiType.g_AiType_dead_zhuolu) {
                        continue;
                    }
                    if (playerObj.getCurStateType() == e_AiType.g_AiType_Dead) {
                        continue;
                    }

                    let monsterpos = playerObj.getPosition();
                    let dis = cc.pDistance(m_pos_bullet, monsterpos);
                    if (dis > rect_bullet.width + 120) {
                        return;
                    }

                    let _rectIntersectsRect = cc.rectIntersectsRect(playerObj.getshoujizudang(), rect_bullet);
                    if (_rectIntersectsRect) {
                        let y = playerObj.getPositionY() - this.m_owner.getPositionY();
                      // if (y > -minY && y < maxY)
                        {
                            this.phyParse(playerObj);
                        }
                    }
                }
            }
            return true;
        }

        //碰撞到了后的处理  (撞到玩家身体)
        phyParse(obj) {
            if (this.m_isAlive == false)
                return;
            this.m_isAlive = false;
            let damageInfo = this.m_info["hit"]["shanghai1"];
            // spineMgr.getMe().createSpineOncePlay( damageInfo.spineName , damageInfo.animationName , roleMgr.getMe(), this.getPosition(), this.getLocalZOrder() );
            //与 受到伤害的特效处理 重复
            //dealDamageEffect (plistEffect, effectSpineName, effectAnimationName) {
            obj.dealDamageEffect(damageInfo.spineName, damageInfo.animationName);
        }

        playAnimation(name, loop) {
            this.m_BulletNode.setAnimation(0, name, loop);
        }

        //被打中  (撞到玩家武器)
        onHit() {
            //子弹能被打爆
            if (this.m_info["hitType"] == null) {
                return;
            }
            if (this.m_info["hitType"] == "bomb") {
                this.m_isAlive = false;
                let damageInfo = this.m_info["hit"]["shanghai1"];
                spineMgr.getMe().createSpineOncePlay(damageInfo.spineName, damageInfo.animationName, roleMgr.getMe().getNode(), this.getPosition(), this.getLocalZOrder());
            }
        }
    }
}
//# sourceMappingURL=baseBullet.js.map