module game {
    export class bulletMgr extends xjNode {

        static getMe  () {
            if (sceneMgr.getMe().m_curScene == null) {
                return null;
            }
            return sceneMgr.getMe().m_curScene.getBulletMgr();
        };
        static create = function (): bulletMgr {
            let _bulletMgr = new bulletMgr();
            return _bulletMgr;
        };

        m_bullet_map: Map< number, baseBullet> = new Map< number, baseBullet>();
        m_des: string = null;


        constructor() {
            super();
            this.m_des = "bulletMgr";
            this.init();
            this.getNode().setName("bulletMgr类");
        }

        init() {
            super.init();
           // this.m_bullet_map = new MapGame();
        }

        update(t) {
            for (let i = 0; i < this.m_bullet_map.size; ++i) {
                let data = this.m_bullet_map.getByIndex(i);
                let ret = data.update(t);
                if (ret == false) {
                    this.removeBullet(data.__instanceId);
                    return;
                }
            }
        }

        shutdown() {
            for (let i = 0; i < this.m_bullet_map.size; ++i) {
                let data = this.m_bullet_map.getByIndex(i);
                data.shutdown();
            }
        }

        zanting(flag) {
            for (let i = 0; i < this.m_bullet_map.size; ++i) {
                let data = this.m_bullet_map.getByIndex(i);
                data.zanting(flag);
            }
        }

        createBullet(info, zOrder) {
            if (info == null) {
                return;
            }
            switch (info.bulletType) {
                case g_bulletType.normal:
                    this.createNormalBullet(info, zOrder);
                    break;
                case g_bulletType.spineline:
                    this.createNormalBulletSpineLine(info, zOrder);
                    break;
                default:
                    uiMgr.getMe().show_ui_MessageBox(true, "bulletType 类型填错了  路线子弹 ：spineline  普通子弹 ：normal  ");
                    // console.error("error createBullet !");
                    break;
            }
        }

        // 创建子弹 普通子弹
        createNormalBullet(info, zOrder) {
            let _normalBullet = normalBullet.create();
            _normalBullet.initEx(info);
            roleMgr.getMe().addChild(_normalBullet.getNode(), zOrder);
            this.m_bullet_map.set(_normalBullet.__instanceId, _normalBullet);
        }

        createNormalBulletSpineLine(info, zOrder) {
            let _normalBullet = normalBulletSpineLine.create();
            _normalBullet.initEx(info);
            roleMgr.getMe().addChild(_normalBullet.getNode(), zOrder);
            this.m_bullet_map.set(_normalBullet.__instanceId, _normalBullet);
        }

        createNormalBullet_texiao(info, zOrder) {
            let _normalBullet = normalBullet_texiao.create();
            _normalBullet.initEx(info);
            roleMgr.getMe().addChild(_normalBullet.getNode(), zOrder);
            this.m_bullet_map.set(_normalBullet.__instanceId, _normalBullet);
        }

        // 移除子弹
        removeBullet(keyStr:number) {
            let data = this.m_bullet_map.get(keyStr);
            data.shutdown();
            roleMgr.getMe().removeChild(data.getNode());
            this.m_bullet_map.delete(keyStr);
        }
    }

}
