module game {
    export class bulletMgr_demo extends xjNode {
        m_bullet_map: MapGame = null;
        m_des: any = null;
        static create = function () {
            var _bulletMgr_demo = new game.bulletMgr_demo();
            return _bulletMgr_demo;
        };

        constructor() {
            super();
            this.m_des = "bulletMgr_demo";
            this.init();
            this.getNode().setName("bulletMgr_demo类");
        }

        init() {
            super.init();
            this.m_bullet_map = new game.MapGame();
        }

        update(t) {
            for (var i = 0; i < this.m_bullet_map.getSize(); ++i) {
                var data = this.m_bullet_map.getData(i);
                var ret = data.update(t);
                if (ret == false) {
                    this.removeBullet(data.__instanceId);
                    return;
                }
            }
        }

        shutdown() {
            for (var i = 0; i < this.m_bullet_map.size(); ++i) {
                var data = this.m_bullet_map.getData(i);
                data.shutdown();
                this.removeBullet(data.__instanceId);
            }
        }

        isPlay() {
            for (var i = 0; i < this.m_bullet_map.size(); ++i) {
                var data = this.m_bullet_map.getData(i);
                if (data.isPlay()) {
                    return true;
                }
            }
            return false;
        }

        zanting(flag) {
            for (var i = 0; i < this.m_bullet_map.size(); ++i) {
                var data = this.m_bullet_map.getData(i);
                data.zanting(flag);
            }
        }

        createBullet(info) {
            if (info == null) {
                return;
            }
            switch (info.bulletType) {
                case game.g_bulletType.normal:
                    this.createNormalBullet(info);
                    break;
                case game.g_bulletType.spineline:
                    this.createNormalBulletSpineLine(info);
                    break;
                default:
                    game.uiMgr.getMe().show_ui_MessageBox(true, "bulletType 类型填错了  路线子弹 ：spineline  普通子弹 ：normal  ");
                    // console.error("error createBullet !");
                    break;
            }
        }

        // 创建子弹 普通子弹
        createNormalBullet(info) {
            var _normalBullet = game.normalBullet_demo.create();
            _normalBullet.initEx(info);
            this.addChild(_normalBullet.getNode(), 2000);
            this.m_bullet_map.put(_normalBullet.__instanceId, _normalBullet);
        }

        createNormalBulletSpineLine(info) {
            var _normalBullet = game.normalBulletSpineLine_demo.create();
            _normalBullet.initEx(info);
            this.addChild(_normalBullet.getNode(), 2000);
            this.m_bullet_map.put(_normalBullet.__instanceId, _normalBullet);
        }

        createNormalBullet_texiao(info) {
            var _normalBullet = game.normalBullet_texiao_demo.create();
            _normalBullet.initEx(info);
            this.addChild(_normalBullet.getNode(), 2000);
            this.m_bullet_map.put(_normalBullet.__instanceId, _normalBullet);
        }

        // 移除子弹
        removeBullet(keyStr) {
            var data = this.m_bullet_map.getDataByKey(keyStr);
            data.shutdown();
            this.removeChild(data.getNode());
            this.m_bullet_map.remove(keyStr);
        }
    }

}
//# sourceMappingURL=bulletMgr_demo.js.map