var game;
(function (game) {
    var Map = (function () {
        function Map() {
            this.m_keys = null;
            this._data = null;
            this.size = 0;
            this.m_keys = new Array();
            this._data = new Object();
        }
        Map.prototype.forEach = function (callbackfn, thisArg) {
            if (typeof callbackfn != 'function') {
                return;
            }
            if (thisArg == null) {
                return;
            }
            var len = this.m_keys.length;
            for (var i = 0; i < len; i++) {
                var k = this.m_keys[i];
                callbackfn.call(thisArg, this._data[k], k, this);
            }
        };
        Map.prototype.delete = function (key) {
            for (var i = 0; i < this.m_keys.length; i++) {
                if (key === this.m_keys[i]) {
                    var del_keys = this.m_keys.splice(i, 1);
                    for (var k in del_keys) {
                        var data = del_keys[k];
                        this._data[data] = null;
                    }
                    this.size = this.m_keys.length;
                    return true;
                }
            }
            return false;
        };
        Map.prototype.getKey = function (index) {
            if (index == null) {
                return null;
            }
            return this.m_keys[index];
        };
        Map.prototype.getByIndex = function (index) {
            for (var i = 0; i < this.m_keys.length; i++) {
                if (index === i) {
                    var keybuff = this.m_keys[i];
                    return this._data[keybuff];
                }
            }
            return null;
        };
        // /**
        //  * 获取某键对应的值
        //  * @param {String} key
        //  * @return {Object} value
        //  */
        Map.prototype.get = function (key) {
            for (var i = 0; i < this.m_keys.length; i++) {
                if (key === this.m_keys[i]) {
                    var keybuff = key;
                    return this._data[keybuff];
                }
            }
            return null;
        };
        Map.prototype.has = function (key) {
            var ret = this.get(key);
            if (ret) {
                return true;
            }
            return false;
        };
        Map.prototype.set = function (key, value) {
            this.delete(key); // 替换掉旧的数据
            this.m_keys.push(key);
            var keybuff = key;
            this._data[keybuff] = value;
            this.sort();
            this.size = this.m_keys.length;
            return true;
        };
        //排序
        Map.prototype.sort = function () {
            // this.m_keys.sort( function (a:K, b:K) {
            //     return b < a;
            // });
        };
        //删除所有数据
        Map.prototype.clear = function () {
            this.m_keys = null;
            this._data = null;
            this.m_keys = new Array();
            this._data = new Object();
            this.size = 0;
        };
        /**
         * 判断Map是否为空
         */
        Map.prototype.isEmpty = function () {
            return this.m_keys.length == 0;
        };
        return Map;
    }());
    game.Map = Map;
    var ObjMap = (function () {
        function ObjMap(obj) {
            if (obj === void 0) { obj = null; }
            this.m_keys = null;
            this._data = null;
            this.size = 0;
            this.m_keys = new Array();
            this._data = new Object();
            if (obj) {
                for (var p in obj) {
                    var data = obj[p];
                    this.set(p, data);
                }
            }
        }
        ObjMap.prototype.getObject = function () {
            var obj = new Object();
            this.forEach(function (v, k) {
                obj[k] = v;
            }, this);
            return obj;
        };
        ObjMap.prototype.forEach = function (callbackfn, thisArg) {
            if (typeof callbackfn != 'function') {
                return;
            }
            if (thisArg == null) {
                return;
            }
            var len = this.m_keys.length;
            for (var i = 0; i < len; i++) {
                var k = this.m_keys[i];
                callbackfn.call(thisArg, this._data[k], k, this);
            }
        };
        ObjMap.prototype.delete = function (key) {
            for (var i = 0; i < this.m_keys.length; i++) {
                if (key === this.m_keys[i]) {
                    var del_keys = this.m_keys.splice(i, 1);
                    for (var k in del_keys) {
                        var data = del_keys[k];
                        this._data[data] = null;
                        this.size = this.m_keys.length;
                    }
                    return true;
                }
            }
            return false;
        };
        // /**
        //  * 获取某键对应的值
        //  * @param {String} key
        //  * @return {Object} value
        //  */
        ObjMap.prototype.get = function (key) {
            for (var i = 0; i < this.m_keys.length; i++) {
                if (key === this.m_keys[i]) {
                    var keybuff = key;
                    return this._data[keybuff];
                }
            }
            return null;
        };
        ObjMap.prototype.getByIndex = function (index) {
            for (var i = 0; i < this.m_keys.length; i++) {
                if (index === i) {
                    var keybuff = this.m_keys[i];
                    return this._data[keybuff];
                }
            }
            return null;
        };
        ObjMap.prototype.has = function (key) {
            var ret = this.get(key);
            if (ret) {
                return true;
            }
            return false;
        };
        ObjMap.prototype.set = function (key, value) {
            this.delete(key); // 替换掉旧的数据
            this.m_keys.push(key);
            var keybuff = key;
            this._data[keybuff] = value;
            this.sort();
            this.size = this.m_keys.length;
            return true;
        };
        //排序
        ObjMap.prototype.sort = function () {
            // this.m_keys.sort( function (a:K, b:K) {
            //     return b < a;
            // });
        };
        //删除所有数据
        ObjMap.prototype.clear = function () {
            this.m_keys = null;
            this._data = null;
            this.m_keys = new Array();
            this._data = new Object();
            this.size = 0;
        };
        /**
         * 判断Map是否为空
         */
        ObjMap.prototype.isEmpty = function () {
            return this.m_keys.length == 0;
        };
        return ObjMap;
    }());
    game.ObjMap = ObjMap;
})(game || (game = {}));
//# sourceMappingURL=MapGame.js.map 
//# sourceMappingURL=Map.js.map