// 公用函数库
//
module game {

    export let guid = function() {
        return 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function(c) {
            let r = Math.random()*16|0, v = c == 'x' ? r : (r&0x3|0x8);
            return v.toString(16);
        });
    }

    export let toString = function (val: any): string {
        return val;
    }
    export let toInt32 = function (val: any): number {

        if( typeof(val) == "boolean")
        {
            if(val == true)
                return 1;
            else {
                return 0;
            }
        }
        return parseInt(val);

    }


    export let isTaday = function (str: string): boolean {
        if (!str) {
            return false;
        }
        let ArrayIn = str.split("-");
        let ret = mainserver_getServerTime.getMe().m_curTime.split("-");
        for (let p in ArrayIn) {
            if (ArrayIn[p] != ret[p]) {
                return false;
            }
        }
        return true;
    }

    //返回年月日
    export let getNowTime_year_monsth_day_string = function (): string {

        let date = new Date();
        let l_str: string;
        let month = date.getMonth() + 1;
        let strDate = date.getDate();
        if (month >= 1 && month <= 9) {
            month = 0 + month;
        }

        if (strDate >= 0 && strDate <= 9) {
            strDate = 0 + strDate;
        }

        l_str = date.getFullYear().toString();
        l_str += "-";
        l_str += month.toString();
        l_str += "-";
        l_str += strDate.toString();
        return l_str;
    };
    //interval参数说明 y年  q季度 m月  d日  w周  h小时 n分钟 s秒  ms毫秒
    export let dateDiff = function(interval:string,objDate2:Date) {
        //let dateObj = new Date()
        var d= new Date()
        var i={}, t=d.getTime(), t2 = objDate2.getTime();
        i['y']=objDate2.getFullYear()-d.getFullYear();
        i['q']=i['y']*4+Math.floor(objDate2.getMonth()/4)-Math.floor(d.getMonth()/4);
        i['m']=i['y']*12+objDate2.getMonth()-d.getMonth();
        i['ms']=objDate2.getTime()-d.getTime();
        i['w']=Math.floor((t2+345600000)/(604800000))-Math.floor((t+345600000)/(604800000));
        i['d']=Math.floor(t2/86400000)-Math.floor(t/86400000);
        i['h']=Math.floor(t2/3600000)-Math.floor(t/3600000);
        i['n']=Math.floor(t2/60000)-Math.floor(t/60000);
        i['s']=Math.floor(t2/1000)-Math.floor(t/1000);
        return i[interval];
    }

    export let isString = function (str) {
        if (typeof str == "string") {

            return true;
        } else {

            return false;
        }
    }

    export let boolToNumber = function (b: boolean,): number {
        if (b) {
            return 1;
        }
        return 0;
    };

    export let numberToBool = function (n: number,): boolean {
        if (n > 0) {
            return true;
        }
        return false;
    };

    export var assertNull = function (val, text) {
        if (val == null) {
            game.uiMgr.getMe().show_ui_MessageBox(true, text);
        }
    };
    export var publicGetMe = function (handleMgr) {
        if (handleMgr.g_instance == null) {
            handleMgr.g_instance = new handleMgr();
            return handleMgr.g_instance;
        }
        else {
            return handleMgr.g_instance;
        }
    };


//从 minnum  与 mxnnum 之间 抽出 1个数
    export var public_rand_num = function (minnum, maxnum) {
        var in_array = new Array();
        for (var i = minnum; i <= maxnum; ++i) {
            in_array.push(i);
        }
        var ret = public_rand_array(in_array, 1);
        return ret[0];
    };


//从Array 中抽出几个东西
    export var public_rand_array = function (in_array: Array<any>, num: number) {
        if (in_array.length == 0) {
            return null;
        }
        var ret = new Array();
        while (ret.length < num) {
            var id = Math.random() * in_array.length;
            id = Math.floor(id);
            ret.push(in_array[id]);
        }
        return ret;
    };


    export class funcMgr {
        g_funcMgr: any = null;
        //距离
        float_dis(src, des) {
            var x = parseFloat(src);
            var y = parseFloat(des);
            if (x > y) {
                return x - y;
            }
            return y - x;
        }

        //Min <= rand <= Max
        randFromBothNum(Min, Max) {
            var Range = Max - Min;
            var Rand = Math.random();
            var num = Min + Math.round(Rand * Range);
            return num;
        }

        randFromGameMap(maplist, num) {
            var datalist = new Array();
            for (var i = 0; i < maplist.size(); ++i) {
                datalist[i] = maplist.getData(i);
            }
            return this.randFormList(datalist, num);
        }


        randFromObject(obj: Object, num: number) {
            var datalist = new Array();
            for (var p in obj) {
                datalist.push(p);
            }
            var len = datalist.length;
            if (len < num) {
                return null;
            }

            let copyinlist: Array<any> = cc.clone(datalist);
            let ret = new Array();
            while (ret.length < num) {
                var rend = cc.random0To1() * copyinlist.length;
                var addCound = 0;
                for (var i = 0; i < copyinlist.length; ++i) {
                    if (addCound < rend && rend < i + 1) {
                        addCound = i;
                        break;
                    }
                }
                ret.push(copyinlist[addCound]);
                copyinlist.splice(addCound, 1);
            }
            return ret;
        }

        // 从列表中随机抽出num个
        //inlist Object
        randFormList(inlist, num) {
            if (typeof inlist !== "object") {
                return null;
            }
            var len = inlist.length;
            if (len < num) {
                return null;
            }
            var copyinlist = cc.clone(inlist);
            var ret = new game.MapGame();
            while (ret.size() < num) {
                var rend = cc.random0To1() * copyinlist.length;
                var addCound = 0;
                for (var i = 0; i < copyinlist.length; ++i) {
                    if (addCound < rend && rend < i + 1) {
                        addCound = i;
                        break;
                    }
                }
                ret.put(ret.size(), copyinlist[addCound]);
                copyinlist.splice(addCound, 1);
            }
            return ret;
        }

        //判断js对象是否相等
        isObjectValueEqual(a, b) {
            // Of course, we can do it use for in
            // Create arrays of property names
            if (b == null) {
                return false;
            }
            if (a == null) {
                return false;
            }
            var aProps = Object.getOwnPropertyNames(a);
            var bProps = Object.getOwnPropertyNames(b);
            // If number of properties is different,
            // objects are not equivalent
            if (aProps.length != bProps.length) {
                return false;
            }
            for (var i = 0; i < aProps.length; i++) {
                var propName = aProps[i];
                // If values of same property are not equal,
                // objects are not equivalent
                if (a[propName] !== b[propName]) {
                    return false;
                }
            }
            // If we made it this far, objects
            // are considered equivalent
            return true;
        }

        static g_funcMgr: any = null;
        static getMe = function () {
            return funcMgr.create();
        };
        static create = function () {
            if (funcMgr.g_funcMgr == null) {
                funcMgr.g_funcMgr = new funcMgr();
                return funcMgr.g_funcMgr;
            }
            else {
                return funcMgr.g_funcMgr;
            }
        };

    }


// var g_log = true;
// var g_logger = function (message) {
//     if (g_log) {
//         console.log(message);
//     }
// };
}
