/**
 * Created by Allen on 2016/12/9.
 */
module game {
    export class posEvent{
        eventType:string;
        talkIndex:string;
        eventRect:cc.Rect;
        monsterbirth:Array<monsterbirth>;
    }
    export class monsterbirth{
        interval:number;
        waveIndex:string;
        condition;
    }
    export class guanka {
        m_sceneInfo: scene_config_data_s = null
        m_guankaInfo: GuanKa_s = null
        m_posEvent: Array<posEvent> = null

        init(sceneInfo, guankaInfo) {
            this.m_guankaInfo = guankaInfo;
            this.m_sceneInfo = sceneInfo;
            this.initPosEvent();
        }


        initPosEvent() {
            if (this.m_guankaInfo == null) {
                return;
            }
            if (this.m_guankaInfo.posEvent == null) {
                //console.log(" 场景表没有配置位置事件");
                return;
            }
            this.m_posEvent = cc.clone(this.m_guankaInfo.posEvent);
            if (this.m_posEvent) {
                if (this.m_posEvent.length == 0) {
                    //console.log(" 场景表没有配置位置事件");
                    return;
                }
            }
        }

        updatePosEvent() {
            if (this.m_posEvent == null) {
                return;
            }
            for (var i = 0; i < this.m_posEvent.length; i++) {
                if(this.m_posEvent[i].eventRect == null){
                    continue;
                }
                var ret = cc.rectContainsPoint(this.m_posEvent[i].eventRect, roleMgr.getMe().getControlPlayer().getPosition());
                if (ret) {
                    var posEvent = this.m_posEvent[i];
                    this.m_posEvent.splice(i, 1);
                    if (posEvent.eventType == "monsterbirth") {
                        (<fightscene> sceneMgr.getMe().getCurScene()).m_createMonsterMgr.initMonsterBirthData(posEvent.monsterbirth);
                    }
                    else if (posEvent.eventType == "talk") {

                        var juqingInfo = cc.clone(fileMgr.getMe().getJuqingInfo(sceneMgr.getMe().getCurSceneName()));
                        var talker = dataMgr.getMe().getCurHero();
                        var talkIndex = posEvent.talkIndex;
                        if (juqingInfo == null
                            || juqingInfo[talkIndex] == null) {
                            return;
                        }
                        talkMgr.getMe().initTalkData(juqingInfo[talkIndex]);

                    }
                }
            }
        }

        isWinGuanka (){
            var winCond = this.m_guankaInfo.winCond;
            if ( winCond == null ) {
                console.log(" 场景表配置错误！没有winCond ");
                return false;
            }
            var condType = winCond["type"];
            if (condType == null) {
                uiMgr.getMe().show_ui_MessageBox(true, "关卡胜利条件不对！");
                return false;
            }
            switch (condType) {
                case "killnum": {
                    if (winCond["num"] == null) {
                        uiMgr.getMe().show_ui_MessageBox(true, "关卡胜利条件不对！");
                        return false;
                    }
                    if (roleMgr.getMe().getMonsterDeadNum() >= winCond["num"]) {
                        return true;
                    }
                }
                    break;
                case "killboss": {
                    if (winCond["num"] == null) {
                        uiMgr.getMe().show_ui_MessageBox(true, "关卡胜利条件不对！");
                        return false;
                    }
                    if (roleMgr.getMe().getBossDeadNum() >= winCond["num"]) {
                        return true;
                    }
                }
                    break;
                case "tohpper": {
                    if (winCond["hpper"] == null) {
                        uiMgr.getMe().show_ui_MessageBox(true, "关卡胜利条件不对！");
                        return false;
                    }
                    var boss = roleMgr.getMe().getBoss();
                    if (boss) {
                        if (boss.gethpPer() < winCond["hpper"]) {
                            return true;
                        }
                    }
                    else {
                        uiMgr.getMe().show_ui_MessageBox(true, "场景表中没有配置boss型怪物！");
                        return false;
                    }
                }
                    break;
                default: {
                    console.error("error update Guochang");
                    break;
                }

            }
            return false;
        }

        loop(t) {
        }

        shutdown() {
            this.m_guankaInfo = null;
            this.m_sceneInfo = null;
        }
    }
}
