"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var game;
(function (game) {
    game.g_eventFrameType = {
        "Pause": "dun",
        "TimeScale": "man",
        "ScreenShake": "zhendong",
        "AttackCollision": "gongjizudang",
        "Damage": "shanghai",
        "FireBullet": "fashe",
        "Texiao": "texiao",
        "Zhongduan": "zhongduan"
    };
    //函数管理类 （函数式接口）
    var aiBase_public_func = (function () {
        function aiBase_public_func() {
        }
        aiBase_public_func.prototype.resetPos_y = function (_object_role) {
            _object_role.setPositionY(_object_role.m_ground.y);
        };
        //被击方向重置
        aiBase_public_func.prototype.resetDir_beiji = function (_gameobj, _object_role) {
            if (_gameobj.getType() == game.g_ObjType.bullet) {
                if (_gameobj.m_bulletType == game.g_bulletType.texiao) {
                    var posbulletdir = cc.pSub(_gameobj.getPosition(), _object_role.getPosition());
                    _object_role.setDir(posbulletdir.x);
                    return posbulletdir.x;
                }
                _object_role.setDir(-_gameobj.m_dir.x);
                return -_gameobj.m_dir.x;
            }
            else if (_gameobj.getType() == game.g_ObjType.play ||
                _gameobj.getType() == game.g_ObjType.monster ||
                _gameobj.getType() == game.g_ObjType.follower) {
                _object_role.setDir(-_gameobj.m_roledir);
                return -_gameobj.m_roledir;
            }
        };
        aiBase_public_func.prototype.updataDir = function (hitObject, _object_role) {
            if (hitObject == null) {
                return 0;
            }
            if (hitObject.getType() == game.g_ObjType.bullet) {
                if (hitObject.m_dir.x < 0) {
                    return -1;
                }
                else {
                    return 1;
                }
            }
            if (hitObject.getPosition().x > _object_role.getPosition().x) {
                return -1;
            }
            else {
                return 1;
            }
            // return 1;
        };
        aiBase_public_func.g_point = null;
        aiBase_public_func.getMe = function () {
            if (aiBase_public_func.g_point == null) {
                aiBase_public_func.g_point = new aiBase_public_func();
            }
            return aiBase_public_func.g_point;
        };
        return aiBase_public_func;
    }());
    game.aiBase_public_func = aiBase_public_func;
    //http://blog.sina.com.cn/s/blog_5fbae0ad0100igx3.html
    var aiBase_none = (function (_super) {
        __extends(aiBase_none, _super);
        function aiBase_none(role) {
            _super.call(this);
            this.m_stateType = null;
            this.m_object_role = null;
            this.m_object_role = role;
            this.m_stateType = game.e_AiType.g_AiType_none;
            this.initZhongduanLevel();
        }
        aiBase_none.prototype.initZhongduanLevel = function () {
            for (var p in game.g_playAiState_zhongduanLevel) {
                var data = game.g_playAiState_zhongduanLevel[p];
                if (data.type == this.m_stateType) {
                    this.m_stateZhongduanLevel = data.brokenLevel;
                    break;
                }
            }
        };
        return aiBase_none;
    }(game.baseState));
    game.aiBase_none = aiBase_none;
    var aiBase = (function (_super) {
        __extends(aiBase, _super);
        function aiBase(role) {
            _super.call(this);
            this.m_object_role = null;
            this.m_endTime_tiqian = 0;
            this.m_isZhongduan = false;
            this.m_dir = new cc.Vec2(1, 0);
            this.m_object_role = role;
        }
        aiBase.prototype.shutdown = function () {
        };
        aiBase.prototype.resetPos = function () {
            if (this.m_object_role.hasBone("root_2") == false) {
                return;
            }
            var resetpos = this.m_object_role.getBoneWroldPosition("root_2");
            if (resetpos) {
                this.m_object_role.setPosition(resetpos);
            }
        };
        aiBase.prototype.isPlaying = function () {
            return this.m_object_role.isPlay();
        };
        //加入這个状态列表 就不能切换到這个状态
        aiBase.prototype.canChanage = function (key, data) {
            for (var p in game.g_playAiState_config) {
                var config = game.g_playAiState_config[p];
                if (this.m_stateType == config.type) {
                    for (var pp in config.can) {
                        if (config.can[pp] == key) {
                            return true;
                        }
                    }
                }
            }
            return false;
        };
        aiBase.prototype.CanExitExternalEvent = function (key) {
            if (this.m_isEnd == true) {
                return true;
            }
            if (this.CanExitExternalEvent_byZhongduan(key) == true) {
                return true;
            }
            for (var p in game.g_playAiState_config) {
                var data = game.g_playAiState_config[p];
                if (this.m_stateType == data.type) {
                    for (var pp in data.not) {
                        if (data.not[pp] == key) {
                            return false;
                        }
                    }
                }
            }
            // if (this.m_object_role.getType() == g_ObjType.play) {
            //     console.log(g_AiType.getAiTypeStr(key) + "中断" + g_AiType.getAiTypeStr(this.m_stateType));
            // }
            return true;
        };
        aiBase.prototype.CanExitExternalEvent_byZhongduan = function (key) {
            if (this.m_isZhongduan == false) {
                //console.log("不在中断状态：" + key);
                return false;
            }
            var state = this.m_object_role.getState(key);
            if (state.m_stateZhongduanLevel > this.m_stateZhongduanLevel) {
                return true;
            }
            return false;
        };
        /**
         * @return {boolean}
         */
        aiBase.prototype.ExternalEvent = function (key, data) {
            if (this.CanExitExternalEvent(key) == false) {
                return false;
            }
            if (key == this.m_stateType && this.m_isEnd == false)
                return false;
            this.m_object_role.startResetPosition();
            this.m_isEnd = true;
            return true;
        };
        /**
         * @return {boolean}
         */
        aiBase.prototype.InternalEvent = function (key, data) {
            // if (this.m_object_role.getType() == g_ObjType.play) {
            //      console.log("进入了新状态：" + key);
            // }
            this.m_isEnd = false;
            this.m_isZhongduan = false;
            return true;
        };
        aiBase.prototype.update = function (t) {
            if (this.m_endTime_tiqian > 0) {
                var curtime = this.m_object_role.m_SpineNode.getAnimationSurplusTime();
                if (curtime < this.m_endTime_tiqian) {
                    this.Complete();
                }
            }
            return true;
        };
        /**
         * @return {boolean}
         */
        aiBase.prototype.Complete = function (data) {
            if (data === void 0) { data = null; }
            this.m_isEnd = true;
            this.m_object_role.changeState(game.e_AiType.g_AiType_Idle);
            return true;
        };
        /**
         * @return {boolean}
         */
        aiBase.prototype.Event = function (event) {
            var name = event.data.name;
            // console.log(this.m_object_role.m_name +  "：帧监听："+name);
            //伤害处理
            if (name.indexOf(game.g_eventFrameType["Damage"]) > -1) {
                this.OnDamage(event);
            }
            //发射子弹
            if (name.indexOf(game.g_eventFrameType["FireBullet"]) > -1) {
                this.OnFireBullet(event);
            }
            if (name.indexOf(game.g_eventFrameType["Zhongduan"]) > -1) {
                this.onZhongduan(event);
            }
            if (game.rootScene.getMe().fpsLow_15() == true) {
                return;
            }
            //动作停顿
            if (game.roleMgr.getMe().m_curControlRole == this.m_object_role
                || this.m_object_role instanceof game.monster) {
                if (name.indexOf(game.g_eventFrameType["Pause"]) > -1) {
                    game.EffectMgr.getMe().OnPause(event, this.m_object_role);
                }
                //动作时间缩放
                if (name.indexOf(game.g_eventFrameType["TimeScale"]) > -1) {
                    game.EffectMgr.getMe().OnTimeScaleChange(event);
                }
                //震屏
                if (name.indexOf(game.g_eventFrameType["ScreenShake"]) > -1) {
                    game.EffectMgr.getMe().OnScreenShake(event);
                }
            }
            if (name == "chufazhaohuanfenshen") {
                game.roleMgr.getMe().createAvatar("bobifenshen", this.m_object_role.getPosition());
            }
            return true;
        };
        aiBase.prototype.onZhongduan = function (event) {
            var name = event.data.name;
            if (name.indexOf("start") > -1) {
                this.m_isZhongduan = true;
            }
            if (name.indexOf("end") > -1) {
                this.m_isZhongduan = false;
            }
        };
        aiBase.prototype.isZhongduan = function () {
            return this.m_isZhongduan;
        };
        //消耗cpu 较多
        aiBase.prototype.OnFireBullet = function (event) {
            // return;
            if (game.rootScene.getMe().fpsLow_15() == true) {
                return;
            }
            var name = event.data.name;
            var strs = name.split("_"); //字符分割
            var bulletType = name;
            var info = null;
            info = cc.copy(game.g_bullet_play[bulletType]);
            if (info == null) {
                game.uiMgr.getMe().show_ui_MessageBox(true, "g_bullet_play 没有这个子弹" + bulletType);
                return null;
            }
            var pos = this.m_object_role.getBoneWroldPosition(strs[0]);
            if (pos == null) {
                game.uiMgr.getMe().show_ui_MessageBox(true, "特效或子弹 " + bulletType + " 没有骨骼pos，骨骼名" + strs[0]);
                return;
            }
            info.pos = pos;
            var dir = this.m_object_role.m_roledir;
            if (dir < 0) {
                info["dir"] = cc.p(-1, 0);
            }
            else {
                info["dir"] = cc.p(1, 0);
            }
            if (this.m_object_role.getType() == game.g_ObjType.play
                || this.m_object_role.getType() == game.g_ObjType.follower) {
                info["roleType"] = game.g_bulletRoleType.bulletType_play;
            }
            else {
                info["roleType"] = game.g_bulletRoleType.bulletType_monster;
            }
            info["affector"] = this.m_object_role; //发射子弹的角色ID
            game.bulletMgr.getMe().createBullet(info, this.m_object_role.getLocalZOrder());
        };
        //消耗cpu 较多
        aiBase.prototype.OnDamage = function (event) {
            // return;
            if (game.rootScene.getMe().fpsLow_15() == true) {
                return;
            }
            var name = event.data.name;
            var pos = name.indexOf("shanghai");
            var indexString = name.substr(pos, "shanghai".length + 1);
            var damageInfo = this.m_object_role.m_curSkillInfo[indexString];
            if (damageInfo == null) {
                game.uiMgr.getMe().show_ui_MessageBox(true, "技能表未填:" + this.m_object_role.m_name + ":" + this.m_object_role.m_curSkillInfo.animation + ":" + indexString);
                return;
            }
            var colliderPartPos = name.indexOf("gongjizudang");
            var colliderIndexString = name.substr(colliderPartPos, "gongjizudang".length + 1);
            if (colliderIndexString == null) {
                game.uiMgr.getMe().show_ui_MessageBox(true, "OnDamage colliderIndexString == null");
                return;
            }
            var minY = damageInfo.subY;
            var maxY = damageInfo.addY;
            var enemyList = this.m_object_role.getenemy();
            if (enemyList) {
                for (var i = 0; i < enemyList.size; ++i) {
                    var obj = enemyList.getByIndex(i);
                    // if(Math.abs(obj.getPositionX() - this.m_object_role.getPositionX()) > 100 )
                    //     continue;
                    var ret = this.m_object_role.dealPhy(obj, colliderIndexString);
                    if (ret == 1) {
                        var y = obj.getPositionY() - this.m_object_role.getPositionY();
                        if (y > -minY && y < maxY) {
                            obj.OnHit(this.m_object_role, damageInfo);
                        }
                    }
                }
            }
        };
        //打掉子弹
        // OnHitBullet( event )
        // {
        //     let name = event.data.name;
        //     let bulletMap = bulletMgr.getMe().m_bullet_map;
        //     for (let i = 0; i < bulletMap.getSize(); ++i) {
        //         let obj = bulletMap.getData(i);
        //         let rect = obj.getPhyRect();
        //         let ret = this.m_object_role.dealPhyWithRect(rect);
        //         if (ret == 1) {
        //             obj.onHit();
        //         }
        //     }
        // }
        aiBase.prototype.onFrameEvent = function (type, event) {
            //return;
            if (type == "Start") {
            }
            else if (type == "End") {
            }
            else if (type == "Complete") {
                this.Complete();
            }
            else if (type == "event") {
                // let _proforFunc = proforFunc.create();
                this.Event(event);
                this.Event_texiao(event);
            }
            return true;
        };
        aiBase.prototype.Event_texiao = function (event) {
            var name = event.data.name;
            if (name.indexOf(game.g_eventFrameType["Texiao"]) > -1) {
                var strs = name.split("_"); //字符分割
                var pos = this.m_object_role.getBoneWroldPosition(strs[1]);
                if (pos == null) {
                    game.uiMgr.getMe().show_ui_MessageBox(true, "特效或子弹 " + name + " 没有骨骼pos，骨骼名" + strs[1]);
                    return;
                }
                // console.log(strs[1]+"这个的y轴坐标是:"+pos.y);
                var z = this.m_object_role.getLocalZOrder();
                var info = null;
                if (game.g_bullet_play[event.data.name] != null) {
                    info = cc.clone(game.g_bullet_play[event.data.name]);
                }
                else {
                    // ui_messageBox2.ShowOrHide(true,"没有这个子弹" + event.data.name);
                    // console.error("没有这个子弹" + event.data.name);
                    info = cc.clone(game.g_bullet_play["texiao_demo"]);
                }
                info["res"] = strs[0];
                info["resAnimation"] = strs[2];
                info["pos"] = pos;
                var dir = this.m_object_role.m_roledir;
                if (dir < 0) {
                    info["dir"] = cc.p(-1, 0);
                }
                else {
                    info["dir"] = cc.p(1, 0);
                }
                info["affector"] = this.m_object_role;
                if (this.m_object_role.getType() == game.g_ObjType.play || this.m_object_role.getType() == game.g_ObjType.follower) {
                    info["roleType"] = game.g_bulletRoleType.bulletType_play;
                }
                else if (this.m_object_role.getType() == game.g_ObjType.monster) {
                    info["roleType"] = game.g_bulletRoleType.bulletType_monster;
                }
                var zorder = 0;
                if (strs.length > 3) {
                    zorder = Number(strs[3]);
                }
                if (strs.length > 4 && strs[4] == "full") {
                    var skillPos = info.skillpos;
                    if (this.m_object_role.getDir() > 0) {
                        info["pos"].x += skillPos.x;
                    }
                    else {
                        info["pos"].x -= skillPos.x;
                    }
                    info["pos"].y = skillPos.y;
                }
                game.bulletMgr.getMe().createNormalBullet_texiao(info, z + zorder);
            }
        };
        aiBase.prototype.isEnd = function () {
            return this.m_isEnd;
        };
        return aiBase;
    }(game.baseState));
    game.aiBase = aiBase;
    var aiBase_skill = (function (_super) {
        __extends(aiBase_skill, _super);
        function aiBase_skill(role) {
            _super.call(this, role);
            this.m_skillInfo = null;
        }
        aiBase_skill.prototype.initZhongduanLevel = function () {
            for (var p in game.g_playAiState_zhongduanLevel) {
                var data = game.g_playAiState_zhongduanLevel[p];
                if (data.type == this.m_stateType) {
                    this.m_stateZhongduanLevel = data.brokenLevel;
                    break;
                }
            }
        };
        /**
         * @return {boolean}
         */
        aiBase_skill.prototype.ExternalEvent = function (key, data) {
            var ret = _super.prototype.ExternalEvent.call(this, key, data);
            if (ret == false) {
                return ret;
            }
            return ret;
        };
        aiBase_skill.prototype.update = function (dt) {
            //super.update(dt);
            //提前结束3帧
            var curTime = this.m_object_role.m_SpineNode.getAnimationSurplusTime();
            if (curTime <= 0.120) {
                this.Complete();
            }
            return true;
        };
        return aiBase_skill;
    }(aiBase));
    game.aiBase_skill = aiBase_skill;
    var aiBase_fallDown = (function (_super) {
        __extends(aiBase_fallDown, _super);
        function aiBase_fallDown(role) {
            _super.call(this, role);
            this.m_animationName = null;
            this.m_stateType = game.e_AiType.g_AiType_fallDown;
            _super.prototype.initZhongduanLevel.call(this);
        }
        aiBase_fallDown.prototype.InternalEvent = function (key, data) {
            aiBase_public_func.getMe().resetPos_y(this.m_object_role);
            this.m_object_role.startResetPosition();
            // this.m_object_role.stopMoveRootBone(0);
            var ret = _super.prototype.InternalEvent.call(this, key, data);
            if (data == "shouji7") {
                this.m_object_role.playAnimation("shouji7_zhuolu");
            }
            else if (data == "shouji6") {
                this.m_object_role.playAnimation("shouji6_kongzhong_zhuolu");
            }
            else if (data == "shouji6_kongzhong") {
                this.m_object_role.playAnimation("shouji6_kongzhong_zhuolu");
            }
            else if (data == "shouji1_kongzhong") {
                this.m_object_role.playAnimation("shouji1_kongzhong_zhuolu");
            }
            else {
                this.m_object_role.playAnimation("shouji7_zhuolu");
            }
            this.m_animationName = data;
            return ret;
        };
        aiBase_fallDown.prototype.ExternalEvent = function (key, data) {
            return _super.prototype.ExternalEvent.call(this, key, data);
        };
        aiBase_fallDown.prototype.update = function (t) {
            this.m_object_role.resetPosition(t);
            return _super.prototype.update.call(this, t);
        };
        aiBase_fallDown.prototype.Complete = function (data) {
            if (data == "resEnd") {
                return;
            }
            this.m_isEnd = true;
            var maplist = {};
            maplist["shouji1_kongzhong"] = "shouji7_qishen";
            maplist["shouji7"] = "shouji7_qishen";
            maplist["shouji6"] = "shouji6_qishen";
            maplist["shouji6_kongzhong"] = "shouji6_qishen";
            if (maplist[this.m_animationName] != null) {
                this.m_object_role.changeState(game.e_AiType.g_AiType_beiji_qishen, maplist[this.m_animationName]);
            }
            else {
                this.m_object_role.changeState(game.e_AiType.g_AiType_beiji_qishen, "shouji6_qishen");
            }
            return true;
        };
        return aiBase_fallDown;
    }(aiBase_skill));
    game.aiBase_fallDown = aiBase_fallDown;
    var aiBase_AttackRecover = (function (_super) {
        __extends(aiBase_AttackRecover, _super);
        function aiBase_AttackRecover(role) {
            _super.call(this, role);
            this.m_stateType = game.e_AiType.g_AiType_endAnimate;
            _super.prototype.initZhongduanLevel.call(this);
        }
        aiBase_AttackRecover.prototype.InternalEvent = function (key, data) {
            this.m_endTime_tiqian = 0.12;
            this.m_object_role.stopMoveRootBone(0);
            this.m_object_role.playAnimation(this.m_object_role.m_curSkillInfo.endAnimation, false);
            var ret = _super.prototype.InternalEvent.call(this, key, data);
            return ret;
        };
        aiBase_AttackRecover.prototype.update = function (t) {
            this.m_object_role.resetPosition(t);
            return _super.prototype.update.call(this, t);
        };
        return aiBase_AttackRecover;
    }(aiBase_skill));
    game.aiBase_AttackRecover = aiBase_AttackRecover;
    var aiBase_idle = (function (_super) {
        __extends(aiBase_idle, _super);
        function aiBase_idle(role) {
            _super.call(this, role);
            this.m_stateType = game.e_AiType.g_AiType_Idle;
            _super.prototype.initZhongduanLevel.call(this);
        }
        aiBase_idle.prototype.ExternalEvent = function (key, data) {
            return _super.prototype.ExternalEvent.call(this, key, data);
        };
        aiBase_idle.prototype.InternalEvent = function (key, data) {
            aiBase_public_func.getMe().resetPos_y(this.m_object_role);
            this.m_object_role.stopMoveRootBone(0);
            this.m_object_role.playAnimation("daiji", true);
            _super.prototype.InternalEvent.call(this, key, data);
            return true;
        };
        aiBase_idle.prototype.update = function (t) {
            return _super.prototype.update.call(this, t);
        };
        aiBase_idle.prototype.onFrameEvent = function (type, event) {
            _super.prototype.onFrameEvent.call(this, type, event);
            return true;
        };
        return aiBase_idle;
    }(aiBase_skill));
    game.aiBase_idle = aiBase_idle;
    var aiBase_run = (function (_super) {
        __extends(aiBase_run, _super);
        function aiBase_run(role) {
            _super.call(this, role);
            this.m_speed = 100;
            //记录在这个状态跑了多久，超过1秒才切换刹车
            this.m_runTime = 0;
            this.m_zhuangqiang = false;
            this.m_stateType = game.e_AiType.g_AiType_run;
            _super.prototype.initZhongduanLevel.call(this);
        }
        aiBase_run.prototype.setRunDir = function (dir) {
            this.m_dir = cc.clone(dir);
            this.m_object_role.setDir(this.m_dir.x);
        };
        aiBase_run.prototype.ExternalEvent = function (key, data) {
            var ret = _super.prototype.ExternalEvent.call(this, key, data);
            return ret;
        };
        aiBase_run.prototype.InternalEvent = function (key, data) {
            this.m_runTime = 0;
            this.m_zhuangqiang = false;
            this.m_object_role.stopMoveRootBone(0);
            this.m_object_role.playAnimation("yidong");
            if (data) {
                this.m_dir = cc.copy(data);
            }
            this.m_speed = this.m_object_role.getOutSpeed();
            _super.prototype.InternalEvent.call(this, key, data);
            //
            this.m_object_role.setDir(this.m_dir.x);
            return true;
        };
        aiBase_run.prototype.update = function (t) {
            _super.prototype.update.call(this, t);
            return true;
        };
        aiBase_run.prototype.onFrameEvent = function (type, event) {
            _super.prototype.onFrameEvent.call(this, type, event);
            return true;
        };
        aiBase_run.prototype.Complete = function (data) {
            return true;
        };
        return aiBase_run;
    }(aiBase_skill));
    game.aiBase_run = aiBase_run;
    //随从 和 玩家 刹车
    var aiBase_shache = (function (_super) {
        __extends(aiBase_shache, _super);
        function aiBase_shache(role) {
            _super.call(this, role);
            this.m_stateType = game.e_AiType.g_AiType_shache;
            _super.prototype.initZhongduanLevel.call(this);
        }
        aiBase_shache.prototype.ExternalEvent = function (key, data) {
            return _super.prototype.ExternalEvent.call(this, key, data);
        };
        aiBase_shache.prototype.InternalEvent = function (key, data) {
            this.m_object_role.playAnimation("shache");
            this.m_object_role.stopMoveRootBone(0);
            this.m_object_role.startResetPosition();
            _super.prototype.InternalEvent.call(this, key, data);
            return true;
        };
        aiBase_shache.prototype.update = function (t) {
            this.m_object_role.resetPosition(t);
            _super.prototype.update.call(this, t);
            return true;
        };
        aiBase_shache.prototype.onFrameEvent = function (type, event) {
            _super.prototype.onFrameEvent.call(this, type, event);
            return true;
        };
        return aiBase_shache;
    }(aiBase_skill));
    game.aiBase_shache = aiBase_shache;
    var aiBase_dead = (function (_super) {
        __extends(aiBase_dead, _super);
        function aiBase_dead(role) {
            _super.call(this, role);
            this.m_stateType = game.e_AiType.g_AiType_Dead;
            _super.prototype.initZhongduanLevel.call(this);
        }
        aiBase_dead.prototype.ExternalEvent = function (key, data) {
            _super.prototype.ExternalEvent.call(this, key, data);
            return false;
        };
        aiBase_dead.prototype.InternalEvent = function (key, data) {
            _super.prototype.InternalEvent.call(this, key, data);
            //删除buff
            // this.m_object_role.m_buffControl.shutdown();
            if (this.m_object_role.m_curAnimation == "shouji6_kongzhong_zhuolu") {
                this.m_object_role.playAnimation("shouji6_siwang", false);
            }
            else {
                this.m_object_role.playAnimation("shouji7_siwang", false);
            }
            return true;
        };
        aiBase_dead.prototype.update = function (t) {
            _super.prototype.update.call(this, t);
            return true;
        };
        aiBase_dead.prototype.onFrameEvent = function (type, event) {
            if (type == "Complete") {
                this.Complete("resEnd");
            }
            return true;
        };
        aiBase_dead.prototype.Complete = function (data) {
            this.m_isEnd = true;
            return true;
        };
        return aiBase_dead;
    }(aiBase_skill));
    game.aiBase_dead = aiBase_dead;
    //眩晕
    var aiBase_yun = (function (_super) {
        __extends(aiBase_yun, _super);
        function aiBase_yun(role) {
            _super.call(this, role);
            this.m_stateType = game.e_AiType.g_AiType_yun;
            _super.prototype.initZhongduanLevel.call(this);
        }
        aiBase_yun.prototype.ExternalEvent = function (key, data) {
            //
            _super.prototype.ExternalEvent.call(this, key, data);
            return true;
        };
        aiBase_yun.prototype.InternalEvent = function (key, data) {
            this.m_object_role.playAnimation("xuanyun", true);
            _super.prototype.InternalEvent.call(this, key, data);
            return true;
        };
        aiBase_yun.prototype.update = function (t) {
            _super.prototype.update.call(this, t);
            return true;
        };
        aiBase_yun.prototype.onFrameEvent = function (type, event) {
            _super.prototype.onFrameEvent.call(this, type, event);
            return true;
        };
        return aiBase_yun;
    }(aiBase_skill));
    game.aiBase_yun = aiBase_yun;
    //做路线
    var aiBase_beiji = (function (_super) {
        __extends(aiBase_beiji, _super);
        function aiBase_beiji(role) {
            _super.call(this, role);
            this.m_stateType = game.e_AiType.g_AiType_beiji;
            _super.prototype.initZhongduanLevel.call(this);
        }
        aiBase_beiji.prototype.ExternalEvent = function (key, data) {
            var ret = _super.prototype.ExternalEvent.call(this, key, data);
            if (key == this.m_stateType) {
                this.m_object_role.startResetPosition();
                this.m_object_role.stopMoveRootBone(0);
                this.m_isEnd = true;
                return true;
            }
            return ret;
        };
        aiBase_beiji.prototype.InternalEvent = function (key, data) {
            this.m_object_role.stopMoveRootBone(1);
            this.m_object_role.playAnimation(this.m_object_role.m_beHitActName, false);
            _super.prototype.InternalEvent.call(this, key, data);
            return true;
        };
        aiBase_beiji.prototype.update = function (t) {
            _super.prototype.update.call(this, t);
            this.m_object_role.resetPosition(t);
            return true;
        };
        aiBase_beiji.prototype.onFrameEvent = function (type, event) {
            _super.prototype.onFrameEvent.call(this, type, event);
            return true;
        };
        aiBase_beiji.prototype.Complete = function () {
            _super.prototype.Complete.call(this);
            return true;
        };
        return aiBase_beiji;
    }(aiBase_skill));
    game.aiBase_beiji = aiBase_beiji;
    var aiBase_beiji_tiaoqi = (function (_super) {
        __extends(aiBase_beiji_tiaoqi, _super);
        function aiBase_beiji_tiaoqi(role) {
            _super.call(this, role);
            this.m_AnimationName = null;
            this.m_stateType = game.e_AiType.g_AiType_beiji_tiaoqi;
            _super.prototype.initZhongduanLevel.call(this);
        }
        aiBase_beiji_tiaoqi.prototype.shutdown = function () {
            if (this.m_object_role.m_spineLineControl) {
                this.m_object_role.m_spineLineControl.shutdown();
                this.m_object_role.m_spineLineControl = null;
            }
            // aiBase_public_func.getMe().resetPos_y(this.m_object_role);
            _super.prototype.shutdown.call(this);
        };
        aiBase_beiji_tiaoqi.prototype.ExternalEvent = function (key, data) {
            if (_super.prototype.canChanage.call(this, key, data)) {
                this.shutdown();
                this.m_object_role.stopMoveRootBone(0);
                this.m_object_role.startResetPosition();
                return true;
            }
            return false;
        };
        aiBase_beiji_tiaoqi.prototype.InternalEvent = function (key, data) {
            if (this.m_object_role.m_beHitActName == "shouji0") {
                return false;
            }
            // this.resetPos();
            aiBase_public_func.getMe().resetDir_beiji(data, this.m_object_role);
            var dir = aiBase_public_func.getMe().updataDir(data, this.m_object_role);
            this.m_AnimationName = this.m_object_role.m_beHitActName;
            _super.prototype.InternalEvent.call(this, key, data);
            this.m_object_role.m_spineLineControl = game.spineLine.create(this.m_object_role, "luxian", this.m_object_role.m_beHitActName);
            if (dir) {
                this.m_object_role.m_spineLineControl.setDir(-1 * dir);
            }
            this.m_object_role.stopMoveRootBone(0);
            return true;
        };
        aiBase_beiji_tiaoqi.prototype.update = function (t) {
            if (this.m_object_role.m_spineLineControl) {
                //同步速度
                this.m_object_role.m_spineLineControl.setTimeScale(this.m_object_role.getTimeScale());
                var ret = this.m_object_role.m_spineLineControl.loop(t);
                if (ret) {
                    this.Complete();
                    return true;
                }
            }
            //更新空中地面状态
            var rectMe = this.m_object_role.getPosition();
            if (rectMe.y < this.m_object_role.m_ground.y) {
                this.m_object_role.startResetPosition();
                this.Complete();
                return true;
            }
            return true;
        };
        aiBase_beiji_tiaoqi.prototype.Complete = function (data) {
            if (data === void 0) { data = null; }
            if (this.m_object_role.m_curAnimation == "shouji6"
                || this.m_object_role.m_curAnimation == "shouji7"
                || this.m_object_role.m_curAnimation == "shouji6_kongzhong"
                || this.m_object_role.m_curAnimation == "shouji1_kongzhong") {
                this.m_object_role.changeState(game.e_AiType.g_AiType_fallDown, this.m_AnimationName);
                return;
            }
            _super.prototype.Complete.call(this);
            return true;
        };
        return aiBase_beiji_tiaoqi;
    }(aiBase_beiji));
    game.aiBase_beiji_tiaoqi = aiBase_beiji_tiaoqi;
    var aiBaseQishen = (function (_super) {
        __extends(aiBaseQishen, _super);
        function aiBaseQishen(role) {
            _super.call(this, role);
            this.m_stateType = game.e_AiType.g_AiType_beiji_qishen;
            _super.prototype.initZhongduanLevel.call(this);
        }
        aiBaseQishen.prototype.InternalEvent = function (key, data) {
            // this.m_object_role.stopMoveRootBone(0);
            this.m_object_role.playAnimation(data, true);
            _super.prototype.InternalEvent.call(this, key, data);
            return true;
        };
        aiBaseQishen.prototype.ExternalEvent = function (key, data) {
            return false;
        };
        aiBaseQishen.prototype.Complete = function () {
            this.m_object_role.m_wudi_time = 0.5;
            this.m_isEnd = true;
            this.m_object_role.changeState_Ex(game.e_AiType.g_AiType_Idle);
            return true;
        };
        return aiBaseQishen;
    }(aiBase_skill));
    game.aiBaseQishen = aiBaseQishen;
})(game || (game = {}));
//# sourceMappingURL=aiBase.js.map