"use strict";

module game {


    export let g_eventFrameType = {
        "Pause": "dun",
        "TimeScale": "man",
        "ScreenShake": "zhendong",
        "AttackCollision": "gongjizudang",
        "Damage": "shanghai",
        "FireBullet": "fashe",
        "Texiao": "texiao",
        "Zhongduan": "zhongduan"
    };

    //函数管理类 （函数式接口）
    export class aiBase_public_func {
        static g_point: any = null;
        static getMe = function () {
            if (aiBase_public_func.g_point == null) {
                aiBase_public_func.g_point = new aiBase_public_func();
            }
            return aiBase_public_func.g_point;
        };

        resetPos_y(_object_role: baseRole) {
            _object_role.setPositionY(_object_role.m_ground.y);
        }

        //被击方向重置
        resetDir_beiji(_gameobj, _object_role) {
            if (_gameobj.getType() == g_ObjType.bullet) {
                if (_gameobj.m_bulletType == g_bulletType.texiao) {
                    let posbulletdir = cc.pSub(_gameobj.getPosition(), _object_role.getPosition());
                    _object_role.setDir(posbulletdir.x);
                    return posbulletdir.x;
                }
                _object_role.setDir(-_gameobj.m_dir.x);
                return -_gameobj.m_dir.x;
            }
            else if (_gameobj.getType() == g_ObjType.play ||
                _gameobj.getType() == g_ObjType.monster ||
                _gameobj.getType() == g_ObjType.follower) {
                _object_role.setDir(-_gameobj.m_roledir);
                return -_gameobj.m_roledir;
            }
        }

        updataDir(hitObject, _object_role) {
            if (hitObject == null) {
                return 0;
            }
            if (hitObject.getType() == g_ObjType.bullet) {

                if (hitObject.m_dir.x < 0) {
                    return -1;
                }
                else {
                    return 1;
                }
            }
            if (hitObject.getPosition().x > _object_role.getPosition().x) {
                return -1;
            }
            else {
                return 1;
            }
            // return 1;
        }
    }

    //http://blog.sina.com.cn/s/blog_5fbae0ad0100igx3.html
    export class aiBase_none extends baseState {
        m_stateType: e_AiType = null
        m_object_role: baseRole = null

        constructor(role: baseRole) {
            super();
            this.m_object_role = role;
            this.m_stateType = e_AiType.g_AiType_none;
            this.initZhongduanLevel();
        }

        initZhongduanLevel() {
            for (let p in g_playAiState_zhongduanLevel) {
                let data = g_playAiState_zhongduanLevel[p];
                if (data.type == this.m_stateType) {
                    this.m_stateZhongduanLevel = data.brokenLevel;
                    break;
                }
            }
        }
    }

    export class aiBase extends baseState {
        m_object_role: baseRole = null;
        m_endTime_tiqian: number = 0;
        m_isZhongduan: boolean = false;
        m_dir: cc.Vec2 = new cc.Vec2(1, 0);

        constructor(role) {
            super();
            this.m_object_role = role;
        }

        shutdown() {
        }

        resetPos() {
            if (this.m_object_role.hasBone("root_2") == false) {
                return;
            }
            let resetpos = this.m_object_role.getBoneWroldPosition("root_2");
            if (resetpos) {
                this.m_object_role.setPosition(resetpos);
            }
        }

        isPlaying() {
            return this.m_object_role.isPlay();
        }

        //加入這个状态列表 就不能切换到這个状态
        canChanage(key, data): boolean {
            for (let p in g_playAiState_config) {
                let config = g_playAiState_config[p];
                if (this.m_stateType == config.type) {
                    for (let pp in config.can) {
                        if (config.can[pp] == key) {
                            return true;
                        }
                    }
                }
            }
            return false;
        }

        CanExitExternalEvent(key) {
            if (this.m_isEnd == true) {
                return true;
            }
            if (this.CanExitExternalEvent_byZhongduan(key) == true) {
                return true;
            }

            for (let p in g_playAiState_config) {
                let data = g_playAiState_config[p];
                if (this.m_stateType == data.type) {
                    for (let pp in data.not) {
                        if (data.not[pp] == key) {
                            return false;
                        }
                    }
                }
            }
            // if (this.m_object_role.getType() == g_ObjType.play) {
            //     console.log(g_AiType.getAiTypeStr(key) + "中断" + g_AiType.getAiTypeStr(this.m_stateType));
            // }
            return true;

        }

        CanExitExternalEvent_byZhongduan(key) {
            if (this.m_isZhongduan == false) {
                //console.log("不在中断状态：" + key);
                return false;
            }

            let state = this.m_object_role.getState(key);

            if (state.m_stateZhongduanLevel > this.m_stateZhongduanLevel) {
                return true;
            }
            return false;
        }

        /**
         * @return {boolean}
         */
        ExternalEvent(key, data): boolean {
            if (this.CanExitExternalEvent(key) == false) {
                return false;
            }
            if (key == this.m_stateType && this.m_isEnd == false)
                return false;
            this.m_object_role.startResetPosition();
            this.m_isEnd = true;
            return true;
        }

        /**
         * @return {boolean}
         */
        InternalEvent(key, data) {
            // if (this.m_object_role.getType() == g_ObjType.play) {
            //      console.log("进入了新状态：" + key);
            // }
            this.m_isEnd = false;
            this.m_isZhongduan = false;
            return true;
        }

        update(t) {
            if (this.m_endTime_tiqian > 0) {
                let curtime = this.m_object_role.m_SpineNode.getAnimationSurplusTime();
                if (curtime < this.m_endTime_tiqian) {
                    this.Complete();
                }
            }
            return true;
        }

        /**
         * @return {boolean}
         */
        Complete(data: any = null) {
            this.m_isEnd = true;
            this.m_object_role.changeState(e_AiType.g_AiType_Idle);
            return true;
        }

        /**
         * @return {boolean}
         */
        Event(event)
        {
            var name = event.data.name;
            // console.log(this.m_object_role.m_name +  "：帧监听："+name);

            //伤害处理
            if (name.indexOf(g_eventFrameType["Damage"]) > -1) {
                this.OnDamage(event);
            }
            //发射子弹
            if (name.indexOf(g_eventFrameType["FireBullet"]) > -1) {
                this.OnFireBullet(event);
            }
            if (name.indexOf(g_eventFrameType["Zhongduan"]) > -1) {
                this.onZhongduan(event);
            }

            if (rootScene.getMe().fpsLow_15() == true) {
                return;
            }

            //动作停顿
            if (roleMgr.getMe().m_curControlRole == this.m_object_role
                || this.m_object_role instanceof monster) {
                if (name.indexOf(g_eventFrameType["Pause"]) > -1) {
                    EffectMgr.getMe().OnPause(event, this.m_object_role);
                }
                //动作时间缩放
                if (name.indexOf(g_eventFrameType["TimeScale"]) > -1) {
                    EffectMgr.getMe().OnTimeScaleChange(event);
                }
                //震屏
                if (name.indexOf(g_eventFrameType["ScreenShake"]) > -1) {
                    EffectMgr.getMe().OnScreenShake(event);
                }
            }
            if (name == "chufazhaohuanfenshen") {
                roleMgr.getMe().createAvatar("bobifenshen", this.m_object_role.getPosition());
            }

            return true;
        }

        onZhongduan(event) {
            let name = event.data.name;
            if (name.indexOf("start") > -1) {
                this.m_isZhongduan = true;
            }
            if (name.indexOf("end") > -1) {
                this.m_isZhongduan = false;
            }
        }

        isZhongduan() {
            return this.m_isZhongduan;
        }

        //消耗cpu 较多
        OnFireBullet(event) {

            // return;
            if (rootScene.getMe().fpsLow_15() == true) {
                return;
            }

            let name = event.data.name;
            let strs = name.split("_"); //字符分割
            let bulletType = name;
            let info = null;

            info = cc.copy(g_bullet_play[bulletType]);

            if (info == null) {
                uiMgr.getMe().show_ui_MessageBox(true, "g_bullet_play 没有这个子弹" + bulletType);
                return null;
            }
            let pos = this.m_object_role.getBoneWroldPosition(strs[0]);
            if (pos == null) {
                uiMgr.getMe().show_ui_MessageBox(true, "特效或子弹 " + bulletType + " 没有骨骼pos，骨骼名" + strs[0]);
                return;
            }
            info.pos = pos;

            let dir = this.m_object_role.m_roledir;
            if (dir < 0) {
                info["dir"] = cc.p(-1, 0);
            }
            else {
                info["dir"] = cc.p(1, 0);
            }
            if (this.m_object_role.getType() == g_ObjType.play
                || this.m_object_role.getType() == g_ObjType.follower) {
                info["roleType"] = g_bulletRoleType.bulletType_play;
            }
            else {
                info["roleType"] = g_bulletRoleType.bulletType_monster;
            }
            info["affector"] = this.m_object_role; //发射子弹的角色ID
            bulletMgr.getMe().createBullet(info, this.m_object_role.getLocalZOrder());
        }

        //消耗cpu 较多
        OnDamage(event) {
            // return;
            if (rootScene.getMe().fpsLow_15() == true) {
                return;
            }

            let name = event.data.name;
            let pos = name.indexOf("shanghai");
            let indexString = name.substr(pos, "shanghai".length + 1);
            let damageInfo: skill_shanghai_s = this.m_object_role.m_curSkillInfo[indexString];
            if (damageInfo == null) {
                uiMgr.getMe().show_ui_MessageBox(true, "技能表未填:" + this.m_object_role.m_name + ":" + this.m_object_role.m_curSkillInfo.animation + ":" + indexString);
                return;
            }
            let colliderPartPos = name.indexOf("gongjizudang");
            let colliderIndexString = name.substr(colliderPartPos, "gongjizudang".length + 1);
            if (colliderIndexString == null) {
                uiMgr.getMe().show_ui_MessageBox(true, "OnDamage colliderIndexString == null");
                return;
            }

            let minY = damageInfo.subY;
            let maxY = damageInfo.addY;
            let enemyList = this.m_object_role.getenemy();
            if (enemyList) {
                for (let i = 0; i < enemyList.size; ++i) {
                    let obj = enemyList.getByIndex(i);
                    // if(Math.abs(obj.getPositionX() - this.m_object_role.getPositionX()) > 100 )
                    //     continue;
                    let ret = this.m_object_role.dealPhy(obj, colliderIndexString);
                    if (ret == 1) {
                        let y = obj.getPositionY() - this.m_object_role.getPositionY();
                        if (y > -minY && y < maxY) {
                            obj.OnHit(this.m_object_role, damageInfo);
                        }
                    }
                }
            }
        }

        //打掉子弹
        // OnHitBullet( event )
        // {
        //     let name = event.data.name;
        //     let bulletMap = bulletMgr.getMe().m_bullet_map;
        //     for (let i = 0; i < bulletMap.getSize(); ++i) {
        //         let obj = bulletMap.getData(i);
        //         let rect = obj.getPhyRect();
        //         let ret = this.m_object_role.dealPhyWithRect(rect);
        //         if (ret == 1) {
        //             obj.onHit();
        //         }
        //     }
        // }

        onFrameEvent(type, event) {
            //return;
            if (type == "Start") {
            }
            else if (type == "End") {
            }
            else if (type == "Complete") {
                this.Complete();
            }
            else if (type == "event") {
                // let _proforFunc = proforFunc.create();
                this.Event(event);

                this.Event_texiao(event);
                // if (ccs._parser.g_isLowCpu == false) {
                // }

                // _proforFunc.end("onFrameEvent: " + this.m_object_role.getName() + " --- " + event.data.name);
            }
            return true;
        }

        Event_texiao(event) {
            let name = event.data.name;
            if (name.indexOf(g_eventFrameType["Texiao"]) > -1) {
                let strs = name.split("_"); //字符分割
                let pos = this.m_object_role.getBoneWroldPosition(strs[1]);
                if (pos == null) {
                    uiMgr.getMe().show_ui_MessageBox(true, "特效或子弹 " + name + " 没有骨骼pos，骨骼名" + strs[1]);
                    return;
                }
                // console.log(strs[1]+"这个的y轴坐标是:"+pos.y);

                let z = this.m_object_role.getLocalZOrder();
                let info = null;
                if (g_bullet_play[event.data.name] != null) {
                    info = cc.clone(g_bullet_play[event.data.name]);
                }
                else {
                    // ui_messageBox2.ShowOrHide(true,"没有这个子弹" + event.data.name);
                    // console.error("没有这个子弹" + event.data.name);
                    info = cc.clone(g_bullet_play["texiao_demo"]);
                }

                info["res"] = strs[0];
                info["resAnimation"] = strs[2];
                info["pos"] = pos;
                let dir = this.m_object_role.m_roledir;
                if (dir < 0) {
                    info["dir"] = cc.p(-1, 0);
                }
                else {
                    info["dir"] = cc.p(1, 0);
                }
                info["affector"] = this.m_object_role;
                if (this.m_object_role.getType() == g_ObjType.play || this.m_object_role.getType() == g_ObjType.follower) {
                    info["roleType"] = g_bulletRoleType.bulletType_play;
                }
                else if (this.m_object_role.getType() == g_ObjType.monster) {
                    info["roleType"] = g_bulletRoleType.bulletType_monster;
                }
                let zorder = 0;
                if (strs.length > 3) {
                    zorder = Number(strs[3]);
                }

                if (strs.length > 4 && strs[4] == "full") {
                    let skillPos = info.skillpos;
                    if (this.m_object_role.getDir() > 0) {
                        info["pos"].x += skillPos.x;
                    } else {
                        info["pos"].x -= skillPos.x;
                    }
                    info["pos"].y = skillPos.y;
                }
                bulletMgr.getMe().createNormalBullet_texiao(info, z + zorder);
            }
        }

        isEnd() {
            return this.m_isEnd;
        }
    }

    export class aiBase_skill extends aiBase {

        m_skillInfo: any = null;

        constructor(role) {
            super(role);
        }

        initZhongduanLevel() {
            for (let p in g_playAiState_zhongduanLevel) {
                let data = g_playAiState_zhongduanLevel[p];
                if (data.type == this.m_stateType) {
                    this.m_stateZhongduanLevel = data.brokenLevel;
                    break;
                }
            }
        }

        /**
         * @return {boolean}
         */
        ExternalEvent(key, data): boolean {
            let ret = super.ExternalEvent(key, data);
            if (ret == false) {
                return ret;
            }
            return ret;
        }

        update(dt): any {
            //super.update(dt);
            //提前结束3帧
            let curTime = this.m_object_role.m_SpineNode.getAnimationSurplusTime();
            if (curTime <= 0.120) {
                this.Complete();
            }
            return true;
        }
    }


    export class aiBase_fallDown extends aiBase_skill {
        m_animationName: any = null;

        constructor(role) {
            super(role);
            this.m_stateType = e_AiType.g_AiType_fallDown;
            super.initZhongduanLevel();
        }

        InternalEvent(key, data) {
            aiBase_public_func.getMe().resetPos_y(this.m_object_role);
            this.m_object_role.startResetPosition();
            // this.m_object_role.stopMoveRootBone(0);
            let ret = super.InternalEvent(key, data);
            if (data == "shouji7") {
                this.m_object_role.playAnimation("shouji7_zhuolu");
            }
            else if (data == "shouji6") {
                this.m_object_role.playAnimation("shouji6_kongzhong_zhuolu");
            }
            else if (data == "shouji6_kongzhong") {
                this.m_object_role.playAnimation("shouji6_kongzhong_zhuolu");
            }
            else if (data == "shouji1_kongzhong") {
                this.m_object_role.playAnimation("shouji1_kongzhong_zhuolu");
            }
            else {
                this.m_object_role.playAnimation("shouji7_zhuolu");
            }
            this.m_animationName = data;
            return ret;
        }

        ExternalEvent(key, data): boolean {

            return super.ExternalEvent(key, data);

        }

        update(t): boolean {

            this.m_object_role.resetPosition(t);
            return super.update(t);
        }

        Complete(data) {
            if (data == "resEnd") {
                return;
            }
            this.m_isEnd = true;
            let maplist = {};
            maplist["shouji1_kongzhong"] = "shouji7_qishen";
            maplist["shouji7"] = "shouji7_qishen";
            maplist["shouji6"] = "shouji6_qishen";
            maplist["shouji6_kongzhong"] = "shouji6_qishen";
            if (maplist[this.m_animationName] != null) {
                this.m_object_role.changeState(e_AiType.g_AiType_beiji_qishen, maplist[this.m_animationName]);
            }
            else {
                this.m_object_role.changeState(e_AiType.g_AiType_beiji_qishen, "shouji6_qishen");
            }
            return true;
        }
    }
    export class aiBase_AttackRecover extends aiBase_skill {

        constructor(role) {
            super(role);
            this.m_stateType = e_AiType.g_AiType_endAnimate;
            super.initZhongduanLevel();
        }

        InternalEvent(key, data) {
            this.m_endTime_tiqian = 0.12;
            this.m_object_role.stopMoveRootBone(0);
            this.m_object_role.playAnimation(this.m_object_role.m_curSkillInfo.endAnimation, false);
            let ret = super.InternalEvent(key, data);
            return ret;
        }

        update(t): boolean {
            this.m_object_role.resetPosition(t);
            return super.update(t);
        }
    }
    export class aiBase_idle extends aiBase_skill {
        constructor(role) {
            super(role);
            this.m_stateType = e_AiType.g_AiType_Idle;
            super.initZhongduanLevel();
        }

        ExternalEvent(key, data) {
            return super.ExternalEvent(key, data);
        }

        InternalEvent(key, data) {
            aiBase_public_func.getMe().resetPos_y(this.m_object_role);
            this.m_object_role.stopMoveRootBone(0);
            this.m_object_role.playAnimation("daiji", true);
            super.InternalEvent(key, data);
            return true;
        }

        update(t) {
            return super.update(t);
        }

        onFrameEvent(type, event) {
            super.onFrameEvent(type, event);
            return true;
        }
    }
    export class aiBase_run extends aiBase_skill {

        m_speed: number = 100;
        //记录在这个状态跑了多久，超过1秒才切换刹车
        m_runTime: number = 0;
        m_zhuangqiang: boolean = false;

        setRunDir(dir) {
            this.m_dir = cc.clone(dir);
            this.m_object_role.setDir(this.m_dir.x);
        }

        constructor(role) {
            super(role);
            this.m_stateType = e_AiType.g_AiType_run;
            super.initZhongduanLevel();
        }

        ExternalEvent(key, data) {
            let ret = super.ExternalEvent(key, data);
            return ret;
        }

        InternalEvent(key, data) {

            this.m_runTime = 0;
            this.m_zhuangqiang = false;
            this.m_object_role.stopMoveRootBone(0);
            this.m_object_role.playAnimation("yidong");
            if (data) {
                this.m_dir = cc.copy(data);
            }
            this.m_speed = this.m_object_role.getOutSpeed();
            super.InternalEvent(key, data);
            //
            this.m_object_role.setDir(this.m_dir.x);
            return true;
        }


        update(t) {
            super.update(t);
            return true;
        }

        onFrameEvent(type, event) {
            super.onFrameEvent(type, event);
            return true;
        }

        Complete(data) {
            return true;
        }
    }
    //随从 和 玩家 刹车
    export class aiBase_shache extends aiBase_skill {

        constructor(role) {
            super(role);
            this.m_stateType = e_AiType.g_AiType_shache;
            super.initZhongduanLevel();
        }

        ExternalEvent(key, data) {
            return super.ExternalEvent(key, data);
        }

        InternalEvent(key, data) {
            this.m_object_role.playAnimation("shache");
            this.m_object_role.stopMoveRootBone(0);
            this.m_object_role.startResetPosition();
            super.InternalEvent(key, data);
            return true;
        }

        update(t) {
            this.m_object_role.resetPosition(t);
            super.update(t);
            return true;
        }

        onFrameEvent(type, event) {
            super.onFrameEvent(type, event);
            return true;
        }
    }

    export class aiBase_dead extends aiBase_skill {

        constructor(role) {
            super(role);
            this.m_stateType = e_AiType.g_AiType_Dead;
            super.initZhongduanLevel();
        }

        ExternalEvent(key, data) {
            super.ExternalEvent(key, data);
            return false;
        }

        InternalEvent(key, data) {
            super.InternalEvent(key, data);
            //删除buff
            // this.m_object_role.m_buffControl.shutdown();
            if (this.m_object_role.m_curAnimation == "shouji6_kongzhong_zhuolu") {
                this.m_object_role.playAnimation("shouji6_siwang", false);
            }
            else {
                this.m_object_role.playAnimation("shouji7_siwang", false);
            }

            return true;
        }

        update(t) {
            super.update(t);
            return true;
        }

        onFrameEvent(type, event) {
            if (type == "Complete") {
                this.Complete("resEnd");
            }
            return true;
        }

        Complete(data) {
            this.m_isEnd = true;
            return true;
        }
    }
    //眩晕
    export class aiBase_yun extends aiBase_skill {

        constructor(role) {
            super(role);
            this.m_stateType = e_AiType.g_AiType_yun;
            super.initZhongduanLevel();
        }

        ExternalEvent(key, data) {
            //
            super.ExternalEvent(key, data);
            return true;
        }

        InternalEvent(key, data) {
            this.m_object_role.playAnimation("xuanyun", true);
            super.InternalEvent(key, data);
            return true;
        }

        update(t) {
            super.update(t);
            return true;
        }

        onFrameEvent(type, event) {
            super.onFrameEvent(type, event);
            return true;
        }
    }

    //做路线
    export class aiBase_beiji extends aiBase_skill {

        constructor(role) {
            super(role);
            this.m_stateType = e_AiType.g_AiType_beiji;
            super.initZhongduanLevel();
        }

        ExternalEvent(key, data) {
            let ret = super.ExternalEvent(key, data);
            if (key == this.m_stateType) {
                this.m_object_role.startResetPosition();
                this.m_object_role.stopMoveRootBone(0);
                this.m_isEnd = true;
                return true;
            }
            return ret;
        }

        InternalEvent(key, data) {
            this.m_object_role.stopMoveRootBone(1);
            this.m_object_role.playAnimation(this.m_object_role.m_beHitActName, false);
            super.InternalEvent(key, data);
            return true;
        }

        update(t) {
            super.update(t);
            this.m_object_role.resetPosition(t);
            return true;
        }

        onFrameEvent(type, event) {
            super.onFrameEvent(type, event);
            return true;
        }

        Complete() {
            super.Complete();
            return true;
        }
    }
    export class aiBase_beiji_tiaoqi extends aiBase_beiji {
        m_AnimationName: any = null;

        constructor(role) {
            super(role);
            this.m_stateType = e_AiType.g_AiType_beiji_tiaoqi;
            super.initZhongduanLevel();
        }

        shutdown() {
            if (this.m_object_role.m_spineLineControl) {
                this.m_object_role.m_spineLineControl.shutdown();
                this.m_object_role.m_spineLineControl = null;
            }
            // aiBase_public_func.getMe().resetPos_y(this.m_object_role);
            super.shutdown();
        }

        ExternalEvent(key, data) {
            if (super.canChanage(key, data)) {
                this.shutdown();
                this.m_object_role.stopMoveRootBone(0);
                this.m_object_role.startResetPosition();
                return true;
            }
            return false;
        }

        InternalEvent(key, data) {
            if (this.m_object_role.m_beHitActName == "shouji0") {
                return false;
            }
            // this.resetPos();
            aiBase_public_func.getMe().resetDir_beiji(data, this.m_object_role);
            var dir = aiBase_public_func.getMe().updataDir(data, this.m_object_role);
            this.m_AnimationName = this.m_object_role.m_beHitActName;
            super.InternalEvent(key, data);
            this.m_object_role.m_spineLineControl = spineLine.create(this.m_object_role, "luxian", this.m_object_role.m_beHitActName);
            if (dir) {
                this.m_object_role.m_spineLineControl.setDir(-1 * dir);
            }
            this.m_object_role.stopMoveRootBone(0);
            return true;
        }

        update(t) {

            if (this.m_object_role.m_spineLineControl) {
                //同步速度
                this.m_object_role.m_spineLineControl.setTimeScale(this.m_object_role.getTimeScale());
                let ret = this.m_object_role.m_spineLineControl.loop(t);
                if (ret) {
                    this.Complete();
                    return true;
                }
            }
            //更新空中地面状态
            let rectMe = this.m_object_role.getPosition();
            if (rectMe.y < this.m_object_role.m_ground.y) {
                this.m_object_role.startResetPosition();
                this.Complete();
                return true;
            }
            return true;
        }

        Complete(data: any = null) {
            if (this.m_object_role.m_curAnimation == "shouji6"
                || this.m_object_role.m_curAnimation == "shouji7"
                || this.m_object_role.m_curAnimation == "shouji6_kongzhong"
                || this.m_object_role.m_curAnimation == "shouji1_kongzhong") {
                this.m_object_role.changeState(e_AiType.g_AiType_fallDown, this.m_AnimationName);
                return;
            }
            super.Complete();
            return true;
        }
    }


    export class aiBaseQishen extends aiBase_skill {

        constructor(role) {
            super(role);
            this.m_stateType = e_AiType.g_AiType_beiji_qishen;
            super.initZhongduanLevel();
        }

        InternalEvent(key, data) {
            // this.m_object_role.stopMoveRootBone(0);
            this.m_object_role.playAnimation(data, true);
            super.InternalEvent(key, data);
            return true;
        }

        ExternalEvent(key, data) {
            return false;
        }

        Complete(): boolean {
            this.m_object_role.m_wudi_time = 0.5;
            this.m_isEnd = true;
            this.m_object_role.changeState_Ex(e_AiType.g_AiType_Idle);
            return true;
        }
    }
}
