"use strict";
/**
 * Created by hongbing.wei on 2016/9/27.
 *
 */
module game {

    import isNumber = js.isNumber;
    import Vec2 = cc.Vec2;
    export class baseState_AiControl_data {
        rundistance: number; //追击距离
        animation: string;
        aiType: e_AiType;
        idletime: number;
    }

    export class baseState_AiControl extends baseState {
        m_baseAiControl: monsterAiControl = null;
        m_dataInfo: baseState_AiControl_data = null;

        constructor(_baseAiControl: monsterAiControl) {
            super();
            this.m_baseAiControl = _baseAiControl;
            this.m_stateType = null;
        }

        shiftAngle(v: Vec2) {
            if (v.x >= 0) {
                if (v.x > 0.9) {
                    v.x = 1;
                    v.y = 0;
                } else if (v.y > 0.9) {
                    v.x = 0;
                    v.y = 1;
                } else if (v.y > 0) {
                    v.x = 0.5;
                    v.y = 0.5;
                } else {
                    v.x = 0.5;
                    v.y = -0.5;
                }
            }
            if (v.x <= 0) {
                if (v.x < -0.9) {
                    v.x = -1;
                    v.y = 0;
                } else if (v.y < -0.9) {
                    v.x = 0;
                    v.y = -1;
                } else if (v.y > 0) {
                    v.x = -0.5;
                    v.y = 0.5;
                } else {
                    v.x = -0.5;
                    v.y = -0.5;
                }
            }
            return v;
        }

        InternalEvent(key, data) {
            //console.log("baseState_AiControl:" + this.m_stateType);
            return true;
        }

        getRoleObj(): baseRole {
            return this.m_baseAiControl.m_roleObj;
        }

        getTargetPos() {
            let tar_node = this.getTarget();
            if (tar_node) {
                return tar_node.getPosition();
            }
            return cc.p(0, 0);
        }

        getTarget(): baseRole {
            return this.m_baseAiControl.getAttackTarget();
        }

        //根据目标位置更新方向
        updateDir(pos) {
            if (this.getRoleObj().getPositionX() > pos.x) {
                this.getRoleObj().setRoleDir(-1);
                return cc.p(-1, 0);
            }
            else {
                this.getRoleObj().setRoleDir(1);
                return cc.p(1, 0);
            }
            // return cc.p(0, 0);
        }

        //生成状态列表
        generateStateList(pos, in_l_Ai_config: any = null) {
            let l_statelist = null;
            let distanceTarget = this.getRoleObj().getDis(pos);
            let l_Ai_config = in_l_Ai_config;
            if (l_Ai_config == null) {
                let monstername = this.getRoleObj().getRoleName();
                l_Ai_config = fileMgr.getMe().m_monsterAi_config[monstername];
                if (l_Ai_config == null) {
                    uiMgr.getMe().show_ui_MessageBox(true, " m_monsterAi_config 表没有配置自动战斗 ：" + monstername);
                    return null;
                }
            }

            let aiEventInfo = new ArrayEx<any>();
            for (let p in l_Ai_config) {
                let obj = l_Ai_config[p];
                if (distanceTarget.x >= obj.disminX && distanceTarget.x <= obj.dismaxX) {
                    if (distanceTarget.y >= obj.disminY && distanceTarget.y <= obj.dismaxY) {
                        aiEventInfo.put(obj);
                    }
                }
            }
            if (aiEventInfo.isEmpty()) {
                return null;
            }
            let allgailv = 0;
            for (let i = 0; i < aiEventInfo.size(); i++) {
                let obj = aiEventInfo.getData(i);
                allgailv += obj["gailv"];
            }
            let gailv = cc.random0To1() * allgailv;
            let aigailv = 0;
            for (let i = 0; i < aiEventInfo.size(); i++) {
                let obj = aiEventInfo.getData(i);
                let nowgailv = aigailv + obj["gailv"];
                if (aigailv < gailv && nowgailv >= gailv) {
                    l_statelist = cc.clone(obj["stateList"]);
                    break;
                }
                aigailv += obj["gailv"];
            }
            let _map = new MapGame();
            for (let p in l_statelist) {
                _map.put(p, l_statelist[p]);
            }
            return _map; //随机抽一个
        }

        isXuanYun() {
            return this.getRoleObj().m_buffControl.isFaint(); //眩晕转台
        }
    }
    //停止的方式有2种
//追击
    export class baseState_zhuiji extends baseState_AiControl {
        //
        m_startPos: cc.Vec2 = cc.p(0, 0);
        m_dirVec: cc.Vec2 = cc.p(0, 0);
        m_timer = 0;
        m_time = 0;
        //m_resetDir_time: number = 1; //重置方向

        constructor(_baseAiControl: monsterAiControl) {
            super(_baseAiControl);
            this.m_stateType = e_AiType.g_zhuiji;
        }

        InternalEvent(key, data) {
            if (data) {
                this.m_dataInfo = cc.clone(data);
            }
            if (this.m_dataInfo.rundistance == null) {
                uiMgr.getMe().show_ui_MessageBox(true, "前进距离没有填");
                return false;
            }

            this.m_time = 1;
            super.InternalEvent(key, data);

            this.m_startPos = this.getRoleObj().getPosition();

            let distanceVec = cc.pSub(this.getTargetPos(), this.m_startPos);
            this.m_dirVec = this.shiftAngle(cc.pNormalize(distanceVec));
            this.getRoleObj().changeState(e_AiType.g_AiType_run, this.m_dirVec);


            //记录开始位置
            return true;
        }

        //
        //
        // sameSign(a, b): boolean {
        //     if ((a > 0 && b > 0)
        //         || (a <= 0 && b <= 0))
        //         return true;
        //     else
        //         return false;
        // }

        update(t) {
            this.m_time -= t;
            if(this.m_time < 0){
                this.onComplete();
                return;
            }
            if (this.m_dataInfo == null) {///结束
                this.onComplete();
                return;
            }
            let retState = this.getRoleObj().getRunState(); //结束
            if (retState.m_zhuangqiang === true) {
                this.onComplete();
                return;
            }

            if (this.isXuanYun()) {
                this.onComplete();
                return;
            }

            if (this.getRoleObj().getCurStateType() != e_AiType.g_AiType_run) {
                this.onComplete();
                return;
            }
            if (this.getTarget() == null) {
                this.onComplete();
                return;
            }
            if (this.getTarget().isdead()) {
                this.onComplete();
                return;
            }

            this.m_timer+=t;
            if(this.m_timer <= 0.5)
            {
                return true;
            }


            this.m_timer = 0;


            //跟随状态
            let distance_zhuijiDis = this.getRoleObj().getDisX(this.m_startPos);
            // let distancePlayer = this.getRoleObj().getDis(this.getTarget().getPosition());
            //追击距离过长
            if (distance_zhuijiDis > this.m_dataInfo.rundistance) {
                this.onComplete();
                return;
            }

            let nowPos = this.getRoleObj().getPosition();
            let targetPos = this.getTarget().getPosition();
            let distanceVec = cc.pSub(targetPos, nowPos);
            let dirVec = cc.pNormalize(distanceVec);
            dirVec = this.shiftAngle(dirVec);
            this.getRoleObj().setRunDir(dirVec);


            //撞到墙壁停止

            return true;
        }

        onComplete(): boolean {
            this.m_baseAiControl.changeState(e_AiType.g_randSkill);
            return true;
        }
    }
    export class baseState_fight extends baseState_AiControl {

        constructor(_baseAiControl) {
            super(_baseAiControl);
            this.m_stateType = e_AiType.fight;
        }

        InternalEvent(key, data) {
            if (data) {
                this.m_dataInfo = cc.clone(data);
            }

            this.updateDir(this.getTargetPos());
            this.getRoleObj().changeState(this.m_dataInfo.aiType, this.m_dataInfo);
            super.InternalEvent(key, data);
            return true;
        }

        //
        update(t) {
            if (this.isXuanYun()) {
                this.onComplete();
                return true;
            }


            if (this.getRoleObj().getCurStateType() != this.m_dataInfo.aiType) {
                this.onComplete();
                return true;
            }

            return true;
        }

        onComplete(): boolean {
            this.m_baseAiControl.setAttackTarget(this.m_baseAiControl.getAttackTarget_changeByDamage());
            this.m_baseAiControl.changeState(e_AiType.g_randSkill);
            return true;
        }
    }

    //后退状态
    export class baseState_houtui extends baseState_AiControl {
        m_startPos: any = cc.p(0, 0);

        constructor(_baseAiControl) {
            super(_baseAiControl);
            this.m_stateType = e_AiType.g_houtui;
        }

        InternalEvent(key, data) {
            if (data) {
                this.m_dataInfo = cc.clone(data);
            }
            this.m_startPos = this.getRoleObj().getPosition();
            super.InternalEvent(key, data);
            if (this.m_dataInfo.rundistance == null) {
                uiMgr.getMe().show_ui_MessageBox(true, "后退距离没有填");
                return false;
            }

            let randDir = cc.p( -this.getRoleObj().getDir(), 0);

            this.getRoleObj().setRunDir(randDir);
            this.getRoleObj().changeState(e_AiType.g_AiType_run, randDir);

            //记录开始位置
            return true;
        }

        //
        update(t) {
            if (this.isXuanYun()) {
                this.onComplete();
                return;
            }
            if (this.getRoleObj().getCurStateType() != e_AiType.g_AiType_run) {
                this.onComplete();
                return;
            }
            if (this.getTarget() == null) {
                this.onComplete();
                return;
            }
            if (this.getTarget().isdead()) {
                this.onComplete();
                return;
            }
            if (this.m_dataInfo == null) {
                this.onComplete();
                return;
            }
            //判断撞到墙壁了
            let retState = this.getRoleObj().getRunState();
            if (retState.m_zhuangqiang === true) {
                this.onComplete();
                return;
            }
            //
            //判断后退距离
            //跟随状态
            let distance_houtuiDis = this.getRoleObj().getDisX(this.m_startPos);
            // let distance_houtuiDis = this.getRoleObj().getDistance(this.m_startPos);
            if (distance_houtuiDis > this.m_dataInfo.rundistance) {
                this.onComplete();
                return;
            }
            return true;
        }

        onComplete(): boolean {
            this.m_baseAiControl.changeState(e_AiType.g_randSkill);
            return true;
        }
    }
    //被击后退 不切换状态
    export class baseState_beiji_houtui {
        m_baseAiControl: any = null;
        m_object_role: any = null;
        m_isback: boolean = false;

        m_dir: cc.Vec2 = cc.p(1, 0);
        m_beijihoutuiTime: number = 0.2;

        m_loop_notSetPos_buffPos: any = null;


        constructor(_baseAiControl) {
            this.m_baseAiControl = _baseAiControl;
            this.m_object_role = _baseAiControl.m_roleObj;
        }

        isActive() {
            return this.m_isback;
        }

        shutdown() {
            this.m_baseAiControl.setAttackTarget(this.m_baseAiControl.getAttackTarget_changeByDamage());
            if (this.m_object_role.m_spineLineControl) {
                this.m_object_role.m_spineLineControl.shutdown();
                this.m_object_role.m_spineLineControl = null;
            }
            aiBase_public_func.getMe().resetPos_y(this.m_object_role);
        }

        InternalEvent(_obj) {
            let dir = aiBase_public_func.getMe().updataDir(_obj, this.m_object_role);
            this.m_isback = true;
            this.m_beijihoutuiTime = 0.2;
            this.m_loop_notSetPos_buffPos = null;
            if (!this.m_object_role.m_spineLineControl)
                this.m_object_role.m_spineLineControl = spineLine_beiji_noanimation.create(this.m_object_role, "luxian", this.m_object_role.m_beHitActName);
            if (dir) {
                this.m_object_role.m_spineLineControl.setDir(-1 * dir);
            }
            return true;
        }

        //
        update(t) {
            if (this.m_isback == false) {
                return false;
            }
            // let adddispos = null;
            if (this.m_object_role.m_spineLineControl) {
                //同步速度
                this.m_object_role.m_spineLineControl.setTimeScale(this.m_object_role.getTimeScale());
                let ret = this.m_object_role.m_spineLineControl.loop(t);
                if (ret == true) {
                    this.m_isback = false;
                    this.m_object_role.m_spineLineControl.shutdown();
                    this.m_object_role.m_spineLineControl = null;
                }
            } else {
                this.m_isback = false;
            }
            return true;
        }

        onEnd() {
        }
    }

    export class baseState_randSkill extends baseState_AiControl {
        m_statelist: any = null;

        constructor(_baseAiControl) {
            super(_baseAiControl);
            this.m_stateType = e_AiType.g_randSkill;
        }

        InternalEvent(key, data) {
            super.InternalEvent(key, data);
            return true;
        }

        update(t) {
            if (this.isXuanYun()) {
                return true;
            }
            if (this.getRoleObj().isdead()) {
                return true;
            }

            if (this.getRoleObj().isFight()) {
                return true;
            }
            if (this.getRoleObj().isFallDown()) {
                return true;
            }
            if (this.getRoleObj().isBeiji()) {
                this.m_statelist = null;
                if (this.getRoleObj().isStateEnd() == false) {
                    return true;
                }
            }
            if (this.getRoleObj().getCurStateType() == e_AiType.g_AiType_endAnimate) {
                return true;
            }
            if (this.getTarget() == null) {
                return true;
            }
            //没有目标
            if (this.getTarget().isdead()) {
                this.m_baseAiControl.m_target = null;
                return true;
            }

            if (this.m_statelist == null) {
                this.getRoleObj().changeState(e_AiType.g_AiType_Idle);
                let pos = this.getTarget().getPosition();
                this.m_statelist = this.generateStateList(pos);

                if(this.m_statelist == null){
                    let p1 = this.getRoleObj().getPosition();
                    console.log("ai有问题   " + this.getRoleObj().getName() +"的坐标 x:"+p1.x + "\n y:"+p1.y
                        +"\n 目标是:"+this.getTarget().getName() + "  的坐标 x:"+pos.x + "\n y:"+pos.y);
                }
            }
            if (this.m_statelist) {
                if (this.m_statelist.getSize() == 0) {
                    this.m_statelist = null;
                    return true;
                }
                let b_data = this.m_statelist.begin();
                if (b_data == null) {
                    this.m_statelist.pop();
                    return true;
                }
                this.m_statelist.pop();

                //let typebuf :  e_AiType b_data.aiType
                b_data.aiType = g_AiType.strToAiType(b_data.aiType);
                if (b_data.aiType == e_AiType.g_AiType_run) {
                    this.m_baseAiControl.changeState(e_AiType.g_zhuiji, b_data);
                }
                else if (b_data.aiType == e_AiType.g_AiType_back) {
                    this.m_baseAiControl.changeState(e_AiType.g_houtui, b_data);
                }
                else if (b_data.aiType == e_AiType.g_AiType_Idle) {
                    this.m_baseAiControl.changeState(e_AiType.g_silly, b_data);
                }
                else {
                    this.m_baseAiControl.changeState(e_AiType.fight, b_data);
                }
            }
            return true;
        }
    }
    //被动挨打
    export class g_AiType_silly extends baseState_AiControl {
        m_cd: number = 1;

        constructor(role) {
            super(role);
            this.m_stateType = e_AiType.g_silly;
        }

        ExternalEvent(key, data) {
            return super.ExternalEvent(key, data);
        }

        InternalEvent(key, data) {
            if (data != null) {
                this.m_dataInfo = cc.clone(data);
                this.m_cd = this.m_dataInfo.idletime;
            }
            if (this.m_dataInfo.idletime == null) {
                uiMgr.getMe().show_ui_MessageBox(true, "没有idletime");
                return false;
            }
            this.getRoleObj().changeState(e_AiType.g_AiType_Idle);
            super.InternalEvent(key, data);
            return true;
        }

        update(t) {
            if (this.isXuanYun()) {
                this.onComplete();
                return;
            }
            this.m_cd -= t;
            if (this.m_cd < 0) {
                this.Complete();
            }
            super.update(t);
            return true;
        }

        Complete() {
            this.m_isEnd = true;
            this.m_baseAiControl.changeState(e_AiType.g_randSkill);
            return true;
        }
    }

    export class monsterState_xunyun extends baseState_AiControl {

        constructor(role) {
            super(role);
            this.m_stateType = e_AiType.xuanyun;
        }

        ExternalEvent(key, data) {
            return super.ExternalEvent(key, data);
        }

        InternalEvent(key, data) {
            if (data != null) {
                this.m_dataInfo = cc.clone(data);
            }
            this.getRoleObj().changeState(e_AiType.g_AiType_Idle);
            super.InternalEvent(key, data);
            //加特效
            return true;
        }

        update(t) {
            if (this.isXuanYun() == false) {
                this.onComplete();
                return;
            }
            super.update(t);
            return true;
        }

        Complete() {
            this.m_isEnd = true;
            this.m_baseAiControl.changeState(e_AiType.g_randSkill);
            return true;
        }
    }
    //并行状态机
    export class baseAiControl extends baseStateControl {
        m_roleObj: baseRole = null;
        m_target: baseRole = null;
        m_targetPos: cc.Vec2 = new cc.Vec2(0, 0);
        m_Ai_config: any = null;
        m_baseState_beiji_houtui: baseState_beiji_houtui = null;

        constructor(roleObj) {
            super(roleObj);
            this.m_roleObj = roleObj;
            this.m_baseState_beiji_houtui = new baseState_beiji_houtui(this);
            this.initState();
        }

        isboss() {
            return false;
        }

        init() {
        }

        randomTarget() {
            let players = roleMgr.getMe().getPlayerAlive();
            let num = Math.floor(Math.random() * players.size);
            return players.getByIndex(num);
        }

        getAttackTarget(){
            if(!this.m_target){
                this.m_target = this.randomTarget();
            }
            return this.m_target;
        }

        setAttackTarget(t){
            return this.m_target = t;
        }

        //仇恨值系统
        //根据伤害列表选择攻击目标， 谁对我造成的伤害超过现有目标30% 切换目标，
        //如果伤害列表是空的，默认目标
        getAttackTarget_changeByDamage() {

            let shanghaiMap = this.m_roleObj.getShanghaiMap();
            if (shanghaiMap.isEmpty())
            {
                return this.randomTarget();
            }

            let maxShanghai = shanghaiMap.begin();
            let maxShanghaiId = null;
            for (let i = 0; i < shanghaiMap.getSize(); i++) {
                let targetId = shanghaiMap.getKey(i);
                let shanghai = shanghaiMap.getDataByKey(targetId);
                if (shanghai > maxShanghai) {
                    if (roleMgr.getMe().getRoleById(targetId) == null) {
                        shanghaiMap.remove(i);
                        continue;
                    }
                    if (roleMgr.getMe().getRoleById(targetId).isdead()) {
                        shanghaiMap.remove(i);
                        continue;
                    }
                    maxShanghai = shanghai;
                    maxShanghaiId = targetId;
                }
            }

            if (maxShanghaiId == null) {
                return this.randomTarget();
            } else {
                return roleMgr.getMe().getRoleById(maxShanghaiId);
            }

        }

        update(dt) {
            this.m_baseState_beiji_houtui.update(dt);
        }

        onMonsterBackBeiji(_obj) {
            this.m_baseState_beiji_houtui.InternalEvent(_obj);
        }

        shutdown() {
        }
    }
}
