module game {

    export class buffConfig {
        continueTime: number = 0; //持续时间
        perCoefficient: number = 0; //增益或减益的值 正数
    }

    export class baseBuff extends baseObj_notNode {
        m_buffdata = null;
        m_type: any = null;
        m_Alive: boolean = false;
        m_buffControl: buffControl = null;
        m_Owner: baseRole = null;
        m_target: baseRole = null;
        m_buffIcon: ccui.ImageView = null;
        m_skillname: string = null;

        constructor(_buffControl: buffControl) {
            super();
            if (_buffControl == null) {
                console.error("baseBuff _buffControl");
            }
            this.m_Owner = null; //释放buff 的role
            this.m_buffControl = _buffControl; //
        }

        init(Owner, target, data) {
            if (Owner) {
                this.m_Owner = Owner;
            }
            if (target) {
                this.m_target = target;
            }
            this.m_buffdata = cc.clone(data);
            this.m_skillname = this.m_Owner.m_curSkillName;
            this.m_Alive = true; //开始执行buff
            // this.buffTexiao();
            return true;
        }

        //释放特效
        buffTexiao() {
            if (this.m_buffdata.resAnimation == null) {
                return;
            }
            if (this.m_buffdata.resAnimation == "") {
                return;
            }
            this.m_target.playBuffSpineAnimation_Once_foot("buffTexiao", this.m_buffdata.resAnimation);
        }

        // 判断是否是增益buff
        isGoodBuff() {
            for (var p in g_buff_config["public"]) {
                var data = g_buff_config["public"][p];
                if (this.m_type == data.buffType) {
                    if (data.target == "enemy") {
                        return false;
                    }
                }
            }
            return true;
        }

        initBuffIcon(_buffIcon) {
            this.m_buffIcon = _buffIcon;
            this.m_buffIcon.setVisible(true);
            var icon = this.getBuffIocn();
            if (icon) {
                this.m_buffIcon.loadTexture(icon);
            }
            else {
                uiMgr.getMe().show_ui_MessageBox(true, "g_buff_config[public]的buffType为：" + this.m_type + "没有值。。。");
            }
        }

        getBuffIocn() {
            for (var p in g_buff_config["public"]) {
                var data = g_buff_config["public"][p];
                if (data.buffType == this.m_type) {
                    return data.buffIocn;
                }
            }
            return null;
        }

        //释放buff 的role
        getOwner() {
            return this.m_Owner;
        }

        //被释放者
        getTarget(): baseRole {
            return this.m_target;
        }

        // loop_continueTime (t) {
        //     this.m_buffdata.continueTime -= t;
        //     if (this.m_buffdata.continueTime < 0) {
        //         this.m_Alive = false;
        //     }
        // }
        loop(t) {
            // this.loop_continueTime(t);
            return this.m_Alive;
        }

        shutdown() {
            this.m_Alive = false;
        }

        getPerCoefficient(role: baseRole = null) {
            return this.m_buffdata.perCoefficient;
        }

        isSuperposition() {
            return this.m_buffdata.isSuperposition;
        }
    }
}
//# sourceMappingURL=baseBuff.js.map