"use strict";
module game {

    export class skill_shanghai_s {
        "level": number = 1
        "hitAct1": string = "shouji1"
        "hitAct2": string = "shouji1_kongzhong"
        "hitAct3": string = "shouji6"
        "hitAct4": string = "shouji6_kongzhong"
        "spineName": string = "jizhongtexiao"
        "animationName": string = "jizhong1S"
        "stunPoint": number = 10
        "damagePercent": number = 0.3
        "buffType": string = ""
        "addY": number;
        "subY": number;
    }


    export class skill_struct {
        "skillIcon": string = "skskkk/"
        "desName": string = "普通攻击"
        "animation": string = "ptgongji_1"
        "endAnimation": string = "ptgongji_1huifu"
        "brokenLevel": number = 5
        "raiseLimitStunPoint": number = 2
        "chongzhuang": number = 0
        "xiaohao_nuqi": number = 0
        "shanghai1": skill_shanghai_s
        "shanghai2": skill_shanghai_s


    }


    export class baseRole extends baseObj {
        m_name: string = "";
        m_res: string = "";
        m_SpineNode: SkeletonAnimation_Ex = null;
        m_curHp: number = 0;
        m_curAnimation: string = "daiji";
        m_roledir: number = -1;
        m_defaultZ: number = 0;
        m_curSkillInfo: skill_struct = null;
        m_curSkillName: string = null;
        m_buffControl: buffControl = null;
        m_actionPauseCounter: number = 0;
        m_ground: cc.Vec2 = cc.p(0, 0);
        m_beHitActName: string = "shouji1";
        m_shanghaiMap: MapGame = null;
        m_spineLineControl: spineLine = null;
        m_EventEmitter: EventEmitter = null;
        m_wudi_time: number = 0;
        m_isControlRole: boolean = false;
        m_shaderFlash: shaderFlash = null;
        m_SpriteShadow: cc.Sprite = null;
        shutdown_flag: boolean = false;
        m_xuetiao: ui_xuetiao = null;
        m_firstresetPosition: boolean = false;
        m_playStateControl_Parallel: playStateControl_Parallel = null;
        m_playCdControl: playCdControl = null;

        m_baseRole_js: cc.baseRole_jsb = null;

        // m_update_0_3_func:Function = null;
        constructor() {
            super();
            this.m_buffControl = new buffControl(this);
            this.m_shanghaiMap = new MapGame();
            this.m_EventEmitter = new EventEmitter();
            this.getNode().setName("baseRole类");
            //  this.m_update_0_3_func = this.update_0_3.bind(this);
            // rootScene.getMe().m_timingControl_03s.onLoop(this.m_update_0_3_func );


        }

        shutdown() {
            if( this.m_baseRole_js )
            {
                this.m_baseRole_js.retain();
            }
            if (this.shutdown_flag == true) {
                return;
            }
            this.shutdown_flag = true;
            this.m_EventEmitter.emit("exit");
            if (this.m_spineLineControl) {
                this.m_spineLineControl.shutdown();
                this.m_spineLineControl = null;
            }
            if (this.m_buffControl)
                this.m_buffControl.shutdown();
            if (this.m_SpriteShadow) {
                roleMgr.getMe().removeChild(this.m_SpriteShadow);
                this.m_SpriteShadow = null;
            }
            if (this.m_SpineNode) {
                this.removeChild(this.m_SpineNode.getNode());
                this.m_SpineNode = null;
            }
            console.log("卸载资源" + this.m_res);
        }

        getState(aitype: e_AiType): baseState {
            return null;
        }

        getRunState(): aiBase_run {
            return <aiBase_run>this.getState(e_AiType.g_AiType_run);
        }

        setxunyun(flag: boolean) {

        }

        //脚底阴影
        createShadow() {

            if (ccs._parser.g_isLowCpu == true)
                return;

            if (this.m_SpriteShadow)
                return;
            this.m_SpriteShadow = new cc.Sprite("xingjiezhuzhuxia2/big/spine/yingzi.png");
            this.m_SpriteShadow.setAnchorPoint(0.5, 0.5);
            this.m_SpriteShadow.setPosition(cc.p(0, 0));
            roleMgr.getMe().addChild(this.m_SpriteShadow, this.getLocalZOrder() - 100);
        }

        updateShadow(t) {
            try
            {
                if (this.m_SpriteShadow)
                {
                    if (this.isdead() && this.m_SpriteShadow.isVisible()) {
                        this.m_SpriteShadow.setVisible(false);
                        if (this.m_xuetiao) {
                            this.m_xuetiao.setVisible(false);
                        }
                    }
                    else
                    {
                        this.m_SpriteShadow.setPosition(cc.p(this.getPosition().x, this.m_ground.y));
                    }
                }
            }
            catch (e) {
            }
        }

        setRunDir(dir) {
            let run = this.getState(e_AiType.g_AiType_run);
            run.setRunDir(dir);
        }


        // 设置骨骼动画速率
        setSpeed(per) {
            try {
                this.m_SpineNode.setTimeScale(per);
            }
            catch (e) {
                console.log(e.stack);
            }
        }

        getPlayCdControl() {
            return this.m_playCdControl;
        }

        getTimeScale() {
            return this.m_SpineNode.getTimeScale();
        }

        //返回暴击概率
        getBaojiPer(role: baseRole) {
            return 50;
        }

        // 重置初始速率
        resetSpeed() {
            this.m_SpineNode.setTimeScale(1);
        }

        // 无敌状态
        // 玩家被大受击之后，着陆动画、起身动画时无敌，另外起身后短时间无敌。大概0.5秒
        isWudi() {
            if (this.getCurStateType() == e_AiType.g_AiType_fallDown) {
                return true;
            }
            if (this.getCurStateType() == e_AiType.g_AiType_beiji_qishen) {
                return true;
            }
            if (this.m_wudi_time > 0) {
                return true;
            }
            return false;
        }

        loop_wudi(t) {
            if (this.m_wudi_time < 0)
                return;
            this.m_wudi_time -= t;
        }

        isPlay() {
            return this.m_SpineNode.isPlay();
        }

        //是否战斗状态
        isFight() {
            return false;
        }

        isStateEnd() {
            return this.getCurStateInfo().m_isEnd;
        }

        //是否是按键不能操作的状态
        isNotOperation() {
            if (this.isSkyState()) {
                return true;
            }
            switch (this.getCurStateType()) {
                //case e_AiType.g_AiType_beiji:
                //    return true;
                //    break;
                case e_AiType.g_AiType_beiji_tiaoqi:
                    return true;

                case e_AiType.g_AiType_beiji_qishen:
                    return true;

                case e_AiType.g_AiType_fallDown:
                    return true;

                case e_AiType.g_AiType_Dead:
                    return true;

                case e_AiType.g_AiType_dead_zhuolu:
                    return true;

            }
            return false;
        }

        //掉落状态
        isFallDown() {
            if (this.getCurStateType() == e_AiType.g_AiType_fallDown) {
                return true;
            }
            return false;
        }

        //被击状态
        isBeiji() {
            switch (this.getCurStateType()) {
                case e_AiType.g_AiType_beiji:
                    return true;
                case e_AiType.g_AiType_beiji_tiaoqi:
                    return true;
                case e_AiType.g_AiType_beiji_qishen:
                    return true;

            }
            return false;
        }

        //是否在蓄力状态
        isXuli() {
            return false;
        }

        isdead() {
            return false;
        }

        //死亡处理 是否可以
        isdealdead() {
            if (this.isSkyState()) {
                return false;
            }
            if (this.getcurhp() <= 0) {
                return true;
            }
            return false;
        }

        getSkillInfo(name): skill_struct {
            return null;
        }

        getRoleName(): string {
            return this.m_name;
        }

        fuhuo() {
            // parMgr.getMe().createListAnimation_playOnce("xingjiezhuzhuxia2/big/pre/chusheng.plist", this, cc.p(0, 0));
            this.setHp(this.getmaxhp());
            this.changeState_Ex(e_AiType.g_AiType_Idle);
        }

        getCurStateInfo() {
            return null;
        }

        // 返回类型 GameMap
        getenemy(): Map< number,baseRole > {
            if (this.getType() == g_ObjType.play || this.getType() == g_ObjType.follower) {
                return roleMgr.getMe().getMonsterAlive();
            }
            else {
                return roleMgr.getMe().getPlayerAlive();
            }
        }

        HitPause(float) {
            this.m_actionPauseCounter += float;
            this.setSpeed(0);
            //PublicTimer.getMe().delayInvoke(this.resetSpeed, float,this);
        }


        //返回队友 活着的
        getTeam() {
            return null;
        }

        //返回队友 死了的
        getTeam_dead() {
            return null;
        }

        getName() {
            return this.m_name;
        }

        getDistance(pos: cc.Vec2) {
            return cc.pDistance(this.getPosition(), pos);
        }

        getDisX(pos: cc.Vec2) {
            let ret = cc.Vec2.sub(this.getPosition(), pos);
            return Math.abs(ret.x);

        }

        getDis(pos: cc.Vec2) {
            let ret = cc.pSub(this.getPosition(), pos);
            return cc.p(Math.abs(ret.x), Math.abs(ret.y));

        }

        setLocalZOrder(z) {
            this.m_defaultZ = z;
            super.setLocalZOrder(z);
        }

        getShoujidianBoneWroldPosition() {
            return this.getBoneWroldPosition("shoujidian");
        }

        getshoujizudang() {
            return this.m_SpineNode.getBoundingBoxBySlotName("shoujizudang");
        }

        getPhyRect() {
            return this.getshoujizudang();
        }

        getShenti_w() {
            return this.m_SpineNode.getBoundingBoxBySlotName("shoujizudang").width;
        }

        getShenti_h() {
            return this.m_SpineNode.getBoundingBoxBySlotName("shoujizudang").height;
        }

        getHeadBoneWroldPosition() {
            return this.getBoneWroldPosition("head");
        }

        hasBone(bonename) {
            let pspBone = this.m_SpineNode.findBone(bonename);
            if (pspBone) {
                return true;
            }
            return true;
        }

        getBoneWroldPosition(bonename) {
            let pspBone = this.m_SpineNode.getBoneWorldPos_Root(bonename);
            if (pspBone) {
                let buff = cc.p(pspBone.x * this.m_SpineNode.getScaleX(), pspBone.y * this.m_SpineNode.getScaleY());
                let buff1 = this.getPosition();
                return cc.pAdd(buff, buff1);
            }
            else {
                // uiMgr.getMe().show_ui_MessageBox(true, "error SkeletonAnimation_Ex::getBoneWorldPos   " + this.m_name + "没有这个骨骼 ：" + bonename);
                //cc.message("SkeletonAnimation_Ex::getBoneWorldPos", bonename.c_str() );
                //  console.( "error SkeletonAnimation_Ex::getBoneWorldPos   " + this.m_name + "没有这个骨骼 ：" + bonename);
                //  return this.m_SpineNode.getPosition();
                return null;
            }
            // return cc.p(0, 0);


        }

        //骨骼移动相对偏移位置
        getBone_RelativePos(bonename) {
            let pspBone = this.m_SpineNode.findBone(bonename);
            if (pspBone) {
                let data = cc.p(pspBone.worldX * this.m_SpineNode.getScaleX(), pspBone.worldY * this.m_SpineNode.getScaleY());
                //data = cc.pAdd(data, this.getParent().getPosition());
                return data;
            }
            else {
                console.error("error SkeletonAnimation_Ex::getBone_RelativePos  没有这个骨骼 ： %s", bonename);
            }
            return cc.p(0, 0);
        }

        zanting(flag) {
            if (flag) {
                if (this.m_SpineNode) {
                    this.m_SpineNode.pause();
                }
            }
            else {
                if (this.m_SpineNode) {
                    this.m_SpineNode.resume();
                }
            }
            if (this.m_spineLineControl) {
                this.m_spineLineControl.zanting(flag);
            }
        }

        //受到伤害的数值处理
        dealDamage(affector: baseRole, affectSkill) {
            let a = proforFunc.create();
            //攻击力公式：角色攻击力*技能倍率
            if (!affectSkill) {
                console.log("");
            }
            let attackPoint = affectSkill.damagePercent * affector.getOutAtt(this);
            this.dealDamage_val(affector, attackPoint);
            a.end("dealDamage");
        }

        dealDamage_val(affector: baseRole, attackPoint: number) {

        }

        updateShanghaiMap(affectorId, attackPoint) {
            if (this.m_shanghaiMap.hasData(affectorId)) {
                let oldattackPoint = this.m_shanghaiMap.getDataByKey(affectorId);
                this.m_shanghaiMap.put(affectorId, oldattackPoint + attackPoint);
            }
            else {
                this.m_shanghaiMap.put(affectorId, attackPoint);
            }
        }

        getShanghaiMap() {

            return this.m_shanghaiMap;
        }


        //天空中
        isSkyState() {
            if (e_AiType.g_AiType_beiji_tiaoqi == this.getCurStateType()) {
                return true;
            }
            let curpos = this.getBoneWroldPosition("root_2");
            if (curpos == null) {
                curpos = this.getPosition();
            }
            if (curpos.y - this.m_ground.y > 50) {
                return true;
            }
            return false;
        }

        //怪物后退被击
        onMonsterBackBeiji(roleObj) {
        }

        changeState(type, roleObj = null) {
        }

        changeState_Ex(type) {
        }

        //死亡受击处理
        dealDamageAction_dead(damageInfo: skill_shanghai_s, roleObj: baseRole) {
            if (this.isdealdead() == true) {
                this.m_beHitActName = damageInfo.hitAct3;
                this.changeState(e_AiType.g_AiType_beiji_tiaoqi, roleObj);
                return true;
            }
            return false;
        }

        //是否小被击 0 无被击 1： 小 2： 大
        isSmallHit() {
            if (this.getCurStateType() == e_AiType.g_AiType_beiji_qishen)
                return 2;
            if (this.isBeiji()) {
                if (this.m_curAnimation == "shouji0") {
                    return 1;
                }
                else if (this.m_curAnimation == "shouji1") {
                    return 1;
                }
                else if (this.m_curAnimation == "shouji2") {
                    return 1;
                }
                else if (this.m_curAnimation == "shouji3") {
                    return 1;
                }
                else if (this.m_curAnimation == "shouji4") {
                    return 1;
                }
                return 2;
            }
            return 0;
        }

        getDamageActionAnimation(damageInfo, roleObj) {
            let retobj: any = {};
            retobj._hitType = "";

            //基础硬值
            let basestun = this.getBaseAntiStun();
            //计算硬直  基础硬值 + 技能硬值
            retobj.rolestun = this.getAntiStun();

            let stun = retobj.rolestun * 1.5; // 大于%50 重击
            //先设置播放哪种被击动画
            let hit1 = null;
            let hit2 = null;
            let bsky = this.isSkyState();
            if (bsky == true) {
                hit1 = "hitAct2";
                hit2 = "hitAct4";
            }
            else {
                hit1 = "hitAct1";
                hit2 = "hitAct3";
            }
            let bigHit = damageInfo.stunPoint >= stun;
            if (bigHit) {
                retobj._hitType = hit2;
            }
            else {
                retobj._hitType = hit1;

                if (damageInfo.stunPoint >= basestun * 1.5) {
                    retobj._hitType = hit2;
                }
                else {
                    retobj._hitType = hit1;
                }
            }
            //倒在地面能被击
            if (this.m_curAnimation.indexOf("zhuolu") > -1) {
                retobj._hitType = hit2;
            }
            //索引名称处理
            let actName = damageInfo[retobj._hitType];
            retobj._isRoute = false;
            if (actName.indexOf("_luxian") > -1) {
                actName = actName.replace(/_luxian/, "");
                retobj._isRoute = true;
            }

            this.m_beHitActName = actName;

            if (actName == "shouji6" || actName == "shouji7") {
                retobj._isRoute = true;
            }
            return retobj;
        }

        //受到伤害的动作处理
        dealDamageAction(damageInfo: skill_shanghai_s, roleObj: baseRole) {
            let retobj = this.getDamageActionAnimation(damageInfo, roleObj);
            if (retobj.rolestun >= damageInfo.stunPoint) { //没有被击
                //被击后动作切换
                if (this.dealDamageAction_dead(damageInfo, roleObj) == true) {
                    return;
                }

                if (this.m_curAnimation.indexOf("zhuolu") > -1) {
                    return;
                }

                if (this.isSkyState()) {
                    return;
                }

                this.onMonsterBackBeiji(roleObj);

                return;
            }
            if (retobj._hitType == "hitAct2" || retobj._hitType == "hitAct4" || retobj._isRoute) {
                this.changeState(e_AiType.g_AiType_beiji_tiaoqi, roleObj);
            }
            else {
                //被击后动作切换
                if (this.dealDamageAction_dead(damageInfo, roleObj) == true) {
                    return;
                }
                if (this.isSmallHit() == 2) {
                    return;
                }
                this.changeState(e_AiType.g_AiType_beiji, roleObj);
            }
        }

        //受到伤害的特效处理
        dealDamageEffect(effectSpineName, effectAnimationName) {
            // let _proforFunc = proforFunc.create();
            if (effectSpineName == null) {
                uiMgr.getMe().show_ui_MessageBox(true, "子弹表中的hit【shanghai】下没有 spineName");
                return;
            }
            if (effectSpineName == "") {
                uiMgr.getMe().show_ui_MessageBox(true, "子弹表中的hit【shanghai】下没有 spineName");
                return;
            }
            //this.playPlistAnimation_Once(plistEffect);
            // if(  ccs._parser.g_isLowCpu == false )
            {
                let ret = spineMgr.getMe().createSpineOncePlay(effectSpineName, effectAnimationName, roleMgr.getMe().getNode(), cc.p(0, 100), this.getLocalZOrder() + 23);
                if (ret) {
                    let pos = this.getBoneWroldPosition("shoujidian");
                    ret.m_SpineNode.setPosition(pos);
                }
            }
            // _proforFunc.end("dealDamageEffect");
        }

        //被 affectorSkill 击中
        OnHit(affector: baseRole, damageInfo: skill_shanghai_s) {

            let a = proforFunc.create();

            if (this.isWudi() == true) {
                return;
            }

            if (affector != null) {
                //处理buff
                // this.dealBuff(affector, damageInfo);
                this.m_buffControl.createBuff(affector.getName(), damageInfo);
                //掉血数值计算
                this.dealDamage(affector, damageInfo);
                //特效计算
                this.dealDamageEffect(damageInfo.spineName, damageInfo.animationName);
                //处理被击状态
                this.dealDamageAction(damageInfo, affector);

                this.startBloom();
            }

            a.end("baserole_OnHit");

        }

        OnBulletHit(affector, damageInfo, nodeObj) {

            if (this.isWudi() == true) {
                return;
            }
            if (affector != null) {
                // this.dealBuff(affector, damageInfo); //加buff
                this.m_buffControl.createBuff(affector.getName(), damageInfo);
                //掉血数值计算
                this.dealDamage(affector, damageInfo);
                //特效计算
                this.dealDamageEffect(damageInfo.spineName, damageInfo.animationName);
                //处理被击状态
                this.dealDamageAction(damageInfo, nodeObj);
                //处理buff
                this.startBloom();
            }
        }

        fuhuoRole() {
            this.setHp(this.getmaxhp());
            this.changeState_Ex(e_AiType.g_AiType_Idle);
            spineMgr.getMe().createSpineOncePlay("chushengtexiao", "play", roleMgr.getMe().getNode(), this.getPosition(), 1);
        }

        create_baseRole_js()
        {
            if (cc.sys.isNative)
            {
                if(this.m_baseRole_js)
                    return;

                this.m_baseRole_js = new cc.baseRole_jsb();
                this.m_baseRole_js.retain();
                this.m_baseRole_js.initEx(this.getNode(), this.m_SpineNode.getNode());
            }

        }

        loadres(res): any {
            this.m_res = res;
            this.createShadow();

            this.m_SpineNode = spineMgr.getMe().loadSpine(res, this.getNode(), 4);
            this.create_baseRole_js();


            this.m_shaderFlash = new shaderFlash(this.m_SpineNode);

            this.setRoleDir(this.m_roledir);
            this.playAnimation("daiji");

            this.m_SpineNode.setStartListener(function (trackIndex) {
                this.onFrameEvent("Start");
            }.bind(this));
            this.m_SpineNode.setEndListener(function (traceIndex) {
                this.onFrameEvent("End");
            }.bind(this));
            this.m_SpineNode.setCompleteListener(function (traceIndex, loopCount) {
                this.onFrameEvent("Complete");
            }.bind(this));
            this.m_SpineNode.setEventListener(function (traceIndex, event) {
                this.onFrameEvent("event", event);
            }.bind(this));
            if (rootScene.getMe().iszanting() == true) {
                this.zanting(true);
            }
            return true;
        }

        onFrameEvent(type, event) {
            if (type == "event") {
                if (event.data.name.indexOf(".mp3") >= 0) {
                    musicMgr.getMe().playeffect(event.data.name);
                }
            }
        }

        //朝向 dir:1 左边  dir:0 右边
        setRoleDir(dir) {
            this.m_roledir = dir;
            let nowScale = this.m_SpineNode.getScale();
            if (nowScale < 0) {
                nowScale = -nowScale;
            }
            this.m_SpineNode.setScaleX(nowScale * dir);
        }

        //控制角色方向
        setDir(dir) {
            if (dir > 0) {
                this.setRoleDir(1);
            } else if (dir < 0) {
                this.setRoleDir(-1);
            }
        }

        getDir() {
            return this.m_roledir;
        }

        getmaxhp() {
            return 1;
        }

        setHp(val) {
            this.m_curHp = val;
            if (this.m_xuetiao)
                this.m_xuetiao.setHpPer(this.getcurhp() / this.getmaxhp() * 100);
        }

        removeHp(val) {
        }

        addHp(val, _notEffect = null) {
        }


        getcurhp() {
            return this.m_curHp;
        }

        gethpPer() {
            return (this.getcurhp() / this.getmaxhp()) * 100;
        }

        getOutAttNoBuff() {
            return 1;
        }

        getOutAtt(role: baseRole) {
            return 1;
        }

        getAntiStun() {
            return 1;
        }

        getBaseAntiStun() {
            return 1;
        }

        getOutSpeed() {
            return 0;
        }

        setRolePosition(x, y) {
            this.m_SpineNode.setPosition(cc.p(x, y));
        }

        getCurStateType(): e_AiType {
            return e_AiType.g_AiType_Dead;
        }


        //0.3调用一次
        update_0_3(dt: number) {

        }

        update(dt) {
            this.loop_wudi(dt);
            this.loopShader(dt);
            this.loopShader_wudi_shanshuo(dt);
            this.updateShadow(dt);
            this.update_ZOrder();

            if (this.m_buffControl) {
                this.m_buffControl.update(dt);
            }

            //攻击时的暂停处理
            if (this.m_actionPauseCounter > 0) {
                if (this.m_SpineNode.getTimeScale() > 0) {
                    this.m_SpineNode.setTimeScale(0);
                }
                this.m_actionPauseCounter -= dt;
                if (this.m_actionPauseCounter <= 0) {
                    this.m_actionPauseCounter = 0;
                    this.resetSpeed();
                }
            }

        }

        playAnimation(name, loop: any = null, mix: any = null, mintime: any = null, b_setToSetupPose: any = null) {

            if (name == null) {
                console.log("playAnimation 不能为空！" + name);
                return;
            }
            if (loop == null) {
                loop = true;
            }
            if (mix == null) {
                mix = false;
                mintime = 0;
            }
            if (b_setToSetupPose == null) {
                b_setToSetupPose = true;
            }
            // if (this.getType() == g_ObjType.follower) {
            //     console.log("playAnimation:" + name);
            // }
            let data = g_AnimationMix[name];
            if (data != null) {
                let curAnimationMixName = data[this.m_curAnimation];
                if (curAnimationMixName != null) {
                    this.m_SpineNode.setMix(this.m_curAnimation, name, curAnimationMixName["mixtime"]);
                    this.m_SpineNode.setMix(name, this.m_curAnimation, curAnimationMixName["mixtime"]);
                }
                if (data["isReset"] != null) {
                    b_setToSetupPose = data["isReset"];
                }
            }
            if (mix) {
                this.m_SpineNode.setMix(this.m_curAnimation, name, mintime);
                this.m_SpineNode.setMix(name, this.m_curAnimation, mintime);
            }
            //this.m_SpineNode.setMix(this.m_curAnimation, name, 0.1);
            //this.m_SpineNode.setMix(name, this.m_curAnimation, 0.1);
            this.m_curAnimation = name;
            if (b_setToSetupPose) {
                this.m_SpineNode.setToSetupPose();
            }
            let ret = null;
            //this.m_SpineNode.clearTracks();
            ret = this.m_SpineNode.setAnimation(0, name, loop);
            //if (this.m_oldAnimation) {
            //    this.m_SpineNode.clearTracks();
            //    ret = this.m_SpineNode.setAnimation(0, name, loop);
            //}
            //else {
            //    ret = this.m_SpineNode.setAnimation(0, name, loop);
            //}
            if (ret == null) {
                uiMgr.getMe().show_ui_MessageBox(true, "没有动画" + name + "怪物" + this.getRoleName());
            }
        }

        //在身体上播放一个序列帧动画
        // playPlistAnimation (name, loop) {
        //     if (loop == null) {
        //         loop = false;
        //     }
        //     parMgr.getMe().initListAnimation(name, loop);
        //}
        // //在身体上播放一个序列帧动画
        // playPlistAnimation_Once (name) {
        //     if (name == null) {
        //         return;
        //     }
        //     if (name == "") {
        //         return;
        //     }
        //
        //     let pSprite_Once = new Sprite_Once();
        //     pSprite_Once.initEx(roleMgr.getMe(), name, this.getHeadHpPosition());
        //}
        //
        //
        playBuffSpineAnimation_Once(spineName, animation) {
            let shoujidianpos = this.getBoneWroldPosition("shoujidian");
            let pos = this.getPosition();
            let pSpine_Once = spineMgr.getMe().createSpineOncePlay(spineName, animation, this.getNode(), cc.pSub(shoujidianpos, pos), 1000);
            pSpine_Once.m_SpineNode.setScale(g_buff_config["public"][0].scale);
        }

        playBuffSpineAnimation_Once_foot(spineName, animation) {
            let shoujidianpos = this.getBoneWroldPosition("root");
            let pos = this.getPosition();
            let pSpine_Once = spineMgr.getMe().createSpineOncePlay(spineName, animation, this.getNode(), cc.pSub(shoujidianpos, pos), 1000);
            pSpine_Once.m_SpineNode.setScale(g_buff_config["public"][0].scale);
        }

        playBuffSpineAnimation_loop() {
        }

        //开始shader
        startBloom() {
            let _proforFunc = proforFunc.create();
            // if(ccs._parser.g_isLowCpu == true )
            //     return;
            this.m_shaderFlash.startBloom();
            _proforFunc.end("startBloom");
        }

        loopShader(t) {
            this.m_shaderFlash.loopShader(t);
        }

        //结束shader
        endBloom() {
            this.m_shaderFlash.endBloom();
        }

        //开始shader 闪烁
        loopShader_wudi_shanshuo(t) {
            // if(ccs._parser.g_isLowCpu == true ){
            //     return;
            // }
            this.m_shaderFlash.loopShader_shanshuo(t, this.isWudi());
        }

        createXueTiao(pos, per, name) {
            this.m_xuetiao = ui_xuetiao.create(name);
            this.m_SpineNode.addChild(this.m_xuetiao.getNode());
            this.m_xuetiao.setPosition(pos);
            this.m_xuetiao.setAnchorPoint(cc.p(0.5, 0.5));
            this.m_xuetiao.setHpPer(per);
        }

        //控制骨骼移动
        // 设置是否停止移动跟root 骨骼  0 停止移动 1 : 移动
        startResetPosition() {
            if (cc.sys.isNative) {
                this.m_baseRole_js.startResetPosition();
            }

            this.m_SpineNode.startPlayAnimation();
            this.m_SpineNode.m_StartPos_anmimation = this.getPosition();
            this.m_firstresetPosition = true;

        }

        stopMoveRootBone(flag) {
            if (cc.sys.isNative) {
                if (!this.m_SpineNode) {
                    return;
                }
                //console.log("stopMoveRootBone 01" + flag);
                this.m_SpineNode.SetBoneData("root", flag);
            }
            else {
                if (!this.m_SpineNode) {
                    return;
                }
                let pspBone = this.m_SpineNode.findBone("root");
                if (!pspBone) {
                    return;
                }
                pspBone.isMoveX = flag;
            }
        }

        //重置root 节点 到世界坐标  islerp(精确碰撞)

        resetPosition( t , ischongzhuang = null ): any {

            //  return;

            if (this.m_firstresetPosition == true) {
                this.m_firstresetPosition = false;
                return true;
            }

            if (cc.sys.isNative)
            {
                return  this.m_baseRole_js.resetPosition();
            }
            else {

                //判断方向
                let l_resetPos = cc.pAdd(this.m_SpineNode.UndataRootBoneWorldPos(), this.getPosition());
                let cameraMgrrect = cameraMgr.getMe().getRect();
                if (cc.rectContainsPoint(cameraMgrrect, l_resetPos)) {
                    this.setPositionEx(l_resetPos);
                    return l_resetPos;
                }
                else {
                    let endpoint = cameraMgrrect.x + cameraMgrrect.width;
                    let dis_l = funcMgr.getMe().float_dis(l_resetPos.x, cameraMgrrect.x);
                    let dis_r = funcMgr.getMe().float_dis(l_resetPos.x, endpoint);
                    if (dis_l < dis_r) {
                        l_resetPos.x = cameraMgrrect.x;
                    }
                    else {
                        l_resetPos.x = cameraMgrrect.x + cameraMgrrect.width;
                    }
                    this.setPositionEx(l_resetPos);
                }

                return l_resetPos;
            }


        }

        //特别处理冲撞技能
        //144 角色在屏幕边缘释放位移技能的时候，正方向被墙壁挡住不往前走没错，反方向对着空气也不能往前走。
        resetPositionEx(_resetPos) {
            this.m_SpineNode.m_StartPos_anmimation.x = this.m_SpineNode.m_StartPos_anmimation.x + (this.m_SpineNode.m_StartPos_anmimation.x - _resetPos.x) / 3;
            return _resetPos;
        }

        getRootPosition() {
            return this.m_SpineNode.getBoneWorldPos("root");
        }

        dealDamageNumberPosition() {
            return this.getPosition();
        }

        setPositionEx(position) {
            let pos_old = this.getPosition();
            let dis = cc.pDistance(pos_old, position);
            if (dis > 100) {
                this.setPosition(position);
            }
            this.setPosition(position);
            return true;
        }


        //与身体碰撞
        dealPhyWithRect(rect) {
            let rectme_qugan = this.m_SpineNode.getBoundingBoxBySlotName("shoujizudang");
            if (rectme_qugan.width <= 0.1) {
                return 0;
            }
            if (cc.rectIntersectsRect(rectme_qugan, rect)) {
                return 1;
            }
            return 0;
        }

        //碰撞处理
        dealPhy(baseRole_enemy:baseRole, colliderIndex:string ) {
            let rect = this.m_SpineNode.getBoundingBoxBySlotName(colliderIndex);
            if (rect.width <= 0.1) {
                return 0;
            }
            if (rect.height <= 0.1) {
                return 0;
            }

            let rectme_qugan = baseRole_enemy.m_SpineNode.getBoundingBoxBySlotName("shoujizudang");
            if (cc.rectIntersectsRect(rectme_qugan, rect)) {
                //g_logger("碰撞体：" + colliderIndex + "碰撞了" + baseRole_enemy.getRoleName() + "！！！！");
                return 1;
            }
            return 0;
        }

        roleDeathEvent() {
        }

        isRun(): boolean {
            switch (this.getCurStateType()) {
                case e_AiType.g_AiType_run:
                    return true;

                case e_AiType.g_AiType_shache:
                    return true;

            }
            return false;
        }

        isIdle(): boolean {
            switch (this.getCurStateType()) {
                case e_AiType.g_AiType_Idle:
                    return true;

            }
            return false;
        }

        setControlRole(flag: boolean) {
            this.m_isControlRole = flag;
            if(flag)
                cameraMgr.getMe().reset(this);
        }

        isControlRole() {
            return this.m_isControlRole;
        }

        setPosition(pos: cc.Vec2) {
            super.setPosition(pos);
        }

        //只有改变了位置才需要调用
        update_ZOrder() {
            this.setLocalZOrder(2000 - this.getPositionY());
        }

    }
}
