var game;
(function (game) {
    var buffControl = (function () {
        function buffControl(heroobj) {
            this.m_ice_buff = new game.removeSpeedBuff(heroobj);
            this.m_faint_buff = new game.xuanyunBuff(heroobj);
        }
        buffControl.prototype.shutdown = function () {
            this.m_ice_buff.shutdown();
            this.m_faint_buff.shutdown();
        };
        buffControl.prototype.createBuff = function (name, damageInfo) {
            if (damageInfo["buffType"] != null) {
                var buffName = damageInfo["buffType"];
                var buff = this.getBuffConfig(name, buffName);
                if (buff.buffType == game.g_buffType.buffType_removeSpeedBuff) {
                    this.m_ice_buff.buff_start(buff.continueTime, buff.perCoefficient);
                }
                else if (buff.buffType == game.g_buffType.buffType_xuanyun) {
                    this.m_faint_buff.buff_start(buff.continueTime);
                }
                else {
                    console.error("createBuff buffType error");
                }
            }
        };
        buffControl.prototype.getBuffConfig = function (name, key) {
            var bufflist = game.g_buff_config[name];
            for (var p in bufflist) {
                if (key == p) {
                    return bufflist[p];
                }
            }
            return null;
        };
        buffControl.prototype.update = function (t) {
            this.m_faint_buff.loop(t);
            this.m_ice_buff.loop(t);
        };
        buffControl.prototype.isFaint = function () {
            if (this.m_faint_buff.m_buffdata)
                return this.m_faint_buff.m_buffdata.continueTime > 0;
            return false;
        };
        //移动速度
        buffControl.prototype.getBuffSpeed = function () {
            if (this.m_ice_buff.m_buffdata) {
                if (this.m_ice_buff.m_buffdata.continueTime > 0) {
                    return -this.m_ice_buff.getPerCoefficient();
                }
            }
            return 0;
        };
        buffControl.create = function (heroobj) {
            return new buffControl(heroobj);
        };
        return buffControl;
    }());
    game.buffControl = buffControl;
})(game || (game = {}));
//# sourceMappingURL=buffControl.js.map