module game {
    export class buffControl {
        m_ice_buff:removeSpeedBuff;
        m_faint_buff:xuanyunBuff;
        static create = function (heroobj) {
            return new buffControl(heroobj);
        };

        constructor(heroobj) {
            this.m_ice_buff = new removeSpeedBuff(heroobj);
            this.m_faint_buff = new xuanyunBuff(heroobj);
        }

        shutdown() {
            this.m_ice_buff.shutdown();
            this.m_faint_buff.shutdown();
        }

        createBuff(name, damageInfo){
            if (damageInfo["buffType"] != null) {
                let buffName = damageInfo["buffType"];
                let buff = this.getBuffConfig(name,buffName);
                if(buff.buffType == g_buffType.buffType_removeSpeedBuff){
                    this.m_ice_buff.buff_start(buff.continueTime,buff.perCoefficient);
                }else if(buff.buffType == g_buffType.buffType_xuanyun) {
                    this.m_faint_buff.buff_start(buff.continueTime);
                }else{
                    console.error("createBuff buffType error");
                }
            }
        }

        getBuffConfig(name, key) {
            let bufflist = g_buff_config[name];
            for (let p in bufflist) {
                if (key == p) {
                    return bufflist[p];
                }
            }
            return null;
        }

        update(t) {
            this.m_faint_buff.loop(t);
            this.m_ice_buff.loop(t);
        }

        isFaint(){
            if(this.m_faint_buff.m_buffdata)
                return this.m_faint_buff.m_buffdata.continueTime > 0;
            return false;
        }

        //移动速度
        getBuffSpeed() {
            if(this.m_ice_buff.m_buffdata){
                if(this.m_ice_buff.m_buffdata.continueTime > 0){
                    return -this.m_ice_buff.getPerCoefficient();
                }
            }
            return 0;
        }
    }

}