var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var game;
(function (game) {
    var monster = (function (_super) {
        __extends(monster, _super);
        function monster() {
            _super.call(this);
            this.m_monster_config_Data = null;
            this.m_monsterAiControl = null;
            this.m_monsterStateControl = null;
            this.m_isboss = false;
            this.m_bloodBarNum = 0;
            this.m_monsterMaxHp = 0;
            this.m_birthwave = null; //刷怪波次名称
            this.m_canDelete = false;
            this.m_timer = 0;
            this.m_Type = game.g_ObjType.monster;
            this.m_roledir = -1;
            this.m_monsterStateControl = new game.monsterStateControl(this);
            this.getNode().setName("monster类");
        }
        monster.prototype.shutdown = function () {
            var _state = this.getState(game.e_AiType.g_AiType_run);
            _state.shutdown();
            if (this.m_isboss) {
                game.ui_zhandoujm.getMe().m_boss.setVisible(false);
            }
            _super.prototype.shutdown.call(this);
        };
        monster.prototype.setPosition = function (in_xjPoint) {
            var nowpos = this.getPosition();
            var dis = cc.pDistance(nowpos, in_xjPoint);
            if (dis > 200) {
                _super.prototype.setPosition.call(this, in_xjPoint);
            }
            _super.prototype.setPosition.call(this, in_xjPoint);
        };
        monster.prototype.getmaxhp = function () {
            return this.m_monsterMaxHp;
        };
        monster.prototype.setMaxHp = function (hp) {
            if (hp <= 1) {
                hp = 1;
            }
            this.m_monsterMaxHp = hp;
        };
        monster.prototype.setHp = function (val) {
            this.m_curHp = parseInt(val);
            if (this.m_curHp < 0) {
                this.m_curHp = 0;
            }
            if (this.m_isboss) {
                game.ui_zhandoujm.getMe().setBossHp(this.getcurhp() / this.getmaxhp() * 100);
            }
            else {
                if (this.m_xuetiao)
                    this.m_xuetiao.setHpPer(this.getcurhp() / this.getmaxhp() * 100);
            }
            if (this.getcurhp() <= 0) {
                game.roleMgr.getMe().monsterDead(this);
            }
        };
        monster.prototype.removeHp = function (val) {
            if (val < 0)
                return;
            val = parseInt(val);
            var buff = this.getcurhp() - val;
            if (buff < 0) {
                buff = 0;
            }
            game.uieffectMgr.getMe().dropHp(game.roleMgr.getMe(), val, this.dealDamageNumberPosition());
            this.setHp(buff);
        };
        monster.prototype.addHp = function (val, _notEffect) {
            if (_notEffect === void 0) { _notEffect = null; }
            if (val < 0)
                return;
            var buff = this.getcurhp() + val;
            if (buff > this.getmaxhp()) {
                buff = this.getmaxhp();
            }
            this.setHp(buff); //
            game.uieffectMgr.getMe().addHp(game.roleMgr.getMe(), val, this.getBoneWroldPosition("head"));
        };
        monster.prototype.OnHit = function (affector, damageInfo) {
            _super.prototype.OnHit.call(this, affector, damageInfo);
            // 增加连击数和怒气
            game.playComboMgr.getMe().addCombo();
        };
        monster.prototype.fuhuo = function () {
            // parMgr.getMe().createListAnimation_playOnce("xingjiezhuzhuxia2/big/pre/chusheng.plist", this, cc.p(0, 0));
            this.setHp(this.getmaxhp());
            this.changeState_Ex(game.e_AiType.g_AiType_Idle);
        };
        monster.prototype.getBasemiss = function () {
            return this.m_monster_config_Data.dodgeRate;
        };
        monster.prototype.getBasesdefense = function () {
            var defense = this.m_monster_config_Data.defencePoint;
            return defense;
        };
        monster.prototype.getBaseAtt = function () {
            return this.m_monster_config_Data.attackPoint;
        };
        //其实基础cd
        monster.prototype.getBasecd = function () {
            return 0;
        };
        // 输出总的速度
        monster.prototype.getOutSpeed = function () {
            var buffspeed = this.m_buffControl.getBuffSpeed();
            var speed = this.m_monster_config_Data.runSpeed;
            if (buffspeed != 0)
                speed *= (1 + buffspeed);
            return speed;
        };
        //获得总的输出伤害没有buff
        monster.prototype.getOutAttNoBuff = function () {
            var attper = game.sceneMgr.getMe().getCurSceneInfo().attper;
            return (this.getBaseAtt() * attper);
        };
        //获得总的输出伤害
        monster.prototype.getOutAtt = function (role) {
            var NoBuff = this.getOutAttNoBuff();
            // var att = NoBuff * (1 + this.m_buffControl.getAttBuff(role));
            return NoBuff;
        };
        monster.prototype.getBaseAntiStun = function () {
            return this.m_monster_config_Data.antiStun;
        };
        monster.prototype.getAntiStun = function () {
            var skillAntiAtun = 0;
            if (this.isFight()) {
                if (this.m_curSkillInfo) {
                    if (typeof (this.m_curSkillInfo.raiseLimitStunPoint) == "number") {
                        skillAntiAtun = this.m_curSkillInfo.raiseLimitStunPoint;
                    }
                }
            }
            return this.getBaseAntiStun() + skillAntiAtun;
        };
        monster.prototype.getOutMiss = function () {
            //var missPer = sceneMgr.getMe().getCurSceneInfo().missper;
            // if( missPer )
            //+ this.m_buffControl.getBuffMiss()
            var out = this.getBasemiss();
            if (out < 0) {
                out = 0;
            }
            return out;
        };
        monster.prototype.getOutCd = function () {
            var Basecd = this.getBasecd();
            var out = Basecd;
            if (out < 0) {
                out = 0.01;
            }
            return out;
        };
        monster.prototype.dealDamageNumberPosition = function () {
            var name = this.getRoleName();
            var rootPos = this.getPosition();
            return cc.p(rootPos.x + game.g_monster_config[name].headHpNumberPos.x, game.g_monster_config[name].headHpNumberPos.y + rootPos.y); //cc.p(rootPos.x + g_monster[name].headHpPos_x,g_monster[name].headHpPos_y + rootPos.y) ;
        };
        monster.prototype.isWudi = function () {
            if (this.getCurStateType() == game.e_AiType.g_AiType_beiji_qishen) {
                return true;
            }
            return false;
        };
        //是否战斗状态
        monster.prototype.isFight = function () {
            switch (this.getCurStateType()) {
                case game.e_AiType.g_AiType_autofight_ptgongji1:
                    return true;
                case game.e_AiType.g_AiType_autofight_ptgongji2:
                    return true;
                case game.e_AiType.g_AiType_autofight_ptgongji3:
                    return true;
                case game.e_AiType.g_AiType_autofight_ptgongji4:
                    return true;
                case game.e_AiType.g_AiType_autofight_skill:
                    return true;
            }
            return false;
        };
        //返回队友
        monster.prototype.getTeam = function () {
            return game.roleMgr.getMe().getMonsterAlive();
        };
        monster.prototype.init = function (data) {
            this.initex(data);
            var hpper = game.sceneMgr.getMe().getCurSceneInfo().hpper;
            this.setMaxHp(this.m_monster_config_Data.hp * hpper);
            if (this.m_isboss) {
                this.m_monsterAiControl = game.bossAiControl.create(this);
            }
            else {
                this.m_monsterAiControl = game.monsterAiControl.create(this);
            }
            this.setHp(this.getmaxhp());
            this.initAi();
        };
        monster.prototype.isboss = function () {
            return this.m_isboss;
        };
        monster.prototype.initAi = function () {
            this.m_monsterStateControl.initState();
        };
        monster.prototype.getState = function (type) {
            return this.m_monsterStateControl.getState(type);
        };
        monster.prototype.addState = function (data, type) {
            this.m_monsterStateControl.addState(data, type);
        };
        monster.prototype.isdead = function () {
            if (this.getCurStateType() == game.e_AiType.g_AiType_Dead) {
                return true;
            }
            return false;
        };
        monster.prototype.getCurStateType = function () {
            return this.m_monsterStateControl.getCurStateType(); //  this.m_cur_RoleAiState.m_stateType;
        };
        monster.prototype.getCurStateInfo = function () {
            return this.m_monsterStateControl.getCurStateInfo(); //this.m_cur_RoleAiState;
        };
        //强制切换状态
        monster.prototype.changeState_Ex = function (key, data) {
            if (data === void 0) { data = null; }
            return this.m_monsterStateControl.changeState_Ex(key, data);
        };
        monster.prototype.changeState = function (key, data) {
            if (data === void 0) { data = null; }
            // if ("qishen" == key) {
            //     console.log("monster:" + key);
            // }
            // console.log("monster:" + key);
            return this.m_monsterStateControl.changeState(key, data);
        };
        monster.prototype.initex = function (data) {
            var name = data["monstername"];
            this.m_name = name;
            this.m_ground = cc.p(data["pos_x"], data["pos_y"]); //设置位置
            this.setPosition(this.m_ground);
            if (game.g_monster_config[name] == null) {
                console.log("g_monster_config 表没有" + name);
            }
            this.m_monster_config_Data = cc.clone(game.g_monster_config[name]);
            this.m_isboss = (this.m_monster_config_Data.type.indexOf("boss") > -1);
            // this.m_monster_config_Data = roleInfo;
            this.loadres(this.m_monster_config_Data.spine_res); //加载资源
            this.m_SpineNode.setScale(this.m_monster_config_Data.scale);
            var pos = this.m_monster_config_Data.headHpBarPos;
            // boss 不用创建头顶血条
            if (this.m_isboss) {
                this.initBossBloodBar();
            }
            else {
                this.createXueTiao(pos, 100, this.m_monster_config_Data.bloodName);
            }
            this.setRoleDir(this.m_roledir);
            // this.m_buffControl.init(this.getBuffIconMap());
        };
        monster.prototype.setxunyun = function (flag) {
            if (flag) {
                this.changeState(game.e_AiType.g_AiType_yun);
            }
            else {
                this.changeState(game.e_AiType.g_AiType_Idle);
            }
        };
        monster.prototype.resetPosition = function (t, ischongzhuang) {
            if (this.m_monsterAiControl.m_baseState_beiji_houtui.isActive() == true) {
                return;
            }
            _super.prototype.resetPosition.call(this, t, ischongzhuang);
        };
        //m_update_time: 0
        //0.3秒 调用一次
        monster.prototype.update_0_3 = function (dt) {
            // if (ccs._parser.g_isLowCpu == true) {
            //     this.m_timer += dt;
            //     if (this.m_timer > 0.5) {
            //         this.m_timer = 0;
            //         this.m_monsterAiControl.update(dt);
            //     }
            // } else
            {
                this.m_monsterAiControl.update(dt);
            }
        };
        monster.prototype.update = function (dt) {
            var _proforFunc = game.proforFunc.create();
            // return;
            _super.prototype.update.call(this, dt);
            this.m_monsterStateControl.loop(dt);
            if (this.isboss()) {
                this.m_monsterAiControl.update(dt);
                return;
            }
            _proforFunc.end("monster" + this.getName() + "update:" + game.g_AiType.getAiTypeStr(this.getCurStateType()));
        };
        monster.prototype.onFrameEvent = function (type, event) {
            //this.m_cur_RoleAiState.onFrameEvent(type, event);
            this.m_monsterStateControl.onFrameEvent(type, event);
            _super.prototype.onFrameEvent.call(this, type, event);
        };
        monster.prototype.onMonsterBackBeiji = function (roleObj) {
            this.m_monsterAiControl.onMonsterBackBeiji(roleObj);
        };
        //伤害处理
        monster.prototype.dealDamage_val = function (affector, attackPoint) {
            attackPoint = attackPoint * game.g_debug._debug_play_att_per;
            if (attackPoint < 1) {
                attackPoint = 1;
            }
            var isCrit = false;
            //暴击率 改成公式
            var crit = affector.getBaojiPer(this);
            var randNum = Math.floor(Math.random() * 1000 + 1);
            if (randNum <= crit * 10) {
                attackPoint *= 2;
                isCrit = true;
            }
            //判断闪避
            // let rend = cc.random0To1() * 100;
            // if (rend <= this.getOutMiss()) {
            //     uieffectMgr.getMe().addmiss(roleMgr.getMe(), "", this.getBoneWroldPosition("head"));
            //     return;
            // }
            //伤害公式：攻击力-攻击力*防御比率
            // attackPoint -= attackPoint * this.getOutDefense();
            // if (attackPoint <= 1) {
            //     attackPoint = 1;
            // }
            //设置生命值
            this.setHp(this.getcurhp() - attackPoint);
            this.updateShanghaiMap(affector.__instanceId, attackPoint);
            //UI伤害数字
            if (isCrit)
                game.uieffectMgr.getMe().dropCritHp(game.roleMgr.getMe(), attackPoint, this.dealDamageNumberPosition());
            else
                game.uieffectMgr.getMe().dropHp(game.roleMgr.getMe(), attackPoint, this.dealDamageNumberPosition());
        };
        monster.prototype.initBossBloodBar = function () {
            // 当boss出现时显示头像和血条
            // 重置血条 显示头像
            if (game.ui_zhandoujm.getMe()) {
                // this.m_bossUI = ui_zhandoujm.getMe().getUnUsedBossUI();
                // if( this.m_bossUI == null )
                // {
                //     return;
                // }
                // this.m_bloodBarNum = this.m_monster_config_Data.bloodbar_num;
                game.ui_zhandoujm.getMe().initBossBloodBar(this.m_name);
            }
        };
        monster.create = function () {
            return new monster();
        };
        return monster;
    }(game.baseRole));
    game.monster = monster;
})(game || (game = {}));
//# sourceMappingURL=monster.js.map 
//# sourceMappingURL=monster.js.map