module game {
    export class monster extends baseRole {
        m_monster_config_Data: monster_config_data_s = null;
        m_monsterAiControl: baseAiControl = null;
        m_monsterStateControl: monsterStateControl = null;
        m_isboss: boolean = false;
        m_bloodBarNum: number = 0;
        m_monsterMaxHp: number = 0;
        m_birthwave: string = null; //刷怪波次名称
        m_canDelete: boolean = false;
        m_timer = 0;

        static create = function () {
            return new monster();
        };

        constructor() {
            super();
            this.m_Type = g_ObjType.monster;
            this.m_roledir = -1;
            this.m_monsterStateControl = new monsterStateControl(this);
            this.getNode().setName("monster类");
        }

        shutdown()
        {
            let _state : monsterAi_run = <monsterAi_run>this.getState( e_AiType.g_AiType_run );
            _state.shutdown();

            if ( this.m_isboss )
            {
                ui_zhandoujm.getMe().m_boss.setVisible(false);
            }

            super.shutdown();
        }

        setPosition(in_xjPoint: cc.Vec2) {
            let nowpos: cc.Vec2 = this.getPosition();
            let dis = cc.pDistance(nowpos, in_xjPoint);
            if (dis > 200) {
                super.setPosition(in_xjPoint);
            }

            super.setPosition(in_xjPoint);
        }

        getmaxhp() {
            return this.m_monsterMaxHp;
        }

        setMaxHp(hp) {
            if (hp <= 1) {
                hp = 1;
            }
            this.m_monsterMaxHp = hp;
        }

        setHp(val) {
            this.m_curHp = parseInt(val);
            if (this.m_curHp < 0) {
                this.m_curHp = 0;
            }

            if (this.m_isboss) {

                ui_zhandoujm.getMe().setBossHp(this.getcurhp() / this.getmaxhp() * 100);
            } else {
                if (this.m_xuetiao)
                    this.m_xuetiao.setHpPer(this.getcurhp() / this.getmaxhp() * 100);
            }

            if (this.getcurhp() <= 0) {
                roleMgr.getMe().monsterDead(this);
            }
        }

        removeHp(val) {
            if (val < 0)
                return;
            val = parseInt(val);
            var buff = this.getcurhp() - val;
            if (buff < 0) {
                buff = 0;
            }
            uieffectMgr.getMe().dropHp(roleMgr.getMe(), val, this.dealDamageNumberPosition());
            this.setHp(buff);
        }

        addHp(val, _notEffect = null) {
            if (val < 0)
                return;
            var buff = this.getcurhp() + val;
            if (buff > this.getmaxhp()) {
                buff = this.getmaxhp();
            }
            this.setHp(buff); //
            uieffectMgr.getMe().addHp(roleMgr.getMe(), val, this.getBoneWroldPosition("head"));
        }


        OnHit(affector: baseRole, damageInfo: skill_shanghai_s) {
            super.OnHit(affector, damageInfo);
            // 增加连击数和怒气
            playComboMgr.getMe().addCombo();
        }

        fuhuo() {
            // parMgr.getMe().createListAnimation_playOnce("xingjiezhuzhuxia2/big/pre/chusheng.plist", this, cc.p(0, 0));
            this.setHp(this.getmaxhp());
            this.changeState_Ex(e_AiType.g_AiType_Idle);
        }

        getBasemiss() {
            return this.m_monster_config_Data.dodgeRate;
        }

        getBasesdefense() {
            var defense = this.m_monster_config_Data.defencePoint;
            return defense;
        }

        getBaseAtt() {
            return this.m_monster_config_Data.attackPoint;
        }

        //其实基础cd
        getBasecd(): number {
            return 0;
        }

        // 输出总的速度
        getOutSpeed() {
            var buffspeed = this.m_buffControl.getBuffSpeed();
            var speed = this.m_monster_config_Data.runSpeed;
            if (buffspeed != 0)
                speed *= (1 + buffspeed);
            return speed;
        }

        //获得总的输出伤害没有buff
        getOutAttNoBuff() {
            var attper = sceneMgr.getMe().getCurSceneInfo().attper;
            return (this.getBaseAtt() * attper);
        }

        //获得总的输出伤害
        getOutAtt(role: baseRole) {
            var NoBuff = this.getOutAttNoBuff();
            // var att = NoBuff * (1 + this.m_buffControl.getAttBuff(role));
            return NoBuff;
        }

        getBaseAntiStun() {
            return this.m_monster_config_Data.antiStun;
        }

        getAntiStun() {
            var skillAntiAtun = 0;
            if (this.isFight()) {
                if (this.m_curSkillInfo) {
                    if (typeof (this.m_curSkillInfo.raiseLimitStunPoint) == "number") {
                        skillAntiAtun = this.m_curSkillInfo.raiseLimitStunPoint;
                    }
                }
            }
            return this.getBaseAntiStun() + skillAntiAtun;
        }

        getOutMiss() {
            //var missPer = sceneMgr.getMe().getCurSceneInfo().missper;
            // if( missPer )
            //+ this.m_buffControl.getBuffMiss()
            var out = this.getBasemiss();
            if (out < 0) {
                out = 0;
            }
            return out;
        }

        getOutCd() {
            var Basecd: number = this.getBasecd();
            var out: number = Basecd;
            if (out < 0) {
                out = 0.01;
            }
            return out;
        }

        dealDamageNumberPosition() {
            var name = this.getRoleName();
            var rootPos = this.getPosition();
            return cc.p(rootPos.x + g_monster_config[name].headHpNumberPos.x, g_monster_config[name].headHpNumberPos.y + rootPos.y); //cc.p(rootPos.x + g_monster[name].headHpPos_x,g_monster[name].headHpPos_y + rootPos.y) ;
        }

        isWudi() {
            if (this.getCurStateType() == e_AiType.g_AiType_beiji_qishen) {
                return true;
            }
            return false;
        }


        //是否战斗状态
        isFight() {
            switch (this.getCurStateType()) {
                case  e_AiType.g_AiType_autofight_ptgongji1:
                    return true;

                case  e_AiType.g_AiType_autofight_ptgongji2:
                    return true;

                case  e_AiType.g_AiType_autofight_ptgongji3:
                    return true;

                case  e_AiType.g_AiType_autofight_ptgongji4:
                    return true;

                case  e_AiType.g_AiType_autofight_skill:
                    return true;

            }
            return false;
        }


        //返回队友
        getTeam() {
            return roleMgr.getMe().getMonsterAlive();
        }

        init(data) {
            this.initex(data);
            var hpper = sceneMgr.getMe().getCurSceneInfo().hpper;
            this.setMaxHp(this.m_monster_config_Data.hp * hpper);
            if (this.m_isboss) {
                this.m_monsterAiControl = bossAiControl.create(this);
            }
            else {
                this.m_monsterAiControl = monsterAiControl.create(this);
            }
            this.setHp(this.getmaxhp());
            this.initAi();
        }

        isboss() {
            return this.m_isboss;
        }

        initAi() {
            this.m_monsterStateControl.initState();
        }

        getState(type) {
            return this.m_monsterStateControl.getState(type);
        }

        addState(data, type) {
            this.m_monsterStateControl.addState(data, type);
        }

        isdead() {
            if (this.getCurStateType() == e_AiType.g_AiType_Dead) {
                return true;
            }

            return false;
        }

        getCurStateType() {
            return this.m_monsterStateControl.getCurStateType(); //  this.m_cur_RoleAiState.m_stateType;
        }

        getCurStateInfo(): baseState {
            return this.m_monsterStateControl.getCurStateInfo(); //this.m_cur_RoleAiState;
        }

        //强制切换状态
        changeState_Ex(key, data = null) {
            return this.m_monsterStateControl.changeState_Ex(key, data);
        }

        changeState(key, data: any = null) {
            // if ("qishen" == key) {
            //     console.log("monster:" + key);
            // }
            // console.log("monster:" + key);
            return this.m_monsterStateControl.changeState(key, data);
        }

        initex(data) {
            var name = data["monstername"];
            this.m_name = name;
            this.m_ground = cc.p(data["pos_x"], data["pos_y"]); //设置位置

            this.setPosition(this.m_ground);
            if (g_monster_config[name] == null) {
                console.log("g_monster_config 表没有" + name);
            }
            this.m_monster_config_Data = cc.clone(g_monster_config[name]);
            this.m_isboss = (this.m_monster_config_Data.type.indexOf("boss") > -1 );


            // this.m_monster_config_Data = roleInfo;
            this.loadres(this.m_monster_config_Data.spine_res); //加载资源
            this.m_SpineNode.setScale(this.m_monster_config_Data.scale);
            var pos = this.m_monster_config_Data.headHpBarPos;

            // boss 不用创建头顶血条
            if (this.m_isboss) {
                this.initBossBloodBar();
            } else {
                this.createXueTiao(pos, 100, this.m_monster_config_Data.bloodName);
            }

            this.setRoleDir(this.m_roledir);
            // this.m_buffControl.init(this.getBuffIconMap());
        }

        setxunyun(flag) {
            if (flag) {
                this.changeState(e_AiType.g_AiType_yun);
            }
            else {
                this.changeState(e_AiType.g_AiType_Idle);
            }
        }

        resetPosition(t, ischongzhuang) {
            if (this.m_monsterAiControl.m_baseState_beiji_houtui.isActive() == true) {
                return;
            }
            super.resetPosition(t, ischongzhuang);
        }

        //m_update_time: 0
        //0.3秒 调用一次
        update_0_3(dt) {
            // if (ccs._parser.g_isLowCpu == true) {
            //     this.m_timer += dt;
            //     if (this.m_timer > 0.5) {
            //         this.m_timer = 0;
            //         this.m_monsterAiControl.update(dt);
            //     }
            // } else
            {
                this.m_monsterAiControl.update(dt);
            }
        }

        update(dt) {

            let _proforFunc = proforFunc.create();
            // return;
            super.update(dt);
            this.m_monsterStateControl.loop(dt);
            if (this.isboss()) {
                this.m_monsterAiControl.update(dt);
                return;
            }

            _proforFunc.end("monster" + this.getName() + "update:" + g_AiType.getAiTypeStr(this.getCurStateType()));
        }

        onFrameEvent(type, event) {
            //this.m_cur_RoleAiState.onFrameEvent(type, event);
            this.m_monsterStateControl.onFrameEvent(type, event);
            super.onFrameEvent(type, event);
        }

        onMonsterBackBeiji(roleObj) {
            this.m_monsterAiControl.onMonsterBackBeiji(roleObj);
        }

        //伤害处理
        dealDamage_val(affector: baseRole, attackPoint: number) {
            attackPoint = attackPoint * g_debug._debug_play_att_per;
            if (attackPoint < 1) {
                attackPoint = 1;
            }
            let isCrit = false;
            //暴击率 改成公式
            let crit = affector.getBaojiPer(this);
            let randNum = Math.floor(Math.random() * 1000 + 1);
            if (randNum <= crit * 10) {
                attackPoint *= 2;
                isCrit = true;
            }
            //判断闪避
            // let rend = cc.random0To1() * 100;
            // if (rend <= this.getOutMiss()) {
            //     uieffectMgr.getMe().addmiss(roleMgr.getMe(), "", this.getBoneWroldPosition("head"));
            //     return;
            // }
            //伤害公式：攻击力-攻击力*防御比率
            // attackPoint -= attackPoint * this.getOutDefense();
            // if (attackPoint <= 1) {
            //     attackPoint = 1;
            // }
            //设置生命值
            this.setHp(this.getcurhp() - attackPoint);

            this.updateShanghaiMap(affector.__instanceId, attackPoint);
            //UI伤害数字
            if (isCrit)
                uieffectMgr.getMe().dropCritHp(roleMgr.getMe(), attackPoint, this.dealDamageNumberPosition());
            else
                uieffectMgr.getMe().dropHp(roleMgr.getMe(), attackPoint, this.dealDamageNumberPosition());
        }

        initBossBloodBar() {
            // 当boss出现时显示头像和血条
            // 重置血条 显示头像

            if (ui_zhandoujm.getMe()) {
                // this.m_bossUI = ui_zhandoujm.getMe().getUnUsedBossUI();
                // if( this.m_bossUI == null )
                // {
                //     return;
                // }
                // this.m_bloodBarNum = this.m_monster_config_Data.bloodbar_num;
                ui_zhandoujm.getMe().initBossBloodBar(this.m_name);
            }
        }

    }

}
//# sourceMappingURL=monster.js.map