module game {
    export class worldBoss extends monster {
        m_isdead:boolean = false;
        static create = function () {
            return new worldBoss();
        };

        constructor() {
            super();
            this.getNode().setName("worldBoss类");
        }

        init(data) {
            this.m_name = "heianwulingwang_boss";
            this.m_ground = cc.p(data["pos_x"], data["pos_y"]);
            this.setPosition(this.m_ground);
            this.m_monster_config_Data = cc.clone(g_monster_config[this.m_name]);
            this.m_monster_config_Data.attackPoint = data.attackPoint;
            this.m_monsterMaxHp = data.maxhp;
            this.m_curHp = data.curhp;
            this.initBossBloodBar();
            this.loadres(this.m_monster_config_Data.spine_res); //加载资源
            this.setRoleDir(this.m_roledir);
            this.m_SpineNode.setScale(this.m_monster_config_Data.scale);

            this.m_monsterAiControl = bossAiControl.create(this);
            ui_zhandoujm.getMe().setBossHp(this.getcurhp() / this.getmaxhp() * 100);
            this.initAi();
        }

        setHp(val) {
            if(this.m_isdead) return;
            this.m_curHp = parseInt(val);
            if (this.m_curHp <= 0) {
                sceneMgr.getMe().getCurScene().gameOver(true);
                this.m_isdead = true;
            }
            ui_zhandoujm.getMe().setBossHp(this.getcurhp() / this.getmaxhp() * 100);
        }

        dealDamage_val(affector: baseRole, attackPoint: number) {
            attackPoint = attackPoint * g_debug._debug_play_att_per;
            let isCrit = false;
            //暴击率 改成公式
            let crit = affector.getBaojiPer(this);
            let randNum = Math.floor(Math.random() * 1000 + 1);
            if (randNum <= crit * 10) {
                attackPoint *= 2;
                isCrit = true;
            }
            //设置生命值
            this.setHp(this.getcurhp() - attackPoint);
            this.updateShanghaiMap(affector.__instanceId, attackPoint);
            //UI伤害数字
            if (isCrit)
                uieffectMgr.getMe().dropCritHp(roleMgr.getMe(), attackPoint, this.dealDamageNumberPosition());
            else
                uieffectMgr.getMe().dropHp(roleMgr.getMe(), attackPoint, this.dealDamageNumberPosition());
            sceneMgr.getMe().getCurScene().setDamage(attackPoint);
        }
    }

}
//# sourceMappingURL=monster.js.map