var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
/**
 * Created by xieli on 2016/4/24.
 */
//玩家技能动作基本类
var game;
(function (game) {
    var aiBase_play = (function (_super) {
        __extends(aiBase_play, _super);
        function aiBase_play() {
            _super.apply(this, arguments);
        }
        return aiBase_play;
    }(game.aiBase_skill));
    game.aiBase_play = aiBase_play;
    var aiBaseSkill_play = (function (_super) {
        __extends(aiBaseSkill_play, _super);
        function aiBaseSkill_play(role, skillTypeName) {
            _super.call(this, role);
            this.m_skillInfo = null;
            this.m_state = 0;
            this.m_skillTypeName = null;
            this.m_isEndAnimation = 1;
            this.m_skillTypeName = skillTypeName;
            this.m_skillInfo = this.m_object_role.getSkillInfo(skillTypeName);
        }
        aiBaseSkill_play.prototype.InternalEvent = function (key, data) {
            if (data != null) {
                this.m_isEndAnimation = parseInt(data.endAnimate); //;
            }
            _super.prototype.InternalEvent.call(this, key, data);
            if (this.m_skillInfo == null) {
                game.uiMgr.getMe().show_ui_MessageBox(true, "技能天赋没有填表：" + this.m_skillTypeName);
                return false;
            }
            this.m_object_role.m_curSkillInfo = this.m_skillInfo;
        };
        aiBaseSkill_play.prototype.ExternalEvent = function (key, data) {
            return _super.prototype.ExternalEvent.call(this, key, data);
        };
        aiBaseSkill_play.prototype.Complete = function () {
            //判断是否有回复动画
            if (this.m_isEndAnimation == 1) {
                if (this.endAnimation()) {
                    return true;
                }
            }
            _super.prototype.Complete.call(this);
            return true;
        };
        aiBaseSkill_play.prototype.endAnimation = function () {
            //判断是否有回复动画
            var skill = this.m_object_role.m_curSkillInfo.endAnimation;
            if (skill != null) {
                this.m_object_role.changeState(game.e_AiType.g_AiType_endAnimate);
                return true;
            }
            return false;
        };
        return aiBaseSkill_play;
    }(game.aiBase_skill));
    game.aiBaseSkill_play = aiBaseSkill_play;
    var playerAi_idle = (function (_super) {
        __extends(playerAi_idle, _super);
        function playerAi_idle() {
            _super.apply(this, arguments);
        }
        return playerAi_idle;
    }(game.aiBase_idle));
    game.playerAi_idle = playerAi_idle;
    var playerAi_run = (function (_super) {
        __extends(playerAi_run, _super);
        function playerAi_run() {
            _super.apply(this, arguments);
            this.m_Rect = cc.rect(game.g_walkRect.x, game.g_walkRect.y, game.g_walkRect.width, game.g_walkRect.height);
            this.m_aiBaseRun_jsb = null;
        }
        playerAi_run.prototype.ExternalEvent = function (key, data) {
            var ret = _super.prototype.ExternalEvent.call(this, key, data);
            return ret;
        };
        playerAi_run.prototype.shutdown = function () {
            if (this.m_aiBaseRun_jsb) {
                this.m_aiBaseRun_jsb.release();
                this.m_aiBaseRun_jsb = null;
            }
        };
        playerAi_run.prototype.InternalEvent = function (key, data) {
            var ret = _super.prototype.InternalEvent.call(this, key, data);
            if (cc.sys.isNative) {
                if (this.m_aiBaseRun_jsb == null) {
                    this.m_aiBaseRun_jsb = new cc.aiBaseRun_jsb();
                    this.m_aiBaseRun_jsb.initEx(this.m_object_role.m_baseRole_js);
                    this.m_aiBaseRun_jsb.retain();
                }
            }
            return ret;
        };
        playerAi_run.prototype.update = function (t) {
            // return;
            var _proforFunc = game.proforFunc.create();
            this.m_runTime += t;
            if (!game.playControl.getMe().m_maxSpeed) {
                if (this.m_runTime >= 0.5) {
                    game.playControl.getMe().m_maxSpeed = true;
                    this.m_runTime = 0;
                }
            }
            if (cc.sys.isNative) {
                this.m_zhuangqiang = this.m_aiBaseRun_jsb.update(this.m_dir, this.m_speed, t);
            }
            else {
                this.js_update(t);
            }
            this.m_object_role.m_ground.y = this.m_object_role.getPosition().y;
            _proforFunc.end("playerAi_run - " + this.m_object_role.getName());
            return true;
        };
        playerAi_run.prototype.js_update = function (t) {
            var pos = this.m_object_role.getPosition();
            var newpos = cc.pAdd(pos, cc.pMult(this.m_dir, this.m_speed * t));
            //已经嵌入到摄像机外面的情况下可以处理
            var walkRect = cc.rectIntersection(game.cameraMgr.getMe().getRect(), this.m_Rect);
            if (this.m_dir.y > 0) {
                if (pos.y > walkRect.height + walkRect.y) {
                    this.m_zhuangqiang = true;
                    return true;
                }
            }
            if (this.m_dir.y < 0) {
                if (pos.y < walkRect.y) {
                    this.m_zhuangqiang = true;
                    return true;
                }
            }
            if (cc.rectContainsPoint(walkRect, pos) == true) {
                if (!cc.rectContainsPoint(walkRect, newpos)) {
                    this.m_zhuangqiang = true;
                    return true;
                }
            }
            this.m_object_role.setPosition(newpos);
        };
        return playerAi_run;
    }(game.aiBase_run));
    game.playerAi_run = playerAi_run;
    var playerAi_shache = (function (_super) {
        __extends(playerAi_shache, _super);
        function playerAi_shache() {
            _super.apply(this, arguments);
        }
        return playerAi_shache;
    }(game.aiBase_shache));
    game.playerAi_shache = playerAi_shache;
    var playerAi_beiji = (function (_super) {
        __extends(playerAi_beiji, _super);
        function playerAi_beiji(role) {
            _super.call(this, role);
            this.m_AnimationName = null;
            this.m_dir = cc.p(1, 0);
            this.m_stateType = game.e_AiType.g_AiType_beiji;
        }
        playerAi_beiji.prototype.shutdown = function () {
            if (this.m_object_role.m_spineLineControl) {
                this.m_object_role.m_spineLineControl.shutdown();
                this.m_object_role.m_spineLineControl = null;
            }
            game.aiBase_public_func.getMe().resetPos_y(this.m_object_role);
            _super.prototype.shutdown.call(this);
        };
        playerAi_beiji.prototype.InternalEvent = function (key, data) {
            //this.resetPos();
            var dir = game.aiBase_public_func.getMe().updataDir(data, this.m_object_role);
            //updata dir
            this.m_AnimationName = this.m_object_role.m_beHitActName;
            _super.prototype.InternalEvent.call(this, key, data);
            if (!this.m_object_role.m_spineLineControl)
                this.m_object_role.m_spineLineControl = game.spineLine_beiji_noanimation.create(this.m_object_role, "luxian", this.m_object_role.m_beHitActName);
            if (dir) {
                this.m_object_role.m_spineLineControl.setRoleDir(-1 * dir);
            }
            this.m_object_role.stopMoveRootBone(0);
            return true;
        };
        playerAi_beiji.prototype.ExternalEvent = function (key, data) {
            if (_super.prototype.ExternalEvent.call(this, key, data) == true) {
                this.shutdown();
                return true;
            }
            return false;
        };
        playerAi_beiji.prototype.update = function (t) {
            if (this.m_object_role.m_spineLineControl) {
                //同步速度
                this.m_object_role.m_spineLineControl.setTimeScale(this.m_object_role.getTimeScale());
                var ret = this.m_object_role.m_spineLineControl.loop(t);
                if (ret == true) {
                    this.m_object_role.m_spineLineControl.shutdown();
                    this.m_object_role.m_spineLineControl = null;
                    this.Complete();
                    return true;
                }
            }
            _super.prototype.update.call(this, t);
            return true;
        };
        playerAi_beiji.prototype.Complete = function () {
            if (this.m_object_role.m_curAnimation == "shouji6"
                || this.m_object_role.m_curAnimation == "shouji7"
                || this.m_object_role.m_curAnimation == "shouji6_kongzhong"
                || this.m_object_role.m_curAnimation == "shouji1_kongzhong") {
                this.m_object_role.changeState(game.e_AiType.g_AiType_fallDown, this.m_AnimationName);
                return;
            }
            if (this.m_object_role.getcurhp() <= 0) {
                this.m_object_role.changeState_Ex(game.e_AiType.g_AiType_dead_zhuolu);
            }
            else {
                _super.prototype.Complete.call(this);
            }
            return true;
        };
        return playerAi_beiji;
    }(game.aiBase_beiji));
    game.playerAi_beiji = playerAi_beiji;
    var playAiBaseSkill_zhuolu = (function (_super) {
        __extends(playAiBaseSkill_zhuolu, _super);
        function playAiBaseSkill_zhuolu(role) {
            _super.call(this, role);
            this.m_stateType = game.e_AiType.g_AiType_dead_zhuolu;
            _super.prototype.initZhongduanLevel.call(this);
        }
        playAiBaseSkill_zhuolu.prototype.InternalEvent = function (key, data) {
            _super.prototype.InternalEvent.call(this, key, data);
            this.m_object_role.startResetPosition();
            game.aiBase_public_func.getMe().resetPos_y(this.m_object_role);
            if (this.m_object_role.m_curAnimation == "shouji6") {
                this.m_object_role.playAnimation("shouji6_kongzhong_zhuolu", false);
            }
            else if (this.m_object_role.m_curAnimation == "shouji7") {
                this.m_object_role.playAnimation("shouji7_zhuolu", false);
            }
            else if (this.m_object_role.m_curAnimation == "shouji1_kongzhong") {
                this.m_object_role.playAnimation("shouji1_kongzhong_zhuolu", false);
            }
            else {
                this.m_object_role.playAnimation("shouji7_zhuolu", false);
            }
            return true;
        };
        playAiBaseSkill_zhuolu.prototype.update = function (t) {
            this.m_object_role.resetPosition(t);
            _super.prototype.update.call(this, t);
            return true;
        };
        playAiBaseSkill_zhuolu.prototype.ExternalEvent = function (key, data) {
            return false;
        };
        playAiBaseSkill_zhuolu.prototype.Complete = function () {
            this.m_object_role.changeState_Ex(game.e_AiType.g_AiType_Dead);
            return true;
        };
        return playAiBaseSkill_zhuolu;
    }(aiBase_play));
    game.playAiBaseSkill_zhuolu = playAiBaseSkill_zhuolu;
    var playerAi_beiji_tiaoqi = (function (_super) {
        __extends(playerAi_beiji_tiaoqi, _super);
        function playerAi_beiji_tiaoqi() {
            _super.apply(this, arguments);
        }
        return playerAi_beiji_tiaoqi;
    }(game.aiBase_beiji_tiaoqi));
    game.playerAi_beiji_tiaoqi = playerAi_beiji_tiaoqi;
    var playerAi_fallDown = (function (_super) {
        __extends(playerAi_fallDown, _super);
        function playerAi_fallDown() {
            _super.apply(this, arguments);
        }
        return playerAi_fallDown;
    }(game.aiBase_fallDown));
    game.playerAi_fallDown = playerAi_fallDown;
    var playerAi_dead = (function (_super) {
        __extends(playerAi_dead, _super);
        function playerAi_dead() {
            _super.apply(this, arguments);
        }
        playerAi_dead.prototype.Complete = function (data) {
            this.m_isEnd = true;
            //弹出
            // this.m_object_role.setVisible(false);
            if (game.roleMgr.getMe().isPlayerAllDead()) {
                if (game.sceneMgr.getMe().getCurSceneType() == game.e_SceneType.SceneType_yindao) {
                    game.sceneMgr.getMe().getCurScene().gameOver(false);
                    return _super.prototype.Complete.call(this, data);
                }
                game.uiMgr.getMe().show_ui_fuhuo(true);
            }
            else {
                if (this.m_object_role.isControlRole()) {
                    game.roleMgr.getMe().setControlPlayer();
                }
            }
            if (this.m_object_role instanceof game.Avatar) {
                // this.m_object_role.setPosition(cc.p(-200,-200));
                return _super.prototype.Complete.call(this, data);
            }
            game.ui_zhandoujm.getMe().updateUI();
            return _super.prototype.Complete.call(this, data);
        };
        return playerAi_dead;
    }(game.aiBase_dead));
    game.playerAi_dead = playerAi_dead;
    var playerAi_yun = (function (_super) {
        __extends(playerAi_yun, _super);
        function playerAi_yun() {
            _super.apply(this, arguments);
        }
        return playerAi_yun;
    }(game.aiBase_yun));
    game.playerAi_yun = playerAi_yun;
    //普通攻击1 用于自动战斗
    var playerAi_ptgongji1 = (function (_super) {
        __extends(playerAi_ptgongji1, _super);
        function playerAi_ptgongji1(role) {
            _super.call(this, role);
            this.m_currentStage = 1;
            this.m_isEndAnimation = 1;
            this.m_state = null;
            this.m_stateType = game.e_AiType.g_AiType_autofight_ptgongji1;
            this.m_currentStage = 1;
            _super.prototype.initZhongduanLevel.call(this);
        }
        playerAi_ptgongji1.prototype.InternalEvent = function (key, data) {
            _super.prototype.InternalEvent.call(this, key, data);
            if (data != null) {
                this.m_isEndAnimation = parseInt(data.endAnimate); //;
            }
            //设置技能信息到状态
            var skillTypeName = "ptgongji_" + this.m_currentStage;
            this.m_skillInfo = this.m_object_role.getSkillInfo(skillTypeName);
            //更新当前技能信息
            this.m_object_role.m_curSkillInfo = this.m_skillInfo;
            //先更新当前技能信息，再播放攻击动作
            this.m_object_role.playAnimation(this.m_skillInfo.animation, true);
            //提升硬直上限功能
            //this.m_object_role.m_antiStunSum += this.m_skillInfo.raiseLimitStunPoint;
            this.m_object_role.stopMoveRootBone(0);
            return true;
        };
        playerAi_ptgongji1.prototype.update = function (t) {
            this.m_object_role.resetPosition(t);
            _super.prototype.update.call(this, t);
            return true;
        };
        playerAi_ptgongji1.prototype.ExternalEvent = function (key, data) {
            var ret = _super.prototype.ExternalEvent.call(this, key, data);
            if (ret == false) {
                return ret;
            }
            //减去硬直加成
            // this.m_object_role.m_antiStunSum -= this.m_skillInfo.raiseLimitStunPoint;
            //设置接招时间
            return true;
        };
        playerAi_ptgongji1.prototype.Complete = function () {
            this.m_state = 1;
            //判断是否有回复动画
            if (this.m_isEndAnimation == 1) {
                if (this.endAnimation() == true) {
                    return true;
                }
            }
            _super.prototype.Complete.call(this);
            return true;
        };
        playerAi_ptgongji1.prototype.endAnimation = function () {
            //判断是否有回复动画
            var skill = this.m_object_role.m_curSkillInfo.endAnimation;
            if (skill != null) {
                this.m_object_role.changeState(game.e_AiType.g_AiType_endAnimate);
                return true;
            }
            return false;
        };
        return playerAi_ptgongji1;
    }(aiBase_play));
    game.playerAi_ptgongji1 = playerAi_ptgongji1;
    var playerAi_ptgongji2 = (function (_super) {
        __extends(playerAi_ptgongji2, _super);
        function playerAi_ptgongji2(role) {
            _super.call(this, role);
            this.m_stateType = game.e_AiType.g_AiType_autofight_ptgongji2;
            this.m_currentStage = 2;
        }
        return playerAi_ptgongji2;
    }(playerAi_ptgongji1));
    game.playerAi_ptgongji2 = playerAi_ptgongji2;
    var playerAi_ptgongji3 = (function (_super) {
        __extends(playerAi_ptgongji3, _super);
        function playerAi_ptgongji3(role) {
            _super.call(this, role);
            this.m_stateType = game.e_AiType.g_AiType_autofight_ptgongji3;
            this.m_currentStage = 3;
        }
        return playerAi_ptgongji3;
    }(playerAi_ptgongji1));
    game.playerAi_ptgongji3 = playerAi_ptgongji3;
    var playerAi_ptgongji4 = (function (_super) {
        __extends(playerAi_ptgongji4, _super);
        function playerAi_ptgongji4(role) {
            _super.call(this, role);
            this.m_stateType = game.e_AiType.g_AiType_autofight_ptgongji4;
            this.m_currentStage = 4;
        }
        return playerAi_ptgongji4;
    }(playerAi_ptgongji1));
    game.playerAi_ptgongji4 = playerAi_ptgongji4;
})(game || (game = {}));
//# sourceMappingURL=playAi.js.map