/**
 * Created by xieli on 2016/4/24.
 */
//玩家技能动作基本类
module  game {

    export class aiBase_play extends aiBase_skill {
    }
    export class aiBaseSkill_play extends aiBase_skill {
        public m_skillInfo: skill_struct = null;
        m_state: any = 0;
        m_skillTypeName: any = null;
        m_isEndAnimation: any = 1;

        constructor(role, skillTypeName) {
            super(role);
            this.m_skillTypeName = skillTypeName;
            this.m_skillInfo = this.m_object_role.getSkillInfo(skillTypeName);
        }


        InternalEvent(key, data) {
            if (data != null) {
                this.m_isEndAnimation = parseInt(data.endAnimate); //;
            }
            super.InternalEvent(key, data);
            if (this.m_skillInfo == null) {
                uiMgr.getMe().show_ui_MessageBox(true, "技能天赋没有填表：" + this.m_skillTypeName);
                return false;
            }
            this.m_object_role.m_curSkillInfo = this.m_skillInfo;
        }

        ExternalEvent(key, data) {
            return super.ExternalEvent(key, data);
        }

        Complete(): boolean {
            //判断是否有回复动画
            if (this.m_isEndAnimation == 1) {
                if (this.endAnimation()) {
                    return true;
                }
            }
            super.Complete();
            return true;
        }

        endAnimation() {
            //判断是否有回复动画
            let skill = this.m_object_role.m_curSkillInfo.endAnimation;
            if (skill != null) {
                this.m_object_role.changeState(e_AiType.g_AiType_endAnimate);
                return true;
            }
            return false;
        }
    }

    export class playerAi_idle extends aiBase_idle {
    }
    export class playerAi_run extends aiBase_run {
        ExternalEvent(key, data) {
            let ret = super.ExternalEvent(key, data);
            return ret;
        }

        shutdown() {
            if (this.m_aiBaseRun_jsb) {
                this.m_aiBaseRun_jsb.release();
                this.m_aiBaseRun_jsb = null;
            }
        }

        m_Rect: any = cc.rect(game.g_walkRect.x, g_walkRect.y, g_walkRect.width, g_walkRect.height);
        m_aiBaseRun_jsb: cc.aiBaseRun_jsb = null;

        InternalEvent(key, data) {

            let ret = super.InternalEvent(key, data);

            if (cc.sys.isNative) {
                if (this.m_aiBaseRun_jsb == null) {
                    this.m_aiBaseRun_jsb = new cc.aiBaseRun_jsb();
                    this.m_aiBaseRun_jsb.initEx(this.m_object_role.m_baseRole_js);
                    this.m_aiBaseRun_jsb.retain();
                }
            }
            return ret;
        }

        update(t) {

            // return;

            let _proforFunc = proforFunc.create();
            this.m_runTime += t;
            if (!playControl.getMe().m_maxSpeed) {
                if (this.m_runTime >= 0.5) {
                    playControl.getMe().m_maxSpeed = true;
                    this.m_runTime = 0;
                }
            }

            if ( cc.sys.isNative )
            {
                this.m_zhuangqiang =   this.m_aiBaseRun_jsb.update(this.m_dir,this.m_speed ,t);
            }
            else
            {
                this.js_update(t);
            }
            this.m_object_role.m_ground.y = this.m_object_role.getPosition().y;
            _proforFunc.end("playerAi_run - " + this.m_object_role.getName());
            return true;
        }

        js_update(t) {
            let pos = this.m_object_role.getPosition();
            let newpos = cc.pAdd(pos, cc.pMult(this.m_dir, this.m_speed * t));
            //已经嵌入到摄像机外面的情况下可以处理

            let walkRect = cc.rectIntersection(cameraMgr.getMe().getRect(), this.m_Rect);
            if (this.m_dir.y > 0) {
                if (pos.y > walkRect.height + walkRect.y) {
                    this.m_zhuangqiang = true;
                    return true;
                }
            }
            if (this.m_dir.y < 0) {
                if (pos.y < walkRect.y) {
                    this.m_zhuangqiang = true;
                    return true;
                }
            }
            if (cc.rectContainsPoint(walkRect, pos) == true) {
                if (!cc.rectContainsPoint(walkRect, newpos)) {
                    this.m_zhuangqiang = true;
                    return true;
                }
            }

            this.m_object_role.setPosition(newpos);
        }


    }


    export class playerAi_shache extends aiBase_shache {
    }
    export class playerAi_beiji extends aiBase_beiji {

        m_AnimationName: string = null;
        m_dir: cc.Vec2 = cc.p(1, 0);

        constructor(role) {
            super(role);
            this.m_stateType = e_AiType.g_AiType_beiji;
        }

        shutdown() {
            if (this.m_object_role.m_spineLineControl) {
                this.m_object_role.m_spineLineControl.shutdown();
                this.m_object_role.m_spineLineControl = null;
            }
            aiBase_public_func.getMe().resetPos_y(this.m_object_role);
            super.shutdown();
        }

        InternalEvent(key, data) {
            //this.resetPos();
            let dir = aiBase_public_func.getMe().updataDir(data, this.m_object_role);
            //updata dir
            this.m_AnimationName = this.m_object_role.m_beHitActName;
            super.InternalEvent(key, data);
            if (!this.m_object_role.m_spineLineControl)
                this.m_object_role.m_spineLineControl = spineLine_beiji_noanimation.create(this.m_object_role, "luxian", this.m_object_role.m_beHitActName);
            if (dir) {
                this.m_object_role.m_spineLineControl.setRoleDir(-1 * dir);
            }
            this.m_object_role.stopMoveRootBone(0);
            return true;
        }

        ExternalEvent(key, data) {
            if (super.ExternalEvent(key, data) == true) {
                this.shutdown();
                return true;
            }
            return false;
        }

        update(t) {
            if (this.m_object_role.m_spineLineControl) {
                //同步速度
                this.m_object_role.m_spineLineControl.setTimeScale(this.m_object_role.getTimeScale());
                let ret = this.m_object_role.m_spineLineControl.loop(t);
                if (ret == true) {
                    this.m_object_role.m_spineLineControl.shutdown();
                    this.m_object_role.m_spineLineControl = null;
                    this.Complete();
                    return true;
                }
            }
            super.update(t);
            return true;
        }

        Complete() {
            if (this.m_object_role.m_curAnimation == "shouji6"
                || this.m_object_role.m_curAnimation == "shouji7"
                || this.m_object_role.m_curAnimation == "shouji6_kongzhong"
                || this.m_object_role.m_curAnimation == "shouji1_kongzhong") {
                this.m_object_role.changeState(e_AiType.g_AiType_fallDown, this.m_AnimationName);
                return;
            }
            if (this.m_object_role.getcurhp() <= 0) {
                this.m_object_role.changeState_Ex(e_AiType.g_AiType_dead_zhuolu);
            }
            else {
                super.Complete();
            }
            return true;
        }
    }
    export class playAiBaseSkill_zhuolu extends aiBase_play {
        constructor(role) {
            super(role);
            this.m_stateType = e_AiType.g_AiType_dead_zhuolu;
            super.initZhongduanLevel();
        }

        InternalEvent(key, data) {
            super.InternalEvent(key, data);
            this.m_object_role.startResetPosition();
            aiBase_public_func.getMe().resetPos_y(this.m_object_role);
            if (this.m_object_role.m_curAnimation == "shouji6") {
                this.m_object_role.playAnimation("shouji6_kongzhong_zhuolu", false);
            }
            else if (this.m_object_role.m_curAnimation == "shouji7") {
                this.m_object_role.playAnimation("shouji7_zhuolu", false);
            }
            else if (this.m_object_role.m_curAnimation == "shouji1_kongzhong") {
                this.m_object_role.playAnimation("shouji1_kongzhong_zhuolu", false);
            }
            else {
                this.m_object_role.playAnimation("shouji7_zhuolu", false);
            }
            return true;
        }

        update(t) {
            this.m_object_role.resetPosition(t);
            super.update(t);
            return true;
        }

        ExternalEvent(key, data) {
            return false;
        }

        Complete() {
            this.m_object_role.changeState_Ex(e_AiType.g_AiType_Dead);
            return true;
        }
    }
    export class playerAi_beiji_tiaoqi extends aiBase_beiji_tiaoqi {
    }
    export class playerAi_fallDown extends aiBase_fallDown {
    }
    export class playerAi_dead extends aiBase_dead {

        Complete(data) {
            this.m_isEnd = true;
            //弹出
            // this.m_object_role.setVisible(false);

            if (roleMgr.getMe().isPlayerAllDead()) {
                if (sceneMgr.getMe().getCurSceneType() == e_SceneType.SceneType_yindao) {
                    sceneMgr.getMe().getCurScene().gameOver(false);
                    return super.Complete(data);
                }
                uiMgr.getMe().show_ui_fuhuo(true);
            } else {
                if (this.m_object_role.isControlRole()) {
                    roleMgr.getMe().setControlPlayer();
                }
            }
            if (this.m_object_role instanceof Avatar) {
                // this.m_object_role.setPosition(cc.p(-200,-200));
                return super.Complete(data);
            }
            ui_zhandoujm.getMe().updateUI();
            return super.Complete(data);
        }
    }
    export class playerAi_yun extends aiBase_yun {
    }
    //普通攻击1 用于自动战斗
    export class playerAi_ptgongji1 extends aiBase_play {
        m_currentStage: any = 1
        m_isEndAnimation: any = 1
        m_state: any = null

        constructor(role) {
            super(role);
            this.m_stateType = e_AiType.g_AiType_autofight_ptgongji1;
            this.m_currentStage = 1;
            super.initZhongduanLevel();
        }

        InternalEvent(key, data) {
            super.InternalEvent(key, data);
            if (data != null) {
                this.m_isEndAnimation = parseInt(data.endAnimate); //;
            }
            //设置技能信息到状态

            let skillTypeName = "ptgongji_" + this.m_currentStage;

            this.m_skillInfo = this.m_object_role.getSkillInfo(skillTypeName);
            //更新当前技能信息
            this.m_object_role.m_curSkillInfo = this.m_skillInfo;
            //先更新当前技能信息，再播放攻击动作
            this.m_object_role.playAnimation(this.m_skillInfo.animation, true);
            //提升硬直上限功能
            //this.m_object_role.m_antiStunSum += this.m_skillInfo.raiseLimitStunPoint;
            this.m_object_role.stopMoveRootBone(0);
            return true;
        }

        update(t) {
            this.m_object_role.resetPosition(t);
            super.update(t);
            return true;
        }

        ExternalEvent(key, data) {
            let ret = super.ExternalEvent(key, data);
            if (ret == false) {
                return ret;
            }
            //减去硬直加成
            // this.m_object_role.m_antiStunSum -= this.m_skillInfo.raiseLimitStunPoint;
            //设置接招时间
            return true;
        }

        Complete() {
            this.m_state = 1;
            //判断是否有回复动画
            if (this.m_isEndAnimation == 1) {
                if (this.endAnimation() == true) {
                    return true;
                }
            }
            super.Complete();
            return true;
        }

        endAnimation() {
            //判断是否有回复动画
            let skill = this.m_object_role.m_curSkillInfo.endAnimation;
            if (skill != null) {
                this.m_object_role.changeState(e_AiType.g_AiType_endAnimate);
                return true;
            }
            return false;
        }
    }
    export class playerAi_ptgongji2 extends playerAi_ptgongji1 {
        constructor(role) {
            super(role);
            this.m_stateType = e_AiType.g_AiType_autofight_ptgongji2;
            this.m_currentStage = 2;
        }
    }
    export class playerAi_ptgongji3 extends playerAi_ptgongji1 {
        constructor(role) {
            super(role);
            this.m_stateType = e_AiType.g_AiType_autofight_ptgongji3;
            this.m_currentStage = 3;
        }
    }
    export class playerAi_ptgongji4 extends playerAi_ptgongji1 {
        constructor(role) {
            super(role);
            this.m_stateType = e_AiType.g_AiType_autofight_ptgongji4;
            this.m_currentStage = 4;
        }
    }

}
