var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
/**
 * Created by cy1234 on 2016/7/30.
 */
var game;
(function (game) {
    var playAutoFightBaseState = (function (_super) {
        __extends(playAutoFightBaseState, _super);
        function playAutoFightBaseState(_playAutoFightControl) {
            _super.call(this);
            this.m_playAutoFightControl = null;
            this.m_data = null;
            this.m_playAutoFightControl = _playAutoFightControl;
            this.m_stateType = game.e_AiType.g_Type_gengsui_play;
        }
        playAutoFightBaseState.prototype.InternalEvent = function (key, data) {
            if (data) {
                this.m_data = cc.clone(data);
            }
            return true;
        };
        playAutoFightBaseState.prototype.getAutoFightHero = function () {
            return this.m_playAutoFightControl.getAutoFightHero();
        };
        //更新目标
        playAutoFightBaseState.prototype.updateTarget = function () {
            // 搜索附近最近的怪物
            var target = game.roleMgr.getMe().getNeerestMonster(this.getAutoFightHero().getPosition(), 500);
            this.m_playAutoFightControl.setTarget(target);
        };
        playAutoFightBaseState.prototype.getTarget = function () {
            return this.m_playAutoFightControl.m_target;
        };
        playAutoFightBaseState.prototype.getRoleObj = function () {
            return this.m_playAutoFightControl.m_roleObj;
        };
        playAutoFightBaseState.prototype.getTargetPos = function () {
            return this.m_playAutoFightControl.m_target.getPosition();
        };
        //主角空闲或跑动 ，随从跟随主角
        playAutoFightBaseState.prototype.update = function (t) {
            //跟随状态
            return true;
        };
        //根据目标位置更新方向
        playAutoFightBaseState.prototype.updateDir = function (pos) {
            if (this.getAutoFightHero().getPositionX() > pos.x) {
                this.getAutoFightHero().setRoleDir(-1);
                return cc.p(-1, 0);
            }
            else {
                this.getAutoFightHero().setRoleDir(1);
                return cc.p(1, 0);
            }
            //return cc.p(0, 0);
        };
        //生成状态列表
        playAutoFightBaseState.prototype.generateStateList = function (pos) {
            var l_statelist = null;
            var distanceTarget = this.getAutoFightHero().getDis(pos);
            var rolename = this.getAutoFightHero().getRoleName();
            var l_Ai_config = game.g_follower_AutoFight_config[rolename];
            if (l_Ai_config == null) {
                game.uiMgr.getMe().show_ui_MessageBox(true, " AutoFight_config 表没有配置自动战斗 hero：" + rolename);
                return null;
            }
            var aiEventInfo = new game.ArrayEx();
            for (var p in l_Ai_config) {
                var obj = l_Ai_config[p];
                if (distanceTarget.x >= obj.disminX && distanceTarget.x <= obj.dismaxX) {
                    if (distanceTarget.y >= obj.disminY && distanceTarget.y <= obj.dismaxY) {
                        aiEventInfo.put(obj);
                    }
                }
            }
            if (aiEventInfo.isEmpty()) {
                return null;
            }
            var allgailv = 0;
            for (var i = 0; i < aiEventInfo.size(); i++) {
                var obj = aiEventInfo.getData(i);
                allgailv += obj["gailv"];
            }
            // let randcount = 0;
            //  while ( ++ randcount < 2 )
            {
                var gailv = cc.random0To1() * allgailv;
                var aigailv = 0;
                for (var i = 0; i < aiEventInfo.size(); i++) {
                    var obj = aiEventInfo.getData(i);
                    var nowgailv = aigailv + obj["gailv"];
                    if (aigailv < gailv && nowgailv >= gailv) {
                        l_statelist = cc.clone(obj["stateList"]);
                        break;
                    }
                    aigailv += obj["gailv"];
                }
            }
            var _map = new game.MapGame();
            for (var p in l_statelist) {
                _map.put(_map.getSize(), l_statelist[p]);
            }
            return _map; //随机抽一个
        };
        return playAutoFightBaseState;
    }(game.baseState));
    game.playAutoFightBaseState = playAutoFightBaseState;
    //g_go 根据go 的指引行走
    var playAutoFight_go = (function (_super) {
        __extends(playAutoFight_go, _super);
        function playAutoFight_go(_playAutoFightControl) {
            _super.call(this, _playAutoFightControl);
            this.m_stateType = game.e_AiType.g_go;
        }
        playAutoFight_go.prototype.shutdown = function () {
        };
        /**
         * @return {boolean}
         */
        playAutoFight_go.prototype.ExternalEvent = function (key, data) {
            return true;
        };
        /**
         * @return {boolean}
         */
        playAutoFight_go.prototype.InternalEvent = function (key, data) {
            //想左边行走
            this.getAutoFightHero().setRunDir(cc.p(1, 0));
            this.getAutoFightHero().changeState(game.e_AiType.g_AiType_run, cc.p(1, 0));
            return true;
        };
        playAutoFight_go.prototype.end = function () {
            this.m_playAutoFightControl.changeState(game.e_AiType.g_Type_randSkill);
        };
        //
        playAutoFight_go.prototype.update = function (t) {
            if (this.getAutoFightHero().isRun() == false) {
                this.end();
                return;
            }
            // 判断go 消失
            if (game.guankaMgr.getMe().isGo() == false) {
                this.end();
                return;
            }
            //撞墙了end
            if (this.getAutoFightHero().getCurStateType() == game.e_AiType.g_AiType_run) {
                if (this.getAutoFightHero().getRunState().m_zhuangqiang == true) {
                    this.end();
                }
            }
            return true;
        };
        return playAutoFight_go;
    }(playAutoFightBaseState));
    game.playAutoFight_go = playAutoFight_go;
    //g_chuansong 行走到传送门
    var playAutoFight_chuansong = (function (_super) {
        __extends(playAutoFight_chuansong, _super);
        function playAutoFight_chuansong(_playAutoFightControl) {
            _super.call(this, _playAutoFightControl);
            this.m_startPos = null;
            this.m_stateType = game.e_AiType.g_chuansong;
        }
        playAutoFight_chuansong.prototype.shutdown = function () {
        };
        playAutoFight_chuansong.prototype.ExternalEvent = function (key, data) {
            return true;
        };
        playAutoFight_chuansong.prototype.InternalEvent = function (key, data) {
            _super.prototype.InternalEvent.call(this, key, data);
            var pos = this.m_data;
            this.m_startPos = cc.clone(this.getAutoFightHero().getPosition());
            //目标点在role前面
            if (this.getAutoFightHero().getPositionX() > pos.x) {
                this.getAutoFightHero().setRunDir(cc.p(-1, 0));
                this.getAutoFightHero().changeState(game.e_AiType.g_AiType_run, cc.p(-1, 0));
            }
            else {
                this.getAutoFightHero().setRunDir(cc.p(1, 0));
                this.getAutoFightHero().changeState(game.e_AiType.g_AiType_run, cc.p(1, 0));
            }
            return true;
        };
        //
        playAutoFight_chuansong.prototype.update = function (t) {
            this.runToTarget(t);
            return true;
        };
        playAutoFight_chuansong.prototype.end = function () {
            this.m_playAutoFightControl.changeState(game.e_AiType.g_Type_randSkill);
        };
        //切换到run状态
        playAutoFight_chuansong.prototype.runToTarget = function (t) {
            var retState = this.getRoleObj().getRunState();
            if (retState.m_zhuangqiang === true) {
                this.end();
                return true;
            }
            if (this.getAutoFightHero().getCurStateType() != game.e_AiType.g_AiType_run) {
                this.end();
                return true;
            }
        };
        return playAutoFight_chuansong;
    }(playAutoFightBaseState));
    game.playAutoFight_chuansong = playAutoFight_chuansong;
    //巡逻
    var playAutoFight_xunluo = (function (_super) {
        __extends(playAutoFight_xunluo, _super);
        function playAutoFight_xunluo(_playAutoFightControl) {
            _super.call(this, _playAutoFightControl);
            this.m_stateType = game.e_AiType.g_xunluo;
        }
        playAutoFight_xunluo.prototype.shutdown = function () {
        };
        /**
         * @return {boolean}
         */
        playAutoFight_xunluo.prototype.ExternalEvent = function (key, data) {
            return true;
        };
        /**
         * @return {boolean}
         */
        playAutoFight_xunluo.prototype.InternalEvent = function (key, data) {
            //想左边行走
            if (data == null) {
                return false;
            }
            var dir = data;
            this.getAutoFightHero().setRunDir(dir);
            this.getAutoFightHero().changeState(game.e_AiType.g_AiType_run, dir);
            return true;
        };
        playAutoFight_xunluo.prototype.end = function () {
            this.m_playAutoFightControl.changeState(game.e_AiType.g_Type_randSkill);
        };
        //
        playAutoFight_xunluo.prototype.update = function (t) {
            if (this.getAutoFightHero().isRun() == false) {
                this.end();
                return;
            }
            this.updateTarget();
            if (this.getTarget() != null) {
                this.end();
                return;
            }
            //撞墙了end
            if (this.getAutoFightHero().getCurStateType() == game.e_AiType.g_AiType_run) {
                if (this.getAutoFightHero().getRunState().m_zhuangqiang == true) {
                    this.m_playAutoFightControl.changeState(game.e_AiType.g_xunluo, cc.p(-1, 0));
                }
            }
            return true;
        };
        return playAutoFight_xunluo;
    }(playAutoFightBaseState));
    game.playAutoFight_xunluo = playAutoFight_xunluo;
    //跟随玩家
    var playAutoFight_gengsui_player = (function (_super) {
        __extends(playAutoFight_gengsui_player, _super);
        function playAutoFight_gengsui_player(_playAutoFightControl) {
            _super.call(this, _playAutoFightControl);
            this.m_stateType = game.e_AiType.g_Type_gengsui_play;
        }
        playAutoFight_gengsui_player.prototype.shutdown = function () {
        };
        /**
         * @return {boolean}
         */
        playAutoFight_gengsui_player.prototype.ExternalEvent = function (key, data) {
            return true;
        };
        /**
         * @return {boolean}
         */
        playAutoFight_gengsui_player.prototype.InternalEvent = function (key, data) {
            return true;
        };
        playAutoFight_gengsui_player.prototype.end = function () {
            this.m_playAutoFightControl.changeState(game.e_AiType.g_Type_randSkill);
        };
        //主角空闲或跑动 ，随从跟随主角
        playAutoFight_gengsui_player.prototype.update = function (t) {
            if (this.getAutoFightHero().isBeiji()) {
                return;
            }
            if (this.m_playAutoFightControl.m_target != null) {
                this.end();
                return;
            }
            //跟随状态
            var distancePlayer = this.getAutoFightHero().getDistance(game.roleMgr.getMe().getControlPlayer().getPosition());
            var shenti_w = this.getAutoFightHero().getShenti_w() + game.roleMgr.getMe().getControlPlayer().getShenti_w() + 300;
            if (distancePlayer > shenti_w) {
                if (this.getAutoFightHero().getPositionX() > game.roleMgr.getMe().getControlPlayer().getPositionX()) {
                    this.getAutoFightHero().setRunDir(cc.p(-1, 0));
                    this.getAutoFightHero().changeState(game.e_AiType.g_AiType_run, cc.p(-1, 0));
                }
                else {
                    this.getAutoFightHero().setRunDir(cc.p(1, 0));
                    this.getAutoFightHero().changeState(game.e_AiType.g_AiType_run, cc.p(1, 0));
                }
            }
            else {
                if (this.getAutoFightHero().getCurStateType() == game.e_AiType.g_AiType_run && distancePlayer < 100) {
                    this.end();
                }
                else if (this.getAutoFightHero().getCurStateType() != game.e_AiType.g_AiType_run) {
                    this.end();
                }
            }
            //撞墙了end
            if (this.getAutoFightHero().getCurStateType() == game.e_AiType.g_AiType_run) {
                if (this.getAutoFightHero().getRunState().m_zhuangqiang == true) {
                    this.getAutoFightHero().changeState(game.e_AiType.g_AiType_Idle);
                    this.end();
                }
            }
            return true;
        };
        return playAutoFight_gengsui_player;
    }(playAutoFightBaseState));
    game.playAutoFight_gengsui_player = playAutoFight_gengsui_player;
    //控制行为
    var playAutoFight_randSkill = (function (_super) {
        __extends(playAutoFight_randSkill, _super);
        function playAutoFight_randSkill(_playAutoFightControl) {
            _super.call(this, _playAutoFightControl);
            this.m_statelist = null;
            this.m_stateType = game.e_AiType.g_Type_randSkill;
        }
        playAutoFight_randSkill.prototype.shutdown = function () {
        };
        /**
         * @return {boolean}
         */
        playAutoFight_randSkill.prototype.ExternalEvent = function (key, data) {
            return true;
        };
        /**
         * @return {boolean}
         */
        playAutoFight_randSkill.prototype.InternalEvent = function (key, data) {
            return true;
        };
        //
        playAutoFight_randSkill.prototype.update = function (t) {
            this.updateTarget();
            if (this.getRoleObj().getCurStateType() == game.e_AiType.g_AiType_endAnimate) {
                return;
            }
            if (this.getRoleObj().isFallDown() == true) {
                return true;
            }
            if (this.getRoleObj().isBeiji()) {
                this.m_statelist = null;
                if (this.getRoleObj().isStateEnd() == false) {
                    return;
                }
            }
            //没有目标 跟随玩家
            if (this.getTarget() == null) {
                this.m_playAutoFightControl.changeState(game.e_AiType.g_Type_gengsui_play);
                return;
            }
            if (this.getTarget().isdead()) {
                this.m_playAutoFightControl.setTarget(null); // = null;
                return;
            }
            if (this.m_statelist == null) {
                this.getAutoFightHero().changeState(game.e_AiType.g_AiType_Idle);
                var pos = this.getTarget().getPosition();
                this.m_statelist = this.generateStateList(pos);
            }
            if (this.m_statelist) {
                if (this.m_statelist.getSize() == 0) {
                    this.m_statelist = null;
                    return;
                }
                var data_state = this.m_statelist.begin();
                if (data_state == null) {
                    this.m_statelist.pop();
                    return true;
                }
                this.m_statelist.pop();
                data_state.aiType = game.g_AiType.strToAiType(data_state.aiType);
                if (data_state.aiType == game.e_AiType.g_AiType_run) {
                    this.m_playAutoFightControl.changeState(game.e_AiType.g_Type_run_dis, data_state);
                }
                else if (data_state.aiType == game.e_AiType.g_AiType_back) {
                    this.m_playAutoFightControl.changeState(game.e_AiType.g_houtui, data_state);
                }
                else if (data_state.aiType == game.e_AiType.g_AiType_Idle) {
                    this.m_playAutoFightControl.changeState(game.e_AiType.g_silly, data_state);
                }
                else {
                    this.m_playAutoFightControl.changeState(game.e_AiType.g_Type_fight, data_state);
                }
            }
            return true;
        };
        return playAutoFight_randSkill;
    }(playAutoFightBaseState));
    game.playAutoFight_randSkill = playAutoFight_randSkill;
    //随机战斗
    var playAutoFight_fight = (function (_super) {
        __extends(playAutoFight_fight, _super);
        function playAutoFight_fight(_playAutoFightControl) {
            _super.call(this, _playAutoFightControl);
            //m_statelist: any = null
            this.m_data = null;
            this.m_stateType = game.e_AiType.g_Type_fight;
        }
        /**
         * @return {boolean}
         */
        playAutoFight_fight.prototype.ExternalEvent = function (key, data) {
            return true;
        };
        /**
         * @return {boolean}
         */
        playAutoFight_fight.prototype.InternalEvent = function (key, data) {
            if (data) {
                this.m_data = cc.clone(data);
            }
            var skillname = game.g_AiType.getAiTypeStr(data.aiType);
            if (skillname == "") {
                this.end();
                return false;
            }
            if (this.getRoleObj().getPlayCdControl().getSkillColdState(skillname) == false) {
                this.end();
                return false;
            }
            var skillInfo = this.getRoleObj().getSkillInfo(skillname);
            this.updateDir(this.getTargetPos());
            var ret = this.getAutoFightHero().changeState(data.aiType, this.m_data);
            if (ret) {
                game.playNuqiMgr.getMe().removeNuqi(skillInfo.xiaohao_nuqi);
                this.getRoleObj().getPlayCdControl().skillStart(skillname);
            }
            return true;
        };
        //
        playAutoFight_fight.prototype.update = function (t) {
            //没有目标 跟随玩家
            if (this.getAutoFightHero().getCurStateType() != this.m_data.aiType) {
                this.end();
            }
            return true;
        };
        playAutoFight_fight.prototype.end = function () {
            this.m_playAutoFightControl.changeState(game.e_AiType.g_Type_randSkill);
        };
        return playAutoFight_fight;
    }(playAutoFightBaseState));
    game.playAutoFight_fight = playAutoFight_fight;
    //跟随怪物
    var playAutoFight_gengsui_monster = (function (_super) {
        __extends(playAutoFight_gengsui_monster, _super);
        function playAutoFight_gengsui_monster(_playAutoFightControl) {
            _super.call(this, _playAutoFightControl);
            this.m_startPos = null;
            this.m_stateType = game.e_AiType.g_Type_run_dis;
        }
        playAutoFight_gengsui_monster.prototype.shutdown = function () {
        };
        playAutoFight_gengsui_monster.prototype.ExternalEvent = function (key, data) {
            return true;
        };
        playAutoFight_gengsui_monster.prototype.InternalEvent = function (key, data) {
            _super.prototype.InternalEvent.call(this, key, data);
            this.m_startPos = this.getAutoFightHero().getPosition();
            var distanceVec = cc.pSub(this.getTargetPos(), this.m_startPos);
            var dirVec = cc.pNormalize(distanceVec);
            this.getRoleObj().setRunDir(dirVec);
            this.getRoleObj().changeState(game.e_AiType.g_AiType_run, dirVec);
            return true;
        };
        //
        playAutoFight_gengsui_monster.prototype.update = function (t) {
            if (this.getAutoFightHero().isBeiji()) {
                this.end();
                return true;
            }
            if (this.getTarget() == null) {
                this.end();
                return;
            }
            if (this.getTarget().isdead()) {
                this.end();
                return;
            }
            this.runToTarget(t);
            return true;
        };
        playAutoFight_gengsui_monster.prototype.end = function () {
            this.m_playAutoFightControl.changeState(game.e_AiType.g_Type_randSkill);
        };
        //切换到run状态
        playAutoFight_gengsui_monster.prototype.runToTarget = function (t) {
            // let nowPos = this.getRoleObj().getPosition();
            var retState = this.getRoleObj().getRunState();
            if (retState.m_zhuangqiang === true) {
                this.end();
                return true;
            }
            if (this.getAutoFightHero().getCurStateType() != game.e_AiType.g_AiType_run) {
                this.end();
                return true;
            }
            //
            var distanceTarget = this.getAutoFightHero().getDistance(this.m_startPos);
            if (distanceTarget > this.m_data.rundistance) {
                this.end();
            }
        };
        return playAutoFight_gengsui_monster;
    }(playAutoFightBaseState));
    game.playAutoFight_gengsui_monster = playAutoFight_gengsui_monster;
    //后退状态
    var playAutoFight_houtui = (function (_super) {
        __extends(playAutoFight_houtui, _super);
        function playAutoFight_houtui(_playAutoFightControl) {
            _super.call(this, _playAutoFightControl);
            this.m_startPos = cc.p(0, 0);
            this.m_dataInfo = null;
            this.m_stateType = game.e_AiType.g_houtui;
        }
        playAutoFight_houtui.prototype.InternalEvent = function (key, data) {
            if (data) {
                this.m_dataInfo = cc.clone(data);
            }
            this.m_startPos = this.getRoleObj().getPosition();
            _super.prototype.InternalEvent.call(this, key, data);
            if (this.m_dataInfo.rundistance == null) {
                game.uiMgr.getMe().show_ui_MessageBox(true, "后退距离没有填");
                return false;
            }
            var randDir = cc.p(Math.random() * 2 - 1, Math.random() * 2 - 1);
            randDir = cc.pNormalize(randDir);
            randDir = this.shiftAngle(randDir);
            // console.log(this.getRoleObj().getName() + " ----- x:"+randDir.x +"// y:"+randDir.y);
            this.getRoleObj().setRunDir(randDir);
            this.getRoleObj().changeState(game.e_AiType.g_AiType_run, randDir);
            //记录开始位置
            return true;
        };
        playAutoFight_houtui.prototype.shiftAngle = function (v) {
            if (v.x >= 0) {
                if (v.x > 0.9) {
                    v.x = 1;
                    v.y = 0;
                }
                else if (v.y > 0.9) {
                    v.x = 0;
                    v.y = 1;
                }
                else if (v.y > 0) {
                    v.x = 0.5;
                    v.y = 0.5;
                }
                else {
                    v.x = 0.5;
                    v.y = -0.5;
                }
            }
            if (v.x <= 0) {
                if (v.x < -0.9) {
                    v.x = -1;
                    v.y = 0;
                }
                else if (v.y < -0.9) {
                    v.x = 0;
                    v.y = -1;
                }
                else if (v.y > 0) {
                    v.x = -0.5;
                    v.y = 0.5;
                }
                else {
                    v.x = -0.5;
                    v.y = -0.5;
                }
            }
            return v;
        };
        //
        playAutoFight_houtui.prototype.update = function (t) {
            if (this.getRoleObj().getCurStateType() != game.e_AiType.g_AiType_run) {
                this.onComplete();
                return;
            }
            if (this.getTarget() == null) {
                this.onComplete();
                return;
            }
            if (this.getTarget().isdead()) {
                this.onComplete();
                return;
            }
            if (this.m_dataInfo == null) {
                this.onComplete();
                return;
            }
            //判断撞到墙壁了
            var retState = this.getRoleObj().getRunState();
            if (retState.m_zhuangqiang === true) {
                this.onComplete();
                return;
            }
            //
            //判断后退距离
            var distance_houtuiDis = this.getRoleObj().getDistance(this.m_startPos);
            if (distance_houtuiDis > this.m_dataInfo.rundistance) {
                this.onComplete();
                return;
            }
            return true;
        };
        playAutoFight_houtui.prototype.onComplete = function () {
            this.m_playAutoFightControl.changeState(game.e_AiType.g_Type_randSkill);
            return true;
        };
        return playAutoFight_houtui;
    }(playAutoFightBaseState));
    game.playAutoFight_houtui = playAutoFight_houtui;
    //傻站着
    var playAutoFight_silly = (function (_super) {
        __extends(playAutoFight_silly, _super);
        function playAutoFight_silly(role) {
            _super.call(this, role);
            this.m_cd = 1;
            this.m_dataInfo = null;
            this.m_stateType = game.e_AiType.g_silly;
        }
        playAutoFight_silly.prototype.ExternalEvent = function (key, data) {
            return _super.prototype.ExternalEvent.call(this, key, data);
        };
        playAutoFight_silly.prototype.InternalEvent = function (key, data) {
            if (data != null) {
                this.m_dataInfo = cc.clone(data);
                this.m_cd = this.m_dataInfo.idletime;
            }
            if (this.m_dataInfo.idletime == null) {
                game.uiMgr.getMe().show_ui_MessageBox(true, "没有idletime");
                return false;
            }
            this.getRoleObj().changeState(game.e_AiType.g_AiType_Idle);
            _super.prototype.InternalEvent.call(this, key, data);
            return true;
        };
        playAutoFight_silly.prototype.update = function (t) {
            this.m_cd -= t;
            if (this.m_cd < 0) {
                this.end();
            }
            _super.prototype.update.call(this, t);
            return true;
        };
        playAutoFight_silly.prototype.end = function () {
            this.m_playAutoFightControl.changeState(game.e_AiType.g_Type_randSkill);
            return true;
        };
        return playAutoFight_silly;
    }(playAutoFightBaseState));
    game.playAutoFight_silly = playAutoFight_silly;
    var playAutoFightControl = (function (_super) {
        __extends(playAutoFightControl, _super);
        function playAutoFightControl(roleObj) {
            _super.call(this, roleObj);
            this.m_target = null;
            this.m_targetPos = cc.p(0, 0);
            this.m_playAutoFight_gengsui_player = new playAutoFight_gengsui_player(this);
            this.m_playAutoFight_fight = new playAutoFight_fight(this);
            this.m_playAutoFight_gengsui_monster = new playAutoFight_gengsui_monster(this);
            this.m_playAutoFight_houtui = new playAutoFight_houtui(this);
            this.m_playAutoFight_randSkill = new playAutoFight_randSkill(this);
            this.m_playAutoFight_silly = new playAutoFight_silly(this);
            this.m_playAutoFight_go = new playAutoFight_go(this);
            this.m_playAutoFight_chuansong = new playAutoFight_chuansong(this);
            this.m_playAutoFight_xunluo = new playAutoFight_xunluo(this);
            this.initState();
        }
        playAutoFightControl.prototype.initState = function () {
            this.addState(this.m_playAutoFight_go);
            this.addState(this.m_playAutoFight_silly);
            this.addState(this.m_playAutoFight_houtui);
            this.addState(this.m_playAutoFight_randSkill);
            this.addState(this.m_playAutoFight_gengsui_player);
            this.addState(this.m_playAutoFight_fight);
            this.addState(this.m_playAutoFight_gengsui_monster);
            this.addState(this.m_playAutoFight_chuansong);
            this.addState(this.m_playAutoFight_xunluo);
            this.m_cur_RoleAiState = this.m_playAutoFight_gengsui_player;
        };
        playAutoFightControl.prototype.init = function () {
        };
        playAutoFightControl.prototype.setTarget = function (target) {
            if (this.m_target != null) {
                if (this.m_target.isdead() == false) {
                    return;
                }
            }
            this.m_target = target;
        };
        playAutoFightControl.prototype.update = function (dt) {
            if (this.getRoleObj().isdead()) {
                return;
            }
            // 2个hero
            if (!this.getAutoFightHero()) {
                return;
            }
            if (game.roleMgr.getMe() == null) {
                return;
            }
            if (!game.roleMgr.getMe().getControlPlayer()) {
                return;
            }
            //有目标就一直干掉目标
            this.m_cur_RoleAiState.update(dt);
        };
        playAutoFightControl.prototype.getAutoFightHero = function () {
            return this.m_roleObj;
        };
        playAutoFightControl.prototype.shutdown = function () {
        };
        // m_timer = 0;
        playAutoFightControl.create = function (role) {
            return new playAutoFightControl(role);
        };
        return playAutoFightControl;
    }(game.baseStateControl));
    game.playAutoFightControl = playAutoFightControl;
})(game || (game = {}));
//# sourceMappingURL=playAutoFightControl.js.map