/**
 * Created by cy1234 on 2016/7/30.
 */
module  game {

    export class playAutoFightBaseState extends baseState {
        m_playAutoFightControl: playAutoFightControl = null;
        m_data: any = null;

        constructor(_playAutoFightControl) {
            super();
            this.m_playAutoFightControl = _playAutoFightControl;
            this.m_stateType = e_AiType.g_Type_gengsui_play;
        }

        InternalEvent(key, data) {
            if (data) {
                this.m_data = cc.clone(data);
            }
            return true;
        }

        getAutoFightHero() {
            return this.m_playAutoFightControl.getAutoFightHero();
        }

        //更新目标
        updateTarget() {
            // 搜索附近最近的怪物
            let target = roleMgr.getMe().getNeerestMonster(this.getAutoFightHero().getPosition(), 500);
            this.m_playAutoFightControl.setTarget(target);
        }

        getTarget() {
            return this.m_playAutoFightControl.m_target;
        }

        getRoleObj(): player {
            return <player>this.m_playAutoFightControl.m_roleObj;
        }

        getTargetPos() {
            return this.m_playAutoFightControl.m_target.getPosition();
        }

        //主角空闲或跑动 ，随从跟随主角
        update(t) {
            //跟随状态
            return true;
        }

        //根据目标位置更新方向
        updateDir(pos) {
            if (this.getAutoFightHero().getPositionX() > pos.x) {
                this.getAutoFightHero().setRoleDir(-1);
                return cc.p(-1, 0);
            }
            else {
                this.getAutoFightHero().setRoleDir(1);
                return cc.p(1, 0);
            }
            //return cc.p(0, 0);
        }

        //生成状态列表
        generateStateList(pos) {
            let l_statelist = null;
            let distanceTarget = this.getAutoFightHero().getDis(pos);
            let rolename = this.getAutoFightHero().getRoleName();
            let l_Ai_config = g_follower_AutoFight_config[rolename];
            if (l_Ai_config == null) {
                uiMgr.getMe().show_ui_MessageBox(true, " AutoFight_config 表没有配置自动战斗 hero：" + rolename);
                return null;
            }
            let aiEventInfo = new ArrayEx<any>();
            for (let p in l_Ai_config) {
                let obj = l_Ai_config[p];
                if (distanceTarget.x >= obj.disminX && distanceTarget.x <= obj.dismaxX) {
                    if (distanceTarget.y >= obj.disminY && distanceTarget.y <= obj.dismaxY) {
                        aiEventInfo.put(obj);
                    }
                }
            }
            if (aiEventInfo.isEmpty()) {
                return null;
            }
            let allgailv = 0;
            for (let i = 0; i < aiEventInfo.size(); i++) {
                let obj = aiEventInfo.getData(i);
                allgailv += obj["gailv"];
            }
            // let randcount = 0;
            //  while ( ++ randcount < 2 )
            {
                let gailv = cc.random0To1() * allgailv;
                let aigailv = 0;
                for (let i = 0; i < aiEventInfo.size(); i++) {
                    let obj = aiEventInfo.getData(i);
                    let nowgailv = aigailv + obj["gailv"];
                    if (aigailv < gailv && nowgailv >= gailv) {
                        l_statelist = cc.clone(obj["stateList"]);
                        break;
                    }
                    aigailv += obj["gailv"];
                }
            }
            let _map = new MapGame();
            for (let p in l_statelist) {
                _map.put(_map.getSize(), l_statelist[p]);
            }
            return _map; //随机抽一个
        }
    }
    //g_go 根据go 的指引行走
    export class playAutoFight_go extends playAutoFightBaseState {

        constructor(_playAutoFightControl) {
            super(_playAutoFightControl);
            this.m_stateType = e_AiType.g_go;
        }

        shutdown() {
        }

        /**
         * @return {boolean}
         */
        ExternalEvent(key, data) {
            return true;
        }

        /**
         * @return {boolean}
         */
        InternalEvent(key, data) {
            //想左边行走
            this.getAutoFightHero().setRunDir(cc.p(1, 0));
            this.getAutoFightHero().changeState(e_AiType.g_AiType_run, cc.p(1, 0));
            return true;
        }

        end() {
            this.m_playAutoFightControl.changeState(e_AiType.g_Type_randSkill);
        }

        //
        update(t) {
            if (this.getAutoFightHero().isRun() == false) {
                this.end();
                return;
            }
            // 判断go 消失
            if (guankaMgr.getMe().isGo() == false) {
                this.end();
                return;
            }
            //撞墙了end
            if (this.getAutoFightHero().getCurStateType() == e_AiType.g_AiType_run) {
                if (this.getAutoFightHero().getRunState().m_zhuangqiang == true) {
                    this.end();
                }
            }
            return true;
        }
    }
    //g_chuansong 行走到传送门
    export class playAutoFight_chuansong extends playAutoFightBaseState {
        m_startPos: any = null;

        constructor(_playAutoFightControl) {
            super(_playAutoFightControl);
            this.m_stateType = e_AiType.g_chuansong;
        }

        shutdown() {
        }

        ExternalEvent(key, data) {
            return true;
        }

        InternalEvent(key, data) {
            super.InternalEvent(key, data);
            let pos = this.m_data;
            this.m_startPos = cc.clone(this.getAutoFightHero().getPosition());
            //目标点在role前面
            if (this.getAutoFightHero().getPositionX() > pos.x) {
                this.getAutoFightHero().setRunDir(cc.p(-1, 0));
                this.getAutoFightHero().changeState(e_AiType.g_AiType_run, cc.p(-1, 0));
            }
            else {
                this.getAutoFightHero().setRunDir(cc.p(1, 0));
                this.getAutoFightHero().changeState(e_AiType.g_AiType_run, cc.p(1, 0));
            }
            return true;
        }

        //
        update(t) {
            this.runToTarget(t);
            return true;
        }

        end() {
            this.m_playAutoFightControl.changeState(e_AiType.g_Type_randSkill);
        }

        //切换到run状态
        runToTarget(t) {
            let retState = this.getRoleObj().getRunState();
            if (retState.m_zhuangqiang === true) {
                this.end();
                return true;
            }
            if (this.getAutoFightHero().getCurStateType() != e_AiType.g_AiType_run) {
                this.end();
                return true;
            }
        }
    }
    //巡逻
    export class playAutoFight_xunluo extends playAutoFightBaseState {
        constructor(_playAutoFightControl) {
            super(_playAutoFightControl);
            this.m_stateType = e_AiType.g_xunluo;
        }

        shutdown() {
        }

        /**
         * @return {boolean}
         */
        ExternalEvent(key, data) {
            return true;
        }

        /**
         * @return {boolean}
         */
        InternalEvent(key, data) {
            //想左边行走
            if (data == null) {
                return false;
            }
            let dir = data;
            this.getAutoFightHero().setRunDir(dir);
            this.getAutoFightHero().changeState(e_AiType.g_AiType_run, dir);
            return true;
        }

        end() {
            this.m_playAutoFightControl.changeState(e_AiType.g_Type_randSkill);
        }

        //
        update(t) {
            if (this.getAutoFightHero().isRun() == false) {
                this.end();
                return;
            }
            this.updateTarget();
            if (this.getTarget() != null) {
                this.end();
                return;
            }
            //撞墙了end
            if (this.getAutoFightHero().getCurStateType() == e_AiType.g_AiType_run) {
                if (this.getAutoFightHero().getRunState().m_zhuangqiang == true) {
                    this.m_playAutoFightControl.changeState(e_AiType.g_xunluo, cc.p(-1, 0));
                }
            }
            return true;
        }
    }
    //跟随玩家
    export class playAutoFight_gengsui_player extends playAutoFightBaseState {
        constructor(_playAutoFightControl) {
            super(_playAutoFightControl);
            this.m_stateType = e_AiType.g_Type_gengsui_play;
        }

        shutdown() {
        }

        /**
         * @return {boolean}
         */
        ExternalEvent(key, data) {
            return true;
        }

        /**
         * @return {boolean}
         */
        InternalEvent(key, data) {
            return true;
        }

        end() {
            this.m_playAutoFightControl.changeState(e_AiType.g_Type_randSkill);
        }

        //主角空闲或跑动 ，随从跟随主角
        update(t) {
            if (this.getAutoFightHero().isBeiji()) {
                return;
            }
            if (this.m_playAutoFightControl.m_target != null) {
                this.end();
                return;
            }
            //跟随状态
            let distancePlayer = this.getAutoFightHero().getDistance(roleMgr.getMe().getControlPlayer().getPosition());
            let shenti_w = this.getAutoFightHero().getShenti_w() + roleMgr.getMe().getControlPlayer().getShenti_w() + 300;
            if (distancePlayer > shenti_w) {
                if (this.getAutoFightHero().getPositionX() > roleMgr.getMe().getControlPlayer().getPositionX()) {
                    this.getAutoFightHero().setRunDir(cc.p(-1, 0));
                    this.getAutoFightHero().changeState(e_AiType.g_AiType_run, cc.p(-1, 0));
                }
                else {
                    this.getAutoFightHero().setRunDir(cc.p(1, 0));
                    this.getAutoFightHero().changeState(e_AiType.g_AiType_run, cc.p(1, 0));
                }
            }
            else {
                if (this.getAutoFightHero().getCurStateType() == e_AiType.g_AiType_run && distancePlayer < 100) {
                    this.end();
                }
                else if (this.getAutoFightHero().getCurStateType() != e_AiType.g_AiType_run) {
                    this.end();
                }
            }
            //撞墙了end
            if (this.getAutoFightHero().getCurStateType() == e_AiType.g_AiType_run) {
                if (this.getAutoFightHero().getRunState().m_zhuangqiang == true) {
                    this.getAutoFightHero().changeState(e_AiType.g_AiType_Idle);
                    this.end();
                }
            }
            return true;
        }
    }
    //控制行为
    export class playAutoFight_randSkill extends playAutoFightBaseState {
        m_statelist: any = null

        constructor(_playAutoFightControl) {
            super(_playAutoFightControl);
            this.m_stateType = e_AiType.g_Type_randSkill;
        }

        shutdown() {
        }

        /**
         * @return {boolean}
         */
        ExternalEvent(key, data) {
            return true;
        }

        /**
         * @return {boolean}
         */
        InternalEvent(key, data) {
            return true;
        }

        //
        update(t) {
            this.updateTarget();
            if (this.getRoleObj().getCurStateType() == e_AiType.g_AiType_endAnimate) {
                return;
            }
            if (this.getRoleObj().isFallDown() == true) {
                return true;
            }
            if (this.getRoleObj().isBeiji()) {
                this.m_statelist = null;
                if (this.getRoleObj().isStateEnd() == false) {
                    return;
                }
            }

            //没有目标 跟随玩家
            if (this.getTarget() == null) {
                this.m_playAutoFightControl.changeState(e_AiType.g_Type_gengsui_play);
                return;
            }
            if (this.getTarget().isdead()) {
                this.m_playAutoFightControl.setTarget(null); // = null;
                return;
            }
            if (this.m_statelist == null) {
                this.getAutoFightHero().changeState(e_AiType.g_AiType_Idle);
                let pos = this.getTarget().getPosition();
                this.m_statelist = this.generateStateList(pos);
            }

            if (this.m_statelist) {
                if (this.m_statelist.getSize() == 0) {
                    this.m_statelist = null;
                    return;
                }
                let data_state = this.m_statelist.begin();
                if (data_state == null) {
                    this.m_statelist.pop();
                    return true;
                }
                this.m_statelist.pop();
                data_state.aiType = g_AiType.strToAiType(data_state.aiType);
                if (data_state.aiType == e_AiType.g_AiType_run) {
                    this.m_playAutoFightControl.changeState(e_AiType.g_Type_run_dis, data_state);
                }
                else if (data_state.aiType == e_AiType.g_AiType_back) {
                    this.m_playAutoFightControl.changeState(e_AiType.g_houtui, data_state);
                }
                else if (data_state.aiType == e_AiType.g_AiType_Idle) {
                    this.m_playAutoFightControl.changeState(e_AiType.g_silly, data_state);
                }
                else {
                    this.m_playAutoFightControl.changeState(e_AiType.g_Type_fight, data_state);
                }
            }
            return true;
        }
    }
    //随机战斗
    export class playAutoFight_fight extends playAutoFightBaseState {
        //m_statelist: any = null

        m_data: any = null

        constructor(_playAutoFightControl) {
            super(_playAutoFightControl);
            this.m_stateType = e_AiType.g_Type_fight;
        }

        /**
         * @return {boolean}
         */
        ExternalEvent(key, data) {
            return true;
        }

        /**
         * @return {boolean}
         */

        InternalEvent(key, data) {
            if (data) {
                this.m_data = cc.clone(data);
            }

            let skillname = g_AiType.getAiTypeStr(data.aiType);
            if (skillname == "") {
                this.end();
                return false;
            }

            if (this.getRoleObj().getPlayCdControl().getSkillColdState(skillname) == false) {
                this.end();
                return false;
            }

            let skillInfo = this.getRoleObj().getSkillInfo(skillname);

            this.updateDir(this.getTargetPos());
            let ret = this.getAutoFightHero().changeState(data.aiType, this.m_data);
            if ( ret )
            {
                playNuqiMgr.getMe().removeNuqi(skillInfo.xiaohao_nuqi);
                this.getRoleObj().getPlayCdControl().skillStart(skillname);
            }

            return true;
        }

        //
        update(t) {
            //没有目标 跟随玩家
            if (this.getAutoFightHero().getCurStateType() != this.m_data.aiType) {
                this.end();
            }
            return true;
        }

        end() {
            this.m_playAutoFightControl.changeState(e_AiType.g_Type_randSkill);
        }
    }
    //跟随怪物
    export class playAutoFight_gengsui_monster extends playAutoFightBaseState {
        m_startPos: any = null;

        constructor(_playAutoFightControl) {
            super(_playAutoFightControl);
            this.m_stateType = e_AiType.g_Type_run_dis;
        }

        shutdown() {
        }

        ExternalEvent(key, data) {
            return true;
        }

        InternalEvent(key, data) {
            super.InternalEvent(key, data);
            this.m_startPos = this.getAutoFightHero().getPosition();

            let distanceVec = cc.pSub(this.getTargetPos(), this.m_startPos);
            let dirVec = cc.pNormalize(distanceVec);
            this.getRoleObj().setRunDir(dirVec);
            this.getRoleObj().changeState(e_AiType.g_AiType_run, dirVec);


            return true;
        }

        //
        update(t) {


            if (this.getAutoFightHero().isBeiji()) {
                this.end();
                return true;
            }

            if (this.getTarget() == null) {
                this.end();
                return;
            }
            if (this.getTarget().isdead()) {
                this.end();
                return;
            }

            this.runToTarget(t);
            return true;
        }

        end() {
            this.m_playAutoFightControl.changeState(e_AiType.g_Type_randSkill);
        }

        //切换到run状态
        runToTarget(t) {

           // let nowPos = this.getRoleObj().getPosition();
            let retState = this.getRoleObj().getRunState();
            if (retState.m_zhuangqiang === true) {
                this.end();
                return true;
            }
            if (this.getAutoFightHero().getCurStateType() != e_AiType.g_AiType_run) {
                this.end();
                return true;
            }
            //

            let distanceTarget = this.getAutoFightHero().getDistance(this.m_startPos);
            if (distanceTarget > this.m_data.rundistance) {
                this.end();
            }
        }
    }
    //后退状态
    export class playAutoFight_houtui extends playAutoFightBaseState {
        m_startPos: cc.Vec2 = cc.p(0, 0)
        m_dataInfo: any = null;

        constructor(_playAutoFightControl) {
            super(_playAutoFightControl);
            this.m_stateType = e_AiType.g_houtui;
        }

        InternalEvent(key, data) {
            if (data) {
                this.m_dataInfo = cc.clone(data);
            }
            this.m_startPos = this.getRoleObj().getPosition();
            super.InternalEvent(key, data);
            if (this.m_dataInfo.rundistance == null) {
                uiMgr.getMe().show_ui_MessageBox(true, "后退距离没有填");
                return false;
            }

            let randDir = cc.p(Math.random() * 2 - 1, Math.random() * 2 - 1);
            randDir = cc.pNormalize(randDir);
            randDir = this.shiftAngle(randDir);

            // console.log(this.getRoleObj().getName() + " ----- x:"+randDir.x +"// y:"+randDir.y);
            this.getRoleObj().setRunDir(randDir);
            this.getRoleObj().changeState(e_AiType.g_AiType_run, randDir);

            //记录开始位置
            return true;
        }

        shiftAngle(v){
            if(v.x >= 0){
                if(v.x > 0.9){
                    v.x = 1;
                    v.y = 0;
                }else if(v.y > 0.9){
                    v.x = 0;
                    v.y = 1;
                }else if(v.y > 0){
                    v.x = 0.5;
                    v.y = 0.5;
                }else{
                    v.x = 0.5;
                    v.y = -0.5;
                }
            }
            if(v.x <= 0){
                if(v.x < -0.9){
                    v.x = -1;
                    v.y = 0;
                }else if(v.y < -0.9){
                    v.x = 0;
                    v.y = -1;
                }else if(v.y > 0){
                    v.x = -0.5;
                    v.y = 0.5;
                }else{
                    v.x = -0.5;
                    v.y = -0.5;
                }
            }
            return v;
        }
        //
        update(t) {
            if (this.getRoleObj().getCurStateType() != e_AiType.g_AiType_run) {
                this.onComplete();
                return;
            }
            if (this.getTarget() == null) {
                this.onComplete();
                return;
            }
            if (this.getTarget().isdead()) {
                this.onComplete();
                return;
            }
            if (this.m_dataInfo == null) {
                this.onComplete();
                return;
            }
            //判断撞到墙壁了
            let retState = this.getRoleObj().getRunState();
            if (retState.m_zhuangqiang === true) {
                this.onComplete();
                return;
            }
            //
            //判断后退距离
            let distance_houtuiDis = this.getRoleObj().getDistance(this.m_startPos);
            if (distance_houtuiDis > this.m_dataInfo.rundistance) {
                this.onComplete();
                return;
            }
            return true;
        }

        onComplete() {
            this.m_playAutoFightControl.changeState(e_AiType.g_Type_randSkill);
            return true;
        }
    }
    //傻站着
    export class playAutoFight_silly extends playAutoFightBaseState {
        m_cd: any = 1
        m_dataInfo: any = null;

        constructor(role) {
            super(role);
            this.m_stateType = e_AiType.g_silly;
        }

        ExternalEvent(key, data) {
            return super.ExternalEvent(key, data);
        }

        InternalEvent(key, data) {
            if (data != null) {
                this.m_dataInfo = cc.clone(data);
                this.m_cd = this.m_dataInfo.idletime;
            }
            if (this.m_dataInfo.idletime == null) {
                uiMgr.getMe().show_ui_MessageBox(true, "没有idletime");
                return false;
            }
            this.getRoleObj().changeState(e_AiType.g_AiType_Idle);
            super.InternalEvent(key, data);
            return true;
        }

        update(t) {
            this.m_cd -= t;
            if (this.m_cd < 0) {
                this.end();
            }
            super.update(t);
            return true;
        }

        end() {
            this.m_playAutoFightControl.changeState(e_AiType.g_Type_randSkill);
            return true;
        }
    }

    export class playAutoFightControl extends baseStateControl {
        m_target: baseRole = null;
        m_targetPos: cc.Vec2 = cc.p(0, 0);
        m_playAutoFight_gengsui_player: playAutoFight_gengsui_player = new playAutoFight_gengsui_player(this);
        m_playAutoFight_fight: playAutoFight_fight = new playAutoFight_fight(this);
        m_playAutoFight_gengsui_monster: playAutoFight_gengsui_monster = new playAutoFight_gengsui_monster(this);
        m_playAutoFight_houtui: playAutoFight_houtui = new playAutoFight_houtui(this);
        m_playAutoFight_randSkill: playAutoFight_randSkill = new playAutoFight_randSkill(this);
        m_playAutoFight_silly: playAutoFight_silly = new playAutoFight_silly(this);
        m_playAutoFight_go: playAutoFight_go = new playAutoFight_go(this);
        m_playAutoFight_chuansong: playAutoFight_chuansong = new playAutoFight_chuansong(this);
        m_playAutoFight_xunluo: playAutoFight_xunluo = new playAutoFight_xunluo(this);

        // m_timer = 0;

        static create = function (role): playAutoFightControl {
            return new playAutoFightControl(role);
        };

        constructor(roleObj) {
            super(roleObj);
            this.initState();
        }

        initState() {
            this.addState(this.m_playAutoFight_go);
            this.addState(this.m_playAutoFight_silly);
            this.addState(this.m_playAutoFight_houtui);
            this.addState(this.m_playAutoFight_randSkill);
            this.addState(this.m_playAutoFight_gengsui_player);
            this.addState(this.m_playAutoFight_fight);
            this.addState(this.m_playAutoFight_gengsui_monster);
            this.addState(this.m_playAutoFight_chuansong);
            this.addState(this.m_playAutoFight_xunluo);
            this.m_cur_RoleAiState = this.m_playAutoFight_gengsui_player;
        }

        init() {
        }

        setTarget(target) {
            if (this.m_target != null) {
                if (this.m_target.isdead() == false) {
                    return;
                }
            }
            this.m_target = target;
        }

        update( dt )
        {

            if ( this.getRoleObj().isdead() )
            {
                return;
            }
            // 2个hero
            if (!this.getAutoFightHero()) {
                return;
            }
            if(game.roleMgr.getMe() == null)
            {
                return;
            }
            if (!roleMgr.getMe().getControlPlayer()) {
                return;
            }
            //有目标就一直干掉目标
            this.m_cur_RoleAiState.update(dt);
        }



        getAutoFightHero(): baseRole {
            return this.m_roleObj;
        }

        shutdown() {
        }
    }


}
