/**
 * Created by Allen on 2017/3/15.
 */
//猪猪侠 技能内置cd，用于控制随从的技能释放
var game;
(function (game) {
    var skillColdObj = (function () {
        function skillColdObj() {
            this.state = true; //当前状态,true 冷却完毕，false 未冷却
            this.coldDownTime = 0; //总冷却时间
            this.nowTime = 0; //当前技能时间
        }
        return skillColdObj;
    }());
    game.skillColdObj = skillColdObj;
    var playCdControl = (function () {
        function playCdControl(heroobj) {
            this.m_role_obj = null;
            this.m_skillColdlist = null;
            if (heroobj == null) {
                console.error("playCdControl ctor");
                return;
            }
            this.m_role_obj = heroobj;
        }
        // getSkillColdDown(heroname: string, skillname: string): number {
        //     let coldDown = game.g_player_skill[heroname][skillname].coldDown;
        //     if (coldDown == null) {
        //         return 0;
        //     }
        //     return coldDown;
        // }
        playCdControl.prototype.init = function () {
            this.m_skillColdlist = new game.Map();
            var name = this.m_role_obj.getName();
            for (var p in game.g_player_skill[name]) {
                var cdTime = game.g_player_skill[name][p].coldDown;
                if (cdTime == null) {
                    return 0;
                }
                var _skillColdObj = new skillColdObj();
                _skillColdObj.state = true;
                _skillColdObj.coldDownTime = cdTime;
                _skillColdObj.nowTime = 0;
                this.m_skillColdlist.set(p, _skillColdObj);
            }
        };
        playCdControl.prototype.setSkillNoCd_once = function (skillname) {
            var lengque = this.m_skillColdlist.get(skillname);
            if (lengque == null) {
                return false;
            }
            lengque.state = true;
            lengque.nowTime = 0;
            return true;
        };
        playCdControl.prototype.setSkillNoCd_forever = function (skillname) {
            var lengque = this.m_skillColdlist.get(skillname);
            if (lengque == null) {
                return false;
            }
            lengque.coldDownTime = 0;
            return true;
        };
        playCdControl.prototype.removeSkillColdTime_forever = function (skillname, val) {
            var lengque = this.m_skillColdlist.get(skillname);
            if (lengque == null) {
                return false;
            }
            lengque.coldDownTime -= val;
            if (lengque.coldDownTime < 0) {
                lengque.coldDownTime = 0;
            }
            return true;
        };
        playCdControl.prototype.removeSkillColdTime_once = function (skillname, val) {
            var lengque = this.m_skillColdlist.get(skillname);
            if (lengque == null) {
                return false;
            }
            lengque.nowTime += val;
            return true;
        };
        playCdControl.prototype.getSkillColdState = function (skillname) {
            var lengque = this.m_skillColdlist.get(skillname);
            if (lengque == null) {
                return null;
            }
            return lengque.state;
        };
        playCdControl.prototype.skillStart = function (skillname) {
            var lengque = this.m_skillColdlist.get(skillname);
            if (lengque == null) {
                return null;
            }
            lengque.nowTime = 0;
            lengque.state = false;
            this.m_role_obj.m_curSkillName = skillname;
        };
        playCdControl.prototype.updateCooling = function (dt) {
            for (var i = 0; i < this.m_skillColdlist.size; i++) {
                var lengque = this.m_skillColdlist.getByIndex(i);
                if (lengque == null) {
                    continue;
                }
                if (lengque.state) {
                    continue;
                }
                else if (lengque.nowTime >= lengque.coldDownTime) {
                    lengque.state = true;
                    lengque.nowTime = 0;
                    continue;
                }
                else {
                    lengque.nowTime += dt;
                }
            }
        };
        playCdControl.prototype.loop = function (t) {
            this.updateCooling(t);
        };
        playCdControl.prototype.shutdown = function () {
        };
        playCdControl.create = function (heroobj) {
            var l_playCdControl = new playCdControl(heroobj);
            return l_playCdControl;
        };
        return playCdControl;
    }());
    game.playCdControl = playCdControl;
})(game || (game = {}));
//# sourceMappingURL=playCdControl.js.map