/**
 * Created by Allen on 2017/3/15.
 */
    //猪猪侠 技能内置cd，用于控制随从的技能释放
module game {

    export class skillColdObj {
        state: boolean = true;//当前状态,true 冷却完毕，false 未冷却
        coldDownTime: number = 0; //总冷却时间
        nowTime: number = 0;//当前技能时间
    }
    export class playCdControl {
        m_role_obj: baseRole = null;
        m_skillColdlist: Map<string, skillColdObj> = null;
        static create = function (heroobj) {
            var l_playCdControl = new playCdControl(heroobj);
            return l_playCdControl;
        };

        constructor(heroobj) {
            if (heroobj == null) {
                console.error("playCdControl ctor");
                return;
            }
            this.m_role_obj = heroobj;
        }


        // getSkillColdDown(heroname: string, skillname: string): number {
        //     let coldDown = game.g_player_skill[heroname][skillname].coldDown;
        //     if (coldDown == null) {
        //         return 0;
        //     }
        //     return coldDown;
        // }

        init() {
            this.m_skillColdlist = new Map<string, skillColdObj>();
            let name = this.m_role_obj.getName();

            for (let p in g_player_skill[name]) {
                let cdTime = game.g_player_skill[name][p].coldDown;
                if (cdTime == null) {
                    return 0;
                }

                var _skillColdObj = new skillColdObj();
                _skillColdObj.state = true;
                _skillColdObj.coldDownTime = cdTime;
                _skillColdObj.nowTime = 0;
                this.m_skillColdlist.set(p, _skillColdObj)

            }
        }

        setSkillNoCd_once(skillname) {
            var lengque = this.m_skillColdlist.get(skillname);
            if (lengque == null) {
                return false;
            }
            lengque.state = true;
            lengque.nowTime = 0;

            return true;
        }

        setSkillNoCd_forever(skillname) {
            var lengque = this.m_skillColdlist.get(skillname);
            if (lengque == null) {
                return false;
            }
            lengque.coldDownTime = 0;

            return true;
        }

        removeSkillColdTime_forever(skillname, val: number) {
            var lengque = this.m_skillColdlist.get(skillname);
            if (lengque == null) {
                return false;
            }
            lengque.coldDownTime -= val;
            if (lengque.coldDownTime < 0) {
                lengque.coldDownTime = 0;
            }
            return true;
        }

        removeSkillColdTime_once(skillname, val: number) {
            var lengque = this.m_skillColdlist.get(skillname);
            if (lengque == null) {
                return false;
            }
            lengque.nowTime += val;

            return true;
        }

        getSkillColdState(skillname) {
            var lengque = this.m_skillColdlist.get(skillname);
            if (lengque == null) {
                return null;
            }
            return lengque.state;
        }

        skillStart(skillname) {
            var lengque = this.m_skillColdlist.get(skillname);
            if (lengque == null) {
                return null;
            }
            lengque.nowTime = 0;
            lengque.state = false;
            this.m_role_obj.m_curSkillName = skillname;
        }

        updateCooling(dt: number) {
            for (let i = 0; i < this.m_skillColdlist.size; i++) {
                var lengque = this.m_skillColdlist.getByIndex(i);
                if (lengque == null) {
                    continue;
                }
                if (lengque.state) {
                    continue;
                }
                else if (lengque.nowTime >= lengque.coldDownTime) {
                    lengque.state = true;
                    lengque.nowTime = 0;
                    continue;
                } else {
                    lengque.nowTime += dt;
                }


            }
        }

        loop(t) {
            this.updateCooling(t);
        }

        shutdown() {

        }

    }

}