var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var game;
(function (game) {
    var player = (function (_super) {
        __extends(player, _super);
        function player() {
            _super.call(this);
            this.m_playStateControl = null;
            this.m_playAutoFightControl = null;
            this.m_heroConfig = null;
            this.m_timer = 0;
            this.m_arrow_update_pos = cc.p(0, 0);
            this.m_Type = game.g_ObjType.play;
            this.m_roledir = 1;
            this.m_isControlRole = true;
            this.m_playStateControl = new game.playStateControl(this);
            this.m_playStateControl_Parallel = new game.playStateControl_Parallel(this);
            // this.m_buffControl.init(this.getBuffIconMap());
            this.getNode().setName("player类");
        }
        player.prototype.init = function (heroName) {
            this.loadres(heroName);
            this.initState();
            this.m_playAutoFightControl = game.playAutoFightControl.create(this);
            this.m_playAutoFightControl.init();
            this.m_playCdControl = game.playCdControl.create(this);
            this.m_playCdControl.init();
        };
        player.prototype.isBeiji = function () {
            switch (this.getCurStateType()) {
                case game.e_AiType.g_AiType_beiji:
                    return true;
                case game.e_AiType.g_AiType_beiji_tiaoqi:
                    return true;
                case game.e_AiType.g_AiType_beiji_qishen:
                    return true;
            }
            return false;
        };
        player.prototype.isRun = function () {
            switch (this.getCurStateType()) {
                case game.e_AiType.g_AiType_run:
                    return true;
                case game.e_AiType.g_AiType_shache:
                    return true;
            }
            return false;
        };
        player.prototype.isIdle = function () {
            switch (this.getCurStateType()) {
                case game.e_AiType.g_AiType_Idle:
                    return true;
            }
            return false;
        };
        player.prototype.isXuli = function () {
            switch (this.getCurStateType()) {
                case game.e_AiType.g_AiType_play_xuli_enter:
                    return true;
            }
            return false;
        };
        //是否战斗状态
        player.prototype.isFight = function () {
            switch (this.getCurStateType()) {
                case game.e_AiType.g_AiType_play_normalSkill:
                    return true;
                case game.e_AiType.g_AiType_play_skill1:
                    return true;
            }
            return false;
        };
        player.prototype.setxunyun = function (flag) {
            if (flag) {
                this.changeState(game.e_AiType.g_AiType_yun);
            }
            else {
                this.changeState(game.e_AiType.g_AiType_Idle);
            }
        };
        player.prototype.getTeam = function () {
            return game.roleMgr.getMe().getPlayerAlive();
        };
        player.prototype.setHp = function (val) {
            this.m_curHp = parseInt(val);
            if (game.ui_zhandoujm.getMe()) {
                game.ui_zhandoujm.getMe().setzhujuePer(this.gethpPer());
            }
        };
        player.prototype.removeHp = function (val) {
            if (val < 0)
                return;
            val = parseInt(val);
            var buff = this.getcurhp() - val;
            if (buff < 0) {
                buff = 0;
            }
            game.uieffectMgr.getMe().dropHp(game.roleMgr.getMe(), val, this.dealDamageNumberPosition());
            this.setHp(buff);
        };
        player.prototype.addHp = function (val, _notEffect) {
            if (_notEffect === void 0) { _notEffect = null; }
            if (val < 0)
                return;
            val = parseInt(val);
            var buff = this.getcurhp() + val;
            if (buff > this.getmaxhp()) {
                buff = this.getmaxhp();
            }
            if (_notEffect == null) {
                _notEffect = true;
            }
            if (_notEffect == true) {
                game.uieffectMgr.getMe().addHp(game.roleMgr.getMe(), val, this.dealDamageNumberPosition());
            }
            this.setHp(buff);
        };
        player.prototype.OnHit = function (affector, damageInfo) {
            _super.prototype.OnHit.call(this, affector, damageInfo);
            game.playComboMgr.getMe().breakCombo();
        };
        player.prototype.getcurhp = function () {
            return this.m_curHp;
        };
        player.prototype.getBasemiss = function () {
            return game.dataMgr.getMe().getBasemiss(this.getRoleName());
        };
        //其实基础speed
        player.prototype.getBaseSpeed = function () {
            return game.dataMgr.getMe().getBaseSpeed(this.getRoleName());
        };
        //其实基础cd
        player.prototype.getBasecd = function () {
            return game.dataMgr.getMe().getBasecd(this.getRoleName());
        };
        player.prototype.getBasesdefense = function () {
            return game.dataMgr.getMe().getBasesdefense(this.getRoleName());
        };
        player.prototype.getBaseAtt = function () {
            return game.dataMgr.getMe().getBaseAtt(this.getRoleName());
        };
        // getSkillAtt() {
        //     return this.getBaseAtt() * this.getCurSkill().damagePercent;
        // }
        player.prototype.getEquipmentAtt = function () {
            return 0;
        };
        player.prototype.getOutAttNoBuff = function () {
            var a = this.getBaseAtt() * (1 + game.propertyMgr.getMe().getPropertyNum(game.e_property_Type.e_att));
            // console.log(this.getName() + "当前攻击是:"+a);
            return a;
        };
        player.prototype.getBaseAntiStun = function () {
            return game.dataMgr.getMe().getHeroConfig(this.getRoleName()).antiStun;
        };
        player.prototype.getAntiStun = function () {
            var skillAntiAtun = 0;
            if (this.isFight()) {
                if (this.m_curSkillInfo) {
                    if (typeof (this.m_curSkillInfo.raiseLimitStunPoint) == "number") {
                        skillAntiAtun = this.m_curSkillInfo.raiseLimitStunPoint;
                    }
                }
            }
            return this.getBaseAntiStun() + skillAntiAtun;
        };
        //获得当前伤害
        player.prototype.getOutAtt = function (role) {
            var NoBuff = this.getOutAttNoBuff();
            // return (NoBuff * (1 + this.m_buffControl.getAttBuff(role)));
            return NoBuff;
        };
        //获得当前防御
        player.prototype.getOutDefense = function () {
            var a = this.getBasesdefense() * (1 + game.propertyMgr.getMe().getPropertyNum(game.e_property_Type.e_defense));
            // var a = this.getBasesdefense() + this.m_buffControl.getBuffdefense();
            var out = a / (500 + 2 * a);
            // if (out < 0) {
            //     out = 0;
            // }
            // console.log(this.getName() + "当前防御是:"+out);
            return out;
        };
        //获得当前miss
        player.prototype.getOutMiss = function () {
            //  + this.m_buffControl.getBuffMiss()
            var out = this.getBasemiss();
            if (out < 0) {
                out = 0;
            }
            return out;
        };
        //获得当前cd
        player.prototype.getOutCd = function () {
            var out = this.getBasecd();
            if (out < 0) {
                out = 0.01;
            }
            return out;
        };
        //获得当前run 移动速度
        player.prototype.getOutSpeed = function () {
            var a = this.getBaseSpeed() * (1 + game.propertyMgr.getMe().getPropertyNum(game.e_property_Type.e_runSpeed));
            // console.log(this.getName() + "当前移速是:"+a);
            var buff = this.m_buffControl.getBuffSpeed();
            // var out = this.getBaseSpeed();
            if (buff != 0)
                a *= (1 + buff);
            return a;
        };
        //最大血量血
        player.prototype.getmaxhp = function () {
            var basehp = game.dataMgr.getMe().getBasehp(this.getRoleName());
            var a = basehp * (1 + game.propertyMgr.getMe().getPropertyNum(game.e_property_Type.e_hp));
            // console.log(this.getName() + "最大血量是:"+a);
            return a;
        };
        player.prototype.getTeam_dead = function () {
            return game.roleMgr.getMe().getPlayerdead();
        };
        player.prototype.onFrameEvent = function (type, event) {
            this.m_playStateControl.onFrameEvent(type, event);
            _super.prototype.onFrameEvent.call(this, type, event);
        };
        player.prototype.initState = function () {
            this.m_playStateControl.initState();
            this.m_playStateControl_Parallel.initState();
        };
        //get run state 返回跑步状态
        player.prototype.getState = function (type) {
            return this.m_playStateControl.getState(type);
        };
        player.prototype.stoprun = function () {
            // m_player_State_run.m_start = false;
            this.changeState(game.e_AiType.g_AiType_Idle);
        };
        //强制切换状态
        player.prototype.changeState_Ex = function (key, data) {
            if (data === void 0) { data = null; }
            // if(this instanceof follower)
            // console.log(   g_AiType.getAiTypeStr( key ) );
            return this.m_playStateControl.changeState_Ex(key, data);
        };
        player.prototype.changeState = function (key, in_data) {
            // if(this instanceof follower)
            // console.log(   g_AiType.getAiTypeStr( key ) );
            if (in_data === void 0) { in_data = null; }
            return this.m_playStateControl.changeState(key, in_data);
        };
        player.prototype.getCurStateInfo = function () {
            return this.m_playStateControl.getCurStateInfo(); //this.m_cur_RoleAiState;
        };
        player.prototype.dealDamageNumberPosition = function () {
            var name = this.getRoleName();
            var ret = game.fileMgr.getMe().m_playHero_data_Map.get(name).headHpNumberPos;
            ret = cc.Vec2.add(ret, this.getPosition());
            // ret = cc.pAdd(ret, this.getPosition());
            return ret;
        };
        //返回主动天赋属性
        player.prototype.getSkillInfo = function (skillName) {
            return game.dataMgr.getMe().getSkillInfo(this.getRoleName(), skillName);
        };
        player.prototype.isStateEnd = function () {
            return this.getCurStateInfo().m_isEnd;
        };
        player.prototype.loadres = function (heroName) {
            var heroLv = game.dataMgr.getMe().getHeroLevel(heroName);
            heroName += heroLv;
            this.m_name = heroName;
            this.m_heroConfig = cc.clone(game.fileMgr.getMe().m_playHero_data_Map.get(this.m_name));
            if (this.m_heroConfig == null) {
                console.log("g_playhero_config 表需要配置：" + heroName);
            }
            if (this.m_heroConfig.spine_res == null) {
                game.uiMgr.getMe().show_ui_MessageBox(true, "hero 表出错: name： " + heroName + "没有字段：spine_res");
                console.error("hero 表出错: name： " + heroName + "没有字段：spine_res");
            }
            _super.prototype.loadres.call(this, this.m_heroConfig.spine_res);
            this.m_SpineNode.setScale(this.m_heroConfig.scale);
            this.setRoleDir(this.m_roledir);
            //設置hp
            this.setHp(this.getmaxhp());
        };
        //初始化战斗属性 血量攻击防御暴击
        player.prototype.initPropertyInfo = function () {
        };
        player.prototype.update_0_3 = function (dt) {
            if (this.m_isControlRole)
                return;
            // let _xingneng = proforFunc.create();
            if (ccs._parser.g_isLowCpu == true) {
                this.m_timer += dt;
                if (this.m_timer > 0.5) {
                    this.m_timer = 0;
                    this.m_playAutoFightControl.update(dt);
                }
            }
            else {
                this.m_playAutoFightControl.update(dt);
            }
            // _xingneng.end( "play+ update_0_3:" + this.m_playAutoFightControl.getCurStateType() );
        };
        player.prototype.update = function (dt) {
            // let _xingneng = proforFunc.create();
            _super.prototype.update.call(this, dt);
            this.m_playStateControl.loop(dt);
            this.m_playStateControl_Parallel.loop(dt);
            game.playComboMgr.getMe().loop(dt);
            this.m_playCdControl.loop(dt);
            // if (!this.m_isControlRole)
            // _xingneng.end("玩家性能"+this.getName()+" update" + g_AiType.getAiTypeStr(this.getCurStateType()));
        };
        player.prototype.update_play = function (dt) {
            if (this.getType() != game.g_ObjType.play) {
                return;
            }
        };
        player.prototype.getCurStateType = function () {
            return this.m_playStateControl.getCurStateType();
        };
        player.prototype.getBaojiPer = function (role) {
            var crit = game.dataMgr.getMe().getBaseCrit(this.getName());
            var a = crit * (1 + game.propertyMgr.getMe().getPropertyNum(game.e_property_Type.e_baoji));
            var out = a / (500 + 2 * a);
            // console.log(this.getName() + "当前暴击是:"+out);
            return out;
        };
        player.prototype.isdead = function () {
            if (this.getCurStateType() == game.e_AiType.g_AiType_Dead) {
                return true;
            }
            if (this.getcurhp() <= 0) {
                return true;
            }
            return false;
        };
        player.prototype.fuhuo = function () {
            //
            // if (this.isdead() == false) {
            //     return;
            // }
            this.m_wudi_time = 3;
            this.m_buffControl.m_faint_buff.init(this);
            this.m_buffControl.m_ice_buff.init(this);
            game.spineMgr.getMe().createSpineOncePlay("chushengtexiao", "play", game.roleMgr.getMe().getNode(), this.getPosition(), 1);
            if (this.m_SpriteShadow)
                this.m_SpriteShadow.setVisible(true);
            // parMgr.getMe().createListAnimation_playOnce("xingjiezhuzhuxia2/big/pre/chusheng.plist", this, cc.p(0, 0));
            this.setVisible(true);
            this.setHp(this.getmaxhp());
            this.changeState_Ex(game.e_AiType.g_AiType_Idle);
            this.m_playAutoFightControl.changeState(game.e_AiType.g_Type_randSkill);
        };
        player.prototype.dealDamage_val = function (affector, attackPoint) {
            attackPoint = attackPoint * game.g_debug._debug_monster_att_per;
            //伤害公式：攻击力-攻击力*防御比率
            attackPoint -= attackPoint * this.getOutDefense();
            if (attackPoint < 1) {
                attackPoint = 1;
            }
            //UI血条效果
            if (game.roleMgr.getMe().getControlPlayer() == this) {
                game.ui_pengxue.getMe().show();
            }
            //设置生命值
            this.setHp(this.getcurhp() - attackPoint);
            this.updateShanghaiMap(affector.__instanceId, attackPoint);
            //UI伤害数字
            game.uieffectMgr.getMe().dropHp(game.roleMgr.getMe(), attackPoint, this.dealDamageNumberPosition());
        };
        player.prototype.shutdown = function () {
            var _state = this.getState(game.e_AiType.g_AiType_run);
            _state.shutdown();
            _super.prototype.shutdown.call(this);
            this.m_playCdControl.shutdown();
            game.playComboMgr.getMe().breakCombo();
        };
        player.prototype.setPosition = function (pos) {
            _super.prototype.setPosition.call(this, pos);
            var _role = game.roleMgr.getMe().getControlPlayer();
            if (_role) {
                if (_role.__instanceId == this.__instanceId) {
                    var nowpos = this.getPosition();
                    var dis = cc.pDistance(this.m_arrow_update_pos, nowpos);
                    // 角色头部箭头  只有移动了才更新
                    if (dis > 10) {
                        this.m_arrow_update_pos = nowpos;
                        var pos1 = _role.getBoneWroldPosition("toubu");
                        pos1.y += 100;
                        game.ui_zhandoujm.getMe().m_arrow.setPosition(pos1);
                    }
                }
            }
        };
        player.getMe = function () {
            return player.create();
        };
        player.create = function () {
            var _player = new player();
            return _player;
        };
        return player;
    }(game.baseRole));
    game.player = player;
})(game || (game = {}));
//# sourceMappingURL=player.js.map