module  game {
    export class player extends baseRole {
        protected m_playStateControl: playStateControl = null;
        m_playAutoFightControl: playAutoFightControl = null;
        m_heroConfig: HeroConfig_s = null;
        m_timer = 0;
        static getMe = function () {
            return player.create();
        };
        static create = function (): player {
            var _player = new player();
            return _player;
        };

        constructor() {
            super();
            this.m_Type = g_ObjType.play;
            this.m_roledir = 1;
            this.m_isControlRole = true;
            this.m_playStateControl = new playStateControl(this);
            this.m_playStateControl_Parallel = new playStateControl_Parallel(this);
            // this.m_buffControl.init(this.getBuffIconMap());
            this.getNode().setName("player类");
        }

        init(heroName: string) {
            this.loadres(heroName);
            this.initState();
            this.m_playAutoFightControl = playAutoFightControl.create(this);
            this.m_playAutoFightControl.init();
            this.m_playCdControl = playCdControl.create(this);
            this.m_playCdControl.init();
        }

        isBeiji() {
            switch (this.getCurStateType()) {
                case e_AiType.g_AiType_beiji:
                    return true;

                case e_AiType.g_AiType_beiji_tiaoqi:
                    return true;

                case e_AiType.g_AiType_beiji_qishen:
                    return true;

            }
            return false;
        }

        isRun() {
            switch (this.getCurStateType()) {
                case e_AiType.g_AiType_run:
                    return true;

                case e_AiType.g_AiType_shache:
                    return true;

            }
            return false;
        }

        isIdle() {
            switch (this.getCurStateType()) {
                case e_AiType.g_AiType_Idle:
                    return true;

            }
            return false;
        }

        isXuli() {
            switch (this.getCurStateType()) {
                case e_AiType.g_AiType_play_xuli_enter:
                    return true;

            }
            return false;
        }

        //是否战斗状态
        isFight() {
            switch (this.getCurStateType()) {
                case e_AiType.g_AiType_play_normalSkill:
                    return true;

                case e_AiType.g_AiType_play_skill1:
                    return true;

            }
            return false;
        }


        setxunyun(flag) {
            if (flag) {
                this.changeState(e_AiType.g_AiType_yun);
            }
            else {
                this.changeState(e_AiType.g_AiType_Idle);
            }
        }

        getTeam() {
            return roleMgr.getMe().getPlayerAlive();
        }

        setHp(val) {
            this.m_curHp = parseInt(val);
            if (ui_zhandoujm.getMe()) {
                ui_zhandoujm.getMe().setzhujuePer(this.gethpPer());
            }
        }

        removeHp(val) {
            if (val < 0)
                return;
            val = parseInt(val);
            var buff = this.getcurhp() - val;
            if (buff < 0) {
                buff = 0;
            }
            uieffectMgr.getMe().dropHp(roleMgr.getMe(), val, this.dealDamageNumberPosition());
            this.setHp(buff);
        }

        addHp(val, _notEffect: any = null) {

            if (val < 0)
                return;
            val = parseInt(val);
            var buff = this.getcurhp() + val;
            if (buff > this.getmaxhp()) {
                buff = this.getmaxhp();
            }
            if (_notEffect == null) {
                _notEffect = true;
            }
            if (_notEffect == true) {
                uieffectMgr.getMe().addHp(roleMgr.getMe(), val, this.dealDamageNumberPosition());
            }
            this.setHp(buff);
        }

        OnHit(affector, damageInfo) {
            super.OnHit(affector, damageInfo);

            playComboMgr.getMe().breakCombo();
        }

        getcurhp() {
            return this.m_curHp;
        }

        getBasemiss() {
            return dataMgr.getMe().getBasemiss(this.getRoleName());
        }

        //其实基础speed
        getBaseSpeed() {
            return dataMgr.getMe().getBaseSpeed(this.getRoleName());
        }

        //其实基础cd
        getBasecd(): number {
            return dataMgr.getMe().getBasecd(this.getRoleName());
        }

        getBasesdefense() {
            return dataMgr.getMe().getBasesdefense(this.getRoleName());
        }

        getBaseAtt() {
            return dataMgr.getMe().getBaseAtt(this.getRoleName())
        }

        // getSkillAtt() {
        //     return this.getBaseAtt() * this.getCurSkill().damagePercent;
        // }

        getEquipmentAtt() {
            return 0;
        }

        getOutAttNoBuff() {
            let a = this.getBaseAtt() * ( 1 + propertyMgr.getMe().getPropertyNum(e_property_Type.e_att));
            // console.log(this.getName() + "当前攻击是:"+a);
            return a;
        }

        getBaseAntiStun() {
            return dataMgr.getMe().getHeroConfig(this.getRoleName()).antiStun;
        }

        getAntiStun() {
            var skillAntiAtun = 0;
            if (this.isFight()) {
                if (this.m_curSkillInfo) {
                    if (typeof (this.m_curSkillInfo.raiseLimitStunPoint) == "number") {
                        skillAntiAtun = this.m_curSkillInfo.raiseLimitStunPoint;
                    }
                }
            }
            return this.getBaseAntiStun() + skillAntiAtun;
        }

        //获得当前伤害
        getOutAtt(role: baseRole) {
            var NoBuff = this.getOutAttNoBuff();
            // return (NoBuff * (1 + this.m_buffControl.getAttBuff(role)));
            return NoBuff;
        }

        //获得当前防御
        getOutDefense() {
            let a = this.getBasesdefense() * ( 1 + propertyMgr.getMe().getPropertyNum(e_property_Type.e_defense));
            // var a = this.getBasesdefense() + this.m_buffControl.getBuffdefense();
            let out = a / (500 + 2 * a);
            // if (out < 0) {
            //     out = 0;
            // }
            // console.log(this.getName() + "当前防御是:"+out);
            return out;
        }

        //获得当前miss
        getOutMiss() {
            //  + this.m_buffControl.getBuffMiss()
            var out = this.getBasemiss();
            if (out < 0) {
                out = 0;
            }
            return out;
        }

        //获得当前cd
        getOutCd() {
            var out = this.getBasecd();
            if (out < 0) {
                out = 0.01;
            }
            return out;
        }

        //获得当前run 移动速度
        getOutSpeed() {
            let a = this.getBaseSpeed() * ( 1 + propertyMgr.getMe().getPropertyNum(e_property_Type.e_runSpeed));
            // console.log(this.getName() + "当前移速是:"+a);
            let buff = this.m_buffControl.getBuffSpeed();
            // var out = this.getBaseSpeed();
            if (buff != 0)
                a *= (1 + buff);
            return a;
        }

        //最大血量血
        getmaxhp() {
            let basehp = dataMgr.getMe().getBasehp(this.getRoleName());
            let a = basehp * (1 + propertyMgr.getMe().getPropertyNum(e_property_Type.e_hp));
            // console.log(this.getName() + "最大血量是:"+a);
            return a;
        }

        getTeam_dead() {
            return roleMgr.getMe().getPlayerdead();
        }

        onFrameEvent(type, event) {
            this.m_playStateControl.onFrameEvent(type, event);
            super.onFrameEvent(type, event);
        }


        initState() {
            this.m_playStateControl.initState();
            this.m_playStateControl_Parallel.initState();
        }

        //get run state 返回跑步状态

        getState(type): baseState {
            return this.m_playStateControl.getState(type);
        }

        stoprun() {
            // m_player_State_run.m_start = false;
            this.changeState(e_AiType.g_AiType_Idle);
        }

        //强制切换状态
        changeState_Ex(key, data: any = null) {
            // if(this instanceof follower)
            // console.log(   g_AiType.getAiTypeStr( key ) );
            return this.m_playStateControl.changeState_Ex(key, data);
        }

        changeState(key: e_AiType, in_data: any = null) {

            // if(this instanceof follower)
            // console.log(   g_AiType.getAiTypeStr( key ) );

            return this.m_playStateControl.changeState(key, in_data);
        }

        getCurStateInfo(): baseState {
            return this.m_playStateControl.getCurStateInfo(); //this.m_cur_RoleAiState;
        }

        dealDamageNumberPosition() {

            var name = this.getRoleName();

            var ret = fileMgr.getMe().m_playHero_data_Map.get(name).headHpNumberPos;
            ret = cc.Vec2.add(ret, this.getPosition())
            // ret = cc.pAdd(ret, this.getPosition());
            return ret;
        }


        //返回主动天赋属性
        getSkillInfo(skillName): skill_struct {
            return dataMgr.getMe().getSkillInfo(this.getRoleName(), skillName);
        }

        isStateEnd() {
            return this.getCurStateInfo().m_isEnd;
        }

        loadres(heroName: string) {

            var heroLv = dataMgr.getMe().getHeroLevel(heroName);
            heroName += heroLv;
            this.m_name = heroName;

            this.m_heroConfig = cc.clone(fileMgr.getMe().m_playHero_data_Map.get(this.m_name));

            if (this.m_heroConfig == null) {
                console.log("g_playhero_config 表需要配置：" + heroName);
            }

            if (this.m_heroConfig.spine_res == null) {
                uiMgr.getMe().show_ui_MessageBox(true, "hero 表出错: name： " + heroName + "没有字段：spine_res");
                console.error("hero 表出错: name： " + heroName + "没有字段：spine_res");
            }

            super.loadres(this.m_heroConfig.spine_res);
            this.m_SpineNode.setScale(this.m_heroConfig.scale);

            this.setRoleDir(this.m_roledir);
            //設置hp
            this.setHp(this.getmaxhp());
        }

        //初始化战斗属性 血量攻击防御暴击
        initPropertyInfo() {

        }

        update_0_3(dt) {
            if (this.m_isControlRole) return;
            // let _xingneng = proforFunc.create();
                if (ccs._parser.g_isLowCpu == true) {
                    this.m_timer += dt;
                    if ( this.m_timer > 0.5 )
                    {
                        this.m_timer = 0;
                        this.m_playAutoFightControl.update(dt);
                    }
                } else {
                    this.m_playAutoFightControl.update(dt);
                }
             // _xingneng.end( "play+ update_0_3:" + this.m_playAutoFightControl.getCurStateType() );
        }

        update(dt) {

            // let _xingneng = proforFunc.create();
            super.update(dt);
            this.m_playStateControl.loop(dt);
            this.m_playStateControl_Parallel.loop(dt);
            playComboMgr.getMe().loop(dt);
            this.m_playCdControl.loop(dt);
            // if (!this.m_isControlRole)
            // _xingneng.end("玩家性能"+this.getName()+" update" + g_AiType.getAiTypeStr(this.getCurStateType()));
        }

        update_play(dt) {
            if (this.getType() != g_ObjType.play) {
                return;
            }
        }

        getCurStateType(): e_AiType {
            return this.m_playStateControl.getCurStateType();
        }

        getBaojiPer(role: baseRole) {
            let crit = dataMgr.getMe().getBaseCrit(this.getName());
            let a = crit * (1 + propertyMgr.getMe().getPropertyNum(e_property_Type.e_baoji));
            let out = a / (500 + 2 * a);
            // console.log(this.getName() + "当前暴击是:"+out);
            return out;
        }

        isdead() {
            if (this.getCurStateType() == e_AiType.g_AiType_Dead) {
                return true;
            }
            if (this.getcurhp() <= 0) {
                return true;
            }
            return false;
        }

        fuhuo() {
            //
            // if (this.isdead() == false) {
            //     return;
            // }
            this.m_wudi_time = 3;
            this.m_buffControl.m_faint_buff.init(this);
            this.m_buffControl.m_ice_buff.init(this);
            spineMgr.getMe().createSpineOncePlay("chushengtexiao", "play", roleMgr.getMe().getNode(), this.getPosition(), 1);
            if (this.m_SpriteShadow)
                this.m_SpriteShadow.setVisible(true);
            // parMgr.getMe().createListAnimation_playOnce("xingjiezhuzhuxia2/big/pre/chusheng.plist", this, cc.p(0, 0));
            this.setVisible(true);
            this.setHp(this.getmaxhp());
            this.changeState_Ex(e_AiType.g_AiType_Idle);
            this.m_playAutoFightControl.changeState(e_AiType.g_Type_randSkill);
        }


        dealDamage_val(affector: baseRole, attackPoint: number) {
            attackPoint = attackPoint * g_debug._debug_monster_att_per;
            //伤害公式：攻击力-攻击力*防御比率
            attackPoint -= attackPoint * this.getOutDefense();
            if (attackPoint < 1) {
                attackPoint = 1;
            }
            //UI血条效果
            if (roleMgr.getMe().getControlPlayer() == this) {
                ui_pengxue.getMe().show();
            }
            //设置生命值
            this.setHp(this.getcurhp() - attackPoint);
            this.updateShanghaiMap(affector.__instanceId, attackPoint);
            //UI伤害数字
            uieffectMgr.getMe().dropHp(roleMgr.getMe(), attackPoint, this.dealDamageNumberPosition());
        }

        shutdown()
        {
            let _state : playerAi_run = <playerAi_run>this.getState( e_AiType.g_AiType_run );
            _state.shutdown();
            super.shutdown();
            this.m_playCdControl.shutdown();
            playComboMgr.getMe().breakCombo();
        }

        m_arrow_update_pos: cc.Vec2 = cc.p(0, 0);

        setPosition(pos) {
            super.setPosition(pos);

            let _role = roleMgr.getMe().getControlPlayer();
            if (_role) {
                if (_role.__instanceId == this.__instanceId) {
                    let nowpos = this.getPosition();
                    let dis = cc.pDistance(this.m_arrow_update_pos, nowpos);
                    // 角色头部箭头  只有移动了才更新
                    if (dis > 10) {
                        this.m_arrow_update_pos = nowpos;
                        let pos1 = _role.getBoneWroldPosition("toubu");
                        pos1.y += 100;
                        ui_zhandoujm.getMe().m_arrow.setPosition(pos1);
                    }
                }
            }
        }

    }
}
