/**
 * Created by xieli on 2017/2/21.
 */
/**
 * 玩家属性管理类
 */
module  game {

    export enum e_property_Type{
        e_hp = 0, // 血
        e_baseAtt = 1,   // 基础攻击力
        e_baoji = 2, //
        e_att = 3,
        e_defense = 4,
        e_attSpeed = 5,
        e_runSpeed = 6,
    }

    export var getPropertyStr = function (t: e_property_Type) {
        if (t == e_property_Type.e_hp)
            return "hp";
        else if (t == e_property_Type.e_baseAtt)
            return "baseatt";
        else if (t == e_property_Type.e_att)
            return "att";
        else if (t == e_property_Type.e_defense)
            return "defense";
        else if (t == e_property_Type.e_attSpeed)
            return "attSpeed";
        else if (t == e_property_Type.e_runSpeed)
            return "runSpeed";
        else if (t == e_property_Type.e_baoji)
            return "baoji";
    }

    export var getPropertyZHStr = function (name) {
        if (name == "hp")
            return "血量";
        else if (name == "att")
            return "攻击";
        else if (name == "defense")
            return "防御";
        else if (name == "attSpeed")
            return "攻速";
        else if (name == "runSpeed")
            return "移速";
        else if (name == "baoji")
            return "暴击";
        return "";
    }

    export var eToPropertyStr = function (t: string): e_property_Type {
        if (t == "hp")
            return e_property_Type.e_hp;
        else if (t == "runSpeed")
            return e_property_Type.e_runSpeed;
        else if (t == "att")
            return e_property_Type.e_att;
        else if (t == "defense")
            return e_property_Type.e_defense;
        else if (t == "attSpeed")
            return e_property_Type.e_attSpeed;
        else if (t == "baoji")
            return e_property_Type.e_baoji;
    }

    export class propertyData {
        constructor(t: e_property_Type, _per: number) {
            this.per = _per;
            this.type = t;
        };

        type: e_property_Type;
        per: number;
    }
    export class propertyMgr {
        m_des: string = "propertyMgr";
        m_propertyMap: Map<e_property_Type, propertyData>;
        static g_propertyMgr: propertyMgr = null;
        static getMe = function () {
            if (propertyMgr.g_propertyMgr == null) {
                propertyMgr.g_propertyMgr = new propertyMgr();
                return propertyMgr.g_propertyMgr;
            }
            return propertyMgr.g_propertyMgr;
        };

        constructor() {

        }

        init(){
            this.reset();
        }

        reset() {
            this.m_propertyMap = new Map<e_property_Type, propertyData>();
            this.m_propertyMap.set(e_property_Type.e_hp, new propertyData(e_property_Type.e_hp, 0));
            this.m_propertyMap.set(e_property_Type.e_att, new propertyData(e_property_Type.e_att, 0));
            this.m_propertyMap.set(e_property_Type.e_defense, new propertyData(e_property_Type.e_defense, 0));
            this.m_propertyMap.set(e_property_Type.e_runSpeed, new propertyData(e_property_Type.e_runSpeed, 0));
            this.m_propertyMap.set(e_property_Type.e_attSpeed, new propertyData(e_property_Type.e_attSpeed, 0));
            this.m_propertyMap.set(e_property_Type.e_baoji, new propertyData(e_property_Type.e_baoji, 0));

            let hero_pintu_data = dataMgr.getMe().getPlayPintuDoc();
            for (var p in hero_pintu_data) {
                let pintu = hero_pintu_data[p];
                let pintuConfig: pintu_data_s = g_pintu_info[p];
                for(let i=0;i<pintu.num;++i){
                    this.addProperty_str("hp", g_pintu_info[p].hp_up);
                    this.addProperty_str("att", g_pintu_info[p].att_up);
                    this.addProperty_str("defense", g_pintu_info[p].def_up);
                    this.addProperty_str("runSpeed", g_pintu_info[p].Speed_up);
                    this.addProperty_str("baoji", g_pintu_info[p].crit_up);
                }
            }
        }

        addProperty_str(strtype: string, per: number) {
            this.addProperty(eToPropertyStr(strtype), per);
        }

        addProperty(t: e_property_Type, per: number) {
            if (per < 0) {
                console.error("error addProperty");
                return;
            }
            return this.m_propertyMap.get(t).per += per;
        }

        getProperty_str(strtype: string) {
            this.getProperty(eToPropertyStr(strtype));
        }

        getProperty(t: e_property_Type): propertyData {
            return this.m_propertyMap.get(t);
        }

        getPropertyNum(t: e_property_Type): number {
            return this.m_propertyMap.get(t).per;
        }

        removeProperty_str(strtype: string, per: number) {
            this.removeProperty(eToPropertyStr(strtype), per);
        }

        removeProperty(t: e_property_Type, per: number) {
            if (per < 0) {
                console.error("error removeProperty");
                return;
            }
            return this.m_propertyMap.get(t).per -= per;
        }

        loop(dt) {

        }

        shutdown() {

        }

    }

}
 