// 角色管理类
module game {

    export class roleMgr extends xjNode {
        m_curRole: player = null;
        m_curControlRole: baseRole = null;
        m_worldBoss: worldBoss = null;
        // m_curFollower: follower = null;
        m_player_map: Map< number,player > = null;
        m_follower_map: Map< number,player > = null;
        m_AllRole_map: Map< number,baseRole > = null;
        m_AllRole_map_Alive: Map< number,baseRole > = null;
        m_player_map_Alive: Map< number,baseRole > = null;
        m_player_map_dead: Map< number,baseRole > = null;

        m_monster_map: Map< number,monster > = null;
        m_monster_map_Alive: Map< number,monster > = null;
        m_monster_map_dead: Map< string,number > = null;

        m_sceneinfo: scene_config_data_s = null;
        m_isChangePlayer: boolean = true;
        m_avatar: Avatar = null;

        m_monsterCount = 0;

        m_roleMgr_jsb: cc.roleMgr_jsb = null;

        static getMe = function (): roleMgr {
            if (sceneMgr.getMe().m_curScene == null) {
                return null;
            }
            return sceneMgr.getMe().m_curScene.getRoleMgr();
        };
        static create = function (): roleMgr {
            let _roleMgr = new roleMgr();
            return _roleMgr;
        };

        constructor() {
            super();

            this.m_follower_map = new Map< number,player >();
            this.m_monster_map = new Map< number,monster >();
            this.m_player_map = new Map< number,player >();
            this.m_AllRole_map = new Map< number,baseRole >();
            this.m_player_map_Alive = new Map< number,baseRole >();
            this.m_monster_map_Alive = new Map< number,monster >();
            this.m_AllRole_map_Alive = new Map< number,baseRole >();
            this.m_player_map_dead = new Map< number,baseRole >();
            this.m_monster_map_dead = new Map< string,number >();

            this.getNode().setName("roleMgr类");
            this.m_monsterCount = 0;

            if (cc.sys.isNative) {
                this.m_roleMgr_jsb = new cc.roleMgr_jsb();
            }
        }

        // 设置当前控制角色
        setControlPlayer() {
            for (let i = 0; i < this.m_player_map.size; ++i) {
                let obj = this.m_player_map.getByIndex(i);
                obj.setControlRole(false);
            }

            for (let i = 0; i < this.m_player_map.size; ++i) {
                let obj = this.m_player_map.getByIndex(i);
                if (!obj.isdead()) {
                    obj.setControlRole(true);
                   // this.m_curControlRole = obj;
                    this.setcurControlRole(obj);
                    break;
                }
            }


            playControl.getMe().resetKey();
        }

        //当前被控制的角色
        getControlPlayer(): baseRole {
            return this.m_curControlRole;
        }

        setcurControlRole(_baseRole: baseRole)
        {
            this.m_curControlRole = _baseRole;
            if (cc.sys.isNative)
            {
                this.m_roleMgr_jsb.setCurControlBaseRole(this.m_curControlRole.m_baseRole_js);
            }
        }

        //////////  调试阻挡模块 开始   //////////////
        updataDebug_drawRect(obj) {
            // if (obj == null) {
            //     return;
            // }
            // let rect = obj.getPhyRect();
            // _DrawNode_debug.drawRect(cc.p(rect.x, rect.y), cc.pAdd(cc.p(rect.width, rect.height), cc.p(rect.x, rect.y)), null, 2, cc.color(255, 0, 255, 255));
            // //  this.m_drawNodeMap.put(obj.__instanceId, obj);
        }

        updataDebug() {
            // if (_DrawNode_debug == null) {
            //     _DrawNode_debug = new cc.DrawNode();
            //     this.addChild(_DrawNode_debug, 100000);
            // }
            // _DrawNode_debug.clear();
            // this.updataDebug_drawRect(this.m_curRole);
            // this.updataDebug_drawRect(this.m_curFollower);
            // for (let i = 0; i < bulletMgr.getMe().m_bullet_map.size; ++i) {
            //     let data = bulletMgr.getMe().m_bullet_map.getByIndex(i);
            //     this.updataDebug_drawRect(data);
            // }
        }

        /////////////////////调试阻挡模块 结束  ////////////////////
        initroleMgr(sceneinfo: scene_config_data_s) {
            if (this.m_curRole) {
                return;
            }
            this.m_sceneinfo = sceneinfo;
            this.createPlayer(dataMgr.getMe().getCurHero());
            let follower = dataMgr.getMe().getCurFollow();

            // if(follower.length > 0)
            // {
            //     this.createFollower(follower[0],0);
            // }


            for (let i = 0; i < follower.length; i++) {
                this.createFollower(follower[i], i);

            }

        }

        //create Follower 随从
        createFollower(followname, num) {
            // return;
            if (followname == "" || followname == null) {
                return;
            }
            let l_follower = follower.create();
            l_follower.init(followname);
            let pos;
            if (num == 0) {
                pos = cc.p(this.m_sceneinfo["follower1birth"]["pos_x"], this.m_sceneinfo["follower1birth"]["pos_y"]);
            }
            else {
                pos = cc.p(this.m_sceneinfo["follower2birth"]["pos_x"], this.m_sceneinfo["follower2birth"]["pos_y"]);
            }
            l_follower.m_ground = pos;
            l_follower.setPosition(pos);

            this.addChild(l_follower.getNode(), 500);

            if (ccs._parser.g_isLowCpu == false) {
                spineMgr.getMe().createSpineOncePlay("chushengtexiao", "play", roleMgr.getMe().getNode(), l_follower.getPosition(), 1001);
            }

            this.m_follower_map.set(l_follower.__instanceId, l_follower);
            this.m_player_map.set(l_follower.__instanceId, l_follower);
            this.m_AllRole_map.set(l_follower.__instanceId, l_follower);
        }

        createAvatar(followname, pos) {
            if (!this.m_avatar) {
                this.m_avatar = Avatar.create();
                this.m_avatar.init(followname);
                this.addChild(this.m_avatar.getNode(), 500);
                this.m_follower_map.set(this.m_avatar.__instanceId, this.m_avatar);
                this.m_player_map.set(this.m_avatar.__instanceId, this.m_avatar);
                this.m_AllRole_map.set(this.m_avatar.__instanceId, this.m_avatar);
            }
            this.m_avatar.setHp(this.m_avatar.getmaxhp());
            this.m_avatar.m_xuetiao.setHpPer(100);
            this.m_avatar.m_ground = pos;
            this.m_avatar.setPosition(pos);
            // spineMgr.getMe().createSpineOncePlay("chushengtexiao", "play", roleMgr.getMe().getNode(), l_follower.getPosition(), 1001);
            if (this.m_avatar.isdead()) {
                this.m_avatar.changeState_Ex(e_AiType.g_AiType_Idle);
            }
            if (this.m_avatar.m_SpriteShadow) {
                this.m_avatar.m_SpriteShadow.setVisible(true);
            }
            if (this.m_avatar.m_xuetiao) {
                this.m_avatar.m_xuetiao.setVisible(true);
            }

            return this.m_avatar;
        }

        removeFollower(l_follower) {
            this.m_follower_map.delete(l_follower.__instanceId);
            this.m_AllRole_map.delete(l_follower.__instanceId);
            this.removeChild(l_follower);
        }

        //create monster
        createMonster(monsterInfo: monster_birth_child) {
            let l_monster = monster.create();
            l_monster.init(monsterInfo);
            l_monster.m_birthwave = monsterInfo.birth_wave; //波次类型 可以为空
            this.addChild(l_monster.getNode(), 0);
            this.m_monster_map.set(l_monster.__instanceId, l_monster);
            this.m_AllRole_map.set(l_monster.__instanceId, l_monster);
            this.m_monster_map_Alive.set(l_monster.__instanceId, l_monster);

            if (ccs._parser.g_isLowCpu == false) {
                spineMgr.getMe().createSpineOncePlay("guaiwuchuchangtexiao", "guaiwuchuchangtexiao", roleMgr.getMe().getNode(), l_monster.getPosition(), 1);
            }

            this.m_monsterCount++;
            return l_monster;
        }


        monsterDead(l_monster: baseRole) {
            this.m_monster_map_Alive.delete(l_monster.__instanceId);
        }

        //create monster
        createWorldBoss(monsterInfo) {
            let l_monster = worldBoss.create();
            l_monster.init(monsterInfo);
            this.addChild(l_monster.getNode(), 0);
            this.m_monster_map.set(l_monster.__instanceId, l_monster);
            this.m_AllRole_map.set(l_monster.__instanceId, l_monster);
            this.m_monster_map_Alive.set(l_monster.__instanceId, l_monster);
            this.m_worldBoss = l_monster;
            if (ccs._parser.g_isLowCpu == false) {
                spineMgr.getMe().createSpineOncePlay("guaiwuchuchangtexiao", "guaiwuchuchangtexiao", roleMgr.getMe().getNode(), l_monster.getPosition(), 1);
            }
            return l_monster;
        }

        getWorldBoss() {
            return this.m_worldBoss;
        }

        removeMonster(l_monster: monster) {
            let monstername = l_monster.getName();
            if (this.m_monster_map_dead.has(monstername)) {

                let deadnum = this.m_monster_map_dead.get(monstername);
                this.m_monster_map_dead.set(monstername, deadnum + 1);
            }
            else {
                this.m_monster_map_dead.set(monstername, 1);
            }
            this.m_monster_map.delete(l_monster.__instanceId);
            this.m_AllRole_map.delete(l_monster.__instanceId);
            l_monster.shutdown();
            this.removeChild(l_monster.getNode());
            this.m_monsterCount--;
        }

        // 当前玩家
        createPlayer(heroname) {
            //create hero
            let l_player = player.create();
            this.m_curRole = l_player;




            l_player.init(heroname);
            let pos = cc.p(this.m_sceneinfo["playerbirth"]["pos_x"], this.m_sceneinfo["playerbirth"]["pos_y"]);
            l_player.m_ground = pos;
            l_player.setPosition(pos);
            cameraMgr.getMe().reset(l_player);
            this.addChild(l_player.getNode(), 1000);
            this.m_player_map.set(l_player.__instanceId, l_player);
            this.m_AllRole_map.set(l_player.__instanceId, l_player);
            spineMgr.getMe().createSpineOncePlay("chushengtexiao", "play", roleMgr.getMe().getNode(), l_player.getPosition(), 1001);

            this.setcurControlRole(l_player);
            return l_player;
        }


        getRoleByName(name) {
            for (let i = 0; i < this.m_AllRole_map.size; ++i) {
                let data = this.m_AllRole_map.getByIndex(i);
                if (data.getRoleName() == name) {
                    return data;
                }
            }
            return null;
        }

        //返回当前玩家
        getPlayer(): player {
            return this.m_curRole;
        }

        //返回当前玩家
        //删除玩家
        deletePlayer() {
        }

        shutdown() {
            uieffectMgr.getMe().reset();
            for (let i = 0; i < this.m_monster_map.size; ++i) {
                let data = this.m_monster_map.getByIndex(i);
                data.shutdown();
            }
            for (let i = 0; i < this.m_player_map.size; ++i) {
                let data = this.m_player_map.getByIndex(i);
                data.shutdown();
            }
        }

        getPlayerdead() {
            this.m_player_map_dead.clear();
            for (let i = 0; i < this.m_player_map.size; ++i) {
                let obj = this.m_player_map.getByIndex(i);
                if (obj.isdead()) {
                    this.m_player_map_dead.set(obj.__instanceId, obj);
                }
            }
            return this.m_player_map_dead;
        }

        getBoss() {
            for (let i = 0; i < this.m_monster_map.size; ++i) {
                let obj = this.m_monster_map.getByIndex(i);
                if (obj.isboss()) {
                    return obj;
                }
            }
            return null;
        }

        resetMonsterDeadNum() {
            this.m_monster_map_dead.clear();
        }

        getMonsterDeadNumByName(name) {
            let monsterDeadNum = 0;
            if (this.m_monster_map_dead != null) {
                for (let i = 0; i < this.m_monster_map_dead.size; ++i) {
                    let obj = this.m_monster_map_dead.getByIndex(i);
                    if (obj == name) {
                        monsterDeadNum = this.m_monster_map_dead.getByIndex(i);
                        break;
                    }
                }
            }
            return monsterDeadNum;
        }

        getMonsterDeadNum() {
            let monsterDeadNum = 0;
            if (this.m_monster_map_dead != null) {
                for (let i = 0; i < this.m_monster_map_dead.size; ++i) {
                    let num = this.m_monster_map_dead.getByIndex(i);
                    monsterDeadNum += num;
                }
            }
            return monsterDeadNum;
        }

        getBossDeadNum() {
            let bossDeadNum = 0;
            if (this.m_monster_map_dead != null) {
                for (let i = 0; i < this.m_monster_map_dead.size; ++i) {
                    let obj = this.m_monster_map_dead.getKey(i);
                    if (dataMgr.getMe().isBoss(obj)) {
                        let num = this.m_monster_map_dead.getByIndex(i);
                        bossDeadNum += num;
                    }
                }
            }
            return bossDeadNum;
        }

        getMonsterAliveById(id) {
            let pMonster = null;
            if (this.m_monster_map.has(id)) {
                pMonster = this.m_monster_map.getByIndex(id);
                if (pMonster.isdead()) {
                    return null;
                }
            }
            return pMonster;
        }

        getMonsterAliveByWave(birthWave) {
            let count = 0;
            let l_MonsterAlive = this.getMonsterAlive();
            for (let i = 0; i < l_MonsterAlive.size; ++i) {
                let monster = l_MonsterAlive.getByIndex(i);
                if (monster.m_birthwave == birthWave)
                    count++;
            }
            return count;
        }

        getRoleById(keyid) {
            let pRole = null;
            if (this.m_AllRole_map.has(keyid)) {
                pRole = this.m_AllRole_map.get(keyid);
                if (pRole.isdead()) {
                    return null;
                }
            }
            return pRole;
        }

        //获取没有死掉的队友
        getPlayerAlive(): Map< number,baseRole > {
            this.m_player_map_Alive.clear();
            for (let i = 0; i < this.m_player_map.size; ++i) {
                let obj = this.m_player_map.getByIndex(i);
                if (!obj.isdead()) {
                    this.m_player_map_Alive.set(obj.__instanceId, obj);
                }
            }
            return this.m_player_map_Alive;
        }

        //获取没有死掉的怪物
        getMonsterAlive(): Map< number,monster > {
            return this.m_monster_map_Alive;
        }

        //根据位置搜索最近的怪物
        getNeerestMonster(pos, minDis) {
            let pMonster = null;
            let l_MonsterAlive = this.getMonsterAlive();
            for (let i = 0; i < l_MonsterAlive.size; ++i) {
                let data = l_MonsterAlive.getByIndex(i);
                if (data.isdead() == true) {
                    continue;
                }
                if (data.getDistance(pos) < minDis) {
                    pMonster = data;
                    minDis = data.getDistance(pos);
                }
            }
            return pMonster;
        }

        isMonsterAllDead() {
            for (let i = 0; i < this.m_monster_map.size; ++i) {
                let obj = this.m_monster_map.getByIndex(i);
                if (!obj.isdead()) {
                    return false;
                }
            }
            return true;
        }

        isPlayerAllDead() {
            for (let i = 0; i < this.m_player_map.size; ++i) {
                let obj = this.m_player_map.getByIndex(i);
                if (obj.getName().indexOf("bobifenshen") > -1) {
                    continue;
                }
                if (!obj.isdead()) {
                    return false;
                }
            }
            return true;
        }

        //暂停动画
        zanting(falg) {
            this.m_AllRole_map.forEach(function (v, k) {
                v.zanting(falg);
            }, this);
        }


        getMonsterSize() {
            return roleMgr.getMe().getMonsterAlive().size;
        }

        update_0_3(t) {
            this.m_AllRole_map.forEach(function (v, k) {
                v.update_0_3(t);
            }, this);
        }

        update(t) {
            //this.updataDebug();
            this.m_AllRole_map.forEach(function (v, k) {
                v.update(t);
            }, this);
            for (let i = 0; i < this.m_monster_map.size; ++i) {
                let data: monster = this.m_monster_map.getByIndex(i);
                if (data.getCurStateType() == e_AiType.g_AiType_Dead) {
                    if (data.m_canDelete == true) {
                        this.removeMonster(data);
                    }
                    return;
                }
            }
        }

    }
    //非静态类

}
//# sourceMappingURL=roleMgr.js.map