var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var game;
(function (game) {
    //
    game.SceneTypeNameToType = function (sceneType) {
        if ('none' == sceneType) {
            return e_SceneType.SceneType_none;
        }
        else if ('login' == sceneType) {
            return e_SceneType.SceneType_login;
        }
        else if ('fight' == sceneType) {
            return e_SceneType.SceneType_fight;
        }
        else if ('cjce' == sceneType) {
            return e_SceneType.SceneType_chengjianchue;
        }
        else if ('worldboss' == sceneType) {
            return e_SceneType.SceneType_worldboss;
        }
        else if ('xiangdao' == sceneType) {
            return e_SceneType.SceneType_yindao;
        }
        return null;
    };
    (function (e_SceneType) {
        e_SceneType[e_SceneType["SceneType_none"] = 0] = "SceneType_none";
        e_SceneType[e_SceneType["SceneType_login"] = 1] = "SceneType_login";
        e_SceneType[e_SceneType["SceneType_fight"] = 2] = "SceneType_fight";
        e_SceneType[e_SceneType["SceneType_chengjianchue"] = 3] = "SceneType_chengjianchue";
        e_SceneType[e_SceneType["SceneType_worldboss"] = 4] = "SceneType_worldboss";
        e_SceneType[e_SceneType["SceneType_yindao"] = 5] = "SceneType_yindao";
    })(game.e_SceneType || (game.e_SceneType = {}));
    var e_SceneType = game.e_SceneType;
    var baseScene = (function (_super) {
        __extends(baseScene, _super);
        function baseScene() {
            _super.call(this);
            this.m_scenenode = null;
            this.m_qianjingnode = null;
            this.m_beijingnode = null;
            this.m_node_roleBase = null;
            this.m_node_baseui = null;
            this.m_SceneInfo = null; // 场景信息
            this.m_roleMgr = null;
            this.m_BulletMgr = null;
            this.m_SceneType = e_SceneType.SceneType_none;
            this.m_scenename = "";
            this.m_bIsloadind = false;
            this.m_backlayerCount = 0;
            this.m_backupLay = null;
            this.m_AllKillMonsterNum = 0;
            this.m_AllKillMonsterExp = 0;
            this.m_baseScene_jsb = null;
            this.m_SceneType = e_SceneType.SceneType_none;
            this.getNode().setName("baseScene类");
            if (cc.sys.isNative) {
                this.m_baseScene_jsb = new cc.baseScene_jsb();
                this.m_baseScene_jsb.initEx(this.getNode());
                this.m_baseScene_jsb.retain();
            }
        }
        baseScene.prototype.init = function () {
            return true;
        };
        baseScene.prototype.setDamage = function (v) {
        };
        baseScene.prototype.closeBoss = function (f) {
        };
        baseScene.prototype.initMonster = function (d) {
        };
        //设置杀怪exp
        baseScene.prototype.setKillMonsterExp = function (exp) {
        };
        baseScene.prototype.gameOver = function (winval, data) {
            if (data === void 0) { data = null; }
        };
        //场景切换卸载内存
        baseScene.prototype.removeMem = function () {
            // TextureCache.getInstance()->removeUnusedTextures();
            if (cc.sys.isNative) {
                cc.textureCache.removeUnusedTextures();
                cc.sys.garbageCollect();
                console.log("删除无用内存！end");
            }
        };
        baseScene.prototype.shutdown = function () {
            if (cc.sys.isNative) {
                this.m_baseScene_jsb.release();
            }
            game.ui_combo.shutdown();
            if (this.m_BulletMgr != null) {
                this.m_BulletMgr.shutdown();
                this.m_BulletMgr = null;
            }
            game.spineMgr.getMe().shutdown();
            game.uieffectMgr.getMe().shutdown();
            if (this.m_roleMgr != null) {
                this.m_roleMgr.shutdown();
                this.m_node_roleBase.removeChild(this.m_roleMgr.getNode(), true);
                this.m_roleMgr = null;
            }
            this.removeMem();
            game.fileMgr.getMe().savePlayInfo();
            return true;
        };
        baseScene.prototype.getRoleMgr = function () {
            return this.m_roleMgr;
        };
        baseScene.prototype.getBulletMgr = function () {
            return this.m_BulletMgr;
        };
        baseScene.prototype.playBackMusic = function () {
            game.musicMgr.getMe().playbackmusic(this.m_SceneInfo["back_music"]);
        };
        baseScene.prototype.getsceneScale = function () {
            return game.rootScene.getMe().m_win_scale;
        };
        baseScene.prototype.getsceneReScale = function () {
            if (game.rootScene.getMe().m_win_scale < 1) {
                return 1.0 / game.rootScene.getMe().m_win_scale;
            }
            else {
                return 1.0 / game.rootScene.getMe().m_win_scale;
            }
            //   return rootScene.getMe().m_win_scale;
        };
        baseScene.prototype.shipeiCenter = function (playout) {
            var winSize = cc.director.getWinSize();
            playout.setPosition(cc.p(0, 0));
            playout.setAnchorPoint(cc.p(0.0, 0.0));
            console.log("shipeiCenter：" + this.getsceneScale());
            playout.setScale(this.getsceneScale());
        };
        baseScene.prototype.loadsceneEx = function () {
        };
        baseScene.prototype.startjuqing = function () {
        };
        baseScene.prototype.loadscene = function (scenename) {
            this.m_scenename = scenename;
            game.rootScene.getMe().zanting(false);
            this.m_SceneInfo = cc.clone(game.fileMgr.getMe().getSceneInfo(scenename));
            if (this.m_SceneInfo == null) {
                console.log("严重错误 没有这个场景名 ：" + scenename);
                console.error("严重错误 没有这个场景名 ：" + scenename);
                return;
            }
            //
            var json = null;
            json = ccs.load("xingjiezhuzhuxia2/big/scene/" + this.m_SceneInfo.res_path);
            if (json.node == null) {
                console.log("没有这个文件" + "xingjiezhuzhuxia2/big/scene/" + this.m_SceneInfo.res_path);
                console.error("" + "xingjiezhuzhuxia2/big/scene/" + this.m_SceneInfo.res_path);
            }
            this.m_scenenode = json.node;
            // 低性能是
            if (game.rootScene.getMe().isLowCpu()) {
                var outObj = game.memCheckMgr.getMe().getNodeNameList(this.m_scenenode);
                var obj = void 0;
                for (var p in outObj) {
                    if (p.indexOf("Particle") > -1) {
                        obj = ccui.helper.seekWidgetByName(this.m_scenenode, p);
                        obj.setVisible(false);
                        obj.pause();
                    }
                }
            }
            this.m_scenenode.setScale(game.rootScene.getMe().m_win_scale);
            this.m_qianjingnode = json.node.getChildByName("qianjing");
            this.m_beijingnode = json.node.getChildByName("beijing"); //
            if (this.m_qianjingnode == null) {
                this.m_qianjingnode = new cc.Node();
                this.m_scenenode.addChild(this.m_qianjingnode);
            }
            if (this.m_beijingnode == null) {
                this.m_beijingnode = new cc.Node();
                this.m_scenenode.addChild(this.m_beijingnode);
            }
            this.m_node_roleBase = new cc.Node();
            this.m_node_baseui = new cc.Node();
            this.m_scenenode.addChild(this.m_node_baseui);
            this.m_scenenode.addChild(this.m_node_roleBase);
            this.m_beijingnode.setLocalZOrder(0);
            this.m_node_baseui.setLocalZOrder(100);
            this.m_node_roleBase.setLocalZOrder(200);
            this.m_qianjingnode.setLocalZOrder(300);
            this.addChild(this.m_scenenode, 10000);
            this.m_roleMgr = game.roleMgr.create();
            this.m_node_roleBase.addChild(this.m_roleMgr.getNode());
            this.m_BulletMgr = game.bulletMgr.create();
            this.m_roleMgr.addChild(this.m_BulletMgr.getNode(), 200);
            this.shipeiCenter(this.m_scenenode); //这个地方的坐标系千万不能改
            this.init();
            this.playBackMusic();
            this.m_bIsloadind = true;
        };
        baseScene.prototype.update_0_3 = function (t) {
            this.updateBackUpLay();
        };
        baseScene.prototype.update = function (t) {
        };
        baseScene.prototype.resetBackUpLay = function () {
            if (this.m_backlayerCount && this.m_backlayerCount > 0) {
                this.m_backlayerCount = 1;
                this.deleteBackUpLay();
            }
        };
        baseScene.prototype.createBackUpLay = function () {
            if (ccs._parser.g_isLowCpu)
                return;
            if (!this.m_node_roleBase) {
                return;
            }
            this.m_backlayerCount++;
            if (!this.m_backupLay) {
                this.m_backupLay = new cc.Sprite("xingjiezhuzhuxia2/big/spine/beijing.png");
                this.m_backupLay.setAnchorPoint(cc.p(0.5, 0.2));
                this.m_backupLay.setScaleX(10000);
                this.m_backupLay.setScaleY(10000);
                this.m_node_roleBase.addChild(this.m_backupLay, -11000);
            }
            this.updateBackUpLay();
        };
        baseScene.prototype.deleteBackUpLay = function () {
            {
                if (!this.m_node_roleBase) {
                    return;
                }
                this.m_backlayerCount--;
                if (this.m_backlayerCount > 0)
                    return;
                if (this.m_backupLay) {
                    this.m_node_roleBase.removeChild(this.m_backupLay);
                    this.m_backupLay = null;
                }
            }
        };
        baseScene.prototype.updateBackUpLay = function () {
            if (this.m_backupLay) {
                var newpos_x = game.roleMgr.getMe().getControlPlayer().getPositionX();
                this.m_backupLay.setPosition(cc.p(newpos_x, 0));
            }
        };
        return baseScene;
    }(game.xjLayer));
    game.baseScene = baseScene;
})(game || (game = {}));
//# sourceMappingURL=baseScene.js.map 
//# sourceMappingURL=baseScene.js.map