module game {

    //

    export var SceneTypeNameToType = function (sceneType: string): e_SceneType {

        if ('none' == sceneType) {
            return e_SceneType.SceneType_none;
        }
        else if ('login' == sceneType) {
            return e_SceneType.SceneType_login;
        }
        else if ('fight' == sceneType) {
            return e_SceneType.SceneType_fight;
        }
        else if ('cjce' == sceneType) {
            return e_SceneType.SceneType_chengjianchue;
        }
        else if ('worldboss' == sceneType) {
            return e_SceneType.SceneType_worldboss;
        }

        else if ('xiangdao' == sceneType) {
            return e_SceneType.SceneType_yindao;
        }

        return null;
    };

    export enum e_SceneType  {
        SceneType_none = 0,
        SceneType_login,
        SceneType_fight,
        SceneType_chengjianchue, //惩奸除恶
        SceneType_worldboss,
        SceneType_yindao,
    }


    export class baseScene extends xjLayer {
        m_scenenode: cc.Node = null
        m_qianjingnode: cc.Node = null
        m_beijingnode: cc.Node = null
        m_node_roleBase: cc.Node = null
        m_node_baseui: cc.Node = null
        m_SceneInfo: scene_config_data_s = null;// 场景信息
        m_roleMgr: roleMgr = null
        m_BulletMgr: bulletMgr = null
        m_SceneType: e_SceneType = e_SceneType.SceneType_none;
        m_scenename: string = "";
        m_bIsloadind: any = false;
        m_backlayerCount: any = 0;
        m_backupLay: cc.Sprite = null;
        m_AllKillMonsterNum: number = 0;
        m_AllKillMonsterExp: number = 0;
        m_baseScene_jsb: cc.baseScene_jsb = null;

        constructor() {
            super();
            this.m_SceneType = e_SceneType.SceneType_none;
            this.getNode().setName("baseScene类");
            if (cc.sys.isNative) {
                this.m_baseScene_jsb = new cc.baseScene_jsb();
                this.m_baseScene_jsb.initEx(this.getNode());
                this.m_baseScene_jsb.retain();
            }

        }

        init(): boolean {
            return true;
        }

        setDamage(v) {

        }

        closeBoss(f) {

        }

        initMonster(d) {

        }

//设置杀怪exp
        setKillMonsterExp(exp: number) {
        }

        gameOver(winval, data: any = null) {

        }


        //场景切换卸载内存
        removeMem() {
            // TextureCache.getInstance()->removeUnusedTextures();
            if (cc.sys.isNative) {
                cc.textureCache.removeUnusedTextures();
                cc.sys.garbageCollect();
                console.log("删除无用内存！end");
            }
        }

        shutdown() {

            if (cc.sys.isNative) {
                this.m_baseScene_jsb.release();
            }
            ui_combo.shutdown();
            if (this.m_BulletMgr != null) {
                this.m_BulletMgr.shutdown();
                this.m_BulletMgr = null;
            }

            spineMgr.getMe().shutdown();
            uieffectMgr.getMe().shutdown();

            if (this.m_roleMgr != null) {
                this.m_roleMgr.shutdown();
                this.m_node_roleBase.removeChild(this.m_roleMgr.getNode(), true);
                this.m_roleMgr = null;
            }
            this.removeMem();
            fileMgr.getMe().savePlayInfo();
            return true;
        }

        getRoleMgr(): roleMgr {
            return this.m_roleMgr;
        }

        getBulletMgr() {
            return this.m_BulletMgr;
        }

        playBackMusic() {
            musicMgr.getMe().playbackmusic(this.m_SceneInfo["back_music"]);
        }

        getsceneScale() {
            return rootScene.getMe().m_win_scale;
        }

        getsceneReScale() {
            if (rootScene.getMe().m_win_scale < 1) {
                return 1.0 / rootScene.getMe().m_win_scale;
            }
            else {
                return 1.0 / rootScene.getMe().m_win_scale;
            }
            //   return rootScene.getMe().m_win_scale;
        }

        shipeiCenter(playout) {
            var winSize = cc.director.getWinSize();
            playout.setPosition(cc.p(0, 0));
            playout.setAnchorPoint(cc.p(0.0, 0.0));
            console.log("shipeiCenter：" + this.getsceneScale());
            playout.setScale(this.getsceneScale());
        }

        loadsceneEx() {

        }

        startjuqing() {

        }

        loadscene(scenename) {
            this.m_scenename = scenename;
            rootScene.getMe().zanting(false);
            this.m_SceneInfo = cc.clone(fileMgr.getMe().getSceneInfo(scenename));
            if (this.m_SceneInfo == null) {
                console.log("严重错误 没有这个场景名 ：" + scenename);
                console.error("严重错误 没有这个场景名 ：" + scenename);
                return;
            }
            //
            var json = null;
            json = ccs.load("xingjiezhuzhuxia2/big/scene/" + this.m_SceneInfo.res_path);
            if (json.node == null) {
                console.log("没有这个文件" + "xingjiezhuzhuxia2/big/scene/" + this.m_SceneInfo.res_path);
                console.error("" + "xingjiezhuzhuxia2/big/scene/" + this.m_SceneInfo.res_path);
            }
            this.m_scenenode = json.node;

            // 低性能是
            if (rootScene.getMe().isLowCpu()) {
                let outObj = memCheckMgr.getMe().getNodeNameList(this.m_scenenode);
                let obj;
                for (let p in outObj) {
                    if (p.indexOf("Particle") > -1) {
                        obj = ccui.helper.seekWidgetByName(this.m_scenenode, p);
                        obj.setVisible(false);
                        obj.pause();
                    }
                    // console.log("uiclassname：" + p + "  num：" + outObj[p]);
                }
            }

            this.m_scenenode.setScale(rootScene.getMe().m_win_scale);
            this.m_qianjingnode = json.node.getChildByName("qianjing");
            this.m_beijingnode = json.node.getChildByName("beijing"); //
            if (this.m_qianjingnode == null) {
                this.m_qianjingnode = new cc.Node();
                this.m_scenenode.addChild(this.m_qianjingnode);
            }
            if (this.m_beijingnode == null) {
                this.m_beijingnode = new cc.Node();
                this.m_scenenode.addChild(this.m_beijingnode);
            }
            this.m_node_roleBase = new cc.Node();
            this.m_node_baseui = new cc.Node();
            this.m_scenenode.addChild(this.m_node_baseui);
            this.m_scenenode.addChild(this.m_node_roleBase);
            this.m_beijingnode.setLocalZOrder(0);
            this.m_node_baseui.setLocalZOrder(100);
            this.m_node_roleBase.setLocalZOrder(200);
            this.m_qianjingnode.setLocalZOrder(300);
            this.addChild(this.m_scenenode, 10000);
            this.m_roleMgr = roleMgr.create();
            this.m_node_roleBase.addChild(this.m_roleMgr.getNode());
            this.m_BulletMgr = bulletMgr.create();
            this.m_roleMgr.addChild(this.m_BulletMgr.getNode(), 200);
            this.shipeiCenter(this.m_scenenode); //这个地方的坐标系千万不能改
            this.init();
            this.playBackMusic();
            this.m_bIsloadind = true;
        }

        update_0_3(t: number) {
            this.updateBackUpLay();

        }

        update(t) {

        }

        resetBackUpLay() {
            if (this.m_backlayerCount && this.m_backlayerCount > 0) {
                this.m_backlayerCount = 1;
                this.deleteBackUpLay();
            }
        }

        createBackUpLay() {
            if (ccs._parser.g_isLowCpu) return;
            if (!this.m_node_roleBase) {
                return;
            }
            this.m_backlayerCount++;
            if (!this.m_backupLay) {

                this.m_backupLay = new cc.Sprite("xingjiezhuzhuxia2/big/spine/beijing.png");
                this.m_backupLay.setAnchorPoint(cc.p(0.5, 0.2));
                this.m_backupLay.setScaleX(10000);
                this.m_backupLay.setScaleY(10000);
                this.m_node_roleBase.addChild(this.m_backupLay, -11000);
            }
            this.updateBackUpLay();
        }

        deleteBackUpLay() {
            {
                if (!this.m_node_roleBase) {
                    return;
                }
                this.m_backlayerCount--;
                if (this.m_backlayerCount > 0)
                    return;
                if (this.m_backupLay) {
                    this.m_node_roleBase.removeChild(this.m_backupLay);
                    this.m_backupLay = null;
                }
            }
        }

        updateBackUpLay() {
            if (this.m_backupLay) {
                var newpos_x = roleMgr.getMe().getControlPlayer().getPositionX();
                this.m_backupLay.setPosition(cc.p(newpos_x, 0));
            }
        }
    }
}
//# sourceMappingURL=baseScene.js.map