//战斗场景  基类
module game {
    export class baseSceneFight extends baseScene {
        m_startGame: boolean = false
        m_gameOver: boolean = false
        m_win: boolean = false
        m_sceneTime: number = 0 //场景运行时间
        m_resultTimer: number = 0
        m_juqingInfo: any = null;


        static scene(): baseSceneFight {
            let layer = new baseSceneFight();
            return layer;
        };

        constructor() {
            super();
            this.m_SceneType = e_SceneType.SceneType_fight;

            this.getNode().setName("baseSceneFight类");
        }

        init() {
            uiMgr.getMe().shutdownAllUi();
            ui_zhandoujm.ShowOrHide(true);
            playNuqiMgr.getMe().init();
            // this.m_createMonsterMgr = createMonsterMgr.create();
            guankaMgr.getMe().initGuanKaData(this.m_SceneInfo);

            this.initlayout();

            return true;
        }

        setKillMonsterExp(exp: number) {
            ++this.m_AllKillMonsterNum;
            if (this.m_SceneInfo.monsterexpPer == null) {
                this.m_SceneInfo.monsterexpPer = 1;
            }
            this.m_AllKillMonsterExp += (exp * this.m_SceneInfo.monsterexpPer );
        }


        start_game() {
            this.m_startGame = true;
            this.m_gameOver = false;
        }

        end_game() {
            this.m_startGame = false;
            this.m_gameOver = true;
        }

        onPlayFollowDead() {


        }

        updateWinOver(t) {
            if (this.m_gameOver == false) {
                return;
            }

            if (this.m_resultTimer > 2) {
                this.m_resultTimer = -10;
                this.endjuqing();
            }
            else {
                this.m_resultTimer += t;
            }
        }

        update_0_3(t) {
            super.update_0_3(t)
            this.update_Layout(t);
        }

        update(t) {
            super.update(t);
            this.updateWinOver(t);
            this.update_Layout(t);
            talkMgr.getMe().update(t);
            if (this.m_gameOver) {
                return;
            }
            if (this.m_startGame) {
                this.updateStartGame(t);
            }
        }

        updateStartGame(t) {

            this.m_sceneTime += t;

            guankaMgr.getMe().loop(t);

        }


        startjuqing() {
            this.m_juqingInfo = cc.clone(fileMgr.getMe().getJuqingInfo(sceneMgr.getMe().getCurSceneName()));

            if (this.m_juqingInfo == null
                || this.m_juqingInfo["start"] == null) {
                this.loadsceneEx();
                return;
            }

            talkMgr.getMe().initTalkData(this.m_juqingInfo["start"], this.loadsceneEx, this);

        }

        //结束剧情处理
        endjuqing() {


            if (this.m_juqingInfo == null
                || this.m_juqingInfo["end"] == null) {
                this.show_shengli_shibai();
                return;
            }

            if (this.m_win) {
                if (this.m_juqingInfo["end"]["win"] == null) {
                    this.show_shengli_shibai();
                    return;
                }
                talkMgr.getMe().initTalkData(this.m_juqingInfo["end"]["win"], this.show_shengli_shibai, this);
            } else {

                if (this.m_juqingInfo["end"]["unwin"] == null) {
                    this.show_shengli_shibai();
                    return;
                }
                talkMgr.getMe().initTalkData(this.m_juqingInfo["end"]["unwin"], this.show_shengli_shibai, this);
            }
        }

        show_shengli_shibai() {
            if (this.m_win) {
                ui_shibai_shengli.ShowOrHide(true, true);
            }
            else {
                ui_shibai_shengli.ShowOrHide(true, false);
            }
        }

        initlayout()
        {
            if (cc.sys.isNative)
            {
                this.m_baseScene_jsb.initlayout();
                return;
            }
         this.initlayout_js();
        }
        initlayout_js()
        {
            if (cc.sys.isNative)
            {
                this.m_baseScene_jsb.initlayout();
                return;
            }
        }
        update_Layout(t: number)
        {
            if (this.m_scenenode == null) {
                return;
            }
            if ( cc.sys.isNative )
            {
                this.m_baseScene_jsb.update_Layout(t);
                return;
            }
            this.update_Layout_js( t );
        }

        update_Layout_js(t: number)
        {
            let moves_node = g_moves;
            for (let p in moves_node) {
                let info = moves_node[p];
                //  let pnode = this.m_scenenode.getChildByTag(parseInt(info.node_id));
                if (!info.pnode) {
                    console.error("移动层id错误没有这个id"); //
                    continue;
                }
                if (info.speed != 0) {
                    let startPos = cc.p(info.startPos_x, info.startPos_y);
                    info.pnode.setPosition(startPos);
                }
                else {
                    let speedlay = fileMgr.getMe().m_curMyStruct_xiangsu_base.laySpeedscale;
                    let pos_play = sceneMgr.getMe().getPosition();
                    let scale = cameraMgr.getMe().m_sceneScale;
                    pos_play = cc.pMult(pos_play, scale);
                    let speedscale = info.playspeed_per_w * speedlay;
                    let nowPos = cc.p(-pos_play.x + speedscale * pos_play.x, 0);
                    info.pnode.setPosition(nowPos);
                }
            }
        }

        gameOver(winval, data: any = null) {
            if (this.m_gameOver) {
                return;
            }
            this.m_win = winval;
            if (playComboMgr.getMe())
                playComboMgr.getMe().breakCombo();
            this.end_game();
        }

        loadscene(scenename) {
            super.loadscene(scenename);
            cameraMgr.getMe().initex();
            // this.startjuqing();
            //this.loadsceneEx();
        }

        loadsceneEx() {
            this.m_roleMgr.initroleMgr(this.m_SceneInfo);
            this.m_sceneTime = 0;
            this.start_game();
        }

        shutdown() {
            if (playComboMgr.getMe())
                playComboMgr.getMe().breakCombo();
            if (sceneMgr.getMe().getCurScene())
                sceneMgr.getMe().getCurScene().resetBackUpLay();
            super.shutdown();

            talkMgr.getMe().shutdown();

            guankaMgr.getMe().shutdown();

            ui_zhandoujm.ShowOrHide(false);
            cameraMgr.getMe().shutdown();
            return true;
        }
    }

}
//# sourceMappingURL=baseSceneFight.js.map