"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var game;
(function (game) {
    game.g_buttonChangeMp3 = "ui_anniu1.mp3";
    var NodeInfo = (function () {
        function NodeInfo() {
            this.id = 0;
            this.name = "";
            this.node = null;
            this.pianchapos = null;
            this.InitPos = null;
            this.isbasd = null;
            this.type = 0;
            this.Movetype = 0;
            this.left_pos = 0;
            this.right_pos = 0;
            this.up_pos = 0;
            this.down_pos = 0;
        }
        NodeInfo.prototype.getButton = function () {
            if (this.type == 0) {
                return this.node;
            }
            return null;
        };
        NodeInfo.prototype.getName = function () {
            return this.node.getName();
        };
        NodeInfo.prototype.getChexButton = function () {
            if (this.type == 1) {
                return this.node;
            }
            return null;
        };
        NodeInfo.prototype.getNode = function () {
            return this.node;
        };
        NodeInfo.prototype.isTouchEnable = function () {
            return this.node.isTouchEnabled();
        };
        return NodeInfo;
    }());
    game.NodeInfo = NodeInfo;
    var BaseKeyState = (function () {
        function BaseKeyState() {
            this.m_key = null; // 指向 node 的焦点
            this.m_buttonlist = null;
            this.m_listjiaodian = 0;
            this.m_curUiBase = null;
            this.m_shouzhi = null;
            this.m_move = false;
            this.m_buttonlist = new game.MapGame();
        }
        BaseKeyState.prototype.init = function (father) {
            this.m_curUiBase = father;
            this.m_curUiBase.m_curstate = this;
            if (this.m_buttonlist.size() == 0) {
                return false;
            }
            this.m_key = this.m_buttonlist.begin();
            return true;
        };
        BaseKeyState.prototype.resetKey = function () {
            this.m_buttonlist.clear();
        };
        // 设置当前选择节点
        BaseKeyState.prototype.setCurKey = function (node) {
            this.m_buttonlist.each(function (k, data) {
                if (data.node.getName() === node.getName()) {
                    this.m_key = data;
                    return;
                }
            }, this);
        };
        BaseKeyState.prototype.setCurKey_byId = function (id) {
            this.m_buttonlist.each(function (k, data) {
                if (data.node.__instanceId === id) {
                    this.m_key = data;
                    return;
                }
            }, this);
        };
        BaseKeyState.prototype.setCurKey_byName = function (name) {
            this.m_buttonlist.each(function (k, data) {
                if (data.node.getName() == name) {
                    this.m_key = data;
                    return;
                }
            }, this);
        };
        BaseKeyState.prototype.shutdown = function () {
        };
        BaseKeyState.prototype.loop = function (t) {
            if (this.m_key == null) {
                return;
            }
            if (this.m_key.node.isVisible()) {
                for (var i = 0; i < this.m_buttonlist.getSize(); i++) {
                    var nodeinfo = this.m_buttonlist.getData(i);
                    if (nodeinfo.getChexButton() == this.m_key.getChexButton()) {
                        this.m_key.getChexButton().setSelected(true);
                        var pButtonImageView = ccui.helper.seekWidgetByName(nodeinfo.getChexButton(), "uitexiao");
                        if (pButtonImageView != null) {
                            pButtonImageView.setVisible(true);
                        }
                    }
                    else {
                        nodeinfo.getChexButton().setSelected(false);
                        var pButtonImageView = ccui.helper.seekWidgetByName(nodeinfo.getChexButton(), "uitexiao");
                        if (pButtonImageView != null) {
                            pButtonImageView.setVisible(false);
                        }
                    }
                }
            }
            else {
                for (var i = 0; i < this.m_buttonlist.getSize(); i++) {
                    var nodeinfo = this.m_buttonlist.getData(i);
                    if (nodeinfo.node.isVisible() == false ||
                        nodeinfo.node.getParent().isVisible() == false ||
                        nodeinfo.isTouchEnable() == false) {
                        continue;
                    }
                    if (nodeinfo.getChexButton() != null) {
                        this.m_key = nodeinfo;
                        break;
                    }
                }
            }
        };
        BaseKeyState.prototype.isCurBaseKeyState = function () {
        };
        BaseKeyState.prototype.regNode = function (rootnode, pos, pianyi) {
            if (!rootnode) {
                return;
            }
            //noinspection JSUnresolvedFunction
            var info = new NodeInfo();
            info.name = rootnode.getName();
            info.node = rootnode;
            info.pianchapos = pianyi;
            info.type = 2;
            info.id = pos;
            this.m_buttonlist.put(pos, info);
        };
        BaseKeyState.prototype.regNodeEx = function (rootnode, pos, pianyi, Movetype) {
            if (!rootnode) {
                console.log("error regNodeEx");
                return false;
            }
            if (rootnode.isVisible() == false) {
                console.log("error regNodeEx  rootnode.isVisible()");
                return false;
            }
            if (Movetype == null) {
                Movetype = 0;
            }
            if (pianyi == null) {
                pianyi = cc.p(0, 0);
            }
            var pButtonImageView = ccui.helper.seekWidgetByName(rootnode, "uitexiao");
            if (pButtonImageView != null) {
                pButtonImageView.setVisible(false);
            }
            var info = new NodeInfo();
            info.name = rootnode.getName();
            info.node = rootnode;
            info.pianchapos = pianyi;
            if (rootnode) {
                info.type = 1;
            }
            info.id = pos;
            info.Movetype = Movetype;
            this.m_buttonlist.put(pos, info);
            return true;
        };
        BaseKeyState.prototype.left = function () {
            this.m_move = true;
            var it_buffnext = null;
            var des = 1000000;
            var left = cc.p(-1, 0);
            game.musicMgr.getMe().playeffect(game.g_buttonChangeMp3);
            for (var i = 0; i < this.m_buttonlist.getSize(); i++) {
                var nodeinfo = this.m_buttonlist.getData(i);
                if (this.m_key == nodeinfo) {
                    continue;
                }
                if (nodeinfo.node.isVisible() == false ||
                    nodeinfo.node.getParent().isVisible() == false ||
                    nodeinfo.isTouchEnable() == false) {
                    continue;
                }
                var f_itx = nodeinfo.node.convertToWorldSpace(cc.p(0, 0));
                var f_curx = this.m_key.node.convertToWorldSpace(cc.p(0, 0));
                //if (Math.abs(f_curx.y - f_itx.y) > 500) {
                //    continue;
                //}
                if (f_itx.x < f_curx.x) {
                    //if (f_curx.x - f_itx.x > 0) {
                    //var nowdis = f_curx.x - f_itx.x;
                    //var nowdis = cc.pDistance(f_itx, f_curx);
                    if (cc.pAngle(cc.pSub(f_itx, f_curx), left) < 0.3) {
                        var nowdis = cc.pDistance(f_itx, f_curx);
                        if (nowdis < des) {
                            des = nowdis;
                            it_buffnext = nodeinfo;
                        }
                    }
                }
            }
            if (it_buffnext != null) {
                this.m_key = it_buffnext;
                if (!this.m_key.node.isTouchEnabled()) {
                    return this.left();
                }
                if (this.m_key.node.isVisible() == false || this.m_key.node.getParent().isVisible() == false) {
                    return this.left();
                }
            }
            else {
                return false;
            }
        };
        BaseKeyState.prototype.right = function () {
            this.m_move = true;
            var it_buffnext = null;
            var des = 1000000;
            var right = cc.p(1, 0);
            game.musicMgr.getMe().playeffect(game.g_buttonChangeMp3);
            ///this.m_buttonlist.each( function(pos,nodeinfo,index)
            //{
            for (var i = 0; i < this.m_buttonlist.getSize(); i++) {
                var nodeinfo = this.m_buttonlist.getData(i);
                if (this.m_key == nodeinfo) {
                    continue;
                }
                if (nodeinfo.node.isVisible() == false ||
                    nodeinfo.node.getParent().isVisible() == false ||
                    nodeinfo.isTouchEnable() == false) {
                    continue;
                }
                var f_itx = nodeinfo.node.convertToWorldSpace(cc.p(0, 0));
                var f_curx = this.m_key.node.convertToWorldSpace(cc.p(0, 0));
                //if (Math.abs(f_curx.y - f_itx.y) > 500) {
                //    continue;
                //}
                if (f_itx.x > f_curx.x) {
                    //if (f_itx.x - f_curx.x > 0) {
                    //var nowdis = f_itx.x - f_curx.x;
                    if (cc.pAngle(cc.pSub(f_itx, f_curx), right) < 0.3) {
                        var nowdis = cc.pDistance(f_itx, f_curx);
                        if (nowdis < des) {
                            des = nowdis;
                            it_buffnext = nodeinfo;
                        }
                    }
                }
            }
            if (it_buffnext != null) {
                this.m_key = it_buffnext;
                if (this.m_key.node.isVisible() == false || this.m_key.node.getParent().isVisible() == false) {
                    return this.right();
                }
                if (!this.m_key.node.isTouchEnabled()) {
                    return this.right();
                }
            }
            else {
                return false;
            }
            return true;
        };
        BaseKeyState.prototype.up = function () {
            this.m_move = true;
            var it_buffnext = null;
            var up = cc.p(0, 1);
            var des = 1000000;
            game.musicMgr.getMe().playeffect(game.g_buttonChangeMp3);
            // this.m_buttonlist.each( function(pos,nodeinfo,index)
            // {
            for (var i = 0; i < this.m_buttonlist.getSize(); i++) {
                var nodeinfo = this.m_buttonlist.getData(i);
                if (this.m_key == nodeinfo) {
                    continue;
                }
                if (nodeinfo.node.isVisible() == false ||
                    nodeinfo.node.getParent().isVisible() == false ||
                    nodeinfo.isTouchEnable() == false) {
                    continue;
                }
                var f_ity = nodeinfo.node.convertToWorldSpace(cc.p(0, 0));
                var f_cury = this.m_key.node.convertToWorldSpace(cc.p(0, 0));
                if (f_ity.y > f_cury.y) {
                    //if (cc.pAngle(cc.pSub(f_ity, f_cury), up) < 0.9) {
                    var nowdis = cc.pDistance(f_ity, f_cury);
                    if (nowdis < des) {
                        des = nowdis;
                        it_buffnext = nodeinfo;
                    }
                }
            }
            if (it_buffnext != null) {
                this.m_key = it_buffnext;
                if (this.m_key.node.isVisible() == false || this.m_key.node.getParent().isVisible() == false) {
                    return this.up();
                }
                if (!this.m_key.node.isTouchEnabled()) {
                    return this.up();
                }
            }
            else {
                return false;
            }
            return true;
        };
        BaseKeyState.prototype.down = function () {
            this.m_move = true;
            var it_buffnext = null;
            var down = cc.p(0, -1);
            var des = 1000000;
            game.musicMgr.getMe().playeffect(game.g_buttonChangeMp3);
            //this.m_buttonlist.each( function(pos,nodeinfo,index)
            for (var i = 0; i < this.m_buttonlist.getSize(); i++) {
                var nodeinfo = this.m_buttonlist.getData(i);
                if (this.m_key == nodeinfo) {
                    continue;
                }
                if (nodeinfo.node.isVisible() == false ||
                    nodeinfo.node.getParent().isVisible() == false ||
                    nodeinfo.isTouchEnable() == false) {
                    continue;
                }
                var f_ity = nodeinfo.node.convertToWorldSpace(cc.p(0, 0));
                var f_cury = this.m_key.node.convertToWorldSpace(cc.p(0, 0));
                if (f_ity.y < f_cury.y) {
                    //if (cc.pAngle(cc.pSub(f_ity, f_cury), down) < 0.9) {
                    var nowdis = cc.pDistance(f_ity, f_cury);
                    if (nowdis < des) {
                        des = nowdis;
                        it_buffnext = nodeinfo;
                    }
                }
            }
            if (it_buffnext != this.m_buttonlist.end()) {
                this.m_key = it_buffnext;
                if (this.m_key.node.isVisible() == false || this.m_key.node.getParent().isVisible() == false) {
                    return this.down();
                }
                if (!this.m_key.node.isTouchEnabled()) {
                    return this.down();
                }
            }
            else {
                return false;
            }
            return true;
        };
        BaseKeyState.prototype.DoEnterCurButton = function () {
            if (this.m_buttonlist.size() == 0) {
                return false;
            }
            if (this.m_key != this.m_buttonlist.end()) {
                var node_ui = this.m_key.node;
                if (cc.sys.isNative) {
                    var ccp = node_ui.convertToWorldSpaceAR(cc.p(0, 0));
                    var ccpx = cc.director.convertToUI(ccp);
                    var handleTouches = new cc.Touch(0, ccpx.x, ccpx.y);
                    var touchEvent = new cc.EventTouch([handleTouches]);
                    touchEvent._eventCode = cc.EventTouch.EventCode.ENDED;
                    touchEvent.setEventCode(touchEvent._eventCode);
                    var touchEvent_begin = new cc.EventTouch([handleTouches]);
                    touchEvent_begin._eventCode = cc.EventTouch.EventCode.BEGAN;
                    touchEvent_begin.setEventCode(touchEvent_begin._eventCode);
                    cc.eventManager.dispatchEvent(touchEvent_begin);
                    cc.eventManager.dispatchEvent(touchEvent);
                }
                else {
                    var ccp = node_ui.convertToWorldSpaceAR(cc.p(0, 0));
                    // var ccp = node_ui.getPosition();
                    var handleTouches = new cc.Touch(ccp.x, ccp.y);
                    handleTouches._setPrevPoint(ccp.x, ccp.y);
                    var touchEvent = new cc.EventTouch([handleTouches]);
                    touchEvent._eventCode = cc.EventTouch.EventCode.ENDED;
                    var touchEvent_begin = new cc.EventTouch([handleTouches]);
                    touchEvent_begin._eventCode = cc.EventTouch.EventCode.BEGAN;
                    cc.eventManager.dispatchEvent(touchEvent_begin);
                    cc.eventManager.dispatchEvent(touchEvent);
                }
                return true;
            }
            return false;
        };
        BaseKeyState.prototype.getCurBtton = function () {
            return this.m_key.node;
        };
        BaseKeyState.prototype.getCurBttonPos = function () {
            //return this.m_key.node.convertToWorldSpace(cc.p(0, 0));
            return this.m_key.node.getWorldPosition();
        };
        return BaseKeyState;
    }());
    game.BaseKeyState = BaseKeyState;
    //通过配置表来确定上下左右顺序
    var BaseKeyState_ui_config = (function (_super) {
        __extends(BaseKeyState_ui_config, _super);
        function BaseKeyState_ui_config() {
            _super.call(this);
            this.m_ui_configname = null;
        }
        BaseKeyState_ui_config.prototype.setUIName = function (name) {
            this.m_ui_configname = game.g_uiKeyLogic[name];
        };
        BaseKeyState_ui_config.prototype.left = function () {
            this.m_move = true;
            game.musicMgr.getMe().playeffect(game.g_buttonChangeMp3);
            var name = this.m_key.getName();
            var nodekeyinfo = this.m_ui_configname[name];
            for (var i = 0; i < this.m_buttonlist.getSize(); i++) {
                var nodeinfo = this.m_buttonlist.getData(i);
                if (this.m_key == nodeinfo) {
                    continue;
                }
                if (nodeinfo.node.isVisible() == false ||
                    nodeinfo.node.getParent().isVisible() == false ||
                    nodeinfo.isTouchEnable() == false) {
                    continue;
                }
                if (nodekeyinfo["left"] == nodeinfo.getName()) {
                    this.m_key = nodeinfo;
                    return true;
                }
            }
            return false;
        };
        BaseKeyState_ui_config.prototype.right = function () {
            this.m_move = true;
            game.musicMgr.getMe().playeffect(game.g_buttonChangeMp3);
            var name = this.m_key.getName();
            var nodekeyinfo = this.m_ui_configname[name];
            for (var i = 0; i < this.m_buttonlist.getSize(); i++) {
                var nodeinfo = this.m_buttonlist.getData(i);
                if (this.m_key == nodeinfo) {
                    continue;
                }
                if (nodeinfo.node.isVisible() == false ||
                    nodeinfo.node.getParent().isVisible() == false ||
                    nodeinfo.isTouchEnable() == false) {
                    continue;
                }
                if (nodekeyinfo["right"] == nodeinfo.getName()) {
                    this.m_key = nodeinfo;
                    return true;
                }
            }
            return false;
        };
        BaseKeyState_ui_config.prototype.up = function () {
            this.m_move = true;
            game.musicMgr.getMe().playeffect(game.g_buttonChangeMp3);
            var name = this.m_key.getName();
            var nodekeyinfo = this.m_ui_configname[name];
            for (var i = 0; i < this.m_buttonlist.getSize(); i++) {
                var nodeinfo = this.m_buttonlist.getData(i);
                if (this.m_key == nodeinfo) {
                    continue;
                }
                if (nodeinfo.node.isVisible() == false ||
                    nodeinfo.node.getParent().isVisible() == false ||
                    nodeinfo.isTouchEnable() == false) {
                    continue;
                }
                if (nodekeyinfo["up"] == nodeinfo.getName()) {
                    this.m_key = nodeinfo;
                    return true;
                }
            }
            return false;
        };
        BaseKeyState_ui_config.prototype.down = function () {
            this.m_move = true;
            game.musicMgr.getMe().playeffect(game.g_buttonChangeMp3);
            var name = this.m_key.getName();
            var nodekeyinfo = this.m_ui_configname[name];
            for (var i = 0; i < this.m_buttonlist.getSize(); i++) {
                var nodeinfo = this.m_buttonlist.getData(i);
                if (this.m_key == nodeinfo) {
                    continue;
                }
                if (nodeinfo.node.isVisible() == false ||
                    nodeinfo.node.getParent().isVisible() == false ||
                    nodeinfo.isTouchEnable() == false) {
                    continue;
                }
                if (nodekeyinfo["down"] == nodeinfo.getName()) {
                    this.m_key = nodeinfo;
                    return true;
                }
            }
            return false;
        };
        BaseKeyState_ui_config.prototype.loop = function (t) {
            _super.prototype.loop.call(this, t);
        };
        return BaseKeyState_ui_config;
    }(BaseKeyState));
    game.BaseKeyState_ui_config = BaseKeyState_ui_config;
    var BaseKeyState_config = (function (_super) {
        __extends(BaseKeyState_config, _super);
        function BaseKeyState_config() {
            _super.call(this);
        }
        BaseKeyState_config.prototype.regNode_config = function (rootnode, pos, left_pos, right_pos, up_pos, down_pos, Movetype, pianyi) {
            if (!rootnode) {
                return;
            }
            if (Movetype == null) {
                Movetype = 0;
            }
            if (pianyi == null) {
                pianyi = cc.p(0, 0);
            }
            var pButtonImageView = ccui.helper.seekWidgetByName(rootnode, "uitexiao");
            if (pButtonImageView != null) {
                pButtonImageView.setVisible(false);
            }
            var info = new NodeInfo();
            info.name = rootnode.getName();
            info.node = rootnode;
            info.left_pos = left_pos;
            info.right_pos = right_pos;
            info.up_pos = up_pos;
            info.down_pos = down_pos;
            info.pianchapos = pianyi;
            if (rootnode) {
                info.type = 1;
            }
            info.id = pos;
            info.Movetype = Movetype;
            this.m_buttonlist.put(pos, info);
        };
        BaseKeyState_config.prototype.left = function () {
            var ret = this.m_buttonlist.getDataByKey(this.m_key.left_pos);
            if (ret) {
                this.m_key = ret;
                return true;
            }
            return false;
        };
        BaseKeyState_config.prototype.right = function () {
            var ret = this.m_buttonlist.getDataByKey(this.m_key.right_pos);
            if (ret) {
                this.m_key = ret;
                return true;
            }
            return false;
        };
        BaseKeyState_config.prototype.up = function () {
            var ret = this.m_buttonlist.getDataByKey(this.m_key.up_pos);
            if (ret) {
                this.m_key = ret;
                return true;
            }
            return false;
        };
        BaseKeyState_config.prototype.down = function () {
            var ret = this.m_buttonlist.getDataByKey(this.m_key.down_pos);
            if (ret) {
                this.m_key = ret;
                return true;
            }
            return false;
        };
        return BaseKeyState_config;
    }(BaseKeyState));
    game.BaseKeyState_config = BaseKeyState_config;
    var CGeziKeyState_list_h = (function (_super) {
        __extends(CGeziKeyState_list_h, _super);
        function CGeziKeyState_list_h() {
            _super.call(this);
            this.m_ScrollView = null;
            this.m_disVal = 300;
        }
        CGeziKeyState_list_h.prototype.loop = function (t) {
            _super.prototype.loop.call(this, t);
            return;
        };
        CGeziKeyState_list_h.prototype.getPercentHorizontal = function () {
            var offsetX = this.m_ScrollView.getInnerContainer().getPositionX();
            var w = this.m_ScrollView.getInnerContainerSize().width - this.m_ScrollView.getContentSize().width;
            return -(offsetX / w * 100);
        };
        return CGeziKeyState_list_h;
    }(BaseKeyState));
    game.CGeziKeyState_list_h = CGeziKeyState_list_h;
    var CGeziKeyState_list_v = (function (_super) {
        __extends(CGeziKeyState_list_v, _super);
        function CGeziKeyState_list_v() {
            _super.call(this);
            this.m_ScrollView = null;
            this.m_disVal = 30;
        }
        CGeziKeyState_list_v.prototype.init = function (father) {
            return _super.prototype.init.call(this, father);
        };
        CGeziKeyState_list_v.prototype.getCurBttonPos = function () {
            return this.m_key.node.getWorldPosition();
        };
        CGeziKeyState_list_v.prototype.loop = function (t) {
            _super.prototype.loop.call(this, t);
            var shouzhipos = this.getCurBttonPos();
            var visibleSize = this.m_ScrollView.getContentSize();
            //var  ScrollView_centerPos = this.m_ScrollView.getWorldPosition();
            var rHeight = visibleSize.height / 2 * game.uiMgr.getMe().getUiScale();
            if (this.m_ScrollView.getDirection() == cc.SCROLLVIEW_DIRECTION_VERTICAL) {
                var dis = Math.abs(shouzhipos.y - rHeight);
                dis = dis + this.m_disVal * game.uiMgr.getMe().getUiScale();
                if (dis > rHeight) {
                    if (shouzhipos.y < rHeight) {
                        var w = this.m_ScrollView.getInnerContainerSize().height - this.m_ScrollView.getContentSize().height;
                        var h = -w;
                        var speed = w / 80;
                        speed = Math.max(speed, 150);
                        speed = speed / 2;
                        var per = this.getPercentVertical();
                        per = per - t * speed;
                        per = 100 - per;
                        if (per > 100) {
                            per = 100;
                        }
                        this.m_ScrollView.jumpToPercentVertical(per);
                    }
                    else {
                        var w = this.m_ScrollView.getInnerContainerSize().height - this.m_ScrollView.getContentSize().height;
                        var h = -w;
                        var speed = w / 80;
                        speed = Math.max(speed, 150);
                        speed = speed / 2;
                        var per = this.getPercentVertical();
                        per = per + t * speed;
                        per = 100 - per;
                        if (per < 0) {
                            per = 0;
                        }
                        this.m_ScrollView.jumpToPercentVertical(per);
                    }
                }
            }
            return;
        };
        CGeziKeyState_list_v.prototype.getPercentVertical = function () {
            var w = this.m_ScrollView.getInnerContainerSize().height - this.m_ScrollView.getContentSize().height;
            w = -w;
            var offsetY = this.m_ScrollView.getInnerContainer().getPositionY();
            return (offsetY / w * 100);
        };
        CGeziKeyState_list_v.prototype.initSort = function () {
            this.m_key = this.m_buttonlist.begin();
            for (var i = 0; i < this.m_buttonlist.getSize(); i++) {
                var nodeinfo = this.m_buttonlist.getData(i);
                var f_ity = nodeinfo.node.convertToWorldSpace(cc.p(0, 0));
                var f_cury = this.m_key.node.convertToWorldSpace(cc.p(0, 0));
                if (f_ity.y > f_cury.y) {
                    this.m_key = nodeinfo;
                }
            }
        };
        return CGeziKeyState_list_v;
    }(BaseKeyState));
    game.CGeziKeyState_list_v = CGeziKeyState_list_v;
})(game || (game = {}));
//# sourceMappingURL=BaseKeyState.js.map