"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var game;
(function (game) {
    var UiBase = (function (_super) {
        __extends(UiBase, _super);
        function UiBase() {
            _super.call(this);
            this.m_des = "描述下這个ui类";
            this.m_type = 0;
            this.m_pLayout = null;
            this.m_curstate = null;
            this.m_key_not_close = true; //触摸穿透
            this.m_root = null;
            this.m_touchListener = null;
            this.m_uiannimationList = null;
            this.m_endLayout = false;
            this.initColor();
            game.uiMgr.getMe().adduibase(this);
            this.initTouch();
        }
        //
        UiBase.prototype.onExit = function () {
            game.uiMgr.getMe().deleteuibase(this);
            _super.prototype.onExit.call(this);
        };
        UiBase.prototype.initTouch = function () {
            var touchListener = {
                event: cc.EventListener.TOUCH_ONE_BY_ONE,
                swallowTouches: true,
                onTouchBegan: this.onTouchBegan.bind(this),
                onTouchMoved: this.onTouchMoved.bind(this),
                onTouchEnded: this.onTouchEnded.bind(this),
            };
            cc.eventManager.addListener(touchListener, this.getNode());
            this.m_touchListener = touchListener;
        };
        UiBase.prototype.onTouchBegan = function (touch, event) {
            var target = event.getCurrentTarget();
            if (this.m_key_not_close == false) {
                return false;
            }
            // if (!uiMgr.getMe()._topUiBase) {
            //     return false;
            // }
            // if (uiMgr.getMe()._topUiBase.__instanceId != target.__instanceId) {
            //     return true;
            // }
            if (!target.isVisible() || (!this.isTouchInside(target, touch))) {
                return false;
            }
            return true;
        };
        UiBase.prototype.onTouchMoved = function (touch, event) {
            return true;
        };
        UiBase.prototype.onTouchEnded = function (touch, event) {
            return true;
        };
        UiBase.prototype.isTouchInside = function (owner, touch) {
            if (!owner || !owner.getParent()) {
                return false;
            }
            var touchLocation = touch.getLocation(); // Get the touch position
            touchLocation = owner.getParent().convertToNodeSpace(touchLocation);
            return cc.rectContainsPoint(owner.getBoundingBox(), touchLocation);
        };
        //界面结束的时候调用
        UiBase.prototype.shutdown = function () {
            // cc.eventManager.addListener( this.m_touchListener, this);
            game.uiMgr.getMe().deleteuibase(this);
        };
        //初始化背景透明度
        UiBase.prototype.initColor = function () {
            this.setColor(cc.color(0, 0, 0));
            this.setOpacity(255 * 0.7);
            return true;
        };
        UiBase.prototype.playAnimationEx = function (_pLayout, name, loop, callback, target) {
            if (loop == null) {
                loop = true;
            }
            if (_pLayout == null) {
                if (callback !== undefined && target !== undefined) {
                    callback.call(target);
                }
                return false;
            }
            var node = _pLayout.node;
            var action = _pLayout.action; // 动作
            if (action.getTarget() == null) {
                node.runAction(action); // 播放动作
            }
            if (callback !== undefined && target !== undefined) {
                callback.bind(target);
                action.clearLastFrameCallFunc();
                action.setLastFrameCallFunc(function () {
                    callback.call(target);
                });
                action.play(name, loop);
            }
            else {
                action.play(name, loop);
            }
        };
        //播放ui 动画
        UiBase.prototype.playAnimation = function (name, loop, callback, target) {
            if (loop === void 0) { loop = true; }
            if (callback === void 0) { callback = undefined; }
            if (target === void 0) { target = null; }
            if (this.m_pLayout == null) {
                if (callback !== undefined && target !== undefined) {
                    callback.call(target);
                }
                return false;
            }
            var node = this.m_root;
            var action = this.m_pLayout.action; // 动作
            if (action == null) {
                return false;
            }
            if (action.getTarget() == null) {
                node.runAction(action); // 播放动作
            }
            //帧事件
            action.clearFrameEventCallFunc();
            action.setFrameEventCallFunc(this.onFrameEvent.bind(this));
            if (typeof callback != "undefined" && typeof target != "undefined") {
                callback.bind(target);
                action.clearLastFrameCallFunc();
                action.setLastFrameCallFunc(function () {
                    callback.call(target);
                });
                action.play(name, loop);
            }
            else {
                action.play(name, loop);
            }
            action.setName(name);
            return action;
        };
        UiBase.prototype.onFrameEvent = function (frame) {
            console.log(frame.getEvent());
            var event = frame.getEvent();
            if (event.indexOf("play") > -1) {
                var outjson = JSON.parse(frame.getEvent());
                if (outjson["play"] != null) {
                    game.musicMgr.getMe().playeffect(outjson["play"]);
                }
            }
        };
        //是否在播放ui动画
        UiBase.prototype.isPlay = function () {
            var action = this.m_pLayout.action; // 动作
            return action.isPlaying();
        };
        //解析ui 资源
        UiBase.prototype._parseUIFile = function (file, cocoStudioOldApi, shipei) {
            if (shipei === void 0) { shipei = null; }
            console.log("_parseUIFile : " + file);
            var json = ccs.load("xingjiezhuzhuxia2/big/ui/" + file);
            this.m_pLayout = json;
            this.m_root = this.m_pLayout.node;
            this.playBackMusic();
            if (this.m_root == null) {
                console.log("_parseUIFile error 没有这个文件" + "xingjiezhuzhuxia2/big/ui/" + file);
                console.error("_parseUIFile error 没有这个文件" + "xingjiezhuzhuxia2/big/ui/" + file);
            }
            return this.m_root;
        };
        //
        UiBase.prototype.parseUiFile_static = function (file) {
            cc.log("parseUiFileEx ccs.load : %s", file);
            var json = ccs.load("xingjiezhuzhuxia2/big/ui/" + file);
            var _root = json.node;
            return _root;
        };
        UiBase.prototype.playBackMusic = function () {
            try {
                if (this.m_root) {
                    var data = this.m_root.getComponent("ComExtensionData").getCustomProperty();
                    if (data != "" && data != null) {
                        var outjson = JSON.parse(data);
                        if (outjson["bm"] != null) {
                            game.musicMgr.getMe().playbackmusic(outjson["bm"]);
                        }
                        else if (outjson["click"] != null) {
                            game.musicMgr.getMe().playeffect(outjson["click"]);
                        }
                    }
                }
            }
            catch (e) {
                throw e;
            }
        };
        UiBase.prototype.backEvent = function (sender, type) {
            if (type == ccui.Widget.TOUCH_ENDED) {
            }
        };
        UiBase.prototype.onInitDialog = function () {
            return true;
        };
        UiBase.prototype.loop = function (t) {
            this.onUpdate(t);
        };
        UiBase.prototype.onUpdate = function (t) {
            if (this.m_curstate != null) {
                this.m_curstate.loop(t);
            }
        };
        UiBase.prototype.onKeyUp = function (keyCode, event) {
        };
        UiBase.prototype.onF1 = function () {
        };
        UiBase.prototype.onKeyDown = function (keyCode, event) {
        };
        UiBase.prototype.left = function () {
            if (this.m_curstate) {
                return this.m_curstate.left();
            }
        };
        UiBase.prototype.right = function () {
            if (this.m_curstate) {
                return this.m_curstate.right();
            }
        };
        UiBase.prototype.up = function () {
            if (this.m_curstate) {
                return this.m_curstate.up();
            }
        };
        UiBase.prototype.down = function () {
            if (this.m_curstate) {
                return this.m_curstate.down();
            }
        };
        UiBase.prototype.left_Released = function () {
            return true;
        };
        UiBase.prototype.right_Released = function () {
            return true;
        };
        UiBase.prototype.up_Released = function () {
            return true;
        };
        UiBase.prototype.down_Released = function () {
            return true;
        };
        UiBase.prototype.DoEnterCurButton = function () {
            var action = this.m_pLayout.action;
            if (action.getName() == "play")
                if (this.m_curstate != null) {
                    return this.m_curstate.DoEnterCurButton();
                }
        };
        UiBase.prototype.DoEnterCurButton_Released = function () {
        };
        UiBase.prototype.onMenu = function () {
        };
        UiBase.prototype.onMenu_Released = function () {
        };
        UiBase.prototype.onHome = function () {
            // if ( fileMgr.getMe().m_xiangsu_info.root.EnterBackgroundColse  == 1 ) {
            //
            // }
            game.fileMgr.getMe().savePlayInfo();
            cc.log("退出游戏！");
            cc.director.end();
        };
        UiBase.prototype.onBack = function () {
        };
        UiBase.prototype.onBack_Released = function () {
        };
        UiBase.prototype.playAnimationList = function (animationMaplist) {
            if (animationMaplist.size() <= 0) {
                return;
            }
            this.m_uiannimationList = animationMaplist;
            var it = this.m_uiannimationList.pop();
            var ret = this.playAnimation(it.animation, it.loop, this.playAnimationListCallback, this);
            if (ret == false) {
                this.playAnimationListCallback();
            }
        };
        UiBase.prototype.playAnimationListCallback = function () {
            if (this.m_uiannimationList.size() <= 0) {
                //this.m_Vis_key = true;
                return;
            }
            var it = this.m_uiannimationList.pop();
            this.playAnimation(it.animation, it.loop, this.playAnimationListCallback, this);
        };
        UiBase.prototype.EnterUI = function () {
            //this.m_Vis_key = false;
            var animationlist = new game.Queue();
            var info = {};
            info.animation = "playstart";
            info.loop = false;
            animationlist.push(info);
            var info2 = {};
            info2.animation = "play";
            info2.loop = true;
            animationlist.push(info2);
            this.playAnimationList(animationlist);
        };
        //结束ui
        UiBase.prototype.endLayout = function (callback) {
            if (this.m_endLayout == true) {
                return;
            }
            this.m_endLayout = true;
            if (callback) {
                this.playAnimation("playend", false, function () {
                    callback.call(this);
                    this.endLayoutCallBack();
                }, this);
            }
            else {
                this.playAnimation("playend", false, this.endLayoutCallBack, this);
            }
        };
        UiBase.prototype.endLayoutCallBack = function () {
            this.m_key_not_close = true;
        };
        UiBase.prototype.EnterUIEx = function (startname, loopname) {
        };
        UiBase.prototype.releaseKeyBoard = function () {
        };
        UiBase.prototype.onkey_1 = function () {
        };
        UiBase.prototype.onkey_2 = function () {
        };
        UiBase.prototype.onKeyPressed = function (keyCode) {
            if (this.m_endLayout == true) {
                return;
            }
            if (this.m_key_not_close == false) {
                return;
            }
            //cc.log("UiBase::onKeyPressed() " + keyCode);
            switch (keyCode) {
                case cc.KEY.num1:
                    {
                        this.onkey_1();
                    }
                    break;
                case 49:
                    {
                        this.onkey_1();
                    }
                    break;
                case cc.KEY.num2: //自动战斗
                case 50: {
                    this.onkey_2();
                }
                case cc.KEY.escape:
                case cc.KEY.back:
                    {
                        this.onBack();
                    }
                    break;
                case cc.KEY.home:
                    {
                        this.onHome();
                    }
                    break;
                case cc.KEY.up:
                case cc.KEY.dpadUp:
                    {
                        this.up();
                    }
                    break;
                case cc.KEY.down:
                case cc.KEY.dpadDown:
                    {
                        this.down();
                    }
                    break;
                case cc.KEY.left:
                case cc.KEY.dpadLeft:
                    {
                        this.left();
                    }
                    break;
                case cc.KEY.right:
                case cc.KEY.dpadRight:
                    {
                        this.right();
                    }
                    break;
                case cc.KEY.dpadCenter:
                case cc.KEY.enter:
                    {
                        this.DoEnterCurButton();
                    }
                    break;
                case cc.KEY.f1:
                    {
                        this.onF1();
                    }
                case cc.KEY.menu:
                    {
                        this.onMenu();
                    }
                    break;
                default:
                    break;
            }
        };
        UiBase.prototype.onKeyReleased = function (keyCode) {
            if (this.m_endLayout == true) {
                return;
            }
            if (this.m_key_not_close == false) {
                return;
            }
            //cc.log("UiBase::onKeyReleased() " + keyCode);
            switch (keyCode) {
                case cc.KEY.up:
                case cc.KEY.dpadUp:
                    {
                        this.up_Released();
                    }
                    break;
                case cc.KEY.down:
                case cc.KEY.dpadDown:
                    {
                        this.down_Released();
                    }
                    break;
                case cc.KEY.left:
                case cc.KEY.dpadLeft:
                    {
                        this.left_Released();
                    }
                    break;
                case cc.KEY.right:
                case cc.KEY.dpadRight:
                    {
                        this.right_Released();
                    }
                    break;
                case cc.KEY.escape:
                case cc.KEY.back:
                    {
                        this.onBack_Released();
                    }
                    break;
                case cc.KEY.enter:
                case cc.KEY.dpadCenter:
                    {
                        this.DoEnterCurButton_Released();
                    }
                    break;
                case cc.KEY.f1:
                case 49:
                case cc.KEY.menu:
                    {
                        this.onMenu_Released();
                    }
                    break;
                default:
                    break;
            }
        };
        UiBase.prototype.shipeiTop = function (playout) {
            var winSize = cc.director.getWinSize();
            playout.setPosition(cc.p(winSize.width / 2, winSize.height));
            playout.setAnchorPoint(cc.p(0.5, 1));
            playout.setScale(game.uiMgr.getMe().getUiScale());
        };
        UiBase.prototype.shipeiRight = function (playout) {
            var winSize = cc.director.getWinSize();
            playout.setPosition(cc.p(winSize.width, winSize.height / 2));
            playout.setAnchorPoint(cc.p(1, 0.5));
            playout.setScale(game.uiMgr.getMe().getUiScale());
        };
        UiBase.prototype.shipeiLift = function (playout) {
            var winSize = cc.director.getWinSize();
            playout.setPosition(cc.p(winSize.width / 2, 0));
            playout.setAnchorPoint(cc.p(0, 0.5));
            playout.setScale(game.uiMgr.getMe().getUiScale());
        };
        UiBase.prototype.shipeiBottom = function (playout) {
            var winSize = cc.director.getWinSize();
            playout.setPosition(cc.p(winSize.width / 2, 0));
            playout.setAnchorPoint(cc.p(0.5, 0));
            playout.setScale(game.uiMgr.getMe().getUiScale());
        };
        UiBase.prototype.shipeiCenter_720 = function (playout) {
            var winSize = cc.director.getWinSize();
            playout.setPosition(cc.p(winSize.width / 2, winSize.height / 2));
            playout.setAnchorPoint(cc.p(0.5, 0.5));
            playout.setScale(game.uiMgr.getMe().getUiScale_720());
            return playout.getScale();
        };
        UiBase.prototype.shipeiCenter = function (playout) {
            var winSize = cc.director.getWinSize();
            playout.setPosition(cc.p(winSize.width / 2, winSize.height / 2));
            playout.setAnchorPoint(cc.p(0.5, 0.5));
            playout.setScale(game.uiMgr.getMe().getUiScale());
            return playout.getScale();
        };
        UiBase.ShowOrHide = function (flag, UiObj, father, zOder, data) {
            if (UiObj === void 0) { UiObj = null; }
            if (father === void 0) { father = null; }
            if (zOder === void 0) { zOder = null; }
            if (data === void 0) { data = null; }
            if (father == null) {
                father = game.uiMgr.getMe();
            }
            if (flag == true) {
                if (UiObj.g_instarn == null) {
                    UiObj.g_instarn = new UiObj();
                    father.addChild(UiObj.g_instarn.getNode(), zOder);
                    UiObj.g_instarn.oninit(data);
                    return UiObj.g_instarn;
                }
                else {
                    return UiObj.g_instarn;
                }
            }
            else {
                if (UiObj.g_instarn != null) {
                    UiObj.g_instarn.shutdown();
                    father.removeChild(UiObj.g_instarn.getNode());
                    UiObj.g_instarn = null;
                }
            }
            return UiObj.g_instarn;
        };
        //选中checkbox play Animation
        UiBase.checkbox_select = function (flag, in_checkbox) {
            if (in_checkbox instanceof ccui.CheckBox) {
                in_checkbox.setSelected(flag);
            }
            var pButtonImageView = ccui.helper.seekWidgetByName(in_checkbox, "uitexiao");
            if (pButtonImageView != null) {
                pButtonImageView.setVisible(flag);
            }
        };
        UiBase.button_select = function (flag, in_button) {
            if (flag) {
                in_button.setEnabled(false);
                in_button.setBrightStyle(ccui.Widget.BRIGHT_STYLE_HIGH_LIGHT);
            }
            else {
                in_button.setEnabled(true);
                in_button.setBrightStyle(ccui.Widget.BRIGHT_STYLE_NORMAL);
            }
        };
        return UiBase;
    }(game.xjLayerColor));
    game.UiBase = UiBase;
})(game || (game = {}));
//# sourceMappingURL=uiBase.js.map 
//# sourceMappingURL=uiBase.js.map