"use strict";
module game {
    export class UiBase extends xjLayerColor {

        static ShowOrHide = function (flag, UiObj: any = null, father = null, zOder: number = null, data: any = null) {
            if (father == null) {
                father = uiMgr.getMe();
            }
            if (flag == true) {
                if (UiObj.g_instarn == null) {
                    UiObj.g_instarn = new UiObj();
                    father.addChild(UiObj.g_instarn.getNode(), zOder);
                    UiObj.g_instarn.oninit(data);
                    return UiObj.g_instarn;
                }
                else {
                    return UiObj.g_instarn;
                }
            }
            else {
                if (UiObj.g_instarn != null) {
                    UiObj.g_instarn.shutdown();
                    father.removeChild(UiObj.g_instarn.getNode());
                    UiObj.g_instarn = null;
                }
            }
            return UiObj.g_instarn;
        };
        //选中checkbox play Animation
        static checkbox_select = function (flag, in_checkbox) {
            if (in_checkbox instanceof ccui.CheckBox) {
                in_checkbox.setSelected(flag);
            }
            let pButtonImageView = ccui.helper.seekWidgetByName(in_checkbox, "uitexiao");
            if (pButtonImageView != null) {
                pButtonImageView.setVisible(flag);
            }
        };
        static button_select = function (flag, in_button) {
            if (flag) {
                in_button.setEnabled(false);
                in_button.setBrightStyle(ccui.Widget.BRIGHT_STYLE_HIGH_LIGHT);
            }
            else {
                in_button.setEnabled(true);
                in_button.setBrightStyle(ccui.Widget.BRIGHT_STYLE_NORMAL);
            }
        };

        m_des: string = "描述下這个ui类";
        m_type: any = 0;
        m_pLayout: any = null;
        m_curstate: any = null;
        m_key_not_close: boolean = true;   //触摸穿透
        m_root: cc.Node = null;
        m_touchListener: any = null;
        m_uiannimationList: any = null;
        m_endLayout: boolean = false;

        constructor() {
            super();
            this.initColor();
            uiMgr.getMe().adduibase(this);
            this.initTouch();
        }

        //
        onExit()
        {
            uiMgr.getMe().deleteuibase(this);
            super.onExit();
        }

        initTouch() {
            let touchListener = {
                event: cc.EventListener.TOUCH_ONE_BY_ONE,
                swallowTouches: true,
                onTouchBegan: this.onTouchBegan.bind(this),
                onTouchMoved: this.onTouchMoved.bind(this),
                onTouchEnded: this.onTouchEnded.bind(this),
            };
            cc.eventManager.addListener(touchListener, this.getNode());
            this.m_touchListener = touchListener;
        }

        onTouchBegan(touch, event) {
            let target = event.getCurrentTarget();
            if (this.m_key_not_close == false) {
                return false;
            }
            // if (!uiMgr.getMe()._topUiBase) {
            //     return false;
            // }
            // if (uiMgr.getMe()._topUiBase.__instanceId != target.__instanceId) {
            //     return true;
            // }
            if (!target.isVisible() || (!this.isTouchInside(target, touch))) {
                return false;
            }
            return true;
        }

        onTouchMoved(touch, event) {
            return true;
        }

        onTouchEnded(touch, event) {

            return true;
        }

        isTouchInside(owner, touch) {
            if (!owner || !owner.getParent()) {
                return false;
            }
            let touchLocation = touch.getLocation(); // Get the touch position
            touchLocation = owner.getParent().convertToNodeSpace(touchLocation);
            return cc.rectContainsPoint(owner.getBoundingBox(), touchLocation);
        }

        //界面结束的时候调用
        shutdown() {
            // cc.eventManager.addListener( this.m_touchListener, this);
            uiMgr.getMe().deleteuibase(this);
        }

        //初始化背景透明度
        initColor() {
            this.setColor(cc.color(0, 0, 0));
            this.setOpacity(255 * 0.7);
            return true;
        }

        playAnimationEx(_pLayout, name, loop, callback, target) {
            if (loop == null) {
                loop = true;
            }
            if (_pLayout == null) {
                if (callback !== undefined && target !== undefined) {
                    callback.call(target);
                }
                return false;
            }
            let node = _pLayout.node;
            let action = _pLayout.action; // 动作
            if (action.getTarget() == null) {
                node.runAction(action); // 播放动作
            }
            if (callback !== undefined && target !== undefined) {
                callback.bind(target);
                action.clearLastFrameCallFunc();
                action.setLastFrameCallFunc(function () {
                    callback.call(target);
                });
                action.play(name, loop);
            }
            else {
                action.play(name, loop);
            }
        }

        //播放ui 动画
        playAnimation(name, loop: boolean = true, callback: any = undefined, target: any = null) {
            if (this.m_pLayout == null) {
                if (callback !== undefined && target !== undefined) {
                    callback.call(target);
                }
                return false;
            }
            let node = this.m_root;
            let action = this.m_pLayout.action; // 动作
            if (action == null) {
                return false;
            }
            if (action.getTarget() == null) {
                node.runAction(action); // 播放动作
            }

            //帧事件
            action.clearFrameEventCallFunc();
            action.setFrameEventCallFunc(this.onFrameEvent.bind(this));

            if (typeof callback != "undefined" && typeof target != "undefined") {
                callback.bind(target);
                action.clearLastFrameCallFunc();
                action.setLastFrameCallFunc(function () {
                    callback.call(target);
                });

                action.play(name, loop);
            }
            else {
                action.play(name, loop);
            }
            action.setName(name);
            return action;
        }

        onFrameEvent(frame){
            console.log(frame.getEvent());
           var event =  frame.getEvent();
            if( event.indexOf("play") > -1){
                let outjson = JSON.parse(frame.getEvent());
                if (outjson["play"] != null) {
                    musicMgr.getMe().playeffect(outjson["play"]);
                }
            }
        }

        //是否在播放ui动画
        isPlay() {
            let action = this.m_pLayout.action; // 动作
            return action.isPlaying();
        }

        //解析ui 资源
        _parseUIFile(file, cocoStudioOldApi, shipei: any = null) {
            console.log("_parseUIFile : " + file);
            let json = ccs.load("xingjiezhuzhuxia2/big/ui/" + file);
            this.m_pLayout = json;
            this.m_root = this.m_pLayout.node;
            this.playBackMusic();
            if (this.m_root == null) {
                console.log("_parseUIFile error 没有这个文件" + "xingjiezhuzhuxia2/big/ui/" + file);
                console.error("_parseUIFile error 没有这个文件" + "xingjiezhuzhuxia2/big/ui/" + file);
            }
            return this.m_root;
        }


        //
        parseUiFile_static(file) {
            cc.log("parseUiFileEx ccs.load : %s", file);
            var json = ccs.load("xingjiezhuzhuxia2/big/ui/" + file);
            let _root = json.node;
            return _root;

        }

        playBackMusic() {
            try {
                if (this.m_root) {
                    let data = this.m_root.getComponent("ComExtensionData").getCustomProperty();
                    if (data != "" && data != null) {
                        let outjson = JSON.parse(data);
                        if (outjson["bm"] != null) {
                            musicMgr.getMe().playbackmusic(outjson["bm"]);
                        }
                        else if (outjson["click"] != null) {
                            musicMgr.getMe().playeffect(outjson["click"]);
                        }
                    }
                }
            }
            catch (e) {
                throw e;
                //cb("load json [" + url + "] failed : " + e);
                //uiMgr.getMe().show_ui_MessageBox(true, "用户数据填错了");
            }
        }

        backEvent(sender, type) {
            if (type == ccui.Widget.TOUCH_ENDED) {
            }
        }

        onInitDialog() {
            return true;
        }

        loop(t) {
            this.onUpdate(t);
        }

        onUpdate(t) {
            if (this.m_curstate != null) {
                this.m_curstate.loop(t);
            }
        }

        onKeyUp(keyCode, event) {
        }


        onF1(){

        }

        onKeyDown(keyCode, event) {
        }

        left() {
            if (this.m_curstate) {
                return this.m_curstate.left();
            }
        }

        right() {
            if (this.m_curstate) {
                return this.m_curstate.right();
            }
        }

        up() {
            if (this.m_curstate) {
                return this.m_curstate.up();
            }
        }

        down() {
            if (this.m_curstate) {
                return this.m_curstate.down();
            }
        }


        left_Released() {
            return true;
        }

        right_Released() {
            return true;
        }

        up_Released() {
            return true;
        }

        down_Released() {
            return true;
        }


        DoEnterCurButton() {
            let action = this.m_pLayout.action;
            if(action.getName() == "play")
            if (this.m_curstate != null) {
                return this.m_curstate.DoEnterCurButton();
            }
        }

        DoEnterCurButton_Released() {
        }

        onMenu() {
        }

        onMenu_Released() {
        }

        onHome() {
            // if ( fileMgr.getMe().m_xiangsu_info.root.EnterBackgroundColse  == 1 ) {
            //
            // }
            fileMgr.getMe().savePlayInfo();
            cc.log("退出游戏！");
            cc.director.end();
        }

        onBack() {

        }

        onBack_Released() {
        }

        playAnimationList(animationMaplist) {
            if (animationMaplist.size() <= 0) {
                return;
            }
            this.m_uiannimationList = animationMaplist;
            let it = this.m_uiannimationList.pop();
            let ret = this.playAnimation(it.animation, it.loop, this.playAnimationListCallback, this);
            if (ret == false) {
                this.playAnimationListCallback();
            }
        }

        playAnimationListCallback() {
            if (this.m_uiannimationList.size() <= 0) {
                //this.m_Vis_key = true;
                return;
            }
            let it = this.m_uiannimationList.pop();
            this.playAnimation(it.animation, it.loop, this.playAnimationListCallback, this);
        }

        EnterUI() {
            //this.m_Vis_key = false;
            let animationlist = new Queue();
            let info: any = {};
            info.animation = "playstart";
            info.loop = false;
            animationlist.push(info);
            let info2: any = {};
            info2.animation = "play";
            info2.loop = true;
            animationlist.push(info2);
            this.playAnimationList(animationlist);
        }

        //结束ui
        endLayout(callback) {
            if (this.m_endLayout == true) {
                return;
            }
            this.m_endLayout = true;
            if (callback) {
                this.playAnimation("playend", false, function () {
                    callback.call(this);
                    this.endLayoutCallBack();
                }, this);
            }
            else {
                this.playAnimation("playend", false, this.endLayoutCallBack, this);
            }
        }

        endLayoutCallBack() {
            this.m_key_not_close = true;
        }

        EnterUIEx(startname, loopname) {
        }

        releaseKeyBoard() {
        }

        onkey_1() {
        }

        onkey_2() {
        }


        onKeyPressed(keyCode) {
            if (this.m_endLayout == true) {
                return;
            }
            if (this.m_key_not_close == false) {
                return;
            }
            //cc.log("UiBase::onKeyPressed() " + keyCode);
            switch (keyCode) {
                case cc.KEY.num1:{
                    this.onkey_1();
                }
                break
                case 49: {
                    this.onkey_1();
                }
                    break;
                case cc.KEY.num2: //自动战斗
                case 50: {
                    this.onkey_2();
                }

                case cc.KEY.escape:
                case cc.KEY.back:
                    {
                        this.onBack();
                    }
                    break;
                case cc.KEY.home:
                    {
                        this.onHome();
                    }
                    break;
                case cc.KEY.up:
                case cc.KEY.dpadUp:
                    {
                        this.up();
                    }
                    break;
                case cc.KEY.down:
                case cc.KEY.dpadDown:
                    {
                        this.down();
                    }
                    break;
                case cc.KEY.left:
                case cc.KEY.dpadLeft:
                    {
                        this.left();
                    }
                    break;
                case cc.KEY.right:
                case cc.KEY.dpadRight:
                    {
                        this.right();
                    }
                    break;
                case cc.KEY.dpadCenter:
                case cc.KEY.enter:
                    {
                        this.DoEnterCurButton();
                    }
                    break;
                case cc.KEY.f1:
                {
                    this.onF1()
                }
                case cc.KEY.menu:
                    {
                        this.onMenu();
                    }
                    break;
                default:
                    break;
            }
        }

        onKeyReleased(keyCode) {
            if (this.m_endLayout == true) {
                return;
            }
            if (this.m_key_not_close == false) {
                return;
            }
            //cc.log("UiBase::onKeyReleased() " + keyCode);
            switch (keyCode) {
                case cc.KEY.up:
                case cc.KEY.dpadUp:
                    {
                        this.up_Released();
                    }
                    break;
                case cc.KEY.down:
                case cc.KEY.dpadDown:
                    {
                        this.down_Released();
                    }
                    break;
                case cc.KEY.left:
                case cc.KEY.dpadLeft:
                    {
                        this.left_Released();
                    }
                    break;
                case cc.KEY.right:
                case cc.KEY.dpadRight:
                    {
                        this.right_Released();
                    }
                    break;
                case cc.KEY.escape:
                case cc.KEY.back:
                    {
                        this.onBack_Released();
                    }
                    break;
                case cc.KEY.enter:
                case cc.KEY.dpadCenter:
                    {
                        this.DoEnterCurButton_Released();
                    }
                    break;
                case cc.KEY.f1:
                case 49:
                case cc.KEY.menu:
                    {
                        this.onMenu_Released();
                    }
                    break;
                default:
                    break;
            }
        }

        shipeiTop(playout) {
            let winSize = cc.director.getWinSize();
            playout.setPosition(cc.p(winSize.width / 2, winSize.height));
            playout.setAnchorPoint(cc.p(0.5, 1));
            playout.setScale(uiMgr.getMe().getUiScale());
        }

        shipeiRight(playout) {
            let winSize = cc.director.getWinSize();
            playout.setPosition(cc.p(winSize.width, winSize.height / 2));
            playout.setAnchorPoint(cc.p(1, 0.5));
            playout.setScale(uiMgr.getMe().getUiScale());
        }

        shipeiLift(playout) {
            let winSize = cc.director.getWinSize();
            playout.setPosition(cc.p(winSize.width / 2, 0));
            playout.setAnchorPoint(cc.p(0, 0.5));
            playout.setScale(uiMgr.getMe().getUiScale());
        }

        shipeiBottom(playout) {
            let winSize = cc.director.getWinSize();
            playout.setPosition(cc.p(winSize.width / 2, 0));
            playout.setAnchorPoint(cc.p(0.5, 0));
            playout.setScale(uiMgr.getMe().getUiScale());
        }

        shipeiCenter_720(playout) {
            let winSize = cc.director.getWinSize();
            playout.setPosition(cc.p(winSize.width / 2, winSize.height / 2));
            playout.setAnchorPoint(cc.p(0.5, 0.5));
            playout.setScale(uiMgr.getMe().getUiScale_720());
            return playout.getScale();
        }

        shipeiCenter(playout) {
            let winSize = cc.director.getWinSize();
            playout.setPosition(cc.p(winSize.width / 2, winSize.height / 2));
            playout.setAnchorPoint(cc.p(0.5, 0.5));
            playout.setScale(uiMgr.getMe().getUiScale());
            return playout.getScale();
        }

        // getUiType () {
        //     return m_type;
        // }
    }

}
//# sourceMappingURL=uiBase.js.map