var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
// 没有消息相应的 ui 节点
var game;
(function (game) {
    var uiBaseNode = (function (_super) {
        __extends(uiBaseNode, _super);
        function uiBaseNode() {
            _super.call(this);
            this.m_des = "描述下這个ui类";
            this.m_pLayout = null;
            this.m_root = null;
            this.m_uiannimationList = null;
            this.m_key_close = null;
        }
        //
        uiBaseNode.prototype.onExit = function () {
            this.shutdown();
            _super.prototype.onExit.call(this);
        };
        uiBaseNode.prototype.shutdown = function () {
        };
        uiBaseNode.prototype.playAnimationEx = function (_pLayout, name, loop, callback, target) {
            if (loop == null) {
                loop = true;
            }
            if (_pLayout == null) {
                if (callback !== undefined && target !== undefined) {
                    callback.call(target);
                }
                return false;
            }
            var node = _pLayout.node;
            var action = _pLayout.action; // 动作
            if (action.getTarget() == null) {
                node.runAction(action); // 播放动作
            }
            if (callback !== undefined && target !== undefined) {
                callback.bind(target);
                action.clearLastFrameCallFunc();
                action.setLastFrameCallFunc(function () {
                    callback.call(target);
                });
                action.play(name, loop);
            }
            else {
                action.play(name, loop);
            }
        };
        uiBaseNode.prototype.playAnimation = function (name, loop, callback, target) {
            if (loop === void 0) { loop = true; }
            if (callback === void 0) { callback = undefined; }
            if (target === void 0) { target = null; }
            if (this.m_pLayout == null) {
                if (callback !== undefined && target !== undefined) {
                    callback.call(target);
                }
                return false;
            }
            var node = this.m_root;
            var action = this.m_pLayout.action; // 动作
            if (action == null) {
                return false;
            }
            if (action.getTarget() == null) {
                node.runAction(action); // 播放动作
            }
            //帧事件
            action.clearFrameEventCallFunc();
            action.setFrameEventCallFunc(this.onFrameEvent.bind(this));
            if (typeof callback != "undefined" && typeof target != "undefined") {
                callback.bind(target);
                action.clearLastFrameCallFunc();
                action.setLastFrameCallFunc(function () {
                    callback.call(target);
                    // target = undefined;
                    // callback = undefined;
                });
                action.play(name, loop);
            }
            else {
                action.play(name, loop);
            }
        };
        uiBaseNode.prototype.onFrameEvent = function (frame) {
            console.log(frame.getEvent());
            var event = frame.getEvent();
            if (event.indexOf("play") > -1) {
                var outjson = JSON.parse(frame.getEvent());
                if (outjson["play"] != null) {
                    game.musicMgr.getMe().playeffect(outjson["play"]);
                }
            }
        };
        //
        uiBaseNode.prototype.isPlay = function () {
            // if(cc.sys.isNative)
            // {
            //     if (this.m_actionPoint == null) {
            //         this.m_actionPoint = this.m_pLayout.action.getPoint();
            //     }
            //     return this.m_pLayout.action.isPlayingEx(this.m_actionPoint);
            // }
            // else
            {
                return this.m_pLayout.action.isPlaying();
            }
        };
        uiBaseNode.prototype._parseUIFile = function (file) {
            // console.log("ccs.load : "+ file);
            var json = ccs.load("xingjiezhuzhuxia2/big/ui/" + file);
            this.m_pLayout = json;
            this.m_root = this.m_pLayout.node;
            return this.m_root;
        };
        //
        uiBaseNode.prototype.parseUiFile_static = function (file) {
            cc.log("parseUiFileEx ccs.load : %s", file);
            var json = ccs.load("xingjiezhuzhuxia2/big/ui/" + file);
            return json;
        };
        uiBaseNode.prototype.loop = function (t) {
            this.onUpdate(t);
        };
        uiBaseNode.prototype.onUpdate = function (t) {
        };
        uiBaseNode.prototype.playAnimationList = function (animationMaplist) {
            if (animationMaplist.size() <= 0) {
                return;
            }
            this.m_uiannimationList = animationMaplist;
            var it = this.m_uiannimationList.pop();
            this.playAnimation(it.animation, it.loop, this.playAnimationListCallback, this);
        };
        uiBaseNode.prototype.playAnimationListCallback = function () {
            if (this.m_uiannimationList.size() <= 0) {
                //this.m_Vis_key = true;
                return;
            }
            var it = this.m_uiannimationList.pop();
            this.playAnimation(it.animation, it.loop, this.playAnimationListCallback, this);
        };
        uiBaseNode.prototype.EnterUI = function () {
            //this.m_Vis_key = false;
            var animationlist = new game.Queue();
            var info = {};
            info.animation = "playstart";
            info.loop = false;
            animationlist.push(info);
            var info2 = {};
            info2.animation = "play";
            info2.loop = true;
            animationlist.push(info2);
            this.playAnimationList(animationlist);
        };
        //结束ui
        uiBaseNode.prototype.endLayout = function (callback) {
            this.m_key_close = false;
            if (callback) {
                this.playAnimation("playend", false, function () {
                    callback.call(this);
                    this.endLayoutCallBack();
                }, this);
            }
            else {
                this.playAnimation("playend", false, this.endLayoutCallBack, this);
            }
        };
        uiBaseNode.prototype.endLayoutCallBack = function () {
            this.m_key_close = true;
        };
        uiBaseNode.prototype.shipeiCenter = function (playout) {
            var winSize = cc.director.getWinSize();
            playout.setPosition(cc.p(winSize.width / 2, winSize.height / 2));
            playout.setAnchorPoint(cc.p(0.5, 0.5));
            playout.setScale(game.uiMgr.getMe().getUiScale());
            return playout.getScale();
        };
        uiBaseNode.prototype.shipeiRight = function (playout) {
            var winSize = cc.director.getWinSize();
            playout.setPosition(cc.p(winSize.width, winSize.height / 2));
            playout.setAnchorPoint(cc.p(1, 0.5));
            playout.setScale(game.uiMgr.getMe().getUiScale());
            return playout.getScale();
        };
        return uiBaseNode;
    }(game.xjNode));
    game.uiBaseNode = uiBaseNode;
})(game || (game = {}));
//# sourceMappingURL=uiBaseNode.js.map 
//# sourceMappingURL=uiBaseNode.js.map