// 没有消息相应的 ui 节点
module game {
    export class uiBaseNode extends xjNode {
        m_des: string = "描述下這个ui类";
        m_pLayout: any = null;
        m_root: cc.Node = null;
        m_uiannimationList: any = null;
        m_key_close: boolean = null;

        constructor() {
            super();
        }

        //
        onExit() {
            this.shutdown();
            super.onExit();
        }

        shutdown() {
        }

        playAnimationEx(_pLayout, name, loop, callback, target) {
            if (loop == null) {
                loop = true;
            }
            if (_pLayout == null) {
                if (callback !== undefined && target !== undefined) {
                    callback.call(target);
                }
                return false;
            }
            let node = _pLayout.node;
            let action = _pLayout.action; // 动作
            if (action.getTarget() == null) {
                node.runAction(action); // 播放动作
            }
            if (callback !== undefined && target !== undefined) {
                callback.bind(target);
                action.clearLastFrameCallFunc();
                action.setLastFrameCallFunc(function () {
                    callback.call(target);
                });
                action.play(name, loop);
            }
            else {
                action.play(name, loop);
            }
        }

        playAnimation(name, loop: boolean = true, callback: any = undefined, target: any = null) {
            if (this.m_pLayout == null) {
                if (callback !== undefined && target !== undefined) {
                    callback.call(target);
                    // target = undefined;
                    // callback = undefined;
                }
                return false;
            }
            let node = this.m_root;
            let action = this.m_pLayout.action; // 动作
            if (action == null) {
                return false;
            }
            if (action.getTarget() == null) {
                node.runAction(action); // 播放动作
            }


            //帧事件
            action.clearFrameEventCallFunc();
            action.setFrameEventCallFunc(this.onFrameEvent.bind(this));

            if (typeof callback != "undefined" && typeof target != "undefined") {

                callback.bind(target);
                action.clearLastFrameCallFunc();
                action.setLastFrameCallFunc(() => {
                    callback.call(target);
                    // target = undefined;
                    // callback = undefined;
                });


                action.play(name, loop);
            }
            else {
                action.play(name, loop);
            }
        }

        onFrameEvent(frame) {
            console.log(frame.getEvent());
            var event = frame.getEvent();
            if (event.indexOf("play") > -1) {
                let outjson = JSON.parse(frame.getEvent());
                if (outjson["play"] != null) {
                    musicMgr.getMe().playeffect(outjson["play"]);
                }
            }
        }

        m_actionPoint:null;
        //
        isPlay()
        {
            // if(cc.sys.isNative)
            // {
            //     if (this.m_actionPoint == null) {
            //         this.m_actionPoint = this.m_pLayout.action.getPoint();
            //     }
            //     return this.m_pLayout.action.isPlayingEx(this.m_actionPoint);
            // }
            // else
            {
                return this.m_pLayout.action.isPlaying();
            }
        }

        _parseUIFile(file) {
            // console.log("ccs.load : "+ file);
            let json = ccs.load("xingjiezhuzhuxia2/big/ui/" + file);
            this.m_pLayout = json;
            this.m_root = this.m_pLayout.node;
            return this.m_root;
        }

        //
        parseUiFile_static(file) {
            cc.log("parseUiFileEx ccs.load : %s", file);
            let json = ccs.load("xingjiezhuzhuxia2/big/ui/" + file);
            return json;
        }

        loop(t) {
            this.onUpdate(t);
        }

        onUpdate(t) {
        }

        playAnimationList(animationMaplist) {
            if (animationMaplist.size() <= 0) {
                return;
            }
            this.m_uiannimationList = animationMaplist;
            let it = this.m_uiannimationList.pop();
            this.playAnimation(it.animation, it.loop, this.playAnimationListCallback, this);
        }

        playAnimationListCallback() {
            if (this.m_uiannimationList.size() <= 0) {
                //this.m_Vis_key = true;
                return;
            }
            let it = this.m_uiannimationList.pop();
            this.playAnimation(it.animation, it.loop, this.playAnimationListCallback, this);
        }

        EnterUI() {
            //this.m_Vis_key = false;
            let animationlist = new game.Queue();
            let info: any = {};
            info.animation = "playstart";
            info.loop = false;
            animationlist.push(info);
            let info2: any = {};
            info2.animation = "play";
            info2.loop = true;
            animationlist.push(info2);
            this.playAnimationList(animationlist);
        }

        //结束ui
        endLayout(callback) {
            this.m_key_close = false;
            if (callback) {
                this.playAnimation("playend", false, function () {
                    callback.call(this);
                    this.endLayoutCallBack();
                }, this);
            }
            else {
                this.playAnimation("playend", false, this.endLayoutCallBack, this);
            }
        }

        endLayoutCallBack() {
            this.m_key_close = true;
        }

        shipeiCenter(playout: cc.Node) {
            let winSize: cc.Size = cc.director.getWinSize();
            playout.setPosition(cc.p(winSize.width / 2, winSize.height / 2));
            playout.setAnchorPoint(cc.p(0.5, 0.5));
            playout.setScale(game.uiMgr.getMe().getUiScale());
            return playout.getScale();

        }

        shipeiRight(playout: cc.Node) {
            var winSize = cc.director.getWinSize();
            playout.setPosition(cc.p(winSize.width, winSize.height / 2));
            playout.setAnchorPoint(cc.p(1, 0.5));
            playout.setScale(uiMgr.getMe().getUiScale());
            return playout.getScale();
        }

    }
}
//# sourceMappingURL=uiBaseNode.js.map