var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
/**
 * Created by Allen on 2016/9/6.
 */
// g_show_animation 动画配置表
//ui控件上的动画展示
var game;
(function (game) {
    var ui_show_spine = (function (_super) {
        __extends(ui_show_spine, _super);
        function ui_show_spine() {
            _super.apply(this, arguments);
            this.m_isLoad = false;
            this.m_roleResName = null;
            this.m_curplay = 0;
            this.m_animationlist = null;
            this.m_BulletMgr = null;
        }
        ui_show_spine.create = function (heroname, animationlist) {
            var spineObj = new ui_show_spine();
            spineObj.oninit(heroname, animationlist);
            return spineObj;
        };
        ;
        ui_show_spine.prototype.oninit = function (heroname, animationlist) {
            this.getNode().setName("ui_show_spine类");
            var roleInfo = game.fileMgr.getMe().m_playHero_data_Map.get(heroname);
            //let roleInfo = g_playhero_config[heroname];
            if (roleInfo.spine_res == null) {
                game.uiMgr.getMe().show_ui_MessageBox(true, "hero 表出错: name： " + heroname + "没有字段：spine_res");
                console.error("hero 表出错: name： " + heroname + "没有字段：spine_res");
            }
            this.m_roleResName = roleInfo.spine_res;
            this.m_animationlist = new game.ArrayEx();
            if (animationlist == undefined) {
                for (var p in game.g_show_animation[heroname]) {
                    this.m_animationlist.put(game.g_show_animation[heroname][p]);
                }
            }
            else {
            }
            this.m_BulletMgr = game.bulletMgr_demo.create();
            this.addChild(this.m_BulletMgr.getNode(), 200);
            this.loadres();
        };
        ui_show_spine.prototype.loadres = function () {
            if (this.m_isLoad) {
                return;
            }
            this.m_isLoad = true;
            if (this.m_SpineNode == null) {
                this.m_SpineNode = game.spineMgr.getMe().loadSpine(this.m_roleResName, this.getNode());
                this.m_SpineNode.setAnchorPoint(cc.p(0.5, 0));
                this.m_SpineNode.setLocalZOrder(4000);
                // this.addChild(this.m_SpineNode.getNode());
                this.m_SpineNode.setVisible(true);
            }
            else {
                this.m_SpineNode.setToSetupPose();
            }
            this.m_SpineNode.setStartListener(this.onStart.bind(this));
            this.m_SpineNode.setEndListener(this.onEnd.bind(this));
            this.m_SpineNode.setCompleteListener(this.onComplete.bind(this));
            this.m_SpineNode.setEventListener(function (traceIndex, event) {
                this.onFrameEvent("event", event);
            }.bind(this));
            this.stopMoveRootBone(0);
        };
        ui_show_spine.prototype.stopMoveRootBone = function (flag) {
            if (cc.sys.isNative) {
                if (!this.m_SpineNode) {
                    return;
                }
                this.m_SpineNode.SetBoneData("root", flag);
            }
            else {
                if (!this.m_SpineNode) {
                    return;
                }
                var pspBone = this.m_SpineNode.findBone("root");
                if (!pspBone) {
                    return;
                }
                pspBone.isMoveX = flag;
            }
        };
        ui_show_spine.prototype.onStart = function (trackIndex) {
        };
        ui_show_spine.prototype.onEnd = function (trackIndex) {
        };
        ui_show_spine.prototype.onComplete = function (traceIndex, loopCount) {
        };
        ui_show_spine.prototype.playAnimationEx = function (name, loop, mix, mintime, b_setToSetupPose) {
            if (loop === void 0) { loop = null; }
            if (mix === void 0) { mix = null; }
            if (mintime === void 0) { mintime = null; }
            if (b_setToSetupPose === void 0) { b_setToSetupPose = null; }
            this.playAnimation(name, loop, mix, mintime, b_setToSetupPose);
        };
        ui_show_spine.prototype.shutdown = function () {
            if (this.m_SpineNode) {
                this.removeChild(this.m_SpineNode.getNode());
                this.m_SpineNode = null;
            }
            if (this.m_BulletMgr != null) {
                this.m_BulletMgr.shutdown();
                this.removeChild(this.m_BulletMgr.getNode());
                this.m_BulletMgr = null;
            }
        };
        ui_show_spine.prototype.animation_completeEx = function () {
            if (!this.m_SpineNode.isVisible()) {
                return;
            }
            if (this.m_animationlist.isEmpty()) {
                return;
            }
            var animObj = this.m_animationlist.getData(this.m_curplay);
            this.m_SpineNode.setScale(animObj.scale);
            var pos = cc.p(0, 0);
            var lsize = this.getParent().getContentSize();
            pos.x = lsize.width * animObj.pos_x_a;
            pos.y = lsize.height * animObj.pos_y_a;
            this.m_SpineNode.setAnchorPoint(cc.p(0, 0));
            this.m_SpineNode.setPosition(pos);
            this.m_SpineNode.setToSetupPose();
            this.playAnimationEx(animObj.animation, false);
            if (++this.m_curplay >= this.m_animationlist.size()) {
                this.m_curplay = 0;
            }
        };
        ui_show_spine.prototype.loop = function (t) {
            if (this.m_SpineNode == null) {
                return;
            }
            if (!this.m_SpineNode.isVisible()) {
                return;
            }
            if (this.m_BulletMgr != null) {
                this.m_BulletMgr.update(t);
            }
            if (this.m_SpineNode.isPlay() == false) {
                if (this.m_BulletMgr.isPlay() == false) {
                    this.animation_completeEx();
                }
            }
        };
        ui_show_spine.prototype.onFrameEvent = function (type, event) {
            if ("event" == type) {
                this.Event_texiao(event);
            }
        };
        ui_show_spine.prototype.Event_texiao = function (event) {
            var name = event.data.name;
            if (name.indexOf(game.g_eventFrameType["Texiao"]) > -1) {
                var strs = name.split("_"); //字符分割
                var pos = this.m_SpineNode.getBoneWorldPos(strs[1]);
                var info = null;
                if (game.g_bullet_demo[name] != null) {
                    info = game.g_bullet_demo[name];
                }
                else {
                    info = game.g_bullet_demo["texiao_demo"];
                }
                var playPos = this.m_SpineNode.getPosition();
                info["res"] = strs[0];
                info["resAnimation"] = strs[2];
                info["pos"] = cc.pAdd(pos, playPos);
                info["dir"] = cc.p(1, 0);
                info["roleType"] = game.g_bulletRoleType.bulletType_play;
                this.m_BulletMgr.createNormalBullet_texiao(info);
            }
            else if (name.indexOf(game.g_eventFrameType["FireBullet"]) > -1) {
                var strs = name.split("_"); //字符分割
                var bulletType = name;
                var info = cc.copy(game.g_bullet_demo[bulletType]);
                if (info == null) {
                    game.uiMgr.getMe().show_ui_MessageBox(true, "g_bullet_demo 没有这个子弹" + bulletType);
                    return null;
                }
                var pos = this.m_SpineNode.getBoneWorldPos(strs[0]);
                var playPos = this.m_SpineNode.getPosition();
                info["pos"] = cc.pAdd(pos, playPos);
                info["dir"] = cc.p(1, 0);
                info["roleType"] = game.g_bulletRoleType.bulletType_play;
                this.m_BulletMgr.createBullet(info);
            }
        };
        return ui_show_spine;
    }(game.spineObj));
    game.ui_show_spine = ui_show_spine;
})(game || (game = {}));
//# sourceMappingURL=ui_show_spine.js.map 
//# sourceMappingURL=ui_show_spine.js.map